(* ----                          Wf_compl.v                           ----*)

(* Author: Pierre Casteran.                                               *)
(*    LABRI, URA CNRS 1304,                                               *)
(*    Departement d'Informatique, Universite Bordeaux I,                  *)
(*    33405 Talence CEDEX,                                                *)
(*    e-mail:  casteran@labri.u-bordeaux.fr                               *)

(* 
   Complements on well_founded Sets 
*)

Section Prop_induction.

 Variable A:Set.
 Variable R:A->A->Prop.
 Hypothesis W:(well_founded A R).
 Hint W.

 Lemma Prop_wfi: (P:A->Prop)
                 ((x:A)((y:A)(R y x)->(P y))->(P x))->
                  (a:A)(P a).
 (****************************************************)
 Proof.
  Intros;Apply (Acc_ind A R P);Auto.
 Qed.

End Prop_induction.


Definition coarser:=[A:Set][R,S:A->A->Prop]
                      (x,y:A)(R x y)->(S x y).

Lemma wf_coarser:
  (A:Set)
   (R,S:A->A->Prop)
     (coarser A R S)->
       (well_founded A S)->
          (well_founded A R).
(***************************)
Proof.
 Unfold well_founded;Intros A R S H H0 a.
 Apply Acc_intro;Intros y H1.
 Pattern y;Apply Prop_wfi with A S.
 Exact H0.
 Intros; Apply Acc_intro;Auto.
Qed.



