(* ----                      binary_strat.v                           ----- *)
(*                                                                          *)
(* Author: Pierre Casteran.                                                 *)
(*    LABRI, URA CNRS 1304,                                                 *)
(*    Departement d'Informatique, Universite Bordeaux I,                    *)
(*    33405 Talence CEDEX,                                                  *)
(*    e-mail:  casteran@labri.u-bordeaux.fr                                 *)

(*
  This file proves that (euclidean) division by 2 is a correct
 strategy (in the sens of or chain generation algorithm); this
 is the worst strategy (wrt. the number of multiplications used
 to compute x^n.

*)

AddPath "$COQTOP/theories/PROGRAMS".
AddPath ".".
Require strategies.
Require Arith.
Require euclid.
Require shift.
Require Euclid_proof.
Require Le_lt_compl.
Require Mult_compl.
Require Constants.


Lemma binary:strategy.  
(********************)
Proof. 
 Realizer [n:nat](quotient two n) .
 (* ----------------------------- *)
 Program_all.
 Elim y;Induction 1; Intros  H1 H2.
  (* H1: n=(plus (mult n0 two) x)
     H2: (gt two x)
  *)
 Case (enum1 x H2);Intro H3.

 (* case of a null rest (x) *)

 Cut n=(mult n0 two);[Intro eg|Idtac].
 Cut (le two n0);[Intro H'1|Idtac].
 Split.
 Rewrite eg;Apply mult_p_lt_pq.
 Apply neq_O_lt; Unfold not;Intro.
 Absurd (lt four n);[Idtac | Auto].
 Rewrite eg;Elim H4;Simpl;Auto.
 Auto.
 Auto.
   (* goal: le two n0 *)
 Apply not_lt_le; Unfold not;Intro.
 Absurd (lt n four);[ Apply lt_not_sym;Auto|Idtac].
 Rewrite eg;Replace four with (mult two two).
 Apply mult_lt_r.
 Auto.
 Auto.
 Simpl;Auto.
 Rewrite (plus_n_O (mult n0 two));Elim H3;Auto.

(* case of a rest = 1 *)
 Cut (le two n0);[Intro H'1 |Idtac].
 Split;[Idtac|Auto].
 Rewrite H1;Rewrite mult_sym;Apply lt_b_qbr.
 Rewrite H3;Auto.
 Auto.
 Apply lt_le_trans with two;[Idtac|Auto].
 Rewrite H3;Auto.
 Apply not_lt_le;Unfold not;Intro.
 Cut (le n three).
 Intro;Absurd (lt four three);[Unfold four three;Auto|Idtac].
 Apply lt_le_trans with n;Auto.
 Replace three with (plus (mult one two) x);Rewrite H1;Auto.
 Rewrite H3;Simpl;Auto.
Qed.





