(*   ---                fmpc.v           --- *)

(*                                                                          *)
(* Author: Pierre Casteran.                                                 *)
(*    LABRI, URA CNRS 1304,                                                 *)
(*    Departement d'Informatique, Universite Bordeaux I,                    *)
(*    33405 Talence CEDEX,                                                  *)
(*    e-mail:  casteran@labri.u-bordeaux.fr                                 *)


(*
     This is just a little tool we used at the first steps of our development;
    "FMPC" is just a macro for "Axiom", but we used it to express facts
     that we wanted to prove later; that explains why this module is not
     used in the proof we present now; The first versions of 
     "Addition Chains: the proof" were full of FMPCs.
*)


(* Proof by intimidation *)
(***************************)
Grammar vernac vernac :=
["FMPC" identarg($a) ":" command:command($term) "."] ->
[$0=<:vernac:<Axiom $a : $term.>>].

Grammar vernac vernac :=
["Well_Known" identarg($a) ":" command:command($term) "."] ->
[$0=<:vernac:<Axiom $a : $term.>>].

(* Examples:
   FMPC square_mono:(n,p:nat)(le n p)->(le (square n) (square p)).
   Well_Known square_mono:
       (n,p:nat)(le n p)->(le (square n) (square p)).
*)

