(*                              monofun.v                                   *)
(*                                                                          *)
(* Author: Pierre Casteran.                                                 *)
(*    LABRI, URA CNRS 1304,                                                 *)
(*    Departement d'Informatique, Universite Bordeaux I,                    *)
(*    33405 Talence CEDEX,                                                  *)
(*    e-mail:  casteran@labri.u-bordeaux.fr                                 *)


(* the monoid of functions from A to A *)
(***************************************)
AddPath ".".
Require monoid.

Section fun.
 Variable A:Set.
 Hypothesis eta_A:(f,g:A->A)((x:A)(f x)=(g x))->f=g.

 Local comp:=[f,g:A->A][x:A](g (f x)).
 Local Id := [a:A]a.

 Lemma funmono: (monoid A->A).
  Proof.
  Realizer (mkmonoid A->A Id  comp).
  Program; Unfold comp;Intros;Apply eta_A;Auto.
 Qed.
End fun.
Transparent funmono.




