(****************************************************************************)
(*                                DeclareN.v                                *)
(****************************************************************************)
     Variable X:Set.
     Local N := (N_glob X).
     Local N_unit := (N_unit_glob X).
     Local NF := (NF_glob X).
     Local N_abstr : (A,B:Set)(A->(N B)) ->(NF A B)  := (N_abstr_glob X).
     Local N_appli : (A,B:Set)(NF A B)->(N A)->(N B) := (N_appli_glob X).
     Local N_lift : (A,B:Set)(A->B)->(N A)->(N B)    := (N_lift_glob X).
     Local N_letin : (A,B:Set)(N A)->(NF A B)->(N B) := (N_letin_glob X).
     Local N_seq  : (A,B:Set) (N A)->(N B)->(N B)    := (N_seq_glob X).
     Local N_fn : (A:Set)(f:A->A)(N A)->(N A)        := (N_fn_glob X).
     Local N_op : (A:Set)(op:A->A->A)(N A)->(N A)->(N A) := (N_op_glob X).
     Local Tcontcc := (Tcontcc_glob X).
     Local contcc := (contcc_glob X).
     Local N_callcc : (A:Set)((Tcontcc A)->(N A))->(N A) := (N_callcc_glob X).
     Local N_throw : (A,B:Set)(Tcontcc A)->(N A)->(N B)  := (N_throw_glob X).

Grammar tactic tactic1 :=
   [ "Nunit" "Realizer" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply N_unit; Realizer $c; Program_all>>]

 | [ "Nunit" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply N_unit; Apply $c>>]

 | [ "Nabstr" ] -> 
   [$0=<:tactic:<Apply N_abstr>>]

 | [ "Napply" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply N_appli with $c; [Apply N_abstr | Idtac]>>]

 | [ "Nlift" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply N_lift with $c>>]

 | [ "Napplift" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply N_lift withFATR $c; [Idtac | Apply $c]>>]

 | [ "Nletin" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply N_letin with 2:=$c>>]

 | [ "Nseq" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply N_seq with $c>>]

 | [ "Ncallcc" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply N_callcc; Intro $c>>]

 | [ "Nthrow" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply N_throw with 1:=$c>>].

