(****************************************************************************)
(*                                DeclareNx.v                               *)
(****************************************************************************)

     Variable X:Set.
     Variable P:Prop.
     Variable e:P->X.
     Local Nx := (Nxglob X P).
     Local Nx_handle := (Nx_handle_glob X P).
     Local Nx_unit := (Nx_unit_glob X P).
     Local Nx_raise := (Nx_raise_glob X P e).
     Local Nx_elim_Nx  : 
        (A,A':Set)(C,C':Prop)
          (A->(C' V+ A'))->(C->C')->(C V+ A)->(C' V+ A') :=
        (Nx_elim_Nx_glob X P).

     Syntax constr PNx <<(Nx $p $s)>> 8 
        [ <hv 0> " "<$p:"term":L> " V+" [1 1] <$s:"term":L> " "] .

     Syntax tactic PNxE <:tactic:<Apply Nx_elim_Nx with 3:=$c>> 0
        "NxElim "<$c:"CommandArg":*>.
     
     Syntax tactic PNxUR 
         <:tactic:<Apply Nx_unit; Realizer $c; Program_all>> 0
        "NxUnit Realizer "<$c:"CommandArg":*>.
     
     Syntax tactic PNxU
         <:tactic:<Apply Nx_unit; Apply $c>> 0
        "NxUnit "<$c:"CommandArg":*>.
     
     Syntax tactic PNxR
         <:tactic:<Apply Nx_raise>> 0
        "NxRaise".

Grammar tactic tactic1 :=
   [ "NxUnit" "Realizer" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply Nx_unit; Realizer $c; Program_all>>]

 | [ "NxUnit" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply Nx_unit; Apply $c>>]

 | [ "NxRaise" ] -> 
   [$0=<:tactic:<Apply Nx_raise>>]

 | [ "NxElim" user_comarg($c) ] -> 
   [$0=<:tactic:<Apply Nx_elim_Nx with 3:=$c>>].
