(* ============================================================== *)
(*                          applytac.ml                           *)
(* ---                                                            *)
(* Jean-Francois.Monin@lannion.cnet.fr                            *)
(* January 1995, Coq V5.10                                        *)
(* ============================================================== *)

#open "std";;
#open "pp";;
#open "stdpp";;
#open "names";;
#open "generic";;
#open "term";;
#open "proof_trees";;
#open "clenv";;
#open "tactics";;
#open "tacmach";;
#infix "THENS";;
#infix "THEN";;

let rec last_constr = function
   DOP2(Prod,_,DLAM(_,c)) -> last_constr c
 | c -> c
;;

let first_arg =
   let st = "arg of first_arg should be an application"
   in function
     DOPN (AppL, v) -> if vect_length v = 2 then vect_item v 1 
                          else error (st^" with exactly one argument")
   | c -> error st
;;

(* pour un Apply f with typeres_of c *)
let resolve_with_tac chd mlist gls =
   let refinew_scheme KONT clause gl = res_pf KONT clause gl in
   let (wc,KONT) = StartWalk gls in
   let clause = mk_clenv_type_of wc chd in
   let clause' = clenv_constrain_missing_args mlist clause
   in refinew_scheme KONT clause' gls
;;

(* f = com a appliquer; c = com dont on veut le type du resultat *)
let resolve_with_compon cpn f c gls =
   let translate = pf_constr_of_com gls in
   let mlist = [cpn gls (translate c)]
   in resolve_with_tac (translate f) mlist gls
;;

let fst_arg_of_restype gls c = first_arg(last_constr (pf_type_of gls c))
;;
      
let ApplyWithFATR_tac = register_tactic "ApplyWithFATR"
  (fun [COMMAND f; COMMAND c] -> resolve_with_compon fst_arg_of_restype f c
     | _ -> error "ApplyWithFATR should be used with 2 commands")
  (fun sigma goal (_,[COMMAND f; COMMAND c]) ->
      [< 'S"ApplyWithFATR" ; 'SPC ; pr_com sigma goal f ; 'SPC ;
         pr_com sigma goal c >])
;;
