(****************************************************************************)
(*                                                                          *)
(* Jean-Francois.Monin@lannion.cnet.fr                                      *)
(* December 1994, Coq V5.10                                                 *)
(*                                                                          *)
(****************************************************************************)
(*                                 cps_Nx.v                                 *)
(****************************************************************************)

(* 
   The following primitives  should be used in a section
   beginning with 

Load DeclareNx.

*)

Grammar command command8 :=
   [ command7($c1) "V" "+"  command5($s) ] -> [ $0=<<(Nx $c1 $s)>> ].


Section defcont.

Variable X:Set.
Variable P:Prop.
Variable e:P->X.


Definition Nxglob := [C:Prop][A:Set](C->P)->(A->X)->X.

Local Nx := Nxglob.

Definition Nx_unit_glob : (C:Prop)(A:Set)A->(C V+ A) :=
   [C:Prop][A:Set][a:A] [i:C->P] [k:A->X](k a).

Definition Nx_raise_glob : (C:Prop)(A:Set)C->(C V+ A) :=
   [C:Prop][A:Set][c:C] [i:C->P][k:A->X](e (i c)).


Definition Nx_elim_Nx_glob : 
  (A,A':Set)(C,C':Prop)(A->(C' V+ A'))->(C->C')->(C V+ A)->(C' V+ A') :=
  [A,A':Set][C,C':Prop]
    [f:A-> C' V+ A'][j:C->C']
      [nx: C V+ A]
        [i:C'->P][k:A'->X](nx ([c:C](i (j c))) ([a:A](f a i k))).


Definition Nx_handle_glob : (C:Prop)(A:Set)(nx:(C V+ A))(C->P)->(A->X)->X :=
  [C:Prop][A:Set][nx:C V+ A]nx.

End defcont.

Require user_comarg.

Require gram1.



