(****************************************************************************)
(*                                                                          *)
(* Jean-Francois.Monin@lannion.cnet.fr                                      *)
(* January 1995, Coq V5.10                                                  *)
(*                                                                          *)
(****************************************************************************)
(*                                Naccu_cc.v                                *)
(****************************************************************************)

Require tests.
Require user_comarg.
Require specif.
Require gram1.
Require cps_N.

Section algocc.

Load DeclareN.

Local T_aux := [m,n:nat]{n':nat|n=n'&~(le m n')}.

Grammar tactic simple_tactic :=
  [ "Split_condsum" user_comarg($c1) user_comarg($c2) user_comarg($c3) ] -> 
  [$0=<:tactic:<Intro s;Elim s;Clear s; Intros $c1 $c2 $c3>>].

Syntax tactic PSplit_condsum 
    <:tactic:<Intro s;Elim s;Clear s; Intros $c1 $c2 $c3>> 0
    "Split_condsum "<$c1:"ComArg":*>" "<$c2:"ComArg":*>" "<$c3:"ComArg":*>.


Theorem ex_deb_cc_V1 :
  (m:nat)(t:tree)(N (RESU m t)).
Intros m t.
Ncallcc c.
Napply (condsum_accu m O t).
  Intro s_cond; Elim s_cond; Intros n Hnt Hmn.
  Nunit Realizer false.
  Apply Sf; Generalize Hmn; Rewrite Hnt; Auto.

  Cut (n:nat) ((le m n)->(P_overweight_accu m O t))->(N (T_aux m n)).
    Intro g.

    Cut (a:nat)((P_overweight_accu m a t)->(P_overweight_accu m O t))->
              (N (condsum_accu m a t)); 
        [Intro comprec; Apply comprec; Intro Hd; Apply Hd | Idtac].
  
  
     Pattern 1 3 t; Elim t.
       Intros n a e.
       Napplift (g (plus a n));
           [Intro sn; Realizer sn; Program_all | Auto].

      Hint deb_left_accu_plus deb_right_accu_plus deb_accu_plus_r.
       Intros t1 R1 t2 R2 a e.
       Napply (condsum_accu m a t1);
         [Split_condsum an1 Han1t1 Hman1 | Apply R1; Auto].
       Napply (condsum_accu m an1 t2);
         [Split_condsum an Hant2 Hmn | Apply R2; Rewrite Han1t1; Auto].
       Nunit Realizer an.
       Rewrite Hant2; Rewrite Han1t1; Rewrite plus_assoc_r; Auto.

     (* definition de g *)

     Intros n e.
     Case (le_dec m n).
       Intro le_mn; Nthrow c; Nunit Realizer true.
          Apply St; Cut (P_overweight_accu m O t); Auto.

       Intro Nle_mn; Nunit Realizer n.
Save.

End algocc.
(* -------------------- *)


Theorem F_overweight_accu_cc : (m:nat)(t:tree)(RESU m t).
  Intros m t; Apply (ex_deb_cc_V1 (RESU m t) m t).
  Intro x; Exact x.
Save.


