(****************************************************************************)
(*                                                                          *)
(* Jean-Francois.Monin@lannion.cnet.fr                                      *)
(* December 1994, Coq V5.10                                                 *)
(*                                                                          *)
(****************************************************************************)
(*                                Nxaccu_ex.v                               *)
(****************************************************************************)

(* Using Nx: only one exception *)


Require tests.
Require user_comarg.
Require gram1.
Require specif.
Require cps_Nx.

Section algorithms.

Load DeclareNx.

Definition condsum_accu_cps := 
   [m,a:nat][t:tree] (P_overweight_accu m a t) V+ (condsum_accu m a t).

Definition condsum_accu_handle :
   (m:nat)(t:tree)(nx:(condsum_accu_cps m O t))
      ((P_overweight_accu m O t)->P)->((condsum_accu m O t)->X)->X :=
   [m:nat][t:tree][nx:(condsum_accu_cps m O t)]
     (Nx_handle (P_overweight_accu m O t) (condsum_accu m O t) nx).

Local T_aux := [m,n:nat]{n':nat|n=n'&~(le m n')}.

Grammar tactic simple_tactic :=
  [ "Split_condsum" user_comarg($c1) user_comarg($c2) user_comarg($c3) ] -> 
  [$0=<:tactic:<Intro s;Elim s;Clear s; Intros $c1 $c2 $c3>>].

Syntax tactic PSplit_condsum 
    <:tactic:<Intro s;Elim s;Clear s; Intros $c1 $c2 $c3>> 0
    "Split_condsum "<$c1:"ComArg":*>" "<$c2:"ComArg":*>" "<$c3:"ComArg":*>.

Theorem core_V1 :
    (m:nat)(t:tree)(condsum_accu_cps m O t).
Do 2 Intro.
Cut (n:nat) (le m n) V+ (T_aux m n).
   Intro g.
   Cut (a:nat)(condsum_accu_cps m a t); [Intro comprec; Apply comprec | Idtac].
   Unfold condsum_accu_cps; Elim t.
     Intros n a.
     NxElim (g (plus a n)); [Intro sn'; NxUnit Realizer sn' | Auto].

     Hint deb_left_accu_plus deb_right_accu_plus deb_accu_plus_r.
     Intros t1 R1 t2 R2 a.
     NxElim (R1 a); [Split_condsum an1 Han1t1 Hman1 | Auto].
     NxElim (R2 an1); [Split_condsum an Hant2 Hmn | Rewrite Han1t1; Auto].
     NxUnit Realizer an.
     Rewrite Hant2; Rewrite Han1t1; Rewrite plus_assoc_r; Simpl; Auto.

     (* definition of g *)

   Intro n; Case (le_dec m n).
     Intro Hlemn; NxRaise; Assumption.
     Intro Nlemn; NxUnit Realizer n.
Save.

End algorithms.



Theorem exc_overweight_accu :
   (m:nat)(t:tree) (P_overweight_accu m O t)->(RESU m t).
Intros; Exists true; Auto.
Save.


Theorem success : (m:nat)(t:tree) (condsum_accu m O t)->(RESU m t).
Intros m t Hsc.
Exists false.
Elim Hsc; Simpl.
Intros n Hn; Rewrite Hn; Auto.
Save.

(* ==> [m:nat][t:tree][Hsc:condsum](exres m t false) *)


Theorem F_overweight_accu_V1 : (m:nat)(t:tree)(RESU m t).
Intros m t; Apply condsum_accu_handle with (P_overweight_accu m O t) m t.
   Apply core_V1; Exact (exc_overweight_accu m t).
   Intro h; Exact h. 
   Exact (success m t).
Save.

(* ======================================================= *)



