(****************************************************************************)
(*                                                                          *)
(* Jean-Francois.Monin@lannion.cnet.fr                                      *)
(* December 1994, Coq V5.10                                                 *)
(*                                                                          *)
(****************************************************************************)
(*                                  tree.v                                  *)
(****************************************************************************)

Inductive tree : Set :=
   leaf : nat->tree
 | node : tree->tree->tree.

Section func_pred.

Variable bin : nat -> nat -> nat.

Fixpoint ext_morph [t:tree]  : nat :=
   <nat>Case t of 
              [n:nat]n 
              [t1,t2:tree](bin (ext_morph t1) (ext_morph t2)) end.

Inductive Pext_morph : tree->nat->Prop :=
   Pl : (n:nat)(Pext_morph (leaf n) n)
 | Pn : (t1,t2:tree)(n1,n2:nat)
         (Pext_morph t1 n1)->(Pext_morph t2 n2)->
             (Pext_morph (node t1 t2) (bin n1 n2)).
Hint Pl Pn.

Theorem Pem_em : (t:tree)(Pext_morph t (ext_morph t)).
Induction t; Simpl; Auto.
Save.

Theorem em_eq_Pem : 
   (t:tree)(n:nat) n=(ext_morph t) ->(Pext_morph t n).
Intros t n Heq; Rewrite Heq; Apply Pem_em.
Save.

Theorem Pem_em_eq : 
   (t:tree)(n:nat)(Pext_morph t n)-> n=(ext_morph t).
Induction 1.
   Auto.
   Intros t1 t2 n1 n2 HPem1 Heq1 HPem2 Heq2.
      Rewrite Heq1; Rewrite Heq2; Auto.
Save.


End func_pred.

(* ============================== *)

