#open "names";;
#open "lexer";;
#open "ast";;
#open "pureparse";;
#open "std";;
#open "pp";;
#open "stdpp";;
#open "parsing";;

let command_gram ts = 
  match interp_gram "command" "command" ts with
     FRAGast t -> t
   | _ -> failwith "command_gram";;

let binary = function
  [<'Tint n >] ->
    let mkid s = ASTnvar(id_of_string s) in
    let xI = mkid "xI" and xO = mkid "xO" and xH = mkid "xH" in
    let app f l = ASTnode ("APPLIST",f::l) in
    let rec loop n = 
      if n=1 then xH  
      else let c = if n mod 10 = 0 then xO else if n mod 10 = 1 then xI
                   else raise Parse_error in
           app c [loop(n/10)] in
     FRAGast(if n = 0 then mkid "ZERO"
             else app (mkid (if n>0 then "POS" else "NEG")) [loop (abs n)])
 | [< 'Tlbracket;command_gram t;'Trbracket; 'Tident id >] ->
     let mkid s = ASTnvar(id_of_string s) in
     let xI = mkid "xI" and xO = mkid "xO" and xH = mkid "xH" in
     let app f l = ASTnode ("APPLIST",f::l) in
     let chars =  rev (explode id) in
     let rec loop = function
	 ["B"] -> t | "0"::l -> app xO [loop l] | "1"::l -> app xI [loop l]
       | _ -> errorlabstrm "Not a binary number.2" 
			   [<'S id;'S " is not a binary number">] in
     FRAGast(app (mkid "POS") [loop chars])
 | [< 'Tspecial "-"; 'Tlbracket;command_gram t;'Trbracket; 'Tident id >] ->
    let mkid s = ASTnvar(id_of_string s) in
    let xI = mkid "xI" and xO = mkid "xO" and xH = mkid "xH" in
    let app f l = ASTnode ("APPLIST",f::l) in
    let rec loop = function
        ["B"] -> t | "0"::l -> app xO [loop l] | "1"::l -> app xI [loop l]
      | _ -> errorlabstrm "Not a binary number.2" 
                          [<'S id;'S " is not a binary number">] in
    FRAGast(app (mkid "NEG") [loop (rev (explode id))]);;


let integer_gram = function
  [< 'Tint n >] ->
    let mkid s = ASTnvar(id_of_string s) in
    let xI = mkid "xI" and xO = mkid "xO" and xH = mkid "xH" in
    let app f l = ASTnode ("APPLIST",f::l) in
    let rec loop n = 
      if n=1 then xH else app (if n mod 2 = 0 then xO else xI) [loop (n/2)] in
    FRAGast(if n = 0 then mkid "ZERO"
            else app (if n > 0 then mkid "POS" else mkid "NEG") [loop (abs n)])
| [< 'Tspecial "##"; binary b >] -> b
;;

let whatfor = id_of_string "prim" in
mhm__add prim_grams 
  ((whatfor,id_of_string "integer"),
   (integer_gram,[PRIMITIVE(whatfor,id_of_string"integer")]))
;;
