Inductive color : Set := 
    blue : color
  | red : color
  | yellow : color.


Inductive tree1 : Set :=
   Leaf : nat -> tree1
 | Nd1 : color -> tree1 -> tree1.


Recursive Definition def_cop : tree1 -> tree1  :=
    (Leaf n) => (Leaf n) |
    (Nd1 blue t) => (Nd1 red (def_cop t)) |
    (Nd1 red t) => (Nd1 red (def_cop t)) |
    (Nd1 yellow t) => (Nd1 yellow (def_cop t)).



Require Mx_defs.

Theorem core_cop :
  (t:tree1) (Mx t=(def_cop t) {t':tree1 | t'=(def_cop t)&~(t=t')}).

Induction t.
  Intros n; Apply Mx_raise; Trivial.

  Intros c t1 R1; Case c; Simpl.
    Apply Mx_try with 1:= R1.     (* c = blue *)
      Intro v1; Apply Mx_unit.
        Elim v1; Intros t' eg di; Exists (Nd1 red t');
          [Elim eg; Trivial | Simplify_eq].

      Intro eg; Apply Mx_unit; Exists (Nd1 red t1);
          [Elim eg; Trivial | Simplify_eq].

    Apply Mx_bind with 1:= R1.     (* c = red *)
      Intro v1; Simpl; Apply Mx_unit; 
        Elim v1; Intros t' eg di; Exists (Nd1 red t');
           [Elim eg; Trivial | Simplify_eq; Assumption].
      Intro eg; Simpl; Elim eg; Trivial.

    Apply Mx_bind with 1:= R1.     (* c = yellow *)
      Intro v1; Simpl; Apply Mx_unit; 
        Elim v1; Intros t' eg di; Exists (Nd1 yellow t');
           [Elim eg; Trivial | Simplify_eq; Assumption].
      Intro eg; Simpl; Elim eg; Trivial.
Qed.




Theorem eff_cop :
    (t:tree1) {t':tree1 | t'=(def_cop t)}.
Intro t; Apply Mx_try with 1:= (core_cop t).
    Intro x; Realizer x;Program_all.
    Intro eg; Exists t; Trivial.
Qed.



Load "$COQTOP/tactics/contrib/path".

Require Extraction.

(* Extracting terms typed in system F but not in ML *)

Poly Extraction.

Write Caml File "extr" [Mx_unit Mx_raise Mx_try Mx_bind 
                        core_cop eff_cop].


