(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              Ensf_couple.v                               *)
(****************************************************************************)
(*              Formal Language Theory                                      *)
(*                                                                          *)
(*              Judicael Courant - Jean-Christophe Filliatre                *)
(*                                                                          *)
(*              Developped in V5.8  June-July 1993                          *)
(*              Ported     to V5.10 October 1994                            *)
(****************************************************************************)


Require Ensf_types.

(*									*)
(*  first et second renvoient repsectivement le premier et le deuxieme 	*)
(*  element d'un couple.						*)
(*									*)
  
Definition first : Elt -> Elt :=
  [x:Elt]
    (<Elt>Case x of
	(* natural *) [n:nat]zero
	(* couple  *) [a:Elt][b:Elt]a
	(* up      *) [e:Ensf]zero
	(* word    *) [w:Word]zero
    end ).

Definition second : Elt -> Elt :=
  [x:Elt]
    (<Elt>Case x of
	(* natural *) [n:nat]zero
	(* couple  *) [a:Elt][b:Elt]b
	(* up      *) [e:Ensf]zero
	(* word    *) [w:Word]zero
    end ).

(* Grace a first et second on recupere facilement le lemme suivant : 	*)

Lemma equal_couple : (x,y,z,t:Elt)
  <Elt>(couple x y)=(couple z t) -> ( <Elt>x=z /\ <Elt>y=t ).
Intros x y z t H.
Injection H; Auto.
Save.

Lemma couple_couple_inv1 : (a,b,c,d:Elt)
   (<Elt>(couple a c)=(couple b d)) -> (<Elt>a=b).
Intros a b c d H.
Injection H; Auto.
Save.
 
Lemma couple_couple_inv2 : (a,b,c,d:Elt)(<Elt>(couple a c)=(couple b d))->
(<Elt>c=d).
Intros a b c d H.
Injection H; Auto.
Save.
