(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                extract.v                                 *)
(****************************************************************************)
(*              Formal Language Theory                                      *)
(*                                                                          *)
(*              Judicael Courant - Jean-Christophe Filliatre                *)
(*                                                                          *)
(*              Developped in V5.8  June-July 1993                          *)
(*              Ported     to V5.10 October 1994                            *)
(****************************************************************************)


Require Ensf.
Require more_words.
Require PushdownAutomata.
Require gram.
Require gram_aut.

Section def_axiom_APD.

Variable X , P : Ensf.
Variable wd : Word.
Variable wa : Word.
Variable d : Ensf.
Local L:=(LA X wd wa d).

Axiom axiom_APD : (P_automata X P wd wa d) ->(u:Word) {(L u)}+{~(L u)}.

End def_axiom_APD.


Section parser.

Variable X,V,R:Ensf.
Variable S':Elt.
Hypothesis H : (isGram X V R S').
Local LL:=(LG X V R S').

Theorem Parser1 : (u:Word){(LL u)}+{~(LL u)}.
Intros.
Local P:=(union X V).

Local f_R_d := [a:Elt](couple (word (cons (first a) nil))
			  (couple (eps X) (second a))
			).

Local f_X_d := [x:Elt](couple (word (cons x nil))
			   (couple x (word nil))
			).

Local d:=(union (map f_R_d R) (map f_X_d X)).

Local wd:=(cons S' nil).

Local wa:=nil.

Local L:=(LA X wd wa d).

ElimType {(L u)}+{~(L u)}.

Intro Hyp.
Left.
Cut (l_egal L LL).
Intro temp;Elim temp.
Unfold l_inclus.
Intros.
Auto.
Unfold L LL wa wd d f_R_d f_X_d.
Apply equiv_APD_Gram.
Exact H.

Unfold not.
Intro Hyp.
Right.
Intro LL_u.
Apply Hyp.
Cut (l_egal L LL).
Intro temp;Elim temp.
Unfold l_inclus.
Intros.
Auto.
Unfold L LL wa wd d f_R_d f_X_d.
Apply equiv_APD_Gram.
Exact H.

Unfold L.
Apply axiom_APD with P.
Unfold P wd wa d f_R_d f_X_d.
Apply X_P_wd_wa_d.
Exact H.
Save.

End parser.
