(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 gram4.v                                  *)
(****************************************************************************)
(*              Formal Language Theory                                      *)
(*                                                                          *)
(*              Judicael Courant - Jean-Christophe Filliatre                *)
(*                                                                          *)
(*              Developped in V5.8  June-July 1993                          *)
(*              Ported     to V5.10 October 1994                            *)
(****************************************************************************)

Require Ensf.
Require Words.
Require more_words.
Require Rat.
Require need.
Require fonctions.
Require Relations.
Require gram.
Require gram2.
Require gram3.

Section gram4.

Variable X,V1,R1:Ensf.
Variable S1:Elt.

Variable V2,R2:Ensf.
Variable S2:Elt.

Variable S:Elt.
Local C := (Gunion_disj_p V1 R1 S1 V2 R2 S2 S).
Local Vu := (fst Ensf (Ensf*Elt) C).
Local C':=(snd Ensf (Ensf*Elt) C).
Local Ru:=(fst Ensf Elt C').
Local Su:=(snd Ensf Elt C').

Lemma inter_X_V1_u_V2 : (isGram X V1 R1 S1)->(isGram X V2 R2 S2)->(inter X (union V1 V2) empty).

Prolog [isGram2 union_inter] 5.
(*Intro G1.
Intro G2.
Apply union_inter.
Apply isGram2 with R1 S1; Assumption.
Apply isGram2 with R2 S2; Assumption.*)
Save.

Lemma inter_X_Vu_d : (isGram X V1 R1 S1)->(isGram X V2 R2 S2)->~(dans S X)
  ->(inter X Vu empty).
Intros G_1 G_2 N_dans_S_X.
Unfold inter.
Split.
 Auto.
 Split.
  Auto.
  Intros x dans_x_X dans_x_Vu.
  Absurd (dans x X).
  Cut (<Elt>S=x)\/(dans x (union V1 V2)).(**)
  Intro temp; Elim temp; Clear temp.
	Intros egal_S_x.
	Rewrite <- egal_S_x; Assumption.

	Intro dans_x_V1_u_V2.
	Prolog [ inter_X_V1_u_V2 sym_inter inter_dans ] 4.
	(*Apply inter_dans with (union V1 V2).
		Apply sym_inter.
		Apply inter_X_V1_u_V2;Assumption.

		Assumption.*)

  (**)Auto.

  Assumption.
Save.

Lemma Gunion_disj_Regles : (isGram X V1 R1 S1)->(isGram X V2 R2 S2)
  ->(Regles X Vu Ru).
Intros.
Unfold Vu Ru ;Simpl.
Apply Regles_add.
Apply Regles_add.
Apply Regles_add2.
Change (Regles X (fst Ensf Ensf (Gunion V1 R1 V2 R2)) 
	         (snd Ensf Ensf (Gunion V1 R1 V2 R2)) ).
Prolog [Gunion_Regles ] 2.
(*Apply Gunion_Regles with S1 S2;Auto.*)
Auto.
Apply inmonoid_cons.
Trivial.
Cut (dans S2 V2);
 [Auto |
Prolog [isGram3 ] 2(*Apply isGram3 with X R2;Assumption*)].

Auto.

Apply inmonoid_cons.
Trivial.
Cut (dans S1 V1);
[Auto |
Prolog [isGram3 ] 2 (*Apply isGram3 with X R1;Assumption*)].

Save.

Lemma inmon_Der_imp_Der_d : ~(dans S X)->~(dans S V1)->~(dans S V2)
    ->(Regles X V1 R1)->(Regles X V2 R2)->(inter (union X V1) V2 empty)
    ->(u,v:Word)(Derive Ru u v)->(inmonoid (union X V1) u)
    ->(Derive R1 u v).
Intros N_dans_X N_dans_V1 N_dans_V2 Re_1 Re_2 inter_X_V1_V2_empty u v Der_Ru_u.
Elim Der_Ru_u.
	Intros u0 v0 A dans_couple_Ru inmon_cons_A_v0.
	Apply Derive1.
	Cut (<Elt>(couple S (word (cons S1 nil)))=(couple A (word u0)))\/
		(dans (couple A (word u0)) (add (couple S (word (cons S2 nil)))
						(union R1 R2))).(**)
	Intro temp; Elim temp; Clear temp.
	Intro egal_S.
	Absurd (dans S X)\/(dans S V1).
	Red.
	Intro temp;Elim temp;Clear temp.
	Exact N_dans_X.
	Exact N_dans_V1.
	Apply dans_union.
	Replace S with A.
	Prolog [inmonoid_cons_inv2] 2.
	(*Apply inmonoid_cons_inv2 with v0;Assumption.*)
	Injection egal_S; Auto.

	Intro dans_couple_add.
	Cut (<Elt>(couple S (word (cons S2 nil)))=(couple A (word u0)))\/
		(dans (couple A (word u0)) (union R1 R2)).(***)
	Intro temp; Elim temp; Clear temp.
	Intro egal_S.
	Absurd (dans S X)\/(dans S V1).
	Red.
	Intro temp;Elim temp ; Auto.

	Apply dans_union.
	Replace S with A.
	Prolog [inmonoid_cons_inv2] 2.
	(*Apply inmonoid_cons_inv2 with v0;Assumption.*)
	Injection egal_S;Auto.

	Intro dans_couple_union.	
	Cut (dans (couple A (word u0)) R1)
		\/(dans (couple A (word u0)) R2).(****)
	(*Intuition.*)Intro temp; Elim temp; Clear temp.
		Auto.
		Intro dans_R2.
		Absurd (inter (union X V1) V2 empty).
			Red.
			Unfold inter.
			(*Intuition.*)Intro temp ; Elim temp ; Clear temp.
				      Intros HH temp ; Elim temp ; Clear temp ;
				      Intros HHH HHHH.
			(*Intros.*)
			Prolog
			  [Regles_inv1 inmonoid_cons_inv2 dans_empty_imp_P] 4.
			(*Intro temp;Elim temp;Clear temp.
			Intros incl_empty_X_V1 temp;Elim temp;Clear temp.
			Intros incl_empty_V2 imp.

			Apply dans_empty_imp_P with A.
			Apply imp.
				Apply inmonoid_cons_inv2 with v0;Assumption.
				Apply Regles_inv1 with X R2 (word u0);
						Assumption.*)
		Assumption.

	(****)Auto.

	(***)Auto.

	(**)Auto.

	Prolog [inmonoid_cons_inv Derive2 ] 10.
	(*Intros u0 v0 x Der_Ru imp inmon_cons_x_u0.
	Apply Derive2.
	Apply imp.
	Apply inmonoid_cons_inv with x.
	Assumption.*)
Save.

Lemma inmon_Der_imp_inmon_R1_d : (u,v:Word)(Regles X V1 R1)->(Derive R1 u v)
  ->(inmonoid (union X V1) u)->(inmonoid (union X V1) v).
Prolog [in_mon_X_Der_imp_inmon_X] 7.
(*Intros.
Apply in_mon_X_Der_imp_inmon_X with R1 u;Assumption.*)
Save.

Lemma inmon_Der_imp_inmon_d :  ~(dans S X)->~(dans S V1)->~(dans S V2)
  ->(u,v:Word)(isGram X V1 R1 S1)->(isGram X V2 R2 S2)
  ->(inter V1 V2 empty)
  ->(inmonoid (union X V1) u)->(Derive Ru u v)->(inmonoid (union X V1) v).
Prolog [isGram2 isGram4 inter_union inmon_Der_imp_Der_d
	inmon_Der_imp_inmon_R1_d] 15.
(*Intros N_dans_X N_dans_V1 N_dans_V2 u v G_R1 G_R2 inter_V1_V2_empty inmon_X_V1_u Der_Ru_u_v.
Apply inmon_Der_imp_inmon_R1_d with u.
	Apply isGram4 with S1;Assumption.

		Apply inmon_Der_imp_Der_d.

		Assumption.

		Assumption.

		Assumption.

		Apply isGram4 with S1;Assumption.

		Apply isGram4 with S2;Assumption.

		Apply inter_union.
			Apply isGram2 with R2 S2; Assumption.
			Assumption.

		Assumption.

		Assumption.

	Assumption.*)
Save.

Lemma Gunion_disj_Derivestar : ~(dans S X)->~(dans S V1)->~(dans S V2)
  ->(isGram X V1 R1 S1)->(isGram X V2 R2 S2)
  ->(inter V1 V2 empty)->(u,v:Word)(Derivestar Ru u v)
  ->(inmonoid (union X V1) u)->(Derivestar R1 u v).
Unfold Derivestar .
Intros N_dans_X N_dans_V1 N_dans_V2 G_1 G_2 inter_V1_V2_empty u v Derivestar_Ru .
Pattern u v.
Apply Derivestar_Ru.
	Auto.

	Intros u0 v0 w Der_Ru inmon_v0_imp_Rstar_R1_v0 inmon_u0. 
	Apply Rstar_R with v0 ; Prolog [isGram2 inter_union isGram4 inmon_Der_imp_Der_d  inmon_Der_imp_inmon_d ] 4.
	(*Apply Rstar_R with v0
		inmon_v0_imp_Rstar_R1_v0 inmon_Der_imp_inmon_d.
		Apply inmon_Der_imp_Der_d.
			Assumption.
			Assumption.
			Assumption.
			Apply isGram4 with S1;Assumption.
			Apply isGram4 with S2;Assumption.
			Apply inter_union.
				Apply isGram2 with R2 S2; Assumption.
				Assumption.
			Assumption.
			Assumption.

		Apply inmon_v0_imp_Rstar_R1_v0.
		Apply inmon_Der_imp_inmon_d with u0;Assumption.*)
Save.

Lemma inmon_Der_imp_Der_d2 : ~(dans S X)->~(dans S V1)->~(dans S V2)
  ->(Regles X V1 R1)->(Regles X V2 R2)->(inter (union X V2) V1 empty)
  ->(u,v:Word)(Derive Ru u v)->(inmonoid (union X V2) u)->(Derive R2 u v).
Intros N_dans_X N_dans_V1 N_dans_V2 Re_1 Re_2 inter_X_V2_V1_empty u v Der_Ru_u.
Elim Der_Ru_u.
	Intros u0 v0 A dans_couple_Ru inmon_cons_A_v0.
	Apply Derive1.
	Cut (<Elt>(couple S (word (cons S1 nil)))=(couple A (word u0)))\/
		(dans (couple A (word u0)) (add (couple S (word (cons S2 nil)))
						(union R1 R2))).(**)
	Intro temp; Elim temp; Clear temp.
	Intro egal_S.
	Absurd (dans S X)\/(dans S V2).
	Red.
	Intuition.
	Apply dans_union.
	Replace S with A.
	Prolog [inmonoid_cons_inv2] 2.
	(*Apply inmonoid_cons_inv2 with v0;Assumption.*)
	Injection egal_S;Auto.

	Intro dans_couple_add.
	Cut (<Elt>(couple S (word (cons S2 nil)))=(couple A (word u0)))\/
		(dans (couple A (word u0)) (union R1 R2)).(***)
	Intro temp; Elim temp; Clear temp.
	Intro egal_S.
	Absurd (dans S X)\/(dans S V2).
	Red.
	Intuition.
	Apply dans_union.
	Replace S with A.
	Prolog [inmonoid_cons_inv2] 2.
	(*Apply inmonoid_cons_inv2 with v0;Assumption.*)
	Injection egal_S ; Auto.

	Intro dans_couple_union.	
	Cut (dans (couple A (word u0)) R1)
		\/(dans (couple A (word u0)) R2).(****)
	(*Intuition.*) Intro temp ; Elim temp ; Clear temp.
		Intro dans_R1 .
		Absurd (inter (union X V2) V1 empty).
			Red.
			Unfold inter.
			(*Intuition.*) Intro temp ; Elim temp ; Clear temp.
				 Intros inc_empt temp ; Elim temp ; Clear temp.
			Intros incl_empty_V1 imp_dans_empty.
			Apply dans_empty_imp_P with A.
			Apply imp_dans_empty ;
				Prolog [Regles_inv1 inmonoid_cons_inv2] 4.
			(*Intro temp;Elim temp;Clear temp.
			Intros incl_empty_X_V2 temp;Elim temp;Clear temp.
			Intros incl_empty_V1 imp.
			Apply dans_empty_imp_P with A.
			Apply imp.
				Apply inmonoid_cons_inv2 with v0;Assumption.
				Apply Regles_inv1 with X R1 (word u0);
						Assumption.*)

		Assumption.


		Trivial.
		
	(****)Auto.

	(***)Auto.

	(**)Auto.

	Prolog [ inmonoid_cons_inv Derive2 ] 10.
	(*Intros u0 v0 x Der_Ru imp inmon_cons_x_u0.
	Apply Derive2.
	Apply imp.
	Apply inmonoid_cons_inv with x.
	Assumption.*)
Save.

Lemma inmon_Der_imp_inmon_R2_d : (u,v:Word)(Regles X V2 R2)->(Derive R2 u v)
  ->(inmonoid (union X V2) u)->(inmonoid (union X V2) v).
Prolog [in_mon_X_Der_imp_inmon_X] 10.
(*Intros.
Apply in_mon_X_Der_imp_inmon_X with R2 u;Assumption.*)
Save.


Lemma inmon_Der_imp_inmon_d2 :  ~(dans S X)->~(dans S V1)->~(dans S V2)
  ->(u,v:Word)(isGram X V1 R1 S1)->(isGram X V2 R2 S2)
  ->(inter V1 V2 empty)
  ->(inmonoid (union X V2) u)->(Derive Ru u v)->(inmonoid (union X V2) v).
Prolog [ sym_inter isGram2 inter_union isGram4 inmon_Der_imp_Der_d2 inmon_Der_imp_inmon_R2_d] 15.
(*Intros N_dans_X N_dans_V1 N_dans_V2 u v G_R1 G_R2 inter_V1_V2_empty inmon_X_V2_u Der_Ru_u_v.
Apply inmon_Der_imp_inmon_R2_d with u.
 	Apply isGram4 with S2;Assumption.

	Apply inmon_Der_imp_Der_d2.

		Assumption.

		Assumption.

		Assumption.

		Apply isGram4 with S1;Assumption.

		Apply isGram4 with S2;Assumption.

		Apply inter_union.
			Apply isGram2 with R1 S1; Assumption.
			Apply sym_inter;Assumption.

		Assumption.

		Assumption.

	Assumption.*)
Save.

Lemma Gunion_disj_Derivestar2 : ~(dans S X)->~(dans S V1)->~(dans S V2)
  ->(isGram X V1 R1 S1)->(isGram X V2 R2 S2)
  ->(inter V1 V2 empty)->(u,v:Word)(Derivestar Ru u v)
  ->(inmonoid (union X V2) u)->(Derivestar R2 u v).
Unfold Derivestar .
Intros N_dans_X N_dans_V1 N_dans_V2 G_1 G_2 inter_V1_V2_empty u v Derivestar_Ru .
Pattern u v.
Apply Derivestar_Ru.
	Auto.

	Intros u0 v0 w Der_Ru inmon_v0_imp_Rstar_R2_v0 inmon_u0. 
	Apply Rstar_R with v0.
		Prolog [ sym_inter isGram2 inter_union isGram4 inmon_Der_imp_Der_d2 ] 4.
		(*Apply inmon_Der_imp_Der_d2.
			Assumption.
			Assumption.
			Assumption.
			Apply isGram4 with S1;Assumption.
			Apply isGram4 with S2;Assumption.
			Apply inter_union.
				Apply isGram2 with R1 S1; Assumption.
				Apply sym_inter;Assumption.
			Assumption.
			Assumption.*)

		Prolog [inmon_Der_imp_inmon_d2] 3.
		(*Apply inmon_v0_imp_Rstar_R2_v0.
		Apply inmon_Der_imp_inmon_d2 with u0;Assumption.*)
Save.


Lemma Gunion_disj_Derive1 : ~(dans S X)->~(dans S V1)->~(dans S V2)
  ->(isGram X V1 R1 S1)->(isGram X V2 R2 S2)
  ->(u:Word)(Derive Ru (cons S nil) u)
  -><Word>(cons S1 nil)=u\/<Word>(cons S2 nil)=u.
Intros N_dans_X N_dans_V1 N_dans_V2 G_1 G_2 u Derive_Ru.
Cut (Derive_inv Ru (cons S nil) u).
Unfold Derive_inv.
Simpl.
Intro temp;Elim temp; Clear temp;Intro temp;Elim temp; Clear temp.

	Intros x dans_S_x_Ru temp.
	Elim temp;Clear temp.
	Intros x0 egal_S_x0_S_nil egal_Append_x_x0_u.
	Replace u with x.

	Cut (<Elt>(couple S (word (cons S1 nil)))=(couple S (word x)))\/
		(dans (couple S (word x)) (add (couple S (word (cons S2 nil)))
						(union R1 R2))).(**)
	Intro temp; Elim temp; Clear temp.
	Intro egal_S.
	Injection egal_S ; Auto.
	
	Intro dans_couple_add.
	Cut (<Elt>(couple S (word (cons S2 nil)))=(couple S (word x)))\/
		(dans (couple S (word x)) (union R1 R2)).(***)
	Intro temp; Elim temp; Clear temp.
	Intro egal_S.
	Injection egal_S ; Auto.
	
	Intro dans_couple_union.	
	Cut (dans (couple S (word x)) R1)
		\/(dans (couple S (word x)) R2).(****)
	Intro temp; Elim temp; Clear temp.
	Intro dans_R1.
	Absurd (dans S V1).
		Assumption.
		Prolog [isGram4 Regles_inv1] 3.
		(*Apply Regles_inv1 with X R1 (word x) .
			Apply isGram4 with S1;Assumption.
			Assumption.*)

	Intros dans_R2.
	Absurd (dans S V2).
		Assumption.
		Prolog [isGram4 Regles_inv1] 3.
		(*Apply Regles_inv1 with X R2 (word x) .
			Apply isGram4 with S2;Assumption.
			Assumption.*)

	(****)Auto.

	(***)Auto.

	(**)Auto.

Replace x with (Append x nil).
Replace nil with x0.
Assumption.
Apply cons_cons_inv2 with S S; Assumption.
Apply Append_w_nil.

Intros.
Cut (Derive_inv Ru nil x).
Unfold Derive_inv.
Simpl.
Tauto.
Auto.

Auto.
Save.

Hint Gunion_disj_Derive1.



Lemma Gunion_disj_Derivestar_S : ~(dans S X)->~(dans S V1)->~(dans S V2)
  ->(isGram X V1 R1 S1)->(isGram X V2 R2 S2)
  ->(inter V1 V2 empty)->(u:Word)(Derivestar Ru (cons S nil) u)
  ->(<Word>(cons S nil)=u)
     \/ (Derivestar R1 (cons S1 nil) u)
     \/ (Derivestar R2 (cons S2 nil) u).
Intros N_dans_X N_dans_V1 N_dans_V2 G_1 G_2 inter_V1_V2_empty u Derivestar_Ru .

Cut (<Word>(cons S nil)= u)\/(<Word>Ex2([w:Word](Derive Ru (cons S nil) w),[w:Word](Derivestar Ru w u))).(**)

Intro temp;Elim temp;Clear temp.
	Auto.

	Intro temp;Elim temp;Clear temp.
	Intros x Der_Ru_cons_S_nil_x Derivestar_Ru_x_u.
	Right.
	Cut <Word>(cons S1 nil)=x\/<Word>(cons S2 nil)=x.(***)

	Intro temp;Elim temp;Clear temp; Intro x_egal; Rewrite x_egal.
		Apply or_introl.	
		Apply Gunion_disj_Derivestar; [ Auto | Auto | Auto | Auto |
						Auto | Auto | Auto | Idtac].
			Rewrite <- x_egal; Cut (dans S1 V1).
						Auto.
						Prolog [isGram3] 2.
						(*Apply isGram3 with X R1.
						Assumption.*)

		Apply or_intror.	
		Apply Gunion_disj_Derivestar2; [Auto|Auto|Auto|Auto|
						Auto|Auto|Auto|Idtac].
			Rewrite <- x_egal; Cut (dans S2 V2).
						Auto.
						Prolog [isGram3] 2.
						(*Apply isGram3 with X R2.
						Assumption.*)

	(***)Auto.
	
(**)Auto.
Save.

Hint Gunion_disj_Derivestar_S.


Lemma Gunion_disj_LG_inclus1 : ~(dans S X)->~(dans S V1)->~(dans S V2)
  ->(isGram X V1 R1 S1)->(isGram X V2 R2 S2)
  ->(inter V1 V2 empty)
  ->(l_inclus (LG X Vu Ru S)
			(lunion (LG X V1 R1 S1)
				(LG X V2 R2 S2))
			).
Intros N_dans_X N_dans_V1 N_dans_V2 G_1 G_2 inter_V1_V2_empty.
Red.
Unfold LG.
Intros w temp;Elim temp;Clear temp; Intros Der_Ru inmonoid_X_w.
Unfold lunion.
ElimType (<Word>(cons S nil)=w)\/(Derivestar R1 (cons S1 nil) w)\/(Derivestar R2 (cons S2 nil) w).(**)
	Intro eg_cons_S_nil_w.
	Absurd (dans S X).
		Assumption.
		Apply inmonoid_cons_inv2 with nil.
		Rewrite eg_cons_S_nil_w;Assumption.

	Intro temp;Elim temp;Clear temp;Auto.

(**)Auto.
Save.

Lemma Gunion_disj_LG_inclus2 : (l_inclus (LG X V1 R1 S1) (LG X Vu Ru S)).
Red.
Unfold LG.
Intros w temp;Elim temp;Clear temp.
Intros Der_Ru inmonoid_X_w.
Unfold Ru; Simpl.
Split.
	Apply Derivestar_R with (cons S1 nil).
		Replace (cons S1 nil) with (Append (cons S1 nil) nil).
			Auto.
			
			Auto.

		Apply Derivestar_inclus with R1;Auto.

Assumption.
Save.


Lemma Gunion_disj_LG_inclus3 : (l_inclus (LG X V2 R2 S2) (LG X Vu Ru S)).
Red.
Unfold LG.
Intros w temp;Elim temp;Clear temp.
Intros Der_Ru inmonoid_X_w.
Unfold Ru; Simpl.
Split.
	Apply Derivestar_R with (cons S2 nil).
		Replace (cons S2 nil) with (Append (cons S2 nil) nil).
			Auto.
			
			Auto.

		Apply Derivestar_inclus with R2;Auto.

Assumption.
Save.


Lemma Gunion_disj_LG_inclus4 : (l_inclus (lunion (LG X V1 R1 S1)
						(LG X V2 R2 S2))

					(LG X Vu Ru S)).
Unfold l_inclus lunion.
Intros w temp;Elim temp;Clear temp;Intro LG_w.
Apply Gunion_disj_LG_inclus2;Assumption.
Apply Gunion_disj_LG_inclus3;Assumption.
Save.


Lemma Gunion_disj_LG :  ~(dans S X)->~(dans S V1)->~(dans S V2)
  ->(isGram X V1 R1 S1)->(isGram X V2 R2 S2)
  ->(inter V1 V2 empty)
  ->(l_egal (LG X Vu Ru S)
			(lunion (LG X V1 R1 S1)
				(LG X V2 R2 S2))
			).
Intros.
Unfold l_egal; Split.
Apply Gunion_disj_LG_inclus1; Assumption.
Exact Gunion_disj_LG_inclus4.
Save.

End gram4.

