(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 gram_g.v                                 *)
(****************************************************************************)
(*              Formal Language Theory                                      *)
(*                                                                          *)
(*              Judicael Courant - Jean-Christophe Filliatre                *)
(*                                                                          *)
(*              Developped in V5.8  June-July 1993                          *)
(*              Ported     to V5.10 October 1994                            *)
(****************************************************************************)

Require Ensf.
Require Words.
Require fonctions.
Require Relations.
Require gram.

Inductive Deriveg [X,R:Ensf] : Word-> Word -> Prop :=
Deriveg1 : (u,v:Word)(A:Elt)(dans (couple A (word u)) R) 
			-> (Deriveg X R (cons A v) (Append u v))

| Deriveg2  	: (u,v:Word)(x:Elt)(dans x X)->(Deriveg X R u v)
			->(Deriveg X R (cons x u) (cons x v))

.

Hint Deriveg1.
Hint Deriveg2.


Definition Derivegstar := [X,R:Ensf]
(Rstar Word (Deriveg X R)).

Lemma Deriveg_Derive : (X,R:Ensf)(u,v:Word)(Deriveg X R u v)->(Derive R u v).
Intros X R u v Der_g.
Elim Der_g.
Intros.
Apply Derive1;Auto.
Intros.
Apply Derive2;Auto.
Save.

Lemma Derivegstar_Derivestar : (X,R:Ensf)(u,v:Word)(Derivegstar X R u v)
  ->(Derivestar R u v).
Unfold Derivegstar Rstar Derivestar.
Intros X R x y Derivegstar_x_y.
Pattern x y.
Apply Derivegstar_x_y.
Intro. Apply Rstar_reflexive.
Intros u v w Der Der_star.
Apply Rstar_R with v.
Apply Deriveg_Derive with X;Assumption.
Assumption.
Save.

 


Axiom Derivestar_Derivegstar : (X,R:Ensf)(u,v:Word)(Derivestar R u v)
  ->(Derivegstar X R u v).

Hint Derivestar_Derivegstar.
