(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  need.v                                  *)
(****************************************************************************)
(*              Formal Language Theory                                      *)
(*                                                                          *)
(*              Judicael Courant - Jean-Christophe Filliatre                *)
(*                                                                          *)
(*              Developped in V5.8  June-July 1993                          *)
(*              Ported     to V5.10 October 1994                            *)
(****************************************************************************)

Require Ensf.
Require Words.
Require more_words.

Axiom Dans_spec : (a:Elt)(E:Ensf){(dans a E)}+{~(dans a E)}.

Definition Dans := [a:Elt][E:Ensf](<bool>Case (Dans_spec a E) of
			[a:(dans a E)]true
			[a:~(dans a E)]false
       					end).


Axiom Append_Append : (a,a',b,b':Word)(Append a b)=(Append a' b')->
(Ex [w:Word]((a=(Append a' w)/\b'=(Append w b))
		\/(a'=(Append a w)/\b=(Append w b')))).


Axiom inmonoid_Append_inv2 : (X:Ensf)(a,b:Word)(inmonoid X (Append a b))->(inmonoid X b).


Hint dans_add.
