(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              July 1st 1995                               *)
(*                                                                          *)
(****************************************************************************)
(****************************************************************)
(*	  	Proof of a multiplier circuit			*)
(*	  	C. Paulin-Mohring, June 95			*)
(****************************************************************)
(*	  	GFP.v						*)
(*	  	Greatest Fixed point of monotonic operators	*)
(****************************************************************)

Section Greatest_Fixpoints.

Variable F : Set -> Set.

Variable FMON : (X,Y:Set)(X->Y) -> (F X) -> (F Y).
Syntactic Definition Fmon := (FMON ? ?).

Inductive nu : Set := CoIt : (X:Set)(X -> (F X)) -> X -> nu.

Definition Out : nu->(F nu) 
  := [m:nu]<(F nu)>Case m of [X:Set][f:X->(F X)][x:X](Fmon (CoIt X f) (f x)) end.

Definition In : (F nu)->nu 
  := [x:(F nu)](CoIt (F nu) (Fmon Out) x).

Definition CoRec : (X:Set)(X->(F (nu+X)))->X->nu 
  := [X:Set][f:X->(F (nu+X))][x:X]
     (CoIt (nu+X) 
           [z:nu+X]<(F (nu+X))>Case z of [n:nu](Fmon (inl nu X) (Out n))
                                         [y:X](f y) 
                               end
           (inr nu X x)).

End Greatest_Fixpoints.
