
-- A minimal interfase developed by hand.

-- An ad-hoc parser

pofs "SF\n" = (Renpair Fail    (Left  Here))
pofs "RF\n" = (Renpair Fail    (Right Here))
pofs "ST\n" = (Renpair Succeed (Left  Here))
pofs "RT\n" = (Renpair Succeed (Right Here))
pofs   x    =  error ("This is not a valid pointer! :"++x)

parser s = 
 let {(x,y)   = (splitAt 3 s)}
 in Cons (pofs x) (parser y)

-- A pretty printer of messages 

printer (Evolve _ _ w t) = 
  "The following message is heard: "++(primPrint 0 w ("\n"++(printer t)))

printer (Refuse _ t)    = 
  "The process refuses to talk (may be you have entered a wrong pointer).\n"++(printer t)

-- The interactive program

interaction  :: Dialogue
interaction  ~(read:s)  = [ReadChan stdin, AppendChan stdout result]
 where result = case read of 
      Str  contents -> (printer  (simulator example (parser contents)))
      Failure _         -> "Can't open stdin"

