(***************************************************************************)
(* File: axs_fundation.v                                                   *)
(* auteur: alex@sysal.ibp.fr                                               *)
(* date: 19/10/95                                                          *)
(***************************************************************************)
Require Export axs_choice.

Axiom axs_vide_or_not :
  (x:E)((x=Vide) \/ ~(x=Vide))
.

Axiom axs_fundation :
  (x:E)(~(x=Vide) -> (Ex[y:E]((In y x) /\ (inter y x) = Vide)))
.
(***************************************************************************)
(* Un ensemble ne s'appartient pas.                                        *)
(***************************************************************************)
Lemma lem_sing_not_empty :
  (x:E)~((singleton x)=Vide)
.
(* Proof of lem_sing_not_empty                                             *)
(Unfold not;Intros).
(Unfold Vide in H;Generalize (lem_vide_propertie x var_vide);Rewrite <- H;Intros).
(Generalize (lem_x_in_sing_x x);Intros).
(Absurd (In x (singleton x));Auto).

Save.
(* End of proof of lem_sing_not_empty                                      *)

Lemma lem_x_not_in_x :
  (x:E)~(In x x)
.
(* Proof of lem_x_not_in_x                                                 *)
(Unfold not;Intros).
(Elim (axs_vide_or_not x);Intros).
(Generalize H;Clear  H;Rewrite -> H0;Clear H0;Intros).
(Generalize lem_not_vide_in_vide;Intros).
(Absurd (In Vide Vide);Auto).

Generalize (axs_fundation (singleton x) (lem_sing_not_empty x));Intros.
Elim H1;Clear H1;Intros;Elim H1;Clear H1;Intros.
Elim (axs_paire x x x0);Intros;Generalize (H3 H1);Clear H1 H3 H4;Intros.
Generalize (lem_or_contract (eq ? x0 x) H1);Clear H1;Intros.
Generalize H2 ;Clear H2;Rewrite -> H1;Clear H1;Intros.
Cut (In x (inter x (singleton x)));Intros.
Generalize H1;Clear H1;Rewrite -> H2;Unfold Vide;Intros.
Generalize (lem_vide_propertie x var_vide);Intros.
Absurd (In x (vide var_vide));Auto.

Unfold inter;Unfold def_F_inter.
Elim (axs_comprehension [x0:E](In x0 (singleton x)) x x);Intros;Apply H3;Clear H1 H3;Intros.
Split;[Auto|Apply lem_x_in_sing_x].

Save.
(* End of proof of lem_x_not_in_x                                          *)

(***************************************************************************)
(* Une propriete sur les intersections vides                               *)
(***************************************************************************)
Lemma lem_inter_is_empty :
  (a,b:E)
  ((x:E)(In x a)->~(In x b))
  ->
  ((y:E)(In y b)->~(In y a))
  ->
  (inter a b)=Vide
.
(* Proof of lem_inter_is_empty                                             *)
Intros.
(Apply lem_x_inc_vide;Unfold inc;Intros).
Unfold inter in H1.
Unfold def_F_inter in H1.
(Elim (axs_comprehension [x:E](In x b) a v0);Intros;Generalize (H2 H1);Clear H1 H2 H3;Intros).
(Elim H1;Clear H1;Intros).
(Generalize (H v0 H1) (H0 v0 H2);Clear H H0;Intros).
(Absurd (In v0 a);Auto).

Save.
(* End of proof of lem_inter_is_empty                                      *)
(***************************************************************************)
