(***************************************************************************)
(* File: axs_parties.v                                                     *)
(* auteur: alex@sysal.ibp.fr                                               *)
(* date: 19/10/95                                                          *)
(***************************************************************************)
Require Export axs_reunion.

(***************************************************************************)
(* Axiome des parties                                                      *)
(***************************************************************************)
Variable parties : E->E.
Axiom axs_parties :
  (v0:E)(v2:E)(
    (In v2 (parties v0)) 
    <-> 
    (v3:E)((In v3 v2)->(In v3 v0)))
.

(***************************************************************************)
(* La reunion des parties de x est x                                       *)
(***************************************************************************)
Lemma lem_reunion_parties :
  (x:E)(reunion (parties x))=x
.
(* Proof of lem_reunion_parties                                            *)
(Intros;Apply axs_extensionnalite;Intros;Unfold iff;Split;Intros).
(Elim (axs_reunion (parties x) v2);Intros;Generalize (H0 H);Clear H H0 H1;Intros).
(Elim H;Clear H;Intros;Elim H;Clear H;Intros).
(Elim (axs_parties x x0);Intros;Generalize (H1 H);Clear H1 H2;Intros).
Exact (H1 v2 H0).

(Elim (axs_reunion (parties x) v2);Intros;Apply H1;Clear H0 H1;Intros).
(Exists (singleton v2);Split;[Idtac|Apply lem_x_in_sing_x]).
(Elim (axs_parties x (singleton v2));Intros;Apply H1;Clear H0 H1;Intros).
Unfold singleton in H0.
(Elim (axs_paire v2 v2 v3);Intros;Generalize (H1 H0);Clear H1 H2;Intros).
(Elim H1;Clear H1;Intros;Rewrite -> H1;Auto).

Save.
(* End of proof of lem_reunion_parties                                     *)
(***************************************************************************)
(*                   Next : axs_comprehension.v                            *)
(***************************************************************************)
