(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                            Nat_complements.v                             *)
(****************************************************************************)
Require Arith.
Require Compare_dec.

(****************)
Lemma eq_gt_O_dec: (n: nat) {n = O}+{gt n O}.

Destruct n; Auto.
Save.

(****************)
Lemma mult_commut: (n, m: nat)  (mult n m) = (mult m n).

Intros; Elim n; Simpl.
Auto.
Intros; Rewrite H; Elim mult_n_Sm; Auto.
Save.

(***************)
Lemma mult_neutr: (n: nat) (mult (S O) n) = n.

Unfold mult; Auto.
Save.

(********************)
Lemma technical_lemma: (y, m: nat) 
   (S (plus (plus (mult y m) (plus y m)) m)) = 
        (plus (mult (S y) m) (plus (S y) m)).

Intros; Simpl; Elim (plus_sym m (plus (mult y m) (plus y m))).
Rewrite (plus_assoc_l m (mult y m) (plus y m)); Auto.
Save.

(**************)
Lemma lt_minus2: (n, m: nat) (lt n m) -> (lt O (minus m n)).
Induction 1; Intros; Elim minus_Sn_m; Auto.
Save.

(***************)
Lemma minus_n_Sm: 
  (n, m: nat) (lt m n) ->  (pred (minus n m)) = (minus n (S m)).

Induction 1; Intros; Elim minus_Sn_m; Auto.
Save.

(************)
Lemma lt_succ: (n, m: nat) (le n (S m)) -> {le n m}+{n = (S m)}.

Intros; Elim (le_lt_eq_dec n (S m) H); Auto.
Save.
