(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  misc.v                                  *)
(****************************************************************************)
Require Lci.

(****************)
Definition antisym := [A: Set] [R: A -> A -> Prop] 
  (x, y: A) (R x y) -> (R y x) -> <A> x = y.

(********************)
Lemma pi1: (A: Set) (P: A -> Prop) {x: A | (P x)} -> A.

Goal.
Induction 1; Auto.
Save.
Transparent pi1.

(********************)
Lemma pi2:  (A: Set) (P: A -> Prop) (p: {x: A | (P x)}) (P (pi1 A P p)).

Goal.
Induction p; Unfold pi1; Trivial.
Save.

(*******************)
Definition inversible := [S: Set] [Mult: S -> S -> S] [I, x: S]
  (Ex ([y: S] ((Mult x y) = I) /\ ((Mult y x) = I))).

(************)
Lemma inv_com: (S: Set) (Mult: S -> S -> S) (I, x: S)
  (commutativity S Mult) -> (Ex ([y: S] ((Mult x y) = I))) -> 
  (inversible S Mult I x).

Goal.
Intros; Unfold inversible.
Elim H0; Intros.
Exists x0.
Split. 
Assumption.
Elim (H x x0); Assumption.
Save.  
