(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  Test.v                                  *)
(****************************************************************************)

(* Arithmetic tests *)

Require Arith.

(* Pattern-matching lemmas for comparing 2 naturals 
   Similar to lemmas in Compare_dec *)

Lemma test : (n,m:nat){le n m}+{gt n m}.
Proof.
Induction n; Induction m; Simpl; Auto.
Intros m' H'; Elim (H m'); Auto.
Qed.
Transparent test.

Lemma le_lt : (n,m:nat)(le n m)->{lt n m}+{n=m}.
Proof.
Induction n; Induction m; Simpl; Auto.
Intros m' H1 H2; Elim (H m'); Auto.
Qed.
Transparent le_lt.

Lemma compare : (n,m:nat){lt n m}+{n=m}+{gt n m}.
Proof.
Intros n m; Elim (test n m); Auto.
Left; Apply le_lt; Trivial.
Qed.
Transparent compare.
Transparent le_lt.


