(****************************************************************************)
(*                                                                          *)
(*                                                                          *)
(*  Absz.v                                                                  *)
(*                                                                          *)
(*  Definition of the absolute value on integers                            *)
(*                                                                          *)
(*                                                                          *)
(*  Samuel Boutin                                                           *)
(*  Coq V5.10                                                               *)
(*  June  1995                                                              *)
(*                                                                          *)
(*                                                                          *)
(****************************************************************************)
(*                               Absz.v                                     *)
(****************************************************************************)



(*
coq -I $COQ/theories/INIT -I "$QUO/Tactics/ML_struct" -I "$QUO/Tactics/AC" -I "$QUO/Tactics/HS" -I "$REA/NATURALS" -I "$REA/INTEGERS" -I "$REA/UTIL" -I "$REA/RATIONALS"  -I "$REA/SUBSETS" -I "$REA/ORDERING" -I "$REA/QUOTIENTS"

coqc  -I $COQ/theories/INIT -I "$QUO/Tactics/ML_struct" -I "$QUO/Tactics/AC" -I "$QUO/Tactics/HS" -I "$REA/NATURALS" -I "$REA/QUOTIENTS" -I "$REA/INTEGERS" -I "$REA/UTIL" -I "$REA/RATIONALS"  -I "$REA/SUBSETS" Absz
*)


Require quotient.
Require Arith.

Section AbsZ.

Require integer.
Require Int_in_com.

Lemma ABSZ : (z:Z)Z.

Intro z.
Elim (Constructive_Z_partition z).
Induction 1.
Intro.
Exact (unary_minus z).
Intro.
Exact z.
Intro.
Exact z.
Save.

(* On a construit le terme:

ABSZ_O < Print ABSZ.
ABSZ =
[z:Z]
 (sumor_rec {(leZ z |((O,(S O)))|)}+{z=|((O,O))|} (leZ |(((S O),O))| z)
   [_:({(leZ z |((O,(S O)))|)}+{z=|((O,O))|})+{(leZ |(((S O),O))| z)}]Z
   [y:{(leZ z |((O,(S O)))|)}+{z=|((O,O))|}]
    (sumbool_rec (leZ z |((O,(S O)))|) z=|((O,O))|
      [_:{(leZ z |((O,(S O)))|)}+{z=|((O,O))|}]Z
      [_:(leZ z |((O,(S O)))|)](unary_minus z) [_:z=|((O,O))|]z y)
   [_:(leZ |(((S O),O))| z)]z (Constructive_Z_partition z))
     : Z->Z

Rappel:


( Syntax sumbool "{_}+{_}". )
Inductive sumbool [A,B:Prop] : Set
    := left  : A -> ({A}+{B}) 
     | right : B -> ({A}+{B}).

*)

Lemma ABSZ_neg: (z:Z)[|z <= - 1 |]-> (ABSZ z) = (unary_minus z).

Intros.
Elim (z_lt_O z H).
Intros.
Transparent ABSZ.
Unfold ABSZ.
Rewrite -> H0;Simpl.
Auto.
Save.

Lemma ABSZ_O : (z:Z)[| z  = 0  |]->(ABSZ z) = z. 

Intros.
Elim (z_eq_O z H).
Intros.
Transparent ABSZ.
Unfold ABSZ.
Rewrite -> H0;Simpl.
Auto.
Save.


Lemma ABSZ_pos: (z:Z) [| 1 <= z |] -> (ABSZ z) = z.

Intros.
Elim (O_lt_z z H).
Intros.
Transparent ABSZ.
Unfold ABSZ.
Rewrite -> H0;Simpl.
Auto.
Save.

End AbsZ.