(****************************************************************************)
(*                                                                          *)
(*                                                                          *)
(*  Rat_in_com.v                                                            *)
(*                                                                          *)
(*  To define rational arithmetic we need integers and rational numbers     *)
(*  In this file we discribe how to use rational and integer entries in     *)
(*  the grammar of commands (see NATURALS/NATSYNTAX.v for more comments     *)
(*                                                                          *)
(*  Samuel Boutin                                                           *)
(*  Coq V5.10                                                               *)
(*  June  1995                                                              *)
(*                                                                          *)
(*                                                                          *)
(****************************************************************************)
(*                            Rat_in_com.v                                  *)
(****************************************************************************)



(*
coqc  -I $COQ/theories/INIT -I "$QUO/Tactics/ML_struct" -I "$QUO/Tactics/AC" -I "$QUO/Tactics/HS" -I "$REA/NATURALS" -I "$REA/QUOTIENTS" -I "$REA/INTEGERS" -I "$REA/UTIL" -I "$REA/RATIONALS"  -I "$REA/SUBSETS" -I "$REA/ORDERING" Rat_in_com
*)
Require subsetSyntax.
Require productSyntax.
Require intSyntax.

Require NATSYNTAX.
Require INTSYNTAX.
Require RATSYNTAX.

Grammar command command0 :=
[ "[" "|" rational:formula($c)"|" "]" ] -> [ $0 = $c ].

Token "!".

Grammar command command0 :=
[ "[" "!" integer:formula($c) "!" "]" ] -> [ $0 = $c ].




