(****************************************************************************)
(*                                                                          *)
(*                                                                          *)
(*  Z_to_Q.v                                                                *)
(*                                                                          *)
(*  Details of the coercion between integers and rationals                  *)
(*                                                                          *)
(*                                                                          *)
(*  Samuel Boutin                                                           *)
(*  Coq V5.10                                                               *)
(*  June  1995                                                              *)
(*                                                                          *)
(*                                                                          *)
(****************************************************************************)
(*                              Z_to_Q.v                                    *)
(****************************************************************************)



(*
coq -I $COQ/theories/INIT -I "$QUO/Tactics/ML_struct" -I "$QUO/Tactics/AC" -I "$QUO/Tactics/HS" -I "$REA/NATURALS" -I "$REA/INTEGERS" -I "$REA/UTIL" -I "$REA/RATIONALS"  -I "$REA/SUBSETS" -I "$REA/ORDERING" -I "$REA/QUOTIENTS"

coqc  -I $COQ/theories/INIT -I "$QUO/Tactics/ML_struct" -I "$QUO/Tactics/AC" -I "$QUO/Tactics/HS" -I "$REA/NATURALS" -I "$REA/QUOTIENTS" -I "$REA/INTEGERS" -I "$REA/UTIL" -I "$REA/RATIONALS"  -I "$REA/SUBSETS" -I "$REA/ORDERING" Z_to_Q
*)


Require quotient.
Require subset.
Require HS.
Require AC.
Require RATIONAL.

Section Integers_are_Rationals.

Require intnumbers.
Require ratSyntax.
Require productSyntax.
Require RATSYNTAX.
Require Rat_in_com.


Lemma one_is_a_denominator: [! 1 <= 1 !].

Red;Simpl.
Rewrite -> (Reduce_prop Z_typ Z_rel).
Red;Simpl.
Rewrite -> (Reduce_prop Z_typ Z_rel).
Red;Simpl.
Apply le_n;Auto.
Save.


Definition fromZ_to_Q : Z -> Q
                      := [x:Z]|(x,(%+ [! 1 !] one_is_a_denominator))|q.


End Integers_are_Rationals.
(*
Grammar rational final :=
[ "{" integer:expr($c) "}" ] -> [$0 = <<(fromZ_to_Q $c)>>].
*)