(****************************************************************************)
(*                                                                          *)
(*                                                                          *)
(*  minus.v                                                                 *)
(*                                                                          *)
(*  Unary and binaru minus operator on rational numbers                     *)
(*                                                                          *)
(*                                                                          *)
(*  Samuel Boutin                                                           *)
(*  Coq V5.10                                                               *)
(*  June  1995                                                              *)
(*                                                                          *)
(*                                                                          *)
(****************************************************************************)
(*                              minus.v                                     *)
(****************************************************************************)


(*
coq -I $COQ/theories/INIT -I "$QUO/Tactics/ML_struct" -I "$QUO/Tactics/AC" -I "$QUO/Tactics/HS" -I "$REA/NATURALS" -I "$REA/INTEGERS" -I "$REA/UTIL" -I "$REA/RATIONALS"  -I "$REA/SUBSETS" -I "$REA/ORDERING" -I "$REA/QUOTIENTS"

coqc  -I $COQ/theories/INIT -I "$QUO/Tactics/ML_struct" -I "$QUO/Tactics/AC" -I "$QUO/Tactics/HS" -I "$REA/NATURALS" -I "$REA/QUOTIENTS" -I "$REA/INTEGERS" -I "$REA/UTIL" -I "$REA/RATIONALS"  -I "$REA/SUBSETS" -I "$REA/ORDERING" minus
*)


Require quotient.
Require subset.
Require HS.
Require AC.
Require RATIONAL.

Section minus.

Require intnumbers.
Require ratSyntax.
Require productSyntax.
Require RATSYNTAX.
Require Int_in_com.

(*
(* TODO axiome `a supprimer  *)

Axiom sign_simpl : (x,y:Z) (x = y) -> [| -x = -y |].
Axiom mult_minus : (x,y:Z) [| (-x) * y = - (x * y) |].
*)


Definition unary_minusQ_XX := [x:Q_typ] 
     ([|- x.1 |],[| [x^2] |]).


Definition unary_minusQ_X : Q_typ -> Q
                    := [x:Q_typ] |(unary_minusQ_XX x)|q.

Lemma Compat_unary_minusQ_X: 
          (Compat Q_typ Q_rel Q unary_minusQ_X).

Red.
Unfold Q_rel.
Unfold unary_minusQ_X.
Unfold unary_minusQ_XX.
Intros.
Apply (From_R_to_L Q_typ Q_rel).
Red;Simpl.
Repeat Rewrite mult_minus.
Apply sign_simpl;Auto.
Save.


Definition unary_minusQ : Q -> Q
                := (lift Q_typ Q_rel Q unary_minusQ_X Compat_unary_minusQ_X).

End minus.

Section binary_minus.

Require PlusQ.

Require ratSyntax.
Require productSyntax.
Require RATSYNTAX.
Require Rat_in_com.


Definition binary_minusQ : Q -> Q -> Q
                        := [x,y:Q] [| x + [(unary_minusQ y)] |].

End binary_minus.
