(****************************************************************************)
(*                                                                          *)
(*                                                                          *)
(*  ratSyntax.v                                                             *)
(*                                                                          *)
(*  Syntax for quotients and subsets in the definition of rational numbers  *)
(*                                                                          *)
(*                                                                          *)
(*  Samuel Boutin                                                           *)
(*  Coq V5.10                                                               *)
(*  June  1995                                                              *)
(*                                                                          *)
(*                                                                          *)
(****************************************************************************)
(*                            ratSyntax.v                                   *)
(****************************************************************************)



Token "%+".
Token "%-".

Grammar command command1 := ["|" command0($c) "|" "q"] ->
                  [$0 = <<(In Q_typ Q_rel $c)>>].

Syntax constr In <<(In Q_typ Q_rel $c)>> 1 
                "|"  <$c : "representant" : L> "|q" .

Grammar command command1 := ["%+" command0($c1) command0($c2)] ->
                  [$0 = <<(In_subset Z Pos $c1 $c2)>>].

Syntax constr In_subQ <<(In_subset Z Pos $c1 $c2)>> 1 
                "%+" <$c1 : "representant" : L>  <$c2 : "representant" : L>.


Grammar command command1 := ["%-" command0($c)] ->
                  [$0 = <<(Out_subset Z Pos $c)>>].


Syntax constr Out_subQ <<(Out_subset Z Pos $c1)>> 1 
                "%-" <$c1 : "representant" : L>.
