(****************************************************************************)
(*                                                                          *)
(*                                                                          *)
(*  subsetSyntax.v                                                          *)
(*                                                                          *)
(*  Syntax for subsets                                                      *)
(*                                                                          *)
(*                                                                          *)
(*  Samuel Boutin                                                           *)
(*  Coq V5.10                                                               *)
(*  June  1995                                                              *)
(*                                                                          *)
(*                                                                          *)
(****************************************************************************)
(*                             subsetSyntax.v                               *)
(****************************************************************************)


Token "%+".
Token "%-".

Grammar command command1 := ["%+" command0($c)] ->
                  [$0 = <<(In_subset ? ? ? $c)>>].

Grammar command command1 := ["%-" command0($c)] ->
                  [$0 = <<(Out_subset ? ? $c)>>].

(* Notations for coercion *)

Syntax constr In_subset <<(In_subset $1 $2 $3 $c)>> 1 
                "%+"  <$c : "representant" : L>.

Syntax constr Out_subset <<(Out_subset $1 $2 $c)>> 1 
                "%-"  <$c : "representant" : L>.
