(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                             confluence_LSL.v                             *)
(****************************************************************************)

(*****************************************************************************)
(*          Projet Coq  - Calculus of Inductive Constructions V5.8           *)
(*****************************************************************************)
(*                                                                           *)
(*      Meta-theory of the explicit substitution calculus lambda-env         *)
(*      Amokrane Saibi                                                       *)
(*                                                                           *)
(*      September 1993                                                       *)
(*                                                                           *)
(*****************************************************************************)


                 (* Confluence du lambda-sigma-lift *)

Require TS.
Require sur_les_relations.
Require sigma_lift.
Require lambda_sigma_lift.
Require terminaison_SL.
Require conf_local_SL.
Require betapar.
Require SLstar_bpar_SLstar.
Require conf_strong_betapar.
Require commutation.
Require Newman.
Require Yokouchi.


Goal (b:wsort)(confluence (e_relSL b)).
Intros b.
Apply Newman.
Apply relSL_noetherian.
Apply conf_local_SL.
Save confluence_SL.

Goal (b:wsort)(strong_confluence (e_slstar_bp_slstar b)).
Intro b;Unfold slstar_bp_slstar.
Change (strong_confluence (Rstar_S_Rstar (TS b) (e_relSL b) (e_beta_par b))).
Apply Yokouchi.
Apply confluence_SL.
Apply relSL_noetherian.
Apply sconf_betapar.
Intros f g h H H0.
Unfold Rstar_S_Rstar.
Change (Ex( ([k:(TS b)](relSLstar g k) /\ (slstar_bp_slstar h k)))).
Apply commutation with f;Assumption.
Save strong_confluence_slbpsl.

Goal (b:wsort)(confluence (e_slstar_bp_slstar b)).
Intro b;Apply strong_conf_conf;Apply strong_confluence_slbpsl.
Save confluence_slbpsl.


(**********************************************)
(*        lambda-sigma-lift est confluent     *)
(**********************************************)

Theorem confluence_LSL: (b:wsort)(confluence (e_relLSL b)).
Goal.
Intro b;Apply inclus_conf with (e_slstar_bp_slstar b).
Apply relLSL_inclus_slbpsl.
Change (inclus (e_slstar_bp_slstar b) (e_relLSLstar b)).
Apply slbpsl_inclus_relLSLstar.
Apply confluence_slbpsl.
Save.



