(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              inversionSL.v                               *)
(****************************************************************************)

(*****************************************************************************)
(*                                                                           *)
(*      Meta-theory of the explicit substitution calculus lambda-env         *)
(*      Amokrane Saibi                                                       *)
(*                                                                           *)
(*      September 1993                                                       *)
(*                                                                           *)
(*****************************************************************************)


                       (* Inversion de sigma_lift (relSL) *)
Require sur_les_relations.
Require TS.
Require sigma_lift.


Definition e_invSL:=[b:wsort][M:(TS b)][N:(TS b)]
(<[b:wsort]Prop>Case M of
 (* var *) [n:nat] False
 (* app *) [M1,M2:terms]
           (<[b:wsort]Prop>Case N of
            (* var *) [n:nat]False
            (* app *) [N1,N2:terms]
                      ((relSL M1 N1) /\ (M2=N2)) 
                   \/ ((M1=N1) /\ (relSL M2 N2))
            (* lam *) [N1:terms]False 
            (* env *) [N1:terms][N2:sub_explicits]False
            (* id  *) False
            (*  |  *) False
            (*  .  *) [N1:terms][N2:sub_explicits]False
            (*  o  *) [N1,N2:sub_explicits]False
            (* ||  *) [N1:sub_explicits]False
            (*  X  *) [n:nat]False
            (*  x  *) [n:nat]False  end)
 (* lam *) [M1:terms]
           (<[b:wsort]Prop>Case N of
            (* var *) [n:nat]False
            (* app *) [N1,N2:terms]False 
            (* lam *) [N1:terms](relSL M1 N1)
            (* env *) [N1:terms][N2:sub_explicits]False
            (* id  *) False
            (*  |  *) False
            (*  .  *) [N1:terms][N2:sub_explicits]False
            (*  o  *) [N1,N2:sub_explicits]False
            (* ||  *) [N1:sub_explicits]False
            (*  X  *) [n:nat]False
            (*  x  *) [n:nat]False  end)
 (* env *) [M1:terms][M2:sub_explicits]
           (<[b:wsort]Prop>Case N of
            (* var *) [n:nat] 
                 (Ex( ([m:nat] (M1=(var m)) /\ (n=(S m)) /\ (M2=shift) )))
             \/  (Ex( ([s:sub_explicits] (M1=(var O)) /\
                                  (M2=(lift s)) /\ (n=O) )))
             \/  (Ex( ([s:sub_explicits] (M1=(var O)) /\
                            (M2=(cons (var n) s)) )))
             \/ ((M1=(var n)) /\ (M2=id))
            (* app *) [N1,N2:terms]
                (Ex( ([a:terms] (Ex( ([b:terms] (M1=(app a b))
                    /\ (N1=(env a M2)) /\ (N2=(env b M2)) ))) )))
             \/ (Ex( ([s:sub_explicits] (M1=(var O)) /\
                            (M2=(cons (app N1 N2) s)) )))
             \/ ((M1=(app N1 N2)) /\ (M2=id)) 
            (* lam *) [N1:terms]
                (Ex( ([a:terms] (M1=(lambda a))
                                 /\ (N1=(env a (lift M2))) )))
             \/ (Ex( ([s:sub_explicits] (M1=(var O)) /\
                            (M2=(cons (lambda N1) s)) )))
             \/ ((M1=(lambda N1)) /\ (M2=id) )
            (* env *) [N1:terms][N2:sub_explicits]
                (Ex( ([s:sub_explicits] (M1=(env N1 s)) /\
                            (N2=(comp s M2)) )))   
             \/ (Ex( ([n:nat] (M1=(var n)) /\
                       (M2=(comp shift N2)) /\ (N1=(var (S n))) )))
             \/ (Ex( ([s:sub_explicits] (M1=(var O)) /\
                               (M2=(cons (env N1 N2) s)) )))
             \/ (Ex( ([s:sub_explicits] (M1=(var O)) /\
                        (M2=(comp (lift s) N2)) /\ (N1=(var O)) )))
             \/ (Ex( ([n:nat] (Ex( ([a:terms] (M1=(var (S n))) /\
                        (M2=(cons a N2)) /\ (N1=(var n)) ))) )))
             \/ (Ex( ([n:nat] (Ex( ([s:sub_explicits]
                   (M1=(var (S n))) /\ (M2=(lift s)) /\
                   (N1=(var n)) /\ (N2=(comp s shift)) ))) )))
             \/ (Ex( ([n:nat] (Ex( ([s:sub_explicits]
                  (Ex( ([t:sub_explicits] (M1=(var (S n))) /\
                  (M2=(comp (lift s) t)) /\ (N1=(var n)) /\
                  (N2=(comp s (comp shift t))) ))) ))) )))
             \/ ((M1=(env N1 N2)) /\ (M2=id))                  
             \/ ((relSL M1 N1) /\ (M2=N2))
             \/ ((M1=N1) /\ (relSL M2 N2))
            (* id  *) False
            (*  |  *) False
            (*  .  *) [N1:terms][N2:sub_explicits]False
            (*  o  *) [N1,N2:sub_explicits]False
            (* ||  *) [N1:sub_explicits]False
            (*  X  *) [n:nat]
             (Ex( ([s:sub_explicits] (M1=(var O)) /\
                            (M2=(cons (meta_X n) s)) )))
             \/ ((M1=(meta_X n)) /\ (M2=id))
            (*  x  *) [n:nat]False  end)
 (* id  *) False
 (*  |  *) False 
 (*  .  *) [M1:terms][M2:sub_explicits]
           (<[b:wsort]Prop>Case N of
            (* var *) [n:nat]False
            (* app *) [N1,N2:terms]False 
            (* lam *) [N1:terms]False 
            (* env *) [N1:terms][N2:sub_explicits]False
            (* id  *) False
            (*  |  *) False
            (*  .  *) [N1:terms][N2:sub_explicits]
                      ((relSL M1 N1) /\ (M2=N2))
                      \/  ((M1=N1) /\ (relSL M2 N2))
            (*  o  *) [N1,N2:sub_explicits]False
            (* ||  *) [N1:sub_explicits]False
            (*  X  *) [n:nat]False
            (*  x  *) [n:nat]False  end)
 (*  o  *) [M1,M2:sub_explicits]
           (<[b:wsort]Prop>Case N of
            (* var *) [n:nat]False
            (* app *) [N1,N2:terms]False 
            (* lam *) [N1:terms]False
            (* env *) [N1:terms][N2:sub_explicits]False
            (* id  *) (Ex( ([a:terms] (M1=shift) /\
                           (M2=(cons a id)) )))
                   \/ ((M1=id) /\ (M2=id))
            (*  |  *) (Ex( ([a:terms] (M1=shift) /\
                        (M2=(cons a shift)) )))
                   \/ ((M1=id) /\ (M2=shift))
                   \/ ((M1=shift) /\ (M2=id))
            (*  .  *) [N1:terms][N2:sub_explicits]
                  (Ex( ([a:terms](Ex( ([s:sub_explicits]
                     (M1=(cons a s)) /\ (N1=(env a M2)) /\
                     (N2=(comp s M2)) ))) )))
               \/ (Ex( ([a:terms] (M1=shift) /\
                        (M2=(cons a (cons N1 N2))) )))
               \/ (Ex( ([s:sub_explicits]
                     (Ex( ([t:sub_explicits] (M1=(lift s)) /\ (M2=(cons N1 t)) 
                         /\ (N2=(comp s t)) ))) )))
               \/ ((M1=id) /\ (M2=(cons N1 N2)))
               \/ ((M1=(cons N1 N2)) /\ (M2=id))
            (*  o  *) [N1,N2:sub_explicits]
                 (Ex( ([t:sub_explicits]
                   (M1=(comp N1 t)) /\ (N2=(comp t M2)) )))
              \/ (Ex( ([a:terms] (M1=shift) /\ (M2=(cons a (comp N1 N2))) )))
              \/ ((M1=shift) /\ (M2=(lift N1)) /\ (N2=shift))
              \/ (Ex( ([t:sub_explicits] (M1=shift) /\
                   (M2=(comp (lift N1) t)) /\ (N2=(comp shift t)) )))
              \/ (Ex( ([s:sub_explicits] 
                 (Ex( ([t:sub_explicits] (M1=(lift s)) /\
                    (M2=(comp (lift t) N2)) /\ (N1=(lift (comp s t)))))))))
              \/ ((M1=id) /\ (M2=(comp N1 N2)))
              \/ ((M1=(comp N1 N2)) /\ (M2=id))
              \/ ((relSL M1 N1) /\ (M2=N2))
              \/ ((M1=N1) /\ (relSL M2 N2)) 
            (* ||  *) [N1:sub_explicits]
                 (Ex( ([a:terms] (M1=shift) /\ (M2=(cons a (lift N1))))))
              \/ (Ex( ([s:sub_explicits] 
                 (Ex( ([t:sub_explicits] (M1=(lift s)) /\
                 (M2=(lift t)) /\ (N1=(comp s t)) ))) )))
              \/ ((M1=id) /\ (M2=(lift N1)))
              \/ ((M1=(lift N1)) /\ (M2=id))
            (*  X  *) [n:nat]False
            (*  x  *) [n:nat] 
                 (Ex( ([a:terms] (M1=shift) /\ (M2=(cons a (meta_x n))))))
                   \/ ((M1=id) /\ (M2=(meta_x n)))
                   \/ ((M1=(meta_x n)) /\ (M2=id))  end)
 (* ||  *) [M1:sub_explicits]
           (<[b:wsort]Prop>Case N of
            (* var *) [n:nat]False
            (* app *) [N1,N2:terms]False 
            (* lam *) [N1:terms]False
            (* env *) [N1:terms][N2:sub_explicits]False
            (* id  *) (M1=id)
            (*  |  *) False
            (*  .  *) [N1:terms][N2:sub_explicits]False
            (*  o  *) [N1,N2:sub_explicits]False
            (* ||  *) [N1:sub_explicits](relSL M1 N1)
            (*  X  *) [n:nat]False
            (*  x  *) [n:nat]False end)
  (*  X  *) [n:nat]False
  (*  x  *) [n:nat]False  end). 


Syntactic Definition invSL := (e_invSL ?).
Syntax constr invSL <<(e_invSL $1 $t1 $t2)>> 10
  [<hov 0> "invSL " <$t1:"term":L> " " <$t2:"term":L>].


Goal (b:wsort)(M,N:(TS b))(systemSL M N)->(invSL M N).
Induction 1;Induction 1;Intros.
(* app *)
Simpl;Left;Exists a0;Exists b1;Auto.
(* lambda *)
Simpl;Left;Exists a0;Auto.
(* clos *)
Simpl;Left;Exists s;Auto.
(* varshift1 *)
Simpl;Left;Exists n;Auto.
(* varshift2 *)
Simpl;Right;Left;Exists n;Auto.
(* fvarcons *)
Pattern a0;Apply terms_ind;Intros;Simpl.
 (* var *)
Do 2 Right;Left;Exists s;Auto.
 (* app *)
Right;Left;Exists s;Auto.
 (* lam *)
Right;Left;Exists s;Auto.
 (* env *)
Do 2 Right;Left;Exists s;Auto.
 (* X *)
Left;Exists s;Auto.
(* fvarlift1 *)
Simpl;Right;Left;Exists s;Auto.
(* fvarlift2 *)
Simpl;Do 3 Right;Left;Exists s;Auto.
(* rvarcons *)
Simpl;Do 4 Right;Left;Exists n;Exists a0;Auto.
(* rvarlift1 *)
Simpl;Do 5 Right;Left;Exists n;Exists s;Auto.
(* rvarlift2 *)
Simpl;Do 6 Right;Left;Exists n;Exists s;Exists t;Auto.
(* assenv *)
Simpl;Left;Exists t0;Auto.
(* mapenv *)
Simpl;Left;Exists a;Exists s0;Auto.
(* shiftcons *)
Pattern s0;Apply sub_explicits_ind;Intros;Simpl.
 (* id *)
Left;Exists a;Auto.
 (* | *)
Left;Exists a;Auto.
 (* . *)
Right;Left;Exists a;Auto.
 (* o *)
Right;Left;Exists a;Auto.
 (* || *)
Left;Exists a;Auto.
 (* x *)
Left;Exists a;Auto.
(* shiftlift1 *)
Simpl;Do 2 Right;Left;Auto.
(* shiftlift2 *)
Simpl;Do 3 Right;Left;Exists t0;Auto.
(* lift1 *)
Simpl;Right;Left;Exists s0;Exists t0;Auto.
(* lift2 *)
Simpl;Do 4 Right;Left;Exists s0;Exists t0;Auto.
(* liftenv *)
Simpl;Right;Right;Left;Exists s0;Exists t0;Auto.
(* idl *)
Pattern s0;Apply sub_explicits_ind;Intros;Simpl.
 (* id *)
Right;Auto.
 (* | *)
Right;Left;Auto.
 (* . *)
Do 3 Right;Left;Auto.
 (* o *)
Do 5 Right;Left;Auto.
 (* || *)
Do 2 Right;Left;Auto.
 (* x *)
Right;Left;Auto.
(* idr *)
Pattern s0;Apply sub_explicits_ind;Intros;Simpl.
 (* id *)
Right;Auto.
 (* | *)
Right;Right;Auto.
 (* . *)
Do 4 Right;Auto.
 (* o *)
Do 6 Right;Left;Auto.
 (* || *)
Do 3 Right;Auto.
 (* x *)
Right;Right;Auto.
(* liftid *)
Simpl;Auto.
(* id *)
Pattern a0;Apply terms_ind;Intros;Simpl.
 (* var *)
Do 3 Right;Auto.
 (* app *)
Do 2 Right;Auto.
 (* lam *)
Do 2 Right;Auto.
 (* env *)
Do 7 Right;Left;Auto.
 (* X *)
Right;Auto.
Save lemma1_inv_systemSL.
Hint lemma1_inv_systemSL.

Goal (b:wsort)(M,N:(TS b))(relSL M N)->(invSL M N).
Induction 1;Intros;Simpl;Auto 11.
Save lemma1_invSL.
Hint lemma1_invSL.











