(****************************************************************************)
(* This contribution was updated for Coq V5.10 by the COQ workgroup.        *)
(* January 1995                                                             *)
(****************************************************************************)
(*                                  Fil.v                                   *)
(****************************************************************************)

Require Ensembles.
Require Relations_1.
Require podefs.
Require podefs_1.
Require ps.
Require Partial_order_facts.

Section First_inductive_lemmas.
   Variable U: Type.
   Variable B: (Ensemble U).
   Variable D: (PO U).
   
   Theorem Pairs_are_enough_finite_case :
        (Cpo U D) ->
              ((x: U) (y: U) (Compatible U D x y) ->
                (ExT [bsup: U] (Lub U D (Couple U x y) bsup))) ->
               (X: (Ensemble U))
               (Finite U X) ->
               (Included U X (Carrier_of U D)) ->
               ((ExT [maj: U] (Upper_Bound U D X maj))) ->
                (ExT [bsup: U] (Lub U D X bsup)).
   (Intros H' H'0 X H'1; Elim H'1); Auto.
   (Intros A H'2 H'3 x H'4 H'5 h; Elim h; Intros maj E; Clear h).
   (Generalize (Upper_downward_stable U D A (Union U (Singleton U x) A) maj);
     Intro h; LApply h;
     [Intro H'6; LApply H'6;
       [Intro H'7; LApply H'7;
         [Intro H'8; LApply H'8;
           [Intro H'9; Clear h H'6 H'7 H'8 | Clear h H'6 H'7; Try Assumption] |
           Clear h H'6] | Clear h] | Clear h]); Auto 10.
   (LApply H'3;
     [Intro H'6; LApply H'6;
       [Intro H'7; Clear H'3 H'6 | Exists maj; Clear H'3; Try Assumption] |
       Idtac]); Auto 10.
   (Elim H'7; Intros bsup E0; Clear H'7; Try Exact E0); Auto 10.
   (Generalize (H'0 x bsup); Intro h; LApply h;
     [Intro h0; Elim h0; Intros bsup0 E1; Clear h h0; Try Exact E1 | Clear h]);
    Clear H'0.
   (Exists bsup0; Apply Lub_definition); Auto 10.
   Elim E1; Intros H'3 H'6.
   Elim H'3; Intros H'7 H'8.
   Apply Upper_Bound_definition; Auto 10.
   (Intros y H'10; Elim H'10).
   (Intros x0 H'11; Elim H'11); Auto 10.
   Intros x0 H'11; Auto 10.
   Generalize Rel_of_transitive; Intro RoT; Red in RoT.
   Apply RoT with bsup; Auto.
   Elim E0.
   (Intro H'12; Elim H'12); Auto.
   Elim E1.
   Intros H'3 H'6 y H'7.
   Apply H'6.
   Elim H'7; Intros H'8 H'10.
   Apply Upper_Bound_definition; Auto.
   (Intros y0 H'11; Elim H'11); Auto 10.
   Elim H'7.
   Elim E0; Auto 10.
   Red.
   Elim H'9.
   (Intros H'0 H'3; Exists maj; Intros H'6 H'7; Split;
     [Idtac | Apply Upper_Bound_definition]); Auto 10.
   (Intros y H'10; Elim H'10); Auto 10.
   Elim E; Auto 10.
   Elim E0; Auto 10.
   Qed.
  
   Theorem Pairs_are_enough :
       (Cpo U D) ->
              ((x: U) (y: U) (Compatible U D x y) ->
                (ExT [bsup: U] (Lub U D (Couple U x y) bsup))) ->
               (Conditionally_complete U D).
   (Intros H' H'0; Apply Definition_of_Conditionally_complete).
   Intros X H'1 H'2.
   (Generalize (Empty_set_has_lub U D); Intro h; LApply h;
     [Intro H'3; Clear h | Clear h; Try Assumption]).
   (Elim H'3; Intros bsup E; Clear H'3).
   Generalize (Inclusion_is_transitive U); Intro T; Red in T.
   (LApply Pairs_are_enough_finite_case;
     [Intro H'3; LApply H'3; [Intro H'4; Clear H'3 | Try Assumption] | Idtac]);
    Auto.
   Elim H'; Intros H'6 H'7; Clear H'.
   Generalize (H'7
                 [bsup: U]
                  (ExT [Y: (Ensemble U)]
                  (Included U Y X) /\ ((Finite U Y) /\ (Lub U D Y bsup))));
    Intro h; LApply h; [Intro H'; Clear h | Clear h; Try Assumption].
   2:Apply Definition_of_Directed; Auto 10.
   2:Red; Auto 10.
   2:(Intros x H'; Elim H'); Auto 10.
   2:(Intros x0 h; Elim h; Intros H'3 h0; Elim h0; Intros H'5 H'8; Clear h h0;
       Elim H'8); Auto 10.
   2:(Intro H'9; Elim H'9); Auto 10.
   2:Apply Non_empty_intro with bsup.
   2:Red; Auto 10.
   2:(Exists (Empty_set U); Split; [Idtac | Split; [Try Assumption | Idtac]]);
      Auto 10.
   2:(Intros x1 x2 H'; Red in H'); Auto 10.
   2:Unfold 1 In.
   2:Unfold 2 In in H'.
   2:(Generalize (H' x1); Intro h; LApply h;
       [Intro H'3; Clear h | Clear h; Try Assumption]); Auto 10.
   2:Elim H'3; Intros Y h; Elim h; Intros H'5 h0; Elim h0; Intros H'8 H'9;
      Clear H'3 h h0; Try Exact H'8.
   2:(Generalize (H' x2); Intro h; LApply h;
       [Intro H'3; Clear h | Clear h; Try Assumption]); Auto 10.
   2:Elim H'3; Intros Y0 h; Elim h; Intros H'10 h0; Elim h0; Intros H'11 H'12;
      Clear H'3 h h0; Try Exact H'11.
   2:(Generalize (Union_of_finite_is_finite U Y Y0); Intro h; LApply h;
       [Intro H'3; LApply H'3; [Intro H'13; Clear h H'3 | Clear h; Try Assumption] |
         Clear h]); Auto 10.
   2:Elim H'2; Intros maj E0; Clear H'2; Try Exact E0.
   2:(Generalize (H'4 (Union U Y Y0)); Intro h; LApply h;
       [Intro H'2; LApply H'2;
         [Intro H'3; LApply H'3;
           [Intro H'14; Clear h H'2 H'3 |
             Exists maj; Clear h H'2; Try Assumption] | Clear h] | Clear h]);
      Auto.
   3:Apply Upper_downward_stable with X; Auto.
   2:Elim H'14; Intros bsup0 E1; Clear H'14; Try Exact E1.
   2:(Exists bsup0; Split;
       [Exists (Union U Y Y0); Split; [Idtac | Split; [Try Assumption | Idtac]] |
         Idtac]); Auto 10.
   2:Elim E1; Intros H'2 H'3; Clear E1.
   2:(Generalize (Upper_downward_stable U D Y (Union U Y Y0) bsup0); Intro h;
       LApply h;
       [Intro H'14; LApply H'14;
         [Intro H'15; LApply H'15;
           [Intro H'16; LApply H'16;
             [Intro H'17; Clear h H'14 H'15 H'16 |
               Clear h H'14 H'15; Try Assumption] | Clear h H'14] | Clear h] |
         Clear h]); Auto.
   2:(Generalize (Upper_downward_stable U D Y0 (Union U Y Y0) bsup0); Intro h;
       LApply h;
       [Intro H'14; LApply H'14;
         [Intro H'15; LApply H'15;
           [Intro H'16; LApply H'16;
             [Intro H'18; Clear h H'14 H'15 H'16 |
               Clear h H'14 H'15; Try Assumption] | Clear h H'14] | Clear h] |
         Clear h]); Auto.
   2:Elim H'12; Intros H'14 H'15; Clear H'12.
   2:(Generalize (H'15 bsup0); Intro h; LApply h;
       [Intro H'16; Clear h | Clear h; Try Assumption]); Auto 10.
   2:Elim H'9; Intros H'12 H'19; Clear H'9.
   2:(Generalize (H'19 bsup0); Intro h; LApply h;
       [Intro H'9; Clear h | Clear h; Try Assumption]); Auto 10.
   2:Apply Upper_Bound_definition; Auto 10.
   2:Elim H'2; Auto 10.
   2:(Intros y H'20; Elim H'20); Auto 10.
   (Elim H'; Intros bsup0 E0; Clear H'; Try Exact E0); Auto 10.
   Exists bsup0; Apply Lub_definition.
   Apply Upper_Bound_definition; Auto 10.
   (Generalize (Lub_is_in_Carrier
                  U D bsup0
                  [bsup: U]
                   (ExT [Y: (Ensemble U)]
                   (Included U Y X) /\ ((Finite U Y) /\ (Lub U D Y bsup))));
     Intro h; LApply h;
     [Intro H'; LApply H'; [Intro H'3; Clear h H' | Clear h; Try Assumption] |
       Clear h]); Auto 10.
   Red.
   (Intros x H'; Red in H'); Auto 10.
   (Elim H'; Intros Y h; Elim h; Intros H'3 h0; Elim h0; Intros H'5 H'8;
     Clear H' h h0; Try Exact H'8); Auto 10.
   Apply Lub_is_in_Carrier with Y; Auto.
   Elim E0; Intros H'3 H'5; Clear E0.
   Elim H'3; Intros H'8 H'9; Clear H'3.
   (Intros y H'; Apply H'9); Auto 10.
   Red;
    (Exists (Singleton U y); Split; [Idtac | Split; [Try Assumption | Idtac]]);
    Auto 10.
   Red; (Intros x H'3; Elim H'3); Auto 10.
   Intros y H'; Try Assumption.
   Elim E0; Intros H'3 H'5; Clear E0; Apply H'5.
   Apply Upper_Bound_definition; Auto 10.
   Elim H'; Auto 10.
   (Intros y0 H'8; Red in H'8); Auto 10.
   (Elim H'8; Intros Y h; Elim h; Intros H'9 h0; Elim h0; Intros H'10 H'11;
     Clear H'8 h h0; Try Exact H'11); Auto 10.
   Elim H'11; Intros H'8 H'12; Clear H'11.
   Apply H'12; Auto 10.
   Apply Upper_downward_stable with X; Auto.
   Qed.
   
End First_inductive_lemmas.
