(****************************************************************************)
(* This contribution was updated for Coq V5.10 by the COQ workgroup.        *)
(* January 1995                                                             *)
(****************************************************************************)
(*                           Relations_1_facts.v                            *)
(****************************************************************************)

Require Relations_1.

Definition Complement : (U: Type) (Relation U) -> (Relation U) :=
   [U: Type] [R: (Relation U)] [x,y: U] ~ (R x y).

Theorem Rsym_imp_notRsym: (U: Type) (R: (Relation U)) (Symmetric U R) ->
            (Symmetric U (Complement U R)).
Unfold Symmetric Complement.
(Intros U R H' x y H'0; Red; Intro H'1; Apply H'0); Auto.
Qed.

Theorem Equiv_from_preorder: (U: Type) (R: (Relation U)) (Preorder U R) ->
            (Equivalence U [x,y: U] (R x y) /\ (R y x)).
(Intros U R H'; Elim H'); Intros H'0 H'1.
Apply Definition_of_equivalence.
Red in H'0; Auto 10.
2:Red; Intros x y h; Elim h; Intros H'3 H'4; Auto 10.
Red in H'1; Red; Auto 10.
Intros x y z h; Elim h; Intros H'3 H'4; Clear h.
Intro h; Elim h; Intros H'5 H'6; Clear h.
Split; Apply H'1 with y; Auto 10.
Qed.
Hint Equiv_from_preorder.

Theorem Equiv_from_order: (U: Type) (R: (Relation U)) (Order U R) ->
            (Equivalence U [x,y: U] (R x y) /\ (R y x)).
(Intros U R H'; Elim H'); Auto 10.
Qed.
Hint Equiv_from_order.

Theorem contains_is_preorder: (U: Type) (Preorder (Relation U) (contains U)).
Auto 10.
Qed.
Hint contains_is_preorder.

Theorem same_relation_is_equivalence: (U: Type) (Equivalence (Relation U) (same_relation U)).
Unfold 1 same_relation; Auto 10.
Qed.
Hint same_relation_is_equivalence.
