(****************************************************************************)
(* This contribution was updated for Coq V5.10 by the COQ workgroup.        *)
(* January 1995                                                             *)
(****************************************************************************)
(*                              Relations_3.v                               *)
(****************************************************************************)

Require Relations_1.
Require Relations_2.

Section Relations_3.
   Variable U: Type.
   Variable R: (Relation U).
   
   Definition coherent : U -> U -> Prop :=
      [x,y: U] (ExT [z: U] (Rstar U R x z) /\ (Rstar U R y z)).
   
   Definition locally_confluent : U -> Prop :=
      [x: U] (y: U) (z: U) (R x y) -> (R x z) -> (coherent y z).
   
   Definition Locally_confluent : Prop :=  (x: U) (locally_confluent x).
   
   Definition confluent : U -> Prop :=
      [x: U] (y: U) (z: U) (Rstar U R x y) -> (Rstar U R x z) -> (coherent y z).
   
   Definition Confluent : Prop :=  (x: U) (confluent x).
   
   Inductive noetherian : U -> Prop :=
         definition_of_noetherian:
           (x: U) ((y: U) (R x y) -> (noetherian y)) -> (noetherian x).
   
   Definition Noetherian : Prop :=  (x: U) (noetherian x).
   
End Relations_3.
Hint Unfold coherent.
Hint Unfold locally_confluent.
Hint Unfold confluent.
Hint Unfold Confluent.
Hint definition_of_noetherian.
Hint Unfold Noetherian.
