(****************************************************************************)
(* This contribution was updated for Coq V5.10 by the COQ workgroup.        *)
(* January 1995                                                             *)
(****************************************************************************)
(*                                  ex1.v                                   *)
(****************************************************************************)


Theorem trivial: (A: Prop) A -> A.
Intros A H'; Exact H'.
Qed.

Theorem and_commutative: (A,B: Prop) A /\ B -> B /\ A.
Intros A B H'; Split.
Elim H'; Intros H'0 H'1; Clear H'; Exact H'1.
Elim H'; Intros H'0 H'1; Clear H'; Exact H'0.
Qed.

Theorem or_commutative: (A,B: Prop) A \/ B -> B \/ A.
Intros A B h; Elim h; [Intro H'; Clear h; Try Exact H' | Clear h; Intro H'].
Right; Assumption.
Left; Assumption.
Qed.

Theorem mp: (A,B: Prop) A -> (A -> B) -> B.
Intros A B H' H'0.
Apply H'0.
Exact H'.
Qed.

Theorem S: (A,B,C: Prop) (A -> B -> C) -> (A -> B) -> A -> C.
Intros A B C H' H'0 H'1.
Apply H'.
Exact H'1.
Apply H'0.
Exact H'1.
Qed.

Theorem Praeclarum: (x,y,z,t: Prop) (x -> z) /\ (y -> t) -> x /\ y -> z /\ t.
Intros x y z t h; Elim h; Intros H' H'0; Clear h.
Intro h; Elim h; Intros H'1 H'2; Clear h.
Split.
Apply H'; Assumption.
Apply H'0; Assumption.
Qed.

Theorem resolution: (p,q: Type -> Prop) (a: Type) (p a) -> ((x: Type) (p x) -> (q x)) ->
            (q a).
Intros p q a H' H'0.
Apply H'0.
Exact H'.
Qed.

Theorem Witnesses: (a,b: Type) (p: Type -> Prop) (p a) \/ (p b) ->
            (ExT [x: Type] (p x)).
Intros a b p h; Elim h; Intro H'; Clear h.
Exists a; Assumption.
Exists b; Assumption.
Qed.

Theorem Simple: (A: Set)
           (R: A -> A -> Prop)
           ((x,y,z: A) (R x y) /\ (R y z) -> (R x z)) ->
           ((x,y: A) (R x y) -> (R y x)) ->
            (x: A) ((Ex [y: A] (R x y))) -> (R x x).
Intros A R H' H'0 x h; Elim h; Intros y E; Clear h.
Apply H' with y.
Split; [Assumption | Idtac].
Apply H'0; Assumption.
Qed.

Theorem not_not: (a: Prop) a -> ~ (~ a).
Intros a H'; Red; Intro H'0; Elim H'0; Assumption.
Qed.

Theorem mini_cases: (x,y: Prop) (x \/ ~ y) /\ y -> x.
Intros x y h; Elim h; Intros h0 H'; Elim h0;
 [Intro H'0; Clear h h0; Try Exact H'0 | Clear h h0; Intro H'0].
Elim H'0; Try Assumption.
Qed.

Require Classical.
(*This theorem needs classical logic*)

Theorem not_not_converse: (a: Prop) ~ (~ a) -> a.
Intros a H'.
Generalize (classic a); Intro h; Elim h;
 [Intro H'0; Clear h; Try Exact H'0 | Clear h; Intro H'0].
Elim H'; Assumption.
Qed.

Theorem not_quite_classic: (a: Prop) ~ (~ (a \/ ~ a)).
Intro a; Red; Intro H'; Elim H'; Right; Red; Intro H'0.
Elim H'; Left; Try Assumption.
Qed.


