(****************************************************************************)
(* This contribution was updated for Coq V5.10 by the COQ workgroup.        *)
(* January 1995                                                             *)
(****************************************************************************)
(*                                ex1_auto.v                                *)
(****************************************************************************)

Theorem trivial: (A: Prop) A -> A.
Auto.
Qed.

Theorem and_commutative: (A,B: Prop) A /\ B -> B /\ A.
(Intros A B H'; Elim H'); Auto.
Qed.

Theorem or_commutative: (A,B: Prop) A \/ B -> B \/ A.
Intros A B H' ; Elim H' ; Auto.
Qed.

Theorem mp: (A,B: Prop) A -> (A -> B) -> B.
Auto.
Qed.

Theorem S: (A,B,C: Prop) (A -> B -> C) -> (A -> B) -> A -> C.
Auto.
Qed.

Theorem Praeclarum: (x,y,z,t: Prop) (x -> z) /\ (y -> t) -> x /\ y -> z /\ t.
Intros x y z t H'; Elim H'.
Intros H'0 H'1 H'2; Elim H'2.
Auto.
Qed.

Theorem resolution: (p,q: Type -> Prop) (a: Type) (p a) -> ((x: Type) (p x) -> (q x)) ->
            (q a).
Auto.
Qed.

Theorem Witnesses: (a,b: Type) (p: Type -> Prop) (p a) \/ (p b) ->
            (ExT [x: Type] (p x)).
Intros a b p h; Elim h; [Intro H'; Clear h; Try Exact H' | Clear h; Intro H'].
Exists a; Try Assumption.
Exists b; Try Assumption.
Qed.

Theorem Simple: (A: Set)
           (R: A -> A -> Prop)
           ((x,y,z: A) (R x y) /\ (R y z) -> (R x z)) ->
           ((x,y: A) (R x y) -> (R y x)) ->
            (x: A) ((Ex [y: A] (R x y))) -> (R x x).
Intros A R H' H'0 x H'1; Try Assumption.
Elim H'1; Intros y E; Clear H'1; Try Exact E.
Apply H' with y; Auto.
Qed.

Theorem not_not: (a: Prop) a -> ~ (~ a).
Unfold not; Auto.
Qed.

Theorem mini_cases: (x,y: Prop) (x \/ ~ y) /\ y -> x.
(Intros x y h; Elim h; Intros h0 H'; Elim h0;
  [Clear h h0; Intro H'0 | Intro H'0; Elim H'0; Clear h h0; Try Assumption]);
 Auto.
Qed.

Require Classical.
(*This theorem needs classical logic*)

Theorem not_not_converse: (a: Prop) ~ (~ a) -> a.
(Intros a H'; Try Assumption); Auto 10.
Generalize (classic a); Intro h; Elim h;
 [Intro H'0; Clear h; Try Exact H'0 | Clear h; Intro H'0].
Elim H'; Assumption.
Qed.

Theorem not_quite_classic: (a: Prop) ~ (~ (a \/ ~ a)).
Unfold not; Auto.
Qed.

Theorem Peirce: (A,B: Prop) ((((A -> B) -> A) -> A) -> B) -> B.
Auto.
Qed.


