(****************************************************************************)
(* This contribution was updated for Coq V5.10 by the COQ workgroup.        *)
(* January 1995                                                             *)
(****************************************************************************)
(*                                 podefs.v                                 *)
(****************************************************************************)

Require Ensembles.
Require Relations_1.

Section Partial_orders.
   Variable U: Type.
   
   Definition Carrier :=  (Ensemble U).
   
   Definition Rel :=  (Relation U).
   
   Inductive PO : Type :=
         Definition_of_PO:
           (C: Carrier) (R: Rel) (Non_empty U C) -> (Order U R) -> PO.
   
   Theorem Carrier_of: PO -> Carrier.
   Intro H'; Elim H'.
   Intros C R H'0 H'1; Exact C.
   Qed.
   Transparent Carrier_of.

   Theorem Rel_of: PO -> Rel.
   (Intro H'; Elim H').
   Intros C R H'0 H'1; Exact R.
   Qed.
   Transparent Rel_of.

   Definition SRel_of : PO -> Rel :=
      [p: PO] [x,y: U] (Rel_of p x y) /\ ~ x == y.
   
End Partial_orders.
Hint Unfold Carrier_of Rel_of.
