(****************************************************************)
(*           The Calculus of Inductive Constructions            *)
(*                       COQ v5.10                              *)
(*                                                              *)
(* Laurent Arditi.  Laboratoire I3S. CNRS ura 1376.             *)
(* Universite de Nice - Sophia Antipolis                        *)
(* arditi@unice.fr, http://wwwi3s.unice.fr/~arditi/lolo.html    *)
(*                                                              *)
(* date: november 1995                                          *)
(* file: Fill_proof.v                                           *)
(* contents: proof of a memory block instruction: Fills cx words*)
(* in memory starting at address di with value                  *)
(* verification that impl -> specif                             *)
(****************************************************************)

Require Fill_spec.
Require Fill_impl.


Variable DC_a : BV.	Axiom DC_asize : (lengthbv DC_a)=a_size.
Variable DC_d : BV.	Axiom DC_dsize : (lengthbv DC_d)=d_size.

Lemma cx_cx' : (t:nat) 
	(cx t di_init cx_init al_init mem_init) =
	(cx' t di_init cx_init al_init mem_init DC_a DC_d).
Unfold cx' .Unfold compo' .Unfold cx3 .Unfold cx_2_1 compo_2_1 .
Unfold di1 cx1 al1 mem1 ad1 da1 .Induction t.Auto.
Intros.Rewrite -> cx_t.Rewrite -> cx2_t.Rewrite -> H.Try Trivial.
Qed.

Lemma di_di' : (t:nat) 
	(di t di_init cx_init al_init mem_init) =
	(di' t di_init cx_init al_init mem_init DC_a DC_d).
Unfold di' .Unfold compo' .
Unfold di3 .Unfold ad_2_1 compo_2_1 .Unfold di1 cx1 al1 mem1 ad1 da1 .
Induction t.Auto.
Intros.Rewrite -> di_t.Rewrite -> ad2_t.Rewrite -> H.
Replace (cx n di_init cx_init al_init mem_init) with (cx' n di_init
                                                       cx_init al_init
                                                       mem_init DC_a
                                                       DC_d).
Unfold cx' compo' .Unfold cx3 .Unfold cx_2_1 compo_2_1 .
Unfold di1 cx1 al1 mem1 ad1 da1 .
Try Trivial.Rewrite -> cx_cx'.Try Trivial.
Qed.


Lemma al_al' : (t:nat) 
	(al t di_init cx_init al_init mem_init) =
	(al' t di_init cx_init al_init mem_init DC_a DC_d).
Intro.
Rewrite -> al_constant.
Unfold al' .
Unfold compo' .
Unfold al3 .
Unfold al_2_1 .
Unfold compo_2_1 .
Rewrite -> al2_constant.
Unfold al1 .
Try Trivial.
Qed.

Lemma mem_mem' : (t:nat) 
	(mem t di_init cx_init al_init mem_init) =
	(mem' t di_init cx_init al_init mem_init DC_a DC_d).
Unfold mem' compo' .
Unfold mem3 .
Unfold mem_2_1 compo_2_1 .
Unfold di1 cx1 al1 mem1 ad1 da1 .
Induction t.
Auto.

Intros.
Rewrite -> mem2_t.
Rewrite -> mem_t.
Rewrite -> H.
Replace (al n di_init cx_init al_init mem_init) with al_init.
Replace (da2 n di_init cx_init al_init mem_init di_init al_init) with al_init.
Rewrite -> (di_di' n).
Unfold di' .
Unfold compo' .
Unfold di3 .
Unfold ad_2_1 compo_2_1 .
Unfold di1 cx1 al1 mem1 ad1 da1 .
Rewrite -> (cx_cx' n).
Unfold cx' compo' cx3 .
Unfold cx_2_1 compo_2_1 .
Unfold di1 cx1 al1 mem1 ad1 da1 .
Try Trivial.

Rewrite -> da2_constant.
Try Trivial.

Rewrite -> al_constant.
Try Trivial.
Qed.

Theorem Fill_ok : (t:nat) 
	((di t di_init cx_init al_init mem_init) =
		(di' t di_init cx_init al_init mem_init DC_a DC_d)) /\
	((cx t di_init cx_init al_init mem_init) =
		(cx' t di_init cx_init al_init mem_init DC_a DC_d)) /\
	((al t di_init cx_init al_init mem_init) =
		(al' t di_init cx_init al_init mem_init DC_a DC_d)) /\
	((mem t di_init cx_init al_init mem_init) =
		(mem' t di_init cx_init al_init mem_init DC_a DC_d)).
Split.Apply di_di'.
Split.Apply cx_cx'.
Split.Apply al_al'.Apply mem_mem'.
Qed.

