Require Import Ensembles.
Require Import Constructive_sets.
Require Import Relations_1.
Require Import Partial_Order.
Require Import Cpo.
Require Import algpodefs.
Require Import Powerset.
Require Import Powerset_facts.
Require Import Finite_sets.
Require Import Finite_sets_facts.
Require Import lpo.
Require Import lpo1.
Require Import alpo.
Require Import newfil.
Section Second_inductive_lemma.
Variable U:Type.
Variable C:(Cpo U).

Definition D: (PO U) := (PO_of_cpo U C).

Theorem Triples_are_enough_finite_case:
  ((x, y, z:U) (Consistent U D (Triple U x y z)) ->
   (exT U [bsup:U](Lub U D (Triple U x y z) bsup))) ->
  (X:(Ensemble U))
  (Finite U X) -> (Included U X (Carrier_of U D)) -> (Consistent U D X) ->
  (exT U [bsup:U](Lub U D X bsup)).
Proof.
Intro H'; Try Assumption.
Intros X H'0; Try Assumption.
Elim H'0 using Generalized_induction_on_finite_sets.
Clear H'0.
Clear X.
Intros X H'0; Elim H'0.
Unfold 6 D; Auto.
Clear H'0 X.
Intros A H'0; Elim H'0.
Intros H'1 x H'2 H'3 H'4 H'5; Try Assumption.
Rewrite (Empty_set_zero' U x).
Exists x; Auto.
Clear H'0 A.
Intros A H'0; Elim H'0.
Intros H'1 x H'2 H'3 x0 H'4 H'5 H'6 H'7; Try Assumption.
2:Clear H'0 A.
2:Intros A H'0 H'1 x H'2 H'3 x0 H'4 H'5 x1 H'6 H'7 H'8 H'9; Try Assumption.
Clear H'5 H'3 H'1.
Rewrite (Empty_set_zero' U x).
Unfold 1 Add.
Rewrite (Couple_as_union U x x0).
Rewrite (Triple_as_Couple U x x0).
Apply H'.
Rewrite <- (Triple_as_union U x x x0).
Rewrite (Union_idempotent U (Singleton U x)).
Generalize H'7.
Rewrite (Empty_set_zero' U x).
Unfold 1 Add; Auto.
Clear H'5 H'3 H'1 H'0.
Cut (X:(Ensemble U)) (Included U X (Add U (Add U (Add U A x) x0) x1)) ->
    (Included U X (Carrier_of U D)); Auto.
Intro L1.
Cut (X:(Ensemble U)) (Included U X (Add U (Add U (Add U A x) x0) x1)) ->
    (Consistent U D X); Auto.
2:Intros X H'0.
2:Apply Consistent_downward_stable with B := (Add U (Add U (Add U A x) x0) x1);
   Auto.
Intro L2.
Cut (Included U (Add U A x) (Add U (Add U (Add U A x) x0) x1)); Auto.
Intro F1.
Cut (Included U (Add U A x0) (Add U (Add U (Add U A x) x0) x1)); Auto.
2:Apply (Inclusion_is_transitive U) with (Add U (Add U A x) x0); Auto.
Intro F2.
Cut (Included U (Add U A x1) (Add U (Add U (Add U A x) x0) x1)); Auto.
Intro F3.
Cut (Included U (Add U (Add U A x) x0) (Add U (Add U (Add U A x) x0) x1)); Auto.
Intro F4.
Cut (Included U (Add U (Add U A x) x1) (Add U (Add U (Add U A x) x0) x1)); Auto.
Intro F5.
Cut (Included U (Add U (Add U A x0) x1) (Add U (Add U (Add U A x) x0) x1)); Auto.
Intro F6.
Cut (Strict_Included U (Add U (Add U A x) x0) (Add U (Add U (Add U A x) x0) x1)).
2:Split; Auto.
2:Red; Intro H'0.
2:LApply (Extension U (Add U (Add U A x) x0) (Add U (Add U (Add U A x) x0) x1));
   [Intro H'10; Elim H'10 | Idtac]; Auto.
Intro G1.
Cut (Strict_Included U (Add U (Add U A x) x1) (Add U (Add U (Add U A x) x0) x1)).
2:Split; Auto.
2:Red; Intro H'0.
2:LApply (Extension U (Add U (Add U A x) x1) (Add U (Add U (Add U A x) x0) x1));
   [Intro H'10; Elim H'10 | Idtac]; Auto.
2:Intros H'1 H'3; Try Assumption.
2:Apply H'4.
2:LApply (incl_add_x U (Add U (Add U A x) x0) (Add U A x) x1);
   [Intro H'14; LApply H'14;
     [Intro H'15; Try Exact H'15; Clear H'14 | Clear H'14] | Idtac]; Auto.
Intro G2.
Cut (Strict_Included
       U (Add U (Add U A x0) x1) (Add U (Add U (Add U A x) x0) x1)).
2:Split; Auto.
2:Red; Intro H'0.
2:LApply (Extension U (Add U (Add U A x0) x1) (Add U (Add U (Add U A x) x0) x1));
   [Intro H'10; Elim H'10 | Idtac]; Auto.
2:Intros H'1 H'3; Try Assumption.
2:Apply H'2.
2:LApply (incl_add_x U (Add U (Add U A x) x0) (Add U A x0) x1);
   [Intro H'14; LApply H'14;
     [Intro H'15; Try Exact H'15; Clear H'14 | Clear H'14] | Idtac]; Auto.
2:LApply (incl_add_x U (Add U A x) A x0);
   [Intro H'14; LApply H'14;
     [Intro H'16; Try Exact H'16; Clear H'14 | Clear H'14] | Idtac]; Auto.
Intro G3; Try Assumption.
Cut (Strict_Included U (Add U A x0) (Add U (Add U (Add U A x) x0) x1)).
2:Apply Strict_inclusion_is_transitive_with_inclusion_left
       with y := (Add U (Add U A x0) x1); Auto.
Intro G4; Try Assumption.
Cut (Strict_Included U (Add U A x1) (Add U (Add U (Add U A x) x0) x1)).
2:Apply Strict_inclusion_is_transitive_with_inclusion_left
       with y := (Add U (Add U A x) x1); Auto.
Intro G5; Try Assumption.
Cut (Strict_Included U (Add U A x) (Add U (Add U (Add U A x) x0) x1)).
2:Apply Strict_inclusion_is_transitive_with_inclusion_left
       with y := (Add U (Add U A x) x0); Auto.
Intro G6; Try Assumption.
Elim (H'7 (Add U A x)); [Intros bsup E; Try Exact E | Idtac | Idtac | Idtac];
 Auto.
Elim (H'7 (Add U A x0));
 [Intros bsup0 E0; Try Exact E0 | Idtac | Idtac | Idtac]; Auto.
Elim (H'7 (Add U A x1));
 [Intros bsup1 E1; Try Exact E1 | Idtac | Idtac | Idtac]; Auto.
Elim (H'7 (Add U (Add U A x) x0));
 [Intros bsup2 E2; Try Exact E2 | Idtac | Idtac | Idtac]; Auto.
Elim (H'7 (Add U (Add U A x) x1));
 [Intros bsup3 E3; Try Exact E3 | Idtac | Idtac | Idtac]; Auto.
Elim (H'7 (Add U (Add U A x0) x1));
 [Intros bsup4 E4; Try Exact E4 | Idtac | Idtac | Idtac]; Auto.
Elim (H' bsup bsup0 bsup1); [Intros bsup5 E5; Try Exact E5 | Idtac]; Auto.
Exists bsup5; Try Assumption.
2:Apply Consistent_triple_intro.
2:Apply Compatible_lubs
       with A := (Add U A x) B := (Add U A x0) C := (Add U (Add U A x) x0)
            c := bsup2; Auto.
2:Apply Compatible_lubs
       with A := (Add U A x0) B := (Add U A x1) C := (Add U (Add U A x0) x1)
            c := bsup4; Auto.
2:Apply Compatible_lubs
       with A := (Add U A x) B := (Add U A x1) C := (Add U (Add U A x) x1)
            c := bsup3; Auto.
Generalize E5.
Clear E5.
Rewrite (Triple_as_Couple_Singleton U bsup bsup0 bsup1).
Intro E5; Try Assumption.
Unfold 1 Add.
Cut (Union U (Add U (Add U A x) x0) (Singleton U x1)) ==
    (Union U (Add U (Add U A x) x0) (Add U A x1)).
Intro H'0; Rewrite H'0.
Clear H'0.
Apply LUaux2 with a := bsup2 b := bsup1; Auto.
Apply LUaux with A := (Couple U bsup bsup0) B := (Singleton U bsup1); Auto.
3:Apply Singleton_has_lub.
Clear E5 E4 E3 G6 G5 G4 G3 G2 G1 H'9 H'7 bsup5 bsup4 bsup3 H'6 H'4 H'2 H'.
Red.
Intros x2 H'; Elim H'; Auto.
Intros x3 H'0; Elim H'0; Auto.
Apply Lub_is_in_Carrier with X := (Add U A x); Auto.
Apply Lub_is_in_Carrier with X := (Add U A x0); Auto.
Intros x3 H'0; Elim H'0; Auto.
Apply Lub_is_in_Carrier with X := (Add U A x1); Auto.
2:Apply Lub_is_in_Carrier with X := (Add U A x1); Auto.
Apply LUaux with A := (Add U A x) B := (Add U A x0); Auto.
Cut (Add U (Add U A x) x0) ==(Union U (Add U A x) (Add U A x0)).
Intro H'0; Rewrite <- H'0; Auto.
Cut <(Ensemble U)> (Add U (Add U A x) x0) ==(Union U (Add U A x) (Add U A x0)).
Clear E5.
Rewrite (Triple_as_Couple_Singleton U bsup bsup0 bsup1).
Intro E5; Try Assumption.
Cut (Lub U D (Couple U bsup bsup0) bsup2).
Intro H'1; Try Assumption.
Apply Add_distributes; Auto.
Apply LUaux with A := (Add U A x) B := (Add U A x0); Auto.
Rewrite <- (Add_distributes U A A x x0); Auto.
Cut <(Ensemble U)>
      (Union U (Add U (Add U A x) x0) (Singleton U x1)) ==
      (Add U (Add U (Add U A x) x0) x1).
Intro H'0; Rewrite H'0.
Rewrite (Add_distributes U (Add U A x) A x0 x1); Auto.
Unfold 3 Add; Auto.
Qed.
Hint Triples_are_enough_finite_case.

Theorem Triples_are_enough:
  ((x, y, z:U) (Consistent U D (Triple U x y z)) ->
   (exT U [bsup:U](Lub U D (Triple U x y z) bsup))) ->(Coherent U D).
Intro H'; Red.
Intros X H'0 K; Try Assumption.
Cut (Complete U D).
2:Exact (Cpo_cond U C).
Unfold 1 D.
Intro H'3; Elim H'3; Intros H'6 H'7.
Elim (H'7 (Lubs_of_finite_parts U C X)); [Intros bsup0 E0 | Apply LFP_directed];
 Auto.
Exists bsup0; Unfold 1 D; Auto.
Intros Y H'1 H'2; Try Assumption.
Change (exT U [bsup:U](Lub U D Y bsup)).
Apply Triples_are_enough_finite_case; Auto.
Apply Consistent_downward_stable with B := X; Auto.
Qed.
End Second_inductive_lemma.


