Require Import Arith.
Require Import Zbase.

Definition succZ :=
   [x: Z]
    <Z>Case x of
      IZ [n: nat] (pos (S n)) [n: nat] <Z>Case n of OZ [m: nat] (neg m) end end.

Definition predZ :=
   [x: Z]
    <Z>Case x of
      (neg O) [n: nat] <Z>Case n of OZ [m: nat] (pos m) end [n: nat] (neg (S n))
      end.

Lemma pred_succZ: (x: Z) (predZ (succZ x)) = x.
Intro x; Elim x; Auto.
Intro n; Elim n; Auto.
Qed.

Lemma succ_predZ: (x: Z) (succZ (predZ x)) = x.
Intro x; Elim x; Auto.
Intro n; Elim n; Auto.
Qed.

Lemma succ_pred_pred_succZ: (x: Z) (succZ (predZ x)) = (predZ (succZ x)).
Intro x; Try Assumption.
Rewrite (pred_succZ x); Rewrite (succ_predZ x); Trivial.
Qed.

Lemma tech_pred_posZ: (n: nat) (lt O n) -> (predZ (pos n)) = (pos (pred n)).
Intro n; Elim n; Auto.
Intro H'; Elim (lt_n_O O); Auto.
Qed.

Lemma tech_succ_posOZ: (n: nat) (succZ (posOZ n)) = (pos n).
Intro n; Elim n; Auto.
Qed.



