
Inductive Z : Set :=
      OZ: Z
   | pos: nat -> Z
   | neg: nat -> Z.

Definition IZ :=  (pos O).

Recursive Definition is_posn : Z -> Z -> Prop :=
      OZ   y => False
    | (pos n)   OZ => False
    | (pos n)   (pos m) => <nat> n = m
    | (pos n)   (neg m) => False
    | (neg n)   y => False.

Lemma tech_pos_not_posZ: (n, m: nat) ~ n = m -> ~ (pos n) = (pos m).
Unfold not; Intros.
Cut (is_posn (pos n) (pos m)).
Simpl; Exact H.
Rewrite H0; Simpl; Reflexivity.
Qed.

Lemma eq_OZ_dec: (x: Z) {x = OZ}+{~ x = OZ}.
Intros; Elim x.
Left; Reflexivity.
Intros; Right; Discriminate.
Intros; Right; Discriminate.
Qed.

Definition posOZ :=  [n: nat] <Z>Case n of OZ [n': nat] (pos n') end.

Definition negOZ :=  [n: nat] <Z>Case n of OZ [n': nat] (neg n') end.

Definition absZ :=
   [x: Z] <Z>Case x of OZ [n: nat] (pos n) [n: nat] (pos n) end.

Definition sgnZ :=
   [x: Z] <Z>Case x of OZ [n: nat] (pos O) [n: nat] (neg O) end.



