(****************************************************************************)
(*                                                                          *)
(*       Ordered sets                                                       *)
(*                                                                          *)
(*                                                                          *)
(****************************************************************************)
(*                                  Order.v                                 *)
(****************************************************************************)

Section VR.

Variable V : Set.          (* The Universe of discourse *)
Variable R : V->V->Prop.   (* Given with order relation R *)
Variable V_eq : V->V->Prop.(* and equality V_eq *)

Definition reflexivity  := (x:V)(R x x).
Definition anti_symetry := (x,y:V)(R x y)->(R y x)->(V_eq x y).
Definition transitivity := (x,y,z:V)(R x y)->(R y z)->(R x z).

Definition order := reflexivity /\ anti_symetry /\ transitivity.

Definition totality    := (x,y:V)(R x y)\/(R y x).
Definition total_order := order /\ totality.

End VR.

