(****************************************************************************)
(* A few extra lemmas concerning arithmetic and booleans                    *)
(*   -- ought to be integrated in ARITH and BOOL libraries                  *)
(*                                                                          *)
(****************************************************************************)
(*                                Prelude1.v                                *)
(****************************************************************************)

Require Compare.
Require Lt.

Lemma le_dec_0 : (n,m:nat) (le n m) \/ (le m n).
Proof.
Intros n m.
Elim (le_dec n m); Auto. 
Qed.
Hint le_dec_0.

Lemma le_nSm_le_nm_or_eq : (m,n:nat)(le n (S m)) -> (le n m) \/ n=(S m).
Proof.
Intros m n H.
Cut (lt n (S m)) \/ n=(S m).
Induction 1; Auto.
Apply le_lt_or_eq; Trivial.
Qed.

Lemma le_ne_gt : (m,n:nat)(le m n) -> ~m=n -> (gt n m).
Proof.
Intros m n H1 H2.
Cut (lt m n) \/ m=n.
Induction 1; Auto.
Intro; Absurd m=n; Auto.
Apply le_lt_or_eq; Trivial.
Qed.

Require Bool.

Lemma eq_bool_dec: (b1,b2:bool) b1=b2 \/ ~b1=b2.
Proof.
Induction b1; Induction b2; Auto.
Qed.
