(****************************************************************************)
(* This contribution was updated for Coq V5.10 by the COQ workgroup.        *)
(* January 1995                                                             *)
(****************************************************************************)
(*                                                                          *)
(*      Coq V5.8                                                            *)
(*                                                                          *)
(*                                                                          *)
(*      Alternating Bit Protocol                                            *)
(*                                                                          *)
(*      Jan Friso Groote                                                    *)
(*      Utrecht University                                                  *)
(*                                                                          *)
(*      November 1992                                                       *)
(*                                                                          *)
(* From bezem@phil.ruu.nl Fri Apr  2 13:14:31 1993                          *)
(*                                                                          *)
(****************************************************************************)
(*                                abp_lem1.v                                *)
(****************************************************************************)

Require abp_base.
Require abp_defs.

Goal (b:bit)(x,y:proc)
     (sum D ([d:D](seq (ia D r1 d) 
        (enc H (mer (seq (Sn_d d b) y) x)))))
           =(enc H (Lmer (seq (Sn b) y) x)).

Intros.
OldElim ProcSn.
OldElim (SUM5 D ([d:D](seq (ia D r1 d) (Sn_d d b))) y).
ElimType ([d:D](seq (ia D r1 d) 
                       (seq (Sn_d d b) y)))
                =([d:D](seq (seq (ia D r1 d) (Sn_d d b)) y)).
2:Apply EXT; Intro; OldElim A5; Apply refl_equal.
OldElim (SUM6 D 
          ([d:D](seq (ia D r1 d) (seq (Sn_d d b) y))) x).
OldElim SUM9.
ElimType ([d:D](seq (ia D r1 d) (enc H (mer (seq (Sn_d d b) y) x))))=
                  ([d:D] (enc H
        (Lmer (seq (ia D r1 d) (seq (Sn_d d b) y)) x))).
           
Apply refl_equal.
Apply EXT ; Intro . 
OldElim CM3.
OldElim D5.
OldElim D1.
Apply refl_equal.
Exact Inr1H.
Save LmerSn.

Goal (x:proc)Delta=(enc H (Lmer (K i) x)).
Intro.
OldElim ChanK.
OldElim (SUM6 Frame ([x:Frame]
           (seq (ia Frame r2 x)
              (seq
                 (alt (seq (ia one int i) (ia Frame s3 x))
                    (seq (ia one int i) (ia Frame s3 lce)))
                 (K i)))) x).
OldElim SUM9.
ElimType ([d:Frame]Delta)=
         ([d:Frame]
     (enc H
        (Lmer
           (seq (ia Frame r2 d)
              (seq
                 (alt (seq (ia one int i) (ia Frame s3 d))
                    (seq (ia one int i) (ia Frame s3 lce)))
                 (K i)))
           x))).
OldElim SUM1.
Apply refl_equal.
Apply EXT. Intro.
OldElim CM3.
OldElim D5.
OldElim D2.
OldElim A7.
Apply refl_equal.
Exact Inr2H.
Save LmerK.

Goal (x:proc)Delta=(enc H (Lmer (L i)  x)).
Intro.
OldElim ChanL.
OldElim (SUM6 frame ([n:frame]
           (seq (ia frame r5 n)
              (seq
                 (alt (seq (ia one int i) (ia frame s6 n))
                    (seq (ia one int i) (ia frame s6 sce)))
                 (L i)))) x).
OldElim SUM9.
ElimType ([d:frame]Delta)=
            ([d:frame]
     (enc H
        (Lmer
           (seq (ia frame r5 d)
              (seq
                 (alt (seq (ia one int i) (ia frame s6 d))
                    (seq (ia one int i) (ia frame s6 sce)))
                 (L i))) x))).
           
OldElim SUM1.
Apply refl_equal.
Apply EXT. Intro.
OldElim CM3.
OldElim D5.
OldElim D2.
OldElim A7.
Apply refl_equal.
Exact Inr5H.
Save LmerL.

Goal (b:bit)(x,y:proc)Delta=(enc H (Lmer (seq (Rn b) y) x)).
Intros.
OldElim ProcRn.
OldElim (A4 (seq
                    (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                       (ia Frame r3 lce))
                    (seq (ia frame s5 (tuple b)) (Rn b)))
                (D+[d:D]
                   (seq (ia Frame r3 (Tuple (toggle b) d))
                      (seq (ia D s4 d)
                         (ia frame s5 (tuple (toggle b))))))
               y).
OldElim (CM4 (seq
                 (seq
                    (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                       (ia Frame r3 lce))
                    (seq (ia frame s5 (tuple b)) (Rn b)))
                 y)
               (seq
                 (D
                 +[d:D]
                   (seq (ia Frame r3 (Tuple (toggle b) d))
                      (seq (ia D s4 d)
                         (ia frame s5 (tuple (toggle b)))))) y) x).
OldElim D4.
Cut Delta=(enc H
         (Lmer
            (seq
               (D
               +[d:D]
                 (seq (ia Frame r3 (Tuple (toggle b) d))
                    (seq (ia D s4 d) (ia frame s5 (tuple (toggle b))))))
                y) x)).
Intro H0.
OldElim H0.
OldElim A6.
OldElim (A4 (D+[d:D](ia Frame r3 (Tuple b d))) (ia Frame r3 lce)
        (seq (ia frame s5 (tuple b)) (Rn b))).
OldElim (A4 (seq (D+[d:D](ia Frame r3 (Tuple b d)))
                  (seq (ia frame s5 (tuple b)) (Rn b)))
           (seq (ia Frame r3 lce)
                  (seq (ia frame s5 (tuple b)) (Rn b))) y).
OldElim (CM4 (seq
               (seq (D+[d:D](ia Frame r3 (Tuple b d)))
                  (seq (ia frame s5 (tuple b)) (Rn b))) y)
         (seq
               (seq (ia Frame r3 lce)
                  (seq (ia frame s5 (tuple b)) (Rn b))) y) x).
OldElim A5.
OldElim A5.
(* added *)
OldElim A5.
(* end added *)
OldElim CM3.
OldElim D4.
OldElim D5.
OldElim D2.
OldElim A7.
OldElim A6.
(* removed
OldElim (A5 (D+[d:D](ia Frame r3 (Tuple b d)))
        (seq (ia frame s5 (tuple b)) (Rn b))
             y).
OldElim (SUM5 D ([d:D](ia Frame r3 (Tuple b d))) 
     (seq (seq (ia frame s5 (tuple b)) (Rn b)) y)).
OldElim (SUM6 D [d:D]
           (seq (ia Frame r3 (Tuple b d))
             (seq (seq (ia frame s5 (tuple b)) (Rn b))
                 y)) x). *)
(* added *)
OldElim SUM5.
OldElim SUM6.
(* end added *)
OldElim SUM9.
(* pattern changed*)
ElimType ([d:D]Delta)=([d:D](enc H
        (Lmer
           (seq (ia Frame r3 (Tuple b d))
              (seq (ia frame s5 (tuple b)) (seq (Rn b) y)))
           x))).
(* end pattern changed*)
OldElim SUM1.
Apply refl_equal.
Apply EXT.
Intro.
OldElim CM3.
OldElim D5.
OldElim D2. 
OldElim A7.
Apply refl_equal.
Exact Inr3H.
Exact Inr3H. 
OldElim (SUM5 D ([d:D]
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b))))))
           y).
OldElim (SUM6 D ([d:D]
           (seq
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
              y)) x).
OldElim SUM9.
ElimType ([d:D]Delta)=
   ([d:D]
     (enc H
        (Lmer
           (seq
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
              y)
           x))).
OldElim SUM1.
Apply refl_equal.
Apply EXT ; Intro.
OldElim A5.
OldElim CM3.
OldElim D5.
OldElim D2.
OldElim A7.
Apply refl_equal.
Exact Inr3H.

Save LmerRn.

Goal (b:bit)(x,y:proc)
       Delta=(enc H (Lmer (comm (L i) (seq (Rn b) y)) x)).
Intros.
Cut Delta=(comm (L i) (seq (Rn b) y)).
Intro H0.
OldElim H0.
Unfold 2 Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.
Apply refl_equal.

OldElim ChanL.
OldElim SUM7.
ElimType ([d:frame]Delta)=
    ([d:frame]
     (comm
        (seq (ia frame r5 d)
           (seq
              (alt (seq (ia one int i) (ia frame s6 d))
                 (seq (ia one int i) (ia frame s6 sce)))
              (L i)))
        (seq (Rn b) y))).
OldElim SUM1.
Apply refl_equal.
Apply EXT.
Intro.
OldElim ProcRn.
OldElim (A4 (seq
               (alt D+[d:D](ia Frame r3 (Tuple b d)) (ia Frame r3 lce))
               (seq (ia frame s5 (tuple b)) (Rn b)))
          ( D
            +[d:D]
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b))))))
          y).

OldElim CM9.

Cut Delta=
        (comm
         (seq (ia frame r5 d)
            (seq
               (alt (seq (ia one int i) (ia frame s6 d))
                  (seq (ia one int i) (ia frame s6 sce)))
               (L i)))
         (seq
            D
            +[d:D]
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
             y)).
Intro.
OldElim H.
OldElim A6.
OldElim (A5 (alt D+[d:D](ia Frame r3 (Tuple b d)) (ia Frame r3 lce))
       (seq (ia frame s5 (tuple b)) (Rn b))
       y).
OldElim A4.
OldElim (A4 D+[d:D](ia Frame r3 (Tuple b d)) (ia Frame r3 lce) 
         (seq (seq (ia frame s5 (tuple b)) (Rn b)) y)).
OldElim CM9.
Cut Delta=
      (comm
         (seq (ia frame r5 d)
            (alt (seq (seq (ia one int i) (ia frame s6 d)) (L i))
               (seq (seq (ia one int i) (ia frame s6 sce)) (L i))))
         (seq (ia Frame r3 lce)
            (seq (seq (ia frame s5 (tuple b)) (Rn b))
               y))).

Intro.
OldElim H0.
OldElim A6.
OldElim (SUM5 D ([d:D](ia Frame r3 (Tuple b d)))
      (seq (seq (ia frame s5 (tuple b)) (Rn b)) y)).
OldElim SC3.
OldElim SUM7.
ElimType ([d:D]Delta)=
    ([d0:D]
     (comm
        (seq (ia Frame r3 (Tuple b d0))
           (seq (seq (ia frame s5 (tuple b)) (Rn b))
              y))
        (seq (ia frame r5 d)
           (alt (seq (seq (ia one int i) (ia frame s6 d)) (L i))
              (seq (seq (ia one int i) (ia frame s6 sce)) (L i)))))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQFf.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Red.
Intro.
Apply EQFf.
Apply EQ_sym.
Assumption.
OldElim (SUM5 D ([d:D]
           (seq (ia Frame r3 (Tuple (toggle b) d))
              (seq (ia D s4 d) (ia frame s5 (tuple (toggle b))))))
     y).
OldElim SC3. 
OldElim SUM7.
ElimType ([d:D]Delta)=
          ([d0:D]
     (comm
        (seq
           (seq (ia Frame r3 (Tuple (toggle b) d0))
              (seq (ia D s4 d0) (ia frame s5 (tuple (toggle b)))))
           y)
        (seq (ia frame r5 d)
           (seq
              (alt (seq (ia one int i) (ia frame s6 d))
                 (seq (ia one int i) (ia frame s6 sce)))
              (L i))))).
OldElim SUM1.   
Apply refl_equal.
Apply EXT ; Intro.
OldElim A5.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQFf.
Save CommLRn.

Goal (x:proc)Delta=(enc H (Lmer (comm (K i) (L i)) x)).
Cut Delta=(comm (K i) (L i)).
Intro H0.
OldElim H0.
Unfold 2 Delta.
Intro.
OldElim CM2.
OldElim A7.
OldElim D3.
Apply refl_equal.
OldElim ChanK.
OldElim SUM7.
ElimType ([d:Frame]Delta)=
       ([d:Frame]
     (comm
        (seq (ia Frame r2 d)
           (seq
              (alt (seq (ia one int i) (ia Frame s3 d))
                 (seq (ia one int i) (ia Frame s3 lce)))
              (K i)))
        (L i))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro .
OldElim ChanL.
OldElim SC3.
OldElim SUM7.
ElimType ([d:frame]Delta)=
         ([d0:frame]
     (comm
        (seq (ia frame r5 d0)
           (seq
              (alt (seq (ia one int i) (ia frame s6 d0))
                 (seq (ia one int i) (ia frame s6 sce)))
              (L i)))
        (seq (ia Frame r2 d)
           (seq
              (alt (seq (ia one int i) (ia Frame s3 d))
                 (seq (ia one int i) (ia Frame s3 lce)))
              (K i))))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro.
OldElim CM7.
OldElim CF2''.   
OldElim A7.
Apply refl_equal.
Red ; Intro.
Apply EQFf.
Apply EQ_sym.
Assumption.

Save CommKL.

Goal (b:bit)(x,y:proc)
       Delta=(enc H (Lmer (comm (K i) (seq (Rn b) y)) x)).
Intros.
Cut Delta=(comm (K i) (seq (Rn b) y)).
Intro H0.
OldElim H0.
Unfold 2 Delta.
OldElim CM2.
OldElim A7. 
OldElim D3.
Apply refl_equal. 

OldElim ChanK.
OldElim SUM7.
ElimType ([d:Frame]Delta)=
      ([d:Frame]
     (comm
        (seq (ia Frame r2 d)
           (seq
              (alt (seq (ia one int i) (ia Frame s3 d))
                 (seq (ia one int i) (ia Frame s3 lce)))
              (K i)))
        (seq (Rn b) y))).
OldElim SUM1 ; Apply refl_equal.  
Apply EXT ; Intro.
OldElim ProcRn.
OldElim A4.
OldElim (A4 
       (seq
               (alt D+[d:D](ia Frame r3 (Tuple b d)) (ia Frame r3 lce))
               (seq (ia frame s5 (tuple b)) (Rn b)))
       (        D
            +[d:D]
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
            )
  y).
OldElim CM9.
Cut Delta=
       (comm
         (seq (ia Frame r2 d)
            (alt (seq (seq (ia one int i) (ia Frame s3 d)) (K i))
               (seq (seq (ia one int i) (ia Frame s3 lce)) (K i))))
         (seq
            D
            +[d:D]
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
             y)).
Intro .
OldElim H.
OldElim A6.
OldElim A5.
OldElim A5.
OldElim (A5 (alt D+[d:D](ia Frame r3 (Tuple b d)) (ia Frame r3 lce))
     (seq (ia frame s5 (tuple b)) (Rn b))
      y).
OldElim (A4 (D+[d:D](ia Frame r3 (Tuple b d))) (ia Frame r3 lce)
         (seq (seq (ia frame s5 (tuple b)) (Rn b))
            y)).
OldElim CM9.
OldElim CM7.
OldElim CF2.
OldElim A7 ; OldElim  A6.
OldElim (SUM5 D ([d:D](ia Frame r3 (Tuple b d)))
          (seq (seq (ia frame s5 (tuple b)) (Rn b))
            y)).
OldElim SC3.
OldElim SUM7.
ElimType ([d:D]Delta)= 
     ([d0:D]
     (comm
        (seq (ia Frame r3 (Tuple b d0))
           (seq (seq (ia frame s5 (tuple b)) (Rn b))
              y))
        (seq (ia Frame r2 d)
           (alt (seq (ia one int i) (seq (ia Frame s3 d) (K i)))
              (seq (ia one int i) (seq (ia Frame s3 lce) (K i))))))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro.
OldElim CM7.
OldElim CF2.
OldElim A7 ; Apply refl_equal.  
Apply refl_equal.
Apply refl_equal.
OldElim SC3.

OldElim (SUM5 D ([d:D]
           (seq (ia Frame r3 (Tuple (toggle b) d))
              (seq (ia D s4 d) (ia frame s5 (tuple (toggle b))))))
       y).
OldElim SUM7.
ElimType ([d:D]Delta)=
     ([d0:D]
     (comm
        (seq
           (seq (ia Frame r3 (Tuple (toggle b) d0))
              (seq (ia D s4 d0) (ia frame s5 (tuple (toggle b)))))
           y)
        (seq (ia Frame r2 d)
           (alt (seq (seq (ia one int i) (ia Frame s3 d)) (K i))
              (seq (seq (ia one int i) (ia Frame s3 lce)) (K i)))))).
OldElim SUM1 ; Apply refl_equal.  
Apply EXT ; Intro.
OldElim A5.
OldElim CM7.
OldElim CF2.
OldElim A7.
Apply refl_equal.
Apply refl_equal.  
Save CommKRn.



Goal (b:bit)(x,y:proc)
      Delta=(enc H (Lmer (comm (seq (Sn b) y) (K i)) x)).
Intros.
Cut Delta=(comm (seq (Sn b) y) (K i)).
Intro H0. 
OldElim H0.
Unfold 2 Delta.
OldElim CM2.
OldElim A7.
OldElim D3.
Apply refl_equal.

OldElim ProcSn.
OldElim (SUM5 D ([d:D](seq (ia D r1 d) (Sn_d d b))) y).
OldElim SUM7.
ElimType ([d:D]Delta)=
        ([d:D](comm (seq (seq (ia D r1 d) (Sn_d d b)) y) (K i))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro.
OldElim A5.
OldElim ChanK.
OldElim SC3.
OldElim SUM7.
ElimType ([d:Frame]Delta)=
    ([d0:Frame]
     (comm
        (seq (ia Frame r2 d0)
           (seq
              (alt (seq (ia one int i) (ia Frame s3 d0))
                 (seq (ia one int i) (ia Frame s3 lce)))
              (K i)))
        (seq (ia D r1 d) (seq (Sn_d d b) y)))).
OldElim SUM1 ; Apply refl_equal.   
Apply EXT ; Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQFD.

Save  CommSnK.

Goal (b:bit)(x,y:proc)
          Delta=(enc H (Lmer (comm (seq (Sn b) y) (L i)) x)).

Intros.    
Cut Delta=(comm (seq (Sn b) y) (L i)).
Intro H0.   
OldElim H0.
Unfold 2 Delta.
OldElim CM2. 
OldElim A7.
OldElim D3.
Apply refl_equal.

OldElim ProcSn.
OldElim (SUM5 D ([d:D](seq (ia D r1 d) (Sn_d d b))) y).
OldElim SUM7.
ElimType ([d:D]Delta)=
        ([d:D](comm (seq (seq (ia D r1 d) (Sn_d d b)) y) (L i))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro. 
OldElim A5.
OldElim ChanL.
OldElim SC3.
OldElim SUM7.
ElimType ([d:frame]Delta)=
     ([d0:frame]
     (comm
        (seq (ia frame r5 d0)
           (seq
              (alt (seq (ia one int i) (ia frame s6 d0))
                 (seq (ia one int i) (ia frame s6 sce)))
              (L i)))
        (seq (ia D r1 d) (seq (Sn_d d b) y)))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQfD.
Save CommSnL.


Goal (b,b':bit)(x,y,y':proc)
         Delta=(enc H (Lmer (comm (seq (Sn b) y) (seq (Rn b') y')) x)).
Intros.
Cut Delta=(comm (seq (Sn b) y) (seq (Rn b') y')). 
Intro H0.   
OldElim H0.
Unfold 2 Delta. 
OldElim CM2. 
OldElim A7. 
OldElim D3.
Apply refl_equal. 
 
OldElim ProcSn.
OldElim (SUM5 D ([d:D](seq (ia D r1 d) (Sn_d d b))) y). 
OldElim SUM7.
ElimType ([d:D]Delta)=
       ([d:D](comm (seq (seq (ia D r1 d) (Sn_d d b)) y) (seq (Rn b') y'))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro. 
OldElim A5.

OldElim ProcRn.
OldElim (A4 (seq
               (alt D+[d:D](ia Frame r3 (Tuple b' d)) (ia Frame r3 lce))
               (seq (ia frame s5 (tuple b')) (Rn b')))
         (D
            +[d:D]
              (seq (ia Frame r3 (Tuple (toggle b') d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b')))))
            )
         y').

OldElim CM9.
Cut Delta=
        (comm (seq (ia D r1 d) (seq (Sn_d d b) y))
         (seq
            D
            +[d:D]
              (seq (ia Frame r3 (Tuple (toggle b') d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b')))))
             y')).
Intro.
OldElim H.
OldElim A6.
OldElim (A5 (alt D+[d:D](ia Frame r3 (Tuple b' d)) (ia Frame r3 lce))
                 (seq (ia frame s5 (tuple b')) (Rn b'))
                  y').
OldElim (A4 (D+[d:D](ia Frame r3 (Tuple b' d)))
          (ia Frame r3 lce)
              (seq (seq (ia frame s5 (tuple b')) (Rn b'))
            y')).  
OldElim CM9.
OldElim CM7.
OldElim CF2''.
OldElim A7 ; OldElim A6.
OldElim SC3.
OldElim (SUM5 D ([d:D](ia Frame r3 (Tuple b' d)))
              (seq (seq (ia frame s5 (tuple b')) (Rn b'))
                   y')).
OldElim SUM7.
ElimType  ([d:D]Delta)=
      ([d0:D] (comm
        (seq (ia Frame r3 (Tuple b' d0))
           (seq (seq (ia frame s5 (tuple b')) (Rn b')) y'))
        (seq (ia D r1 d) (seq (Sn_d d b) y)))).
OldElim SUM1 ; Apply refl_equal. 
Apply EXT ; Intro. 
OldElim CM7 . 
OldElim CF2'' . 
OldElim A7 ; Apply refl_equal. 
Exact EQFD.
Red.
Intro.
Apply EQFD.
Apply EQ_sym.
Assumption.

OldElim (SUM5 D ([d:D]
           (seq (ia Frame r3 (Tuple (toggle b') d))
              (seq (ia D s4 d) (ia frame s5 (tuple (toggle b'))))))
           y').
OldElim SC3.
OldElim SUM7.
ElimType ([d:D]Delta)=
     ([d0:D]
      (comm
        (seq
           (seq (ia Frame r3 (Tuple (toggle b') d0))
              (seq (ia D s4 d0) (ia frame s5 (tuple (toggle b')))))
           y')
        (seq (ia D r1 d) (seq (Sn_d d b) y)))).

OldElim SUM1 ; Apply refl_equal.  
Apply EXT ; Intro. 
OldElim A5.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQFD.

Save CommSnRn.

Goal (b:bit)(d:D)(x,y:proc)Delta=(enc H (Lmer (seq (Sn_d d b) y) x)).

Intros.
OldElim ProcSn_d.
OldElim A5.
OldElim CM3.
OldElim D5.
OldElim D2.
OldElim A7.
Apply refl_equal.
Exact Ins2H.
Save LmerSnd.

Goal (b:bit)(d:D)(x,y:proc)Delta=(enc H (Lmer (seq (Tn_d d b) y) x)).
Intros.
OldElim ProcTn_d.
OldElim A4.
OldElim A4.
OldElim A4.
OldElim CM4.
OldElim CM4.
OldElim A5.
OldElim A5.
OldElim CM3.
OldElim CM3.
OldElim CM3.
OldElim D4.
OldElim D4.
OldElim D5.
OldElim D5.
OldElim D5.
OldElim D2.
OldElim D2.
OldElim D2.
OldElim A7.
OldElim A7.
OldElim A6.
OldElim A6.
Apply refl_equal.
Exact Inr6H.
Exact Inr6H.
Exact Inr6H.
Save LmerTnd.

Goal (f:frame)(x,y:proc)
        Delta=(enc H (Lmer (seq (ia frame s5 f) y) x)).

Intros.
OldElim CM3.
OldElim D5.
OldElim D2.
OldElim A7.
Apply refl_equal.
Exact Ins5H.
Save Lmers5.

Goal (d:D)(x,y:proc)
        (seq (ia D s4 d) (enc H (mer y x)))=
             (enc H (Lmer (seq (ia D s4 d) y) x)).

Intros.
OldElim CM3.
OldElim D5.
OldElim D1.
Apply refl_equal.
Exact Ins4H.
Save Lmers4.

 
Goal (x,y,y':proc)
        (alt (seq (ia one int i) (enc H (mer y x)))
                    (seq (ia one int i) (enc H (mer y' x))))=
             (enc H (Lmer (alt (seq (ia one int i) y)
                               (seq (ia one int i) y')) x)).
 
Intros.
OldElim CM4.
OldElim CM3.
OldElim CM3.
OldElim D4.
OldElim D5.
OldElim D5.
OldElim D1.
Apply refl_equal.
Exact InintH.
Save Lmeri.

Goal (f:Frame)(x,y:proc)
       Delta=(enc H (Lmer (seq (ia Frame s3 f) y) x)).

Intros.
OldElim CM3.
OldElim D5.
OldElim D2.
OldElim A7.
Apply refl_equal.
Exact Ins3H.
Save Lmers3.

Goal (f:frame)(x,y:proc)
       Delta=(enc H (Lmer (seq (ia frame s6 f) y) x)).

Intros.
OldElim CM3.
OldElim D5.
OldElim D2.
OldElim A7.
Apply refl_equal.
Exact Ins6H.
Save Lmers6.

Goal (c: bool)(p:proc)(cond p c p)=p.
Intros.
OldElim c.
OldElim COND1.
Apply refl_equal.
OldElim COND2.
Apply refl_equal.
Save Bak4_2_1.

Goal (c:bool)(x,y,z:proc)
      ((true=c)->(x=y))->((cond x c z)=(cond y c z)).
Intro.
Intro.
Intro.
Intro.
OldElim c.
Intro.
OldElim COND1.
OldElim COND1.
OldElim H.
Apply refl_equal.
Apply refl_equal.

Intro.
OldElim COND2.
OldElim COND2.
Apply refl_equal.
Save Def4_3_1_2.

Goal (c:bool)(x,y,z:proc)
      ((false=c)->(x=y))->((cond z c x)=(cond z c y)).

Intro.
Intro.
Intro.
Intro.
OldElim c.
Intro.
OldElim COND1.
OldElim COND1.
Apply refl_equal.

Intro.
OldElim COND2.
OldElim COND2.
OldElim H.
Apply refl_equal.
Apply refl_equal.
Save Def4_3_1_2'.

Goal(x:Frame->proc)(d:Frame)(x d) =
    (sum Frame ([e:Frame](cond (x d) (eqF e d) Delta))).

Intros.
Pattern 1 (x d).
ElimType ((Frame+[e:Frame](x d))=(x d)).
Cut (e:Frame)(x d)=(alt (cond (x d) (eqF e d) Delta) (x d)).
Intros.
OldElim (SUM3 Frame d [e:Frame](cond (x d) (eqF e d) Delta)).

OldElim eqF7.
OldElim COND1.
Pattern 3 (x d).
ElimType ((Frame+[e:Frame](x d))=(x d)).
Cut (x,y:Frame->proc)
      ((Frame+[d:Frame](alt (x d) (y d)))=(alt (Frame+x) (Frame+y))).
Intro SUM4r.

OldElim SUM4r.
Cut ([e:Frame](alt (cond (x d) (eqF e d) Delta) (x d)))=
                          [e:Frame](x d).
Intros.
OldElim H0.
Apply refl_equal.

Apply EXT.
Intro ; Apply sym_equal ; Trivial.
Intros.
Apply sym_equal.
Apply SUM4.


OldElim SUM1; Auto.
Intro.
OldElim (eqF e d).
OldElim COND1.
OldElim A3;Auto.
OldElim COND2.
OldElim A1;OldElim A6;Auto.
OldElim SUM1;Auto.
Save Sum_EliminationF.

Goal(x:frame->proc)(d:frame)(x d) =
    (sum frame ([e:frame](cond (x d) (eqf e d) Delta))).

Intros.
Pattern 1 (x d).
ElimType ((frame+[e:frame](x d))=(x d)).
Cut (e:frame)(x d)=(alt (cond (x d) (eqf e d) Delta) (x d)).
Intros.
OldElim (SUM3 frame d [e:frame](cond (x d) (eqf e d) Delta)).

OldElim eqf7.
OldElim COND1.
Pattern 3 (x d).
ElimType ((frame+[e:frame](x d))=(x d)).
Cut (x,y:frame->proc)
      ((frame+[d:frame](alt (x d) (y d)))=(alt (frame+x) (frame+y))).
Intro SUM4r.

OldElim SUM4r.
Cut ([e:frame](alt (cond (x d) (eqf e d) Delta) (x d)))=
                          ([e:frame](x d)).
Intros.
OldElim H0.
Apply refl_equal.

Apply EXT.
Intro ; Apply sym_equal ; Trivial.
Intros.
Apply sym_equal.
Apply SUM4.
 
 
OldElim SUM1; Auto.
Intro.
OldElim (eqf e d).
OldElim COND1.
OldElim A3;Auto.
OldElim COND2.
OldElim A1;OldElim A6;Auto.
OldElim SUM1;Auto.
Save Sum_Eliminationf.
 

Goal(x:D->proc)(d:D)(x d) =
    (sum D ([e:D](cond (x d) (eqD e d) Delta))).
 
Intros.
Pattern 1 (x d).
ElimType ((D+[e:D](x d))=(x d)).
Cut (e:D)(x d)=(alt (cond (x d) (eqD e d) Delta) (x d)).
Intros.  
OldElim (SUM3 D d [e:D](cond (x d) (eqD e d) Delta)).
 
OldElim eqD7.
OldElim COND1.
Pattern 3 (x d).
ElimType ((D+[e:D](x d))=(x d)).
Cut (x,y:D->proc)
      ((D+[d:D](alt (x d) (y d)))=(alt (D+x) (D+y))).
Intro SUM4r.
 
OldElim SUM4r.
Cut ([e:D](alt (cond (x d) (eqD e d) Delta) (x d)))=
                          ([e:D](x d)).
Intros.  
OldElim H0.
Apply refl_equal.
 
Apply EXT.
Intro ; Apply sym_equal ; Trivial.
Intros.  
Apply sym_equal.
Apply SUM4.
 
 
OldElim SUM1; Auto.
Intro.   
OldElim (eqD e d).
OldElim COND1.
OldElim A3;Auto.
OldElim COND2.
OldElim A1;OldElim A6;Auto.
OldElim SUM1;Auto.
Save Sum_EliminationD.
 

Goal (d:D)(n:bit)(y:proc)
     
     (seq
         (ia Frame c2 (Tuple n d))
         (mer
             y
             (seq
                 (alt
                     (seq
                         (ia one int i)
                         (ia Frame s3 (Tuple n d)))   
                     (seq
                         (ia one int i)
                         (ia Frame s3 lce)))   
                 (K i))))=
     (comm (seq (ia Frame s2 (Tuple n d)) y) (K i)).

Intros.
Pattern 2 (K i).
OldElim ChanK.
OldElim SC3.
OldElim SUM7.

ElimType 
    ([d0:Frame]
    (cond
      (seq (ia Frame c2 (Tuple n d))
      (mer y
         (seq
            (alt (seq (ia one int i) (ia Frame s3 (Tuple n d)))
               (seq (ia one int i) (ia Frame s3 lce)))
            (K i))))
       (eqF d0 (Tuple n d))
       Delta))
     =
     ([d0:Frame]
     (comm
        (seq (ia Frame r2 d0)
           (seq
              (alt (seq (ia one int i) (ia Frame s3 d0))
                 (seq (ia one int i) (ia Frame s3 lce)))
              (K i)))
        (seq (ia Frame s2 (Tuple n d)) y))).


2:Apply EXT ; Intro.
2:OldElim CM7.
2:OldElim (Bak4_2_1
       (eqF d0 (Tuple n d))  
       (seq (comm (ia Frame r2 d0) (ia Frame s2 (Tuple n d)))
        (mer
         (seq
            (alt (seq (ia one int i) (ia Frame s3 d0))
               (seq (ia one int i) (ia Frame s3 lce)))
            (K i))
         y))
       ).
2:OldElim (Def4_3_1_2' 
         (eqF d0 (Tuple n d))
         Delta
         (seq (comm (ia Frame r2 d0) (ia Frame s2 (Tuple n d)))
         (mer
            (seq
               (alt (seq (ia one int i) (ia Frame s3 d0))
                  (seq (ia one int i) (ia Frame s3 lce)))
               (K i))
            y))
         (seq (comm (ia Frame r2 d0) (ia Frame s2 (Tuple n d)))
         (mer
            (seq
               (alt (seq (ia one int i) (ia Frame s3 d0))
                  (seq (ia one int i) (ia Frame s3 lce)))
               (K i))
            y))).
2:OldElim (Def4_3_1_2
          (eqF d0 (Tuple n d))
          (seq (ia Frame c2 (Tuple n d))
         (mer y
            (seq
               (alt (seq (ia one int i) (ia Frame s3 (Tuple n d)))
                  (seq (ia one int i) (ia Frame s3 lce)))
               (K i))))
           (seq (comm (ia Frame r2 d0) (ia Frame s2 (Tuple n d)))
         (mer
            (seq
               (alt (seq (ia one int i) (ia Frame s3 d0))
                  (seq (ia one int i) (ia Frame s3 lce)))
               (K i))
            y))
         Delta).
2:Apply refl_equal.
2:Intros.
2:OldElim (eqF_intro d0 (Tuple n d)).
3:Assumption.
2:OldElim CF1.
2:Unfold gamma.
2:OldElim SC6.
2:Apply refl_equal.

2:Intro.
2:OldElim CF2'.
2:OldElim A7.
2:Apply refl_equal.

2:Apply eqF_intro'.
2:Assumption.
OldElim (Sum_EliminationF
          [d':Frame]
          (seq (ia Frame c2 d')
           (mer y
              (seq
                 (alt (seq (ia one int i) (ia Frame s3 d'))
                    (seq (ia one int i) (ia Frame s3 lce)))
                 (K i))))
          (Tuple n d)).
Apply refl_equal.
Save comms2K.


Goal (d:D)(n:bit)(y,x:proc)
     
     (seq
         (ia Frame c2 (Tuple n d))
         (enc H
          (mer
           (mer
             y
             (seq
                 (alt
                     (seq
                         (ia one int i)
                         (ia Frame s3 (Tuple n d)))
                     (seq
                         (ia one int i)
                         (ia Frame s3 lce)))
                 (K i)))
          x)))=
     (enc H (Lmer (comm (seq (ia Frame s2 (Tuple n d)) y) (K i)) x)).

Intros.
OldElim comms2K.
OldElim CM3.
OldElim D5.
OldElim D1.
Apply refl_equal.
Exact Inc2H.
Save Comms2K.

Goal (d:D)(n,n':bit)(y,y':proc)
      Delta=
     (comm (seq (ia Frame s2 (Tuple n d)) y) (seq (Rn n') y')).
Intros.
OldElim ProcRn.
OldElim (A4 
        (seq
               (alt (D+[d:D](ia Frame r3 (Tuple n' d))) (ia Frame r3 lce))
               (seq (ia frame s5 (tuple n')) (Rn n')))
        (D+[d:D]
              (seq (ia Frame r3 (Tuple (toggle n') d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle n'))))))
       y').
OldElim CM9.
OldElim (A4 (D+[d:D](ia Frame r3 (Tuple n' d)))
                  (ia Frame r3 lce) (seq (ia frame s5 (tuple n')) (Rn n'))).
OldElim (A4 (seq (D+[d:D](ia Frame r3 (Tuple n' d)))
                  (seq (ia frame s5 (tuple n')) (Rn n')))
               (seq (ia Frame r3 lce)
                  (seq (ia frame s5 (tuple n')) (Rn n')))
               y').           
OldElim (CM9 
       (seq (ia Frame s2 (Tuple n d)) y)
             (seq
               (seq (D+[d:D](ia Frame r3 (Tuple n' d)))
                  (seq (ia frame s5 (tuple n')) (Rn n')))
               y')
       (seq
               (seq (ia Frame r3 lce)
                  (seq (ia frame s5 (tuple n')) (Rn n')))
               y')).

ElimType Delta=
       (comm (seq (ia Frame s2 (Tuple n d)) y)
         (seq
            (D
            +[d:D]
              (seq (ia Frame r3 (Tuple (toggle n') d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle n'))))))
             y')).


ElimType Delta=
 (comm (seq (ia Frame s2 (Tuple n d)) y)
            (seq
               (seq (ia Frame r3 lce)
                  (seq (ia frame s5 (tuple n')) (Rn n')))
               y')).

Repeat OldElim A6.
OldElim (A5 (D+[d:D](ia Frame r3 (Tuple n' d)))
             (seq (ia frame s5 (tuple n')) (Rn n'))
                y').
OldElim SC3.

OldElim (SUM5 D 
        [d:D](ia Frame r3 (Tuple n' d))
        (seq (seq (ia frame s5 (tuple n')) (Rn n')) y')).
OldElim SUM7.
ElimType ([d0:D]Delta)=
     ([d0:D]
     (comm
        (seq (ia Frame r3 (Tuple n' d0))
           (seq (seq (ia frame s5 (tuple n')) (Rn n')) y'))
        (seq (ia Frame s2 (Tuple n d)) y))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro.
OldElim CM7.
OldElim CF2.
OldElim A7.
Apply refl_equal.
Apply refl_equal.
OldElim A5.
OldElim CM7.
OldElim CF2.
OldElim A7. 
Apply refl_equal. 
Apply refl_equal. 
OldElim SC3.
OldElim (SUM5 D [d:D]
           (seq (ia Frame r3 (Tuple (toggle n') d))
              (seq (ia D s4 d) (ia frame s5 (tuple (toggle n')))))
       y').
OldElim SUM7.
ElimType  ([d0:D]Delta)= 
     ([d0:D]
     (comm
        (seq
           (seq (ia Frame r3 (Tuple (toggle n') d0))
              (seq (ia D s4 d0) (ia frame s5 (tuple (toggle n')))))
           y')
        (seq (ia Frame s2 (Tuple n d)) y))).

OldElim SUM1 ; Apply refl_equal. 
Apply EXT ; Intro. 
OldElim A5.
OldElim CM7.
OldElim CF2.
OldElim A7.
Apply refl_equal.
Apply refl_equal.

Save comms2Rn.

Goal (n,n':bit)(d:D)(x,y,y':proc)Delta=
   (enc H (Lmer  (comm (seq (ia Frame s2 (Tuple n d)) y) (seq (Rn n') y')) x)).
Intros.
OldElim comms2Rn.
Unfold Delta.
OldElim CM2.
OldElim A7.
OldElim D3.
Apply refl_equal.

Save Comms2Rn.

Goal (d:D)(n:bit)(y:proc)
      Delta=
     (comm (seq (ia Frame s2 (Tuple n d)) y) (L i)).
Intros.
OldElim ChanL.
OldElim SC3.
OldElim SUM7.
ElimType  ([d0:frame]Delta)=
     ([d0:frame]
     (comm
        (seq (ia frame r5 d0)
           (seq
              (alt (seq (ia one int i) (ia frame s6 d0))
                 (seq (ia one int i) (ia frame s6 sce)))
              (L i)))
        (seq (ia Frame s2 (Tuple n d)) y))).
OldElim SUM1.
Apply refl_equal.
Apply EXT ; Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Red.
Intro.
Apply EQFf.
Apply EQ_sym.
Assumption.
Save comms2L.

Goal (d:D)(n:bit)(x,y:proc)
      Delta=
     (enc H (Lmer (comm (seq (ia Frame s2 (Tuple n d)) y) (L i)) x)).
Intros.
OldElim comms2L.
Unfold Delta.
OldElim CM2.
OldElim A7.
OldElim D3.
Apply refl_equal.
Save Comms2L.

Goal (x,y,y':proc)Delta=
     (enc H 
        (Lmer 
           (comm 
              (alt (seq (ia one int i) y) (seq (ia one int i) y'))
              (L i))
           x)).
Intros.
OldElim SC3.
OldElim CM9.
OldElim ChanL.
ElimType Delta=
      (comm
               (frame
               +[n:frame]
                 (seq (ia frame r5 n)
                    (seq
                       (alt (seq (ia one int i) (ia frame s6 n))
                          (seq (ia one int i) (ia frame s6 sce)))
                       (L i))))
                (seq (ia one int i) y')).

ElimType Delta= 
            (comm
               (frame
               +[n:frame]
                 (seq (ia frame r5 n)
                    (seq
                       (alt (seq (ia one int i) (ia frame s6 n))
                          (seq (ia one int i) (ia frame s6 sce)))
                       (L i))))
                (seq (ia one int i) y)) .
OldElim A6.
Unfold Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.
Apply refl_equal.
OldElim SUM7.
ElimType ([d:frame]Delta)=
   ([d:frame]
     (comm
        (seq (ia frame r5 d)
           (seq
              (alt (seq (ia one int i) (ia frame s6 d))
                 (seq (ia one int i) (ia frame s6 sce)))
              (L i)))
        (seq (ia one int i) y))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQfi.
OldElim SUM7.
ElimType ([d:frame]Delta)= 
     ([d:frame]
     (comm
        (seq (ia frame r5 d)
           (seq
              (alt (seq (ia one int i) (ia frame s6 d))
                 (seq (ia one int i) (ia frame s6 sce)))
              (L i)))
        (seq (ia one int i) y'))).

OldElim SUM1 ; Apply refl_equal. 
Apply EXT ; Intro.
OldElim CM7.
OldElim CF2''. 
OldElim A7.
Apply refl_equal. 
Exact EQfi.

Save CommiL.

Goal
    (x,y,y':proc)Delta=
     (enc H
        (Lmer
           (comm
              (alt (seq (ia one int i) y) (seq (ia one int i) y'))
              (K i))
           x)).
Intros.
OldElim SC3.
OldElim ChanK.
OldElim (SUM7 Frame
             [x:Frame]
              (seq (ia Frame r2 x)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 x))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
             (alt (seq (ia one int i) y) (seq (ia one int i) y'))).
ElimType ([d:Frame]Delta)=
      ([d:Frame]
           (comm
              (seq (ia Frame r2 d)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 d))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
              (alt (seq (ia one int i) y) (seq (ia one int i) y')))).
OldElim SUM1.
Unfold 2 Delta.
OldElim CM2.
OldElim D5. OldElim D3.
OldElim A7. Apply refl_equal.
Apply EXT. Intro.
OldElim A4.
OldElim CM9.
OldElim CM7.
OldElim CM7.
OldElim CF2''.
OldElim A7.
OldElim A7.
OldElim A6.
Apply refl_equal.
Exact EQFi.

Save CommiK.



Goal (x,y,y':proc)(b:bit)
     Delta= 
     (enc H 
        (Lmer 
           (comm 
              (seq (ia one int i) y)
              (seq (Rn b) y'))
           x)).   
Intros.
OldElim SC3.
OldElim ProcRn.
ElimType Delta=
      (comm
               (seq
                  (alt
                     (seq
                        (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                           (ia Frame r3 lce))
                        (seq (ia frame s5 (tuple b)) (Rn b)))
                     (D
                     +[d:D]
                       (seq (ia Frame r3 (Tuple (toggle b) d))
                          (seq (ia D s4 d)
                             (ia frame s5 (tuple (toggle b))))))
                     )
                  y')
               (seq (ia one int i) y)).

Unfold Delta.
OldElim CM2.
OldElim A7.
OldElim D3.
Apply refl_equal. 

OldElim (A4 (seq
               (alt (D+[d:D](ia Frame r3 (Tuple b d))) (ia Frame r3 lce))
               (seq (ia frame s5 (tuple b)) (Rn b)))
         (D +[d:D]
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b))))))
         y').
OldElim CM8.
ElimType Delta=
       (comm
         (seq
            (D
            +[d:D]
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b))))))
             y')
         (seq (ia one int i) y)).
OldElim A6.
OldElim (A5 (alt (D+[d:D](ia Frame r3 (Tuple b d))) (ia Frame r3 lce))
         (seq (ia frame s5 (tuple b)) (Rn b))
         y').
OldElim (A4  (D+[d:D](ia Frame r3 (Tuple b d)))
          (ia Frame r3 lce)
          (seq (seq (ia frame s5 (tuple b)) (Rn b)) y')).
OldElim CM8.
ElimType Delta=
         (comm
         (seq (ia Frame r3 lce)
            (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
         (seq (ia one int i) y)).
OldElim A6.
OldElim (SUM5 D [d:D](ia Frame r3 (Tuple b d))
          (seq (seq (ia frame s5 (tuple b)) (Rn b)) y')).
OldElim SUM7.
ElimType ([d:D]Delta)=
        ([d:D]
     (comm
        (seq (ia Frame r3 (Tuple b d))
           (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
        (seq (ia one int i) y))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQFi.
OldElim CM7.
OldElim CF2''.
OldElim A7. 
Apply refl_equal.
Exact EQFi. 
OldElim (SUM5 D [d:D]
           (seq (ia Frame r3 (Tuple (toggle b) d))
              (seq (ia D s4 d) (ia frame s5 (tuple (toggle b))))) y').
OldElim SUM7.
ElimType ([d:D]Delta)=
            ([d:D]
     (comm
        (seq
           (seq (ia Frame r3 (Tuple (toggle b) d))
              (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
           y')
        (seq (ia one int i) y))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro.
OldElim A5.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQFi.
Save commiRn.

Goal (x,y,y',y'':proc)(b:bit)
     Delta= 
     (enc H 
        (Lmer 
           (comm 
              (alt (seq (ia one int i) y) (seq (ia one int i) y'))
              (seq (Rn b) y''))
           x)).   
Intros.
OldElim CM8.
OldElim CM4.
OldElim D4.
OldElim commiRn.
OldElim commiRn.
OldElim A6.
Apply refl_equal.
Save CommiRn.

Goal (x,y:proc)(b:bit)(d:D)
     Delta=
     (enc H  
        (Lmer  
           (comm  
              (seq (Tn_d d b) y)
              (L i))
           x)).
Intros.
OldElim ProcTn_d.
OldElim ChanL.
OldElim A4.
OldElim (SC3 (alt
               (seq
                  (seq
                     (alt (ia frame r6 (tuple (toggle b)))
                        (ia frame r6 sce))
                     (Sn_d d b))
                  y)
               (seq (ia frame r6 (tuple b)) y))
           (frame
            +[n:frame]
              (seq (ia frame r5 n)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 n))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i))))).
OldElim (SUM7 frame 
          [n:frame]
              (seq (ia frame r5 n)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 n))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
              
            (alt
               (seq
                  (seq
                     (alt (ia frame r6 (tuple (toggle b)))
                        (ia frame r6 sce))
                     (Sn_d d b))
                  y)
               (seq (ia frame r6 (tuple b)) y))).
OldElim (SUM6 frame 
           [d0:frame]
           (comm
              (seq (ia frame r5 d0)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 d0))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
              (alt
                 (seq
                    (seq
                       (alt (ia frame r6 (tuple (toggle b)))
                          (ia frame r6 sce))
                       (Sn_d d b))
                    y)
                 (seq (ia frame r6 (tuple b)) y)))
              x).
OldElim SUM9.
ElimType ([d:frame]Delta)=
     ([d0:frame]
     (enc H
        (Lmer
           (comm
              (seq (ia frame r5 d0)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 d0))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
              (alt
                 (seq
                    (seq
                       (alt (ia frame r6 (tuple (toggle b)))
                          (ia frame r6 sce))
                       (Sn_d d b))
                    y)
                 (seq (ia frame r6 (tuple b)) y)))
           x))).
OldElim SUM1 ; Apply refl_equal.
Apply EXT ; Intro.
OldElim CM9.
OldElim A5.
OldElim A4.
OldElim A4.
OldElim CM9.
OldElim CM7.
OldElim CM7.
OldElim CM7.
OldElim CF2.
OldElim CF2.
OldElim CF2.
OldElim A7.
OldElim A7.
OldElim A6.
OldElim A6.
Unfold Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.
Apply refl_equal.
Apply refl_equal.
Apply refl_equal.
Apply refl_equal.
Save CommTn_dL.


Goal (x,y,y':proc)(b:bit)(d:D)
     Delta=
     (enc H   
        (Lmer 
           (comm
              (seq (Tn_d d b) y)
              (seq (ia one int i) y'))
           x)).
Intros.
OldElim ProcTn_d.
OldElim A4.
OldElim CM8.
OldElim A5.
OldElim A4.
OldElim CM8.
OldElim CM7.
OldElim CM7.
OldElim CM7.
OldElim CF2''.
OldElim CF2''.
OldElim CF2''.
OldElim A7.
OldElim A7.
OldElim A6.
OldElim A6.
Unfold Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.
Apply refl_equal.
Exact EQfi.
Exact EQfi.
Exact EQfi.
Save commTn_di1.

Goal (x,y,y',y'':proc)(b:bit)(d:D)
     Delta= 
     (enc H     
        (Lmer   
           (comm  
              (seq (Tn_d d b) y)
              (alt (seq (ia one int i) y') (seq (ia one int i) y'')))
           x)). 
Intros.
OldElim CM9.
OldElim CM4.
OldElim D4.
OldElim commTn_di1.
OldElim commTn_di1.
OldElim A6.
Apply refl_equal.
Save CommTn_di. 

Goal
    (x,y:proc)(b:bit)(d:D)
     Delta=
     (enc H
        (Lmer
           (comm
              (seq (Sn_d d b) y)
              (L i))
           x)).
Intros.
OldElim ProcSn_d.
OldElim A5.
OldElim SC3.
OldElim ChanL.
OldElim (SUM7 frame [n:frame]
              (seq (ia frame r5 n)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 n))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
             (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y))).
ElimType ([d:frame]Delta)=
   ([d0:frame]
           (comm
              (seq (ia frame r5 d0)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 d0))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
              (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y)))).
OldElim SUM1.
Unfold 2 Delta.
OldElim CM2.
OldElim D5. OldElim D3.
OldElim A7. Apply refl_equal.
Apply EXT. Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Red. Intro.
Apply EQFf.
Apply EQ_sym.
Assumption.
Save CommSn_dL.

Goal
 (x,y:proc)(b:bit)(d:D) 
   (seq (ia Frame c2 (Tuple b d))
      (enc H (mer (seq (Tn_d d b) y)  
               (mer 
                 (alt (seq (ia one int i) (seq (ia Frame s3 (Tuple b d))(K i)))
                     (seq (ia one int i) (seq (ia Frame s3 lce)(K i))))
                 x))))=
   (enc H (Lmer (comm (seq (Sn_d d b) y) (K i)) x)).
Intros.
OldElim ProcSn_d.
OldElim A5.
Pattern 3 (K i).
OldElim ChanK.
OldElim (SC3 (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y))
            (Frame
            +[x:Frame]
              (seq (ia Frame r2 x)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 x))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i))))).
OldElim (SUM7 Frame [x:Frame]
              (seq (ia Frame r2 x)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 x))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
             (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y))).
ElimType (Frame+[d0:Frame]
       (cond
          (comm
              (seq (ia Frame r2 (Tuple b d))
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 (Tuple b d)))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
              (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y)))
         (eqF d0 (Tuple b d)) Delta)) =
        (Frame+[d0:Frame]
          (comm
              (seq (ia Frame r2 d0)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 d0))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
              (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y)))).
OldElim (Sum_EliminationF [d0:Frame]
              (comm
                 (seq (ia Frame r2 d0)
                    (seq
                       (alt (seq (ia one int i) (ia Frame s3 d0))
                          (seq (ia one int i) (ia Frame s3 lce)))
                       (K i)))
                 (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y)))
          (Tuple b d)).
OldElim CM7;OldElim CF1.
OldElim CM3;OldElim D5.
OldElim A4.
OldElim A5.
OldElim A5.
OldElim (SC6 (seq (Tn_d d b) y)
(alt
                  (seq (ia one int i)
                     (seq (ia Frame s3 (Tuple b d)) (K i)))
                  (seq (ia one int i) (seq (ia Frame s3 lce) (K i))))).
OldElim SC7.
Unfold gamma; Trivial.
OldElim D1.
Trivial.
Exact Inc2H.
ElimType 
([d0:Frame]
      (cond
         (comm
            (seq (ia Frame r2 (Tuple b d))
               (seq
                  (alt (seq (ia one int i) (ia Frame s3 (Tuple b d)))
                     (seq (ia one int i) (ia Frame s3 lce)))
                  (K i)))
            (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y)))
         (eqF d0 (Tuple b d)) Delta))
=
([d0:Frame]
      (comm
         (seq (ia Frame r2 d0)
            (seq
               (alt (seq (ia one int i) (ia Frame s3 d0))
                  (seq (ia one int i) (ia Frame s3 lce)))
               (K i)))
         (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y)))).
Trivial.
Apply EXT;Intros.
Cut ((true=(eqF d0 (Tuple b d))) \/ (false=(eqF d0 (Tuple b d)))).
Cut (true=(eqF d0 (Tuple b d)))->
  (cond
      (comm
         (seq (ia Frame r2 (Tuple b d))
            (seq
               (alt (seq (ia one int i) (ia Frame s3 (Tuple b d)))
                  (seq (ia one int i) (ia Frame s3 lce)))
               (K i)))
         (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y)))
      (eqF d0 (Tuple b d)) Delta)
  =(comm
      (seq (ia Frame r2 d0)
         (seq
            (alt (seq (ia one int i) (ia Frame s3 d0))
               (seq (ia one int i) (ia Frame s3 lce)))
            (K i)))
      (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y))).
Cut (false=(eqF d0 (Tuple b d)))->
 (cond 
      (comm 
         (seq (ia Frame r2 (Tuple b d)) 
            (seq 
               (alt (seq (ia one int i) (ia Frame s3 (Tuple b d))) 
                  (seq (ia one int i) (ia Frame s3 lce))) 
               (K i))) 
         (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y))) 
      (eqF d0 (Tuple b d)) Delta) 
  =(comm 
      (seq (ia Frame r2 d0) 
         (seq 
            (alt (seq (ia one int i) (ia Frame s3 d0)) 
               (seq (ia one int i) (ia Frame s3 lce))) 
            (K i))) 
      (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y))). 
Intros.
Exact (or_ind
(true=(eqF d0 (Tuple b d)))
(false=(eqF d0 (Tuple b d)))
 (cond 
      (comm 
         (seq (ia Frame r2 (Tuple b d)) 
            (seq 
               (alt (seq (ia one int i) (ia Frame s3 (Tuple b d))) 
                  (seq (ia one int i) (ia Frame s3 lce))) 
               (K i))) 
         (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y))) 
      (eqF d0 (Tuple b d)) Delta) 
  =(comm 
      (seq (ia Frame r2 d0) 
         (seq 
            (alt (seq (ia one int i) (ia Frame s3 d0)) 
               (seq (ia one int i) (ia Frame s3 lce))) 
            (K i))) 
      (seq (ia Frame s2 (Tuple b d)) (seq (Tn_d d b) y)))
H0 H H1).
Intro.
OldElim H.
OldElim COND2.
OldElim CM7.
OldElim CF2'.
OldElim A7.
Trivial.
Exact (eqF_intro' d0 (Tuple b d) H).
Intro.
OldElim  (eqF_intro d0 (Tuple b d) H).
OldElim eqF7;OldElim COND1.
Trivial.
Apply Lemma4.
Save CommSn_dK.

Goal
    (x,y,y':proc)(b,b':bit)(d:D)
     Delta=
     (enc H
        (Lmer
           (comm
              (seq (Sn_d d b) y)
              (seq (Rn b') y'))
           x)).
Intros.
OldElim SC3.
OldElim ProcRn.
OldElim (A4 (seq (alt (D+[d:D](ia Frame r3 (Tuple b' d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b')) (Rn b')))
                  (D+[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b') d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b')))))) y').
OldElim (CM8 (seq (seq
                     (alt (D+[d:D](ia Frame r3 (Tuple b' d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b')) (Rn b')))
                  y')
               (seq
                  (D+[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b') d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b'))))))
                   y') (seq (Sn_d d b) y)).
ElimType Delta=
      (comm (seq (seq (alt (D+[d:D](ia Frame r3 (Tuple b' d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b')) (Rn b')))
                  y')
               (seq (Sn_d d b) y)).
OldElim (A6'  (comm
               (seq
                  (D
                  +[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b') d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b'))))))
                   y')
               (seq (Sn_d d b) y))).
OldElim (SUM5 D [d:D]
                 (seq (ia Frame r3 (Tuple (toggle b') d))
                    (seq (ia D s4 d) (ia frame s5 (tuple (toggle b'))))) y').
OldElim (SUM7 D [d:D]
              (seq
                 (seq (ia Frame r3 (Tuple (toggle b') d))
                    (seq (ia D s4 d) (ia frame s5 (tuple (toggle b')))))
                 y') (seq (Sn_d d b) y)).

ElimType ([d:D]Delta)=
      ([d0:D]
           (comm
              (seq
                 (seq (ia Frame r3 (Tuple (toggle b') d0))
                    (seq (ia D s4 d0) (ia frame s5 (tuple (toggle b')))))
                 y') (seq (Sn_d d b) y))).
OldElim SUM1.
Unfold 2 Delta.
OldElim CM2. OldElim D5. OldElim D3. OldElim A7. Apply refl_equal.
Apply EXT. Intro.
OldElim A5.
OldElim ProcSn_d.
OldElim A5.
OldElim A5.
OldElim CM7.
OldElim CF2.
OldElim A7.
Apply refl_equal.
Apply refl_equal.
OldElim (A4 (D+[d:D](ia Frame r3 (Tuple b' d))) (ia Frame r3 lce)
            (seq (ia frame s5 (tuple b')) (Rn b'))). 
OldElim (A4 (seq (D+[d:D](ia Frame r3 (Tuple b' d)))
               (seq (ia frame s5 (tuple b')) (Rn b')))
            (seq (ia Frame r3 lce)
               (seq (ia frame s5 (tuple b')) (Rn b'))) y').
OldElim CM8.
ElimType Delta=
     (comm
         (seq
            (seq (D+[d:D](ia Frame r3 (Tuple b' d)))
               (seq (ia frame s5 (tuple b')) (Rn b')))
            y') (seq (Sn_d d b) y)).
OldElim A6'.
OldElim A5.
OldElim ProcSn_d.
OldElim A5.
OldElim A5.
OldElim CM7.
OldElim CF2.
OldElim A7.
Apply refl_equal.
Apply refl_equal.
OldElim (A5 (D+[d:D](ia Frame r3 (Tuple b' d)))
            (seq (ia frame s5 (tuple b')) (Rn b')) y').
OldElim (SUM5 D [d:D](ia Frame r3 (Tuple b' d)) (seq (seq (ia frame s5
(tuple b')) (Rn b')) y')).
OldElim SUM7.
ElimType ([d:D]Delta)=
      ([d0:D]
      (comm
         (seq (ia Frame r3 (Tuple b' d0))
            (seq (seq (ia frame s5 (tuple b')) (Rn b')) y'))
         (seq (Sn_d d b) y))).
OldElim SUM1. Apply refl_equal.
Apply EXT. Intro.
OldElim ProcSn_d.
OldElim A5.
OldElim A5.
OldElim CM7.
OldElim CF2.
OldElim A7.
Apply refl_equal.
Apply refl_equal.
Save CommSn_dRn.

Goal
   (x,y,y':proc)(b:bit)(d:D)
     Delta=
     (enc H
        (Lmer
           (comm
              (seq (ia D s4 d) y)
              (seq (Tn_d d b) y'))
           x)).
Intros.
OldElim SC3.
OldElim ProcTn_d.
OldElim A4.
OldElim A4. 
OldElim A4. 
OldElim CM8. 
OldElim CM8. 
OldElim A5. 
OldElim A5. 
OldElim CM7. 
OldElim CM7. 
OldElim CM7. 
OldElim CF2''. 
OldElim CF2''. 
OldElim CF2''. 
  
OldElim A7. 
OldElim A7. 
OldElim A6. 
OldElim A6. 
Unfold 2 Delta. 
OldElim CM2. 
OldElim D5. 
OldElim D3. 
OldElim A7. 
Apply refl_equal.
Exact EQfD.
Exact EQfD.
Exact EQfD.


Save CommTn_ds4.

Goal
   (x,y,y':proc)(b:bit)(d:D)(f:frame)
     Delta=
     (enc H
        (Lmer
           (comm
              (seq (ia frame s5 f) y)
              (seq (Tn_d d b) y'))
           x)).
Intros.
OldElim ProcTn_d.
OldElim A4.
OldElim A4.
OldElim A4.
OldElim CM9.
OldElim CM9.
OldElim A5.
OldElim A5.
OldElim CM7.
OldElim CM7.
OldElim CM7.
OldElim CF2.
OldElim CF2.
OldElim CF2.
 
OldElim A7.
OldElim A7.
OldElim A6.
OldElim A6.
Unfold 2 Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.

Apply refl_equal.
Apply refl_equal.
Apply refl_equal.
Apply refl_equal.

Save CommTn_ds5.

Goal (x,y:proc)(b:bit)(d:D)
     Delta=
     (enc H (Lmer (comm (K i) (seq (Tn_d d b) y)) x)).

Intros.
OldElim ChanK.
OldElim (SUM7 Frame
             [x:Frame]
              (seq (ia Frame r2 x)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 x))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
             (seq (Tn_d d b) y)).
ElimType ([f:Frame]Delta)=
       ([d0:Frame]
           (comm
              (seq (ia Frame r2 d0)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 d0))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
              (seq (Tn_d d b) y))).
OldElim SUM1.
Unfold Delta.
Unfold Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.
Apply refl_equal.
OldElim ProcTn_d.
OldElim A4.
OldElim A4.
OldElim A4.
Apply EXT.
Intro.
OldElim CM9.
OldElim CM9.
OldElim A5.
OldElim A5.
OldElim CM7.
OldElim CM7.
OldElim CM7.
OldElim CF2''.
OldElim CF2''.
OldElim CF2''.

OldElim A7.
OldElim A7.
OldElim A6.
OldElim A6.
Apply refl_equal.
Exact EQFf.
Exact EQFf.
Exact EQFf.
Save CommTn_dK.

Goal 
   (x,y:proc)(d:D)
     Delta= 
     (enc H 
        (Lmer 
           (comm (seq (ia D s4 d) y) (L i)) 
           x)). 
Intros.
OldElim SC3.
OldElim ChanL.
OldElim (SUM7 frame
             [n:frame]
              (seq (ia frame r5 n)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 n))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
             (seq (ia D s4 d) y)).
ElimType ([d:frame]Delta)=
    ([d0:frame]
           (comm
              (seq (ia frame r5 d0)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 d0))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
              (seq (ia D s4 d) y))).
OldElim SUM1.
Unfold Delta.
Unfold Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.
Apply refl_equal.
Apply EXT. Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQfD.
Save CommLs4.

Goal
   (x,y:proc)(f:frame) 
     (seq (ia frame c5 f)
        (enc H
           (mer y
              (mer
                 (alt
                    (seq (ia one int i) (seq (ia frame s6 f) (L i)))
                    (seq (ia one int i) (seq (ia frame s6 sce) (L i))))
                 x))))=
     (enc H (Lmer (comm (seq (ia frame s5 f) y) (L i)) x)).
Intros.
Pattern 3 (L i).
OldElim ChanL.
OldElim (SC3
(seq (ia frame s5 f) y)
(frame
                +[n:frame]
                  (seq (ia frame r5 n)
                     (seq
                        (alt (seq (ia one int i) (ia frame s6 n))
                           (seq (ia one int i) (ia frame s6 sce)))
                        (L i))))
                ).
OldElim (SUM7
frame
             [n:frame]
              (seq (ia frame r5 n)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 n))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
             (seq (ia frame s5 f) y)).
ElimType 
([d:frame]
(cond      (comm
              (seq (ia frame r5 f)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 f))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
              (seq (ia frame s5 f) y))
(eqf d f)
          Delta))
=
([d:frame]
           (comm
              (seq (ia frame r5 d)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 d))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
              (seq (ia frame s5 f) y))).
OldElim (Sum_Eliminationf
[e:frame](comm
              (seq (ia frame r5 e)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 e))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
              (seq (ia frame s5 e) y))
f).
OldElim CM7.
OldElim CF1.
Unfold gamma.
OldElim CM3.
OldElim A4.
OldElim (SC6 y
(alt (seq (seq (ia one int i) (ia frame s6 f)) (L i))
                  (seq (seq (ia one int i) (ia frame s6 sce)) (L i)))).
OldElim SC7.
OldElim D5.
OldElim D1.
OldElim A5;OldElim A5.
Trivial.
Exact Inc5H.
Apply EXT;Intro.
Cut ((true=(eqf d f))\/(false=(eqf d f))).
Cut (true=(eqf d f))->
(cond
      (comm
         (seq (ia frame r5 f)
            (seq
               (alt (seq (ia one int i) (ia frame s6 f))
                  (seq (ia one int i) (ia frame s6 sce)))
               (L i)))
         (seq (ia frame s5 f) y))
      (eqf d f) Delta)
  =(comm
      (seq (ia frame r5 d)
         (seq
            (alt (seq (ia one int i) (ia frame s6 d))
               (seq (ia one int i) (ia frame s6 sce)))
            (L i)))
      (seq (ia frame s5 f) y)).
Cut (false=(eqf d f))->
(cond
      (comm
         (seq (ia frame r5 f)
            (seq
               (alt (seq (ia one int i) (ia frame s6 f))
                  (seq (ia one int i) (ia frame s6 sce)))
               (L i)))
         (seq (ia frame s5 f) y))
      (eqf d f) Delta)
  =(comm
      (seq (ia frame r5 d)
         (seq
            (alt (seq (ia one int i) (ia frame s6 d))
               (seq (ia one int i) (ia frame s6 sce)))
            (L i)))
      (seq (ia frame s5 f) y)).
Intros.
Exact (or_ind
(true=(eqf d f))
(false=(eqf d f))
(cond
      (comm
         (seq (ia frame r5 f)
            (seq
               (alt (seq (ia one int i) (ia frame s6 f))
                  (seq (ia one int i) (ia frame s6 sce)))
               (L i)))
         (seq (ia frame s5 f) y))
      (eqf d f) Delta)
  =(comm
      (seq (ia frame r5 d)
         (seq
            (alt (seq (ia one int i) (ia frame s6 d))
               (seq (ia one int i) (ia frame s6 sce)))
            (L i)))
      (seq (ia frame s5 f) y))
H0 H H1).
Intro.
OldElim H;OldElim COND2.
OldElim CM7;OldElim CF2'.
OldElim A7;Trivial.
Exact (eqf_intro' d f H).
2:Apply Lemma4.
Intros.
OldElim H.
OldElim COND1.
OldElim (eqf_intro d f H).
Trivial.
Save CommLs5.


Goal
   (x,y:proc)(f:frame)
     Delta=
     (enc H
        (Lmer
           (comm (seq (ia frame s6 f) y) (K i))
           x)).
Intros.
OldElim SC3.
OldElim ChanK.
OldElim (SUM7 Frame 
            [x:Frame]
              (seq (ia Frame r2 x)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 x))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
             (seq (ia frame s6 f) y)).
ElimType ([d:Frame]Delta)=
     ([d:Frame]
           (comm
              (seq (ia Frame r2 d)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 d))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
              (seq (ia frame s6 f) y))).
OldElim SUM1.
Unfold Delta.
Unfold Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.
Apply refl_equal.
Apply EXT. Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQFf.


Save CommKs6.


Goal
   (x,y,y':proc)(b:bit)(f:frame)
     Delta=
     (enc H
        (Lmer
           (comm (seq (ia frame s6 f) y) (seq (Rn b) y'))
           x)).
Intros.
OldElim SC3.
OldElim ProcRn.
OldElim (A4 (seq (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  (D +[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b))))))
                  y').
OldElim (CM8 (seq (seq (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  y')
            (seq (D +[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b))))))
                   y')(seq (ia frame s6 f) y)).

ElimType Delta=
            (comm
               (seq
                  (D
                  +[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b))))))
                   y')
               (seq (ia frame s6 f) y)).

OldElim (A6 (comm
               (seq
                  (seq
                     (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  y')
               (seq (ia frame s6 f) y))).
OldElim (A4 (D+[d:D](ia Frame r3 (Tuple b d)))
                     (ia Frame r3 lce) (seq (ia frame s5 (tuple b)) (Rn b))).

OldElim (A4 (seq (D+[d:D](ia Frame r3 (Tuple b d)))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  (seq (ia Frame r3 lce)
                     (seq (ia frame s5 (tuple b)) (Rn b))) y').
OldElim (CM8 (seq (seq (D+[d:D](ia Frame r3 (Tuple b d)))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  y')
               (seq
                  (seq (ia Frame r3 lce)
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  y') (seq (ia frame s6 f) y)).

ElimType Delta=
       (comm (seq (seq (D+[d:D](ia Frame r3 (Tuple b d)))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  y')
               (seq (ia frame s6 f) y)).
OldElim A6'.
OldElim A5.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Unfold 2 Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.
Apply refl_equal.
Exact EQFf.
OldElim (A5 (D+[d:D](ia Frame r3 (Tuple b d)))
            (seq (ia frame s5 (tuple b)) (Rn b)) y').
OldElim (SUM5 D [d:D](ia Frame r3 (Tuple b d))
         (seq (seq (ia frame s5 (tuple b)) (Rn b)) y')).
OldElim SUM7.
ElimType ([d:D]Delta)=
     ([d:D]
      (comm
         (seq (ia Frame r3 (Tuple b d))
            (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
         (seq (ia frame s6 f) y))).
OldElim SUM1.
Apply refl_equal.
Apply EXT. Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQFf.
OldElim (SUM5 D [d:D]
           (seq (ia Frame r3 (Tuple (toggle b) d))
              (seq (ia D s4 d) (ia frame s5 (tuple (toggle b))))) y').
OldElim SUM7.
ElimType ([d:D]Delta)=
      ([d:D]
      (comm
         (seq
            (seq (ia Frame r3 (Tuple (toggle b) d))
               (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
            y')
         (seq (ia frame s6 f) y))).
OldElim SUM1.
Apply refl_equal. 
Apply EXT. Intro. 
OldElim A5.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQFf.
Save CommRns6.

Goal
   (x,y,y':proc)(b:bit)(d:D)
     
     (seq (ia frame c6 sce) (enc H (mer y (mer (seq (Sn_d d b) y') x))))=
     (enc H
        (Lmer
           (comm (seq (ia frame s6 sce) y) (seq (Tn_d d b) y'))
           x)).
Intros.
OldElim ProcTn_d.
OldElim A4.
OldElim A4.
OldElim A4.
OldElim CM9.
OldElim CM9.
OldElim A5.
OldElim A5.
OldElim CM7.
OldElim CM7.
OldElim CM7.
OldElim CF1.
OldElim CF2'.
OldElim CF2'.
OldElim A7.
OldElim A7.
OldElim A6.
OldElim A6'.
OldElim CM3.
OldElim D5.
OldElim D1.
OldElim SC7.
Apply refl_equal.
Exact Inc6H.
Apply eqf_intro'.
Apply eqf2.
Apply eqf_intro'.
Apply eqf2.
Save CommTn_ds6_sce.

Goal
   (x,y,y':proc)(b:bit)(d:D)
     
     (seq (ia frame c6 (tuple (toggle b))) 
        (enc H (mer y (mer (seq (Sn_d d b) y') x))))=
     (enc H
        (Lmer
           (comm (seq (ia frame s6 (tuple (toggle b))) y) (seq (Tn_d d b) y'))
           x)).
Intros.
OldElim ProcTn_d.
OldElim A4.
OldElim A4.
OldElim A4.
OldElim CM9.
OldElim CM9.
OldElim A5.
OldElim A5.
OldElim CM7.
OldElim CM7.
OldElim CM7.
OldElim CF1.
OldElim CF2'.
OldElim CF2'.
OldElim A7.
OldElim A7.
OldElim A6.
OldElim A6.
OldElim CM3.
OldElim D5.
OldElim D1.
OldElim SC7.
Apply refl_equal.
Exact Inc6H.
Apply eqf_intro'.
OldElim eqf4.
Apply bit3.
Apply eqf_intro'.
Apply eqf3.

Save CommTn_ds6_b.

Goal
   (x,y,y':proc)(b:bit)(d:D)
     
     (seq (ia frame c6 (tuple b))
        (enc H (mer y (mer y' x))))=
     (enc H
        (Lmer
           (comm (seq (ia frame s6 (tuple b)) y) (seq (Tn_d d b) y'))
           x)).
Intros.
OldElim ProcTn_d.
OldElim A4.
OldElim A4.
OldElim A4.
OldElim CM9.
OldElim CM9.
OldElim A5.
OldElim A5.
OldElim CM7.
OldElim CM7.
OldElim CM7.
OldElim CF1.
OldElim CF2'.
OldElim CF2'.
OldElim A7.
OldElim A6'.
OldElim A6'.
OldElim CM3.
OldElim D5.
OldElim D1.
OldElim SC7.
Apply refl_equal.
Exact Inc6H.
Apply eqf_intro'.
Apply eqf3.
Apply eqf_intro'.
OldElim eqf4.
Apply bit2.
Save CommTn_ds6_b'.

Goal (x,y:proc)(d:D) 
     Delta=  
     (enc H     
        (Lmer  
           (comm (K i) (seq (ia D s4 d) y)) 
           x)).   
Intros.
OldElim ChanK.
OldElim (SUM7 Frame [x:Frame]
              (seq (ia Frame r2 x)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 x))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))  (seq (ia D s4 d) y)).
ElimType ([d:Frame]Delta)=
     ([d0:Frame]
           (comm
              (seq (ia Frame r2 d0)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 d0))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
              (seq (ia D s4 d) y))).
OldElim SUM1. 
Unfold Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.
Apply refl_equal.
Apply EXT. Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQFD.
Save CommKs4.

Goal (x,y:proc)(f:frame) Delta=
     (enc H (Lmer (comm (K i) (seq (ia frame s5 f) y)) x)).
Intros.
OldElim ChanK.
OldElim (SUM7 Frame [x:Frame]
              (seq (ia Frame r2 x)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 x))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
             (seq (ia frame s5 f) y)).
ElimType ([f:Frame]Delta)=
    ([d:Frame]
           (comm
              (seq (ia Frame r2 d)
                 (seq
                    (alt (seq (ia one int i) (ia Frame s3 d))
                       (seq (ia one int i) (ia Frame s3 lce)))
                    (K i)))
              (seq (ia frame s5 f) y))).
OldElim SUM1.
Unfold Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.
Apply refl_equal.
Apply EXT. Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Exact EQFf.
Save CommKs5.

Theorem CommTn_dRn: (x,y,y':proc)(b,b':bit)(d:D)
     Delta=
     (enc H
        (Lmer
           (comm
              (seq (Tn_d d b) y)
              (seq (Rn b') y'))
           x)).
Goal.
Intros.
OldElim ProcTn_d; OldElim ProcRn.
OldElim A4.
OldElim (CM8 (seq
                  (seq
                     (alt (ia frame r6 (tuple (toggle b)))
                        (ia frame r6 sce))
                     (Sn_d d b))
                  y)
               (seq (ia frame r6 (tuple b)) y)
(seq
               (alt
                  (seq
                     (alt (D+[d:D](ia Frame r3 (Tuple b' d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b')) (Rn b')))
                  (D
                  +[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b') d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b'))))))
                  )
               y')).
OldElim A5.
OldElim A4.
OldElim (CM8 
(seq (ia frame r6 (tuple (toggle b)))(seq (Sn_d d b) y))
(seq (ia frame r6 sce) (seq (Sn_d d b) y))
(seq
                  (alt
                     (seq
                        (alt (D+[d:D](ia Frame r3 (Tuple b' d)))
                           (ia Frame r3 lce))
                        (seq (ia frame s5 (tuple b')) (Rn b')))
                     (D
                     +[d:D]
                       (seq (ia Frame r3 (Tuple (toggle b') d))
                          (seq (ia D s4 d)
                             (ia frame s5 (tuple (toggle b'))))))
                     )
                  y')).
OldElim (A4 
(seq
                           (alt (D+[d:D](ia Frame r3 (Tuple b' d)))
                              (ia Frame r3 lce))
                           (seq (ia frame s5 (tuple b')) (Rn b')))
(D +[d:D]

                          (seq (ia Frame r3 (Tuple (toggle b') d))
                             (seq (ia D s4 d)
                                (ia frame s5 (tuple (toggle b')))))
                        )
                     y').
OldElim (CM9
(seq (ia frame r6 (tuple (toggle b)))
                     (seq (Sn_d d b) y))
(seq
                        (seq
                           (alt (D+[d:D](ia Frame r3 (Tuple b' d)))
                              (ia Frame r3 lce))
                           (seq (ia frame s5 (tuple b')) (Rn b')))
                        y')
(seq
                        (D
                        +[d:D]
                          (seq (ia Frame r3 (Tuple (toggle b') d))
                             (seq (ia D s4 d)
                                (ia frame s5 (tuple (toggle b'))))))
                         y')).
OldElim (A5
(alt (D+[d:D](ia Frame r3 (Tuple b' d)))
                              (ia Frame r3 lce))
(seq (ia frame s5 (tuple b')) (Rn b'))
y').
OldElim (A4
(D+[d:D](ia Frame r3 (Tuple b' d)))
(ia Frame r3 lce)
(seq (seq (ia frame s5 (tuple b')) (Rn b')) y')).
OldElim (CM9
(seq (ia frame r6 (tuple (toggle b)))
                        (seq (Sn_d d b) y))
(seq (D+[d:D](ia Frame r3 (Tuple b' d)))
                           (seq (seq (ia frame s5 (tuple b')) (Rn b'))
                              y'))
(seq (ia Frame r3 lce)
                           (seq (seq (ia frame s5 (tuple b')) (Rn b'))
                              y'))).
OldElim (SUM5
D
[d:D](ia Frame r3 (Tuple b' d))
(seq (seq (ia frame s5 (tuple b')) (Rn b'))
                              y')).
OldElim (SC3
(seq (ia frame r6 (tuple (toggle b)))
                           (seq (Sn_d d b) y))
(D
                        +[d:D]
                          (seq (ia Frame r3 (Tuple b' d))
                             (seq
                                (seq (ia frame s5 (tuple b')) (Rn b'))
                                y')))).
OldElim (SUM7 D
[d:D](seq (ia Frame r3 (Tuple b' d))
                             (seq
                                (seq (ia frame s5 (tuple b')) (Rn b'))
                                y'))
(seq (ia frame r6 (tuple (toggle b)))
                           (seq (Sn_d d b) y))).
OldElim CM7.
Cut (d0:D)Delta=
                       (comm
                          (seq (ia Frame r3 (Tuple b' d0))
                             (seq
                                (seq (ia frame s5 (tuple b')) (Rn b'))
                                y'))
                          (seq (ia frame r6 (tuple (toggle b)))
                             (seq (Sn_d d b) y))).
2:Intro.
2:OldElim (CM7 
(seq
                                (seq (ia frame s5 (tuple b')) (Rn b'))
                                y')
(seq (Sn_d d b) y)
Frame
frame
(Tuple b' d0)
(tuple (toggle b))
r3
r6).
2:OldElim (CF2'' r3 r6 Frame frame (Tuple b' d0) (tuple (toggle b)) EQFf).
2:OldElim A7;Auto.
Intro H0.
OldElim (EXT D [d0:D]Delta [d0:D]
                       (comm
                          (seq (ia Frame r3 (Tuple b' d0))
                             (seq
                                (seq (ia frame s5 (tuple b')) (Rn b'))
                                y'))
                          (seq (ia frame r6 (tuple (toggle b)))
                             (seq (Sn_d d b) y))) H0).
OldElim SUM1.
OldElim (CF2'' r6 r3 frame Frame (tuple (toggle b)) lce).
2:Red.
2:Intro.
2:Apply EQFf.
2:Exact (EQ_sym frame Frame H).
OldElim A7.
OldElim (A3 Delta).
OldElim (A1 
(comm
                     (seq (ia frame r6 (tuple (toggle b)))
                        (seq (Sn_d d b) y))
                     (seq
                        (D
                        +[d:D]
                          (seq (ia Frame r3 (Tuple (toggle b') d))
                             (seq (ia D s4 d)
                                (ia frame s5 (tuple (toggle b'))))))
                         y'))
Delta).
OldElim (A6 (comm
                      (seq (ia frame r6 (tuple (toggle b)))
                         (seq (Sn_d d b) y))
                      (seq
                         (D
                         +[d:D]
                           (seq (ia Frame r3 (Tuple (toggle b') d))
                              (seq (ia D s4 d)
                                 (ia frame s5 (tuple (toggle b'))))))
                          y'))).
OldElim (SUM5
D
[d:D]
                       (seq (ia Frame r3 (Tuple (toggle b') d))
                          (seq (ia D s4 d)
                             (ia frame s5 (tuple (toggle b')))))
y'
                            ). 
OldElim (SC3
(seq (ia frame r6 (tuple (toggle b)))
                     (seq (Sn_d d b) y))
(D+[d:D]
                    (seq
                       (seq (ia Frame r3 (Tuple (toggle b') d))
                          (seq (ia D s4 d)
                             (ia frame s5 (tuple (toggle b')))))
                       y'))
).
OldElim (SUM7 D
[d:D]
                    (seq
                       (seq (ia Frame r3 (Tuple (toggle b') d))
                          (seq (ia D s4 d)
                             (ia frame s5 (tuple (toggle b')))))
                       y')
(seq (ia frame r6 (tuple (toggle b)))
                     (seq (Sn_d d b) y))
).
ElimType ([d:D]Delta)=
([d0:D]
                 (comm
                    (seq
                       (seq (ia Frame r3 (Tuple (toggle b') d0))
                          (seq (ia D s4 d0)
                             (ia frame s5 (tuple (toggle b')))))
                       y')
                    (seq (ia frame r6 (tuple (toggle b)))
                       (seq (Sn_d d b) y)))).
2:Apply EXT;Intro.

2:OldElim (A5
(ia Frame r3 (Tuple (toggle b') d0))
(seq (ia D s4 d0)
                             (ia frame s5 (tuple (toggle b'))))
y').
2:OldElim CM7.
2:OldElim (CF2'' r3 r6 Frame frame (Tuple (toggle b') d0) (tuple (toggle b)) EQFf).2:OldElim A7.
Auto.
OldElim SUM1.
OldElim (CM9
(seq (ia frame r6 sce) (seq (Sn_d d b) y))
                     (alt
                        (D
                        +[d:D]
                          (seq (ia Frame r3 (Tuple b' d))
                             (seq
                                (seq (ia frame s5 (tuple b')) (Rn b'))
                                y')))

                        (seq (ia Frame r3 lce)
                           (seq (seq (ia frame s5 (tuple b')) (Rn b'))
                              y')))
(D +[d:D]
                       (seq
                          (seq (ia Frame r3 (Tuple (toggle b') d))
                             (seq (ia D s4 d)
                                (ia frame s5 (tuple (toggle b')))))
                          y'))
                     ).
OldElim (CM9
(seq (ia frame r6 sce) (seq (Sn_d d b) y))
(D +[d:D]
                          (seq (ia Frame r3 (Tuple b' d))
                             (seq
                                (seq (ia frame s5 (tuple b')) (Rn b'))
                                y')))
(seq (ia Frame r3 lce)
                           (seq (seq (ia frame s5 (tuple b')) (Rn b'))
                              y'))).
OldElim (SC3
(seq (ia frame r6 sce) (seq (Sn_d d b) y))
(D
                        +[d:D]
                          (seq (ia Frame r3 (Tuple b' d))
                             (seq
                                (seq (ia frame s5 (tuple b')) (Rn b'))
                                y')))).
OldElim (SUM7 D
[d:D]
                          (seq (ia Frame r3 (Tuple b' d))
                             (seq
                                (seq (ia frame s5 (tuple b')) (Rn b'))
                                y'))
(seq (ia frame r6 sce) (seq (Sn_d d b) y))
).
ElimType ([d:D]Delta)=
([d0:D]
                       (comm
                          (seq (ia Frame r3 (Tuple b' d0))
                             (seq
                                (seq (ia frame s5 (tuple b')) (Rn b'))
                                y'))
                          (seq (ia frame r6 sce) (seq (Sn_d d b) y)))).
2:Apply EXT;Intro.
2:OldElim CM7.
2:OldElim (CF2'' r3 r6 Frame frame (Tuple b' d0) sce EQFf).
2:OldElim A7.
2:Auto.
OldElim (CM7
(seq (Sn_d d b) y)
(seq (seq (ia frame s5 (tuple b')) (Rn b'))
                              y')).
OldElim (CF2'' r6 r3).
OldElim A7.
OldElim (SC3
(seq (ia frame r6 sce) (seq (Sn_d d b) y))
(D+[d:D]
                       (seq
                          (seq (ia Frame r3 (Tuple (toggle b') d))
                             (seq (ia D s4 d)
                                (ia frame s5 (tuple (toggle b')))))
                          y'))
                     ).
OldElim (SUM7 D
[d:D]
                       (seq
                          (seq (ia Frame r3 (Tuple (toggle b') d))
                             (seq (ia D s4 d)
                                (ia frame s5 (tuple (toggle b')))))
                          y')
(seq (ia frame r6 sce) (seq (Sn_d d b) y))).
ElimType ([d:D]Delta)=
([d0:D]
                    (comm
                       (seq
                          (seq (ia Frame r3 (Tuple (toggle b') d0))
                             (seq (ia D s4 d0)
                                (ia frame s5 (tuple (toggle b')))))
                          y')
                       (seq (ia frame r6 sce) (seq (Sn_d d b) y)))).
2:Apply EXT;Intro.
2:OldElim A5.
2:OldElim CM7.
2:OldElim (CF2'' r3 r6 Frame frame (Tuple (toggle b') d0) sce EQFf).
2:OldElim A7; Auto.
ElimType Delta=
(comm (seq (ia frame r6 (tuple b)) y)
               (alt
                  (alt
                     (D
                     +[d:D]
                       (seq (ia Frame r3 (Tuple b' d))
                          (seq (seq (ia frame s5 (tuple b')) (Rn b'))
                             y')))

                     (seq (ia Frame r3 lce)
                        (seq (seq (ia frame s5 (tuple b')) (Rn b')) y')))
                  (D
                  +[d:D]
                    (seq
                       (seq (ia Frame r3 (Tuple (toggle b') d))
                          (seq (ia D s4 d)
                             (ia frame s5 (tuple (toggle b')))))
                       y'))
                  )).
OldElim SUM1.
OldElim A6.
OldElim A6.
OldElim A6.
OldElim A6.
Unfold Delta.
OldElim CM2.
OldElim A7.
OldElim D3.
Auto.
2:Red.
2:Intro.
2:Apply EQFf.
2:Exact (EQ_sym frame Frame H).
OldElim CM9.
ElimType Delta=
(comm (seq (ia frame r6 (tuple b)) y)
         (alt
            (D
            +[d:D]
              (seq (ia Frame r3 (Tuple b' d))
                 (seq (seq (ia frame s5 (tuple b')) (Rn b')) y')))

            (seq (ia Frame r3 lce)
               (seq (seq (ia frame s5 (tuple b')) (Rn b')) y')))).
ElimType Delta=
(comm (seq (ia frame r6 (tuple b)) y)
         (D
         +[d:D]
           (seq
              (seq (ia Frame r3 (Tuple (toggle b') d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b')))))
              y'))
         ).
OldElim A6;Auto.
OldElim SC3.
OldElim SUM7.
ElimType ([d:D]Delta)=
([d:D]
     (comm
        (seq
           (seq (ia Frame r3 (Tuple (toggle b') d))
              (seq (ia D s4 d) (ia frame s5 (tuple (toggle b')))))
           y')
        (seq (ia frame r6 (tuple b)) y))).
OldElim SUM1.
Auto.
Apply EXT;Intro.
OldElim (A5
(ia Frame r3 (Tuple (toggle b') d0))
(seq (ia D s4 d0) (ia frame s5 (tuple (toggle b'))))
y').
OldElim CM7.
OldElim CF2''.
OldElim A7.
Auto.
Red.
Intro.
Apply EQFf.
Assumption.
OldElim (CM9
(seq (ia frame r6 (tuple b)) y)
(D+[d:D]
           (seq (ia Frame r3 (Tuple b' d))
              (seq (seq (ia frame s5 (tuple b')) (Rn b')) y')))

         (seq (ia Frame r3 lce)
            (seq (seq (ia frame s5 (tuple b')) (Rn b')) y'))).
OldElim (SC3 (seq (ia frame r6 (tuple b)) y)
(D
         +[d:D]
           (seq (ia Frame r3 (Tuple b' d))
              (seq (seq (ia frame s5 (tuple b')) (Rn b')) y')))).
OldElim (SUM7 D
[d:D]
           (seq (ia Frame r3 (Tuple b' d))
              (seq (seq (ia frame s5 (tuple b')) (Rn b')) y'))
          (seq (ia frame r6 (tuple b)) y)).
ElimType ([d:D]Delta)=
([d:D]
        (comm
           (seq (ia Frame r3 (Tuple b' d))
              (seq (seq (ia frame s5 (tuple b')) (Rn b')) y'))
           (seq (ia frame r6 (tuple b)) y) )).
OldElim CM7.
OldElim CF2''.
OldElim A7.
OldElim SUM1;OldElim A6;Auto.
Red.
Intro.
Apply EQFf.
Exact (EQ_sym frame Frame H).
Apply EXT;Intro.
OldElim CM7;OldElim CF2''.
OldElim A7;Auto.
Red.
Intro.
Apply EQFf.
Assumption.
Trivial.
Save.

Theorem Comms3Tn_d : (x,y,y':proc)(b:bit)(d:D)(f:Frame)
     Delta=
     (enc H
        (Lmer
           (comm
              (seq (ia Frame s3 f) y)
              (seq (Tn_d d b) y'))
           x)).
Goal.
Intros.
OldElim ProcTn_d.
OldElim A4.
OldElim CM9.
OldElim A5.
OldElim A4.
OldElim CM9.
OldElim CM7.
OldElim CM7.
OldElim CM7.
OldElim CF2''.
OldElim CF2''.
OldElim CF2''.
OldElim A7.
OldElim A7.
OldElim A6.
OldElim A6.
Unfold Delta.
OldElim CM2.
OldElim A7.
OldElim D3.
Apply refl_equal.
Exact EQFf.
Exact EQFf.
Exact EQFf.
Save.



Theorem Comms3L: (x,y:proc)(f:Frame) Delta=
     (enc H (Lmer (comm (seq (ia Frame s3 f) y) (L i)) x)).
Goal.
Intros.
OldElim SC3.
OldElim ChanL.
OldElim (SUM7 frame [n:frame]
              (seq (ia frame r5 n)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 n))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i))) (seq (ia Frame s3 f) y)).
ElimType ([d:frame]Delta)=
    ([d:frame]
           (comm
              (seq (ia frame r5 d)
                 (seq
                    (alt (seq (ia one int i) (ia frame s6 d))
                       (seq (ia one int i) (ia frame s6 sce)))
                    (L i)))
              (seq (ia Frame s3 f) y))).
OldElim SUM1.
Unfold Delta.
OldElim CM2.
OldElim D5.
OldElim D3.
OldElim A7.
Apply refl_equal.
Apply EXT. Intro.
OldElim CM7.
OldElim CF2''.
OldElim A7.
Apply refl_equal.
Red. Intro.
Apply EQFf.
Apply EQ_sym.
Assumption.
Save.


Theorem Comms3Rn_lce : 
   (x,y,y':proc)(b:bit)
     
     (seq (ia Frame c3 lce) 
       (enc H (mer (mer y (seq (seq (ia frame s5 (tuple b)) (Rn b)) y')) x)))=
     (enc H
        (Lmer
           (comm
              (seq (ia Frame s3 lce) y)
              (seq (Rn b) y'))
           x)).
Goal.
Intros.
Pattern 2 (Rn b).
OldElim ProcRn.
OldElim (A4 
        (seq
           (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                  (ia Frame r3 lce))
               (seq (ia frame s5 (tuple b)) (Rn b)))
             (D+[d:D]
                (seq (ia Frame r3 (Tuple (toggle b) d))
                   (seq (ia D s4 d)
                      (ia frame s5 (tuple (toggle b))))))
            y').
OldElim (CM9
        (seq (ia Frame s3 lce) y)
          (seq
             (seq
                (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                     (ia Frame r3 lce))
                  (seq (ia frame s5 (tuple b)) (Rn b)))
               y')
        (seq (D+[d:D]
                (seq (ia Frame r3 (Tuple (toggle b) d))
                   (seq (ia D s4 d)
                      (ia frame s5 (tuple (toggle b))))))
                   y')).
OldElim (CM4 
        (comm (seq (ia Frame s3 lce) y)
               (seq
                  (seq
                     (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  y'))
        (comm (seq (ia Frame s3 lce) y)
               (seq
                  (D
                  +[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b))))))
                   y'))
        x).
ElimType Delta=
       (Lmer
            (comm (seq (ia Frame s3 lce) y)
               (seq
                  (D
                  +[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b))))))
                   y'))
            x).
OldElim (A6  (Lmer
            (comm (seq (ia Frame s3 lce) y)
               (seq
                  (seq
                     (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  y'))
            x)).
OldElim (A5 (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                     (ia Frame r3 lce))
              (seq (ia frame s5 (tuple b)) (Rn b)) y').
OldElim (A4 (D+[d:D](ia Frame r3 (Tuple b d))) (ia Frame r3 lce)
            (seq (seq (ia frame s5 (tuple b)) (Rn b)) y')).
OldElim (CM9 (seq (ia Frame s3 lce) y)
          (seq (D+[d:D](ia Frame r3 (Tuple b d)))
                  (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
          (seq (ia Frame r3 lce)
                  (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))).
ElimType Delta=
        (comm (seq (ia Frame s3 lce) y)
               (seq (D+[d:D](ia Frame r3 (Tuple b d)))
                  (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))).
OldElim A6'.
OldElim CM7.
OldElim CF1.
OldElim CM3.
OldElim D5.
OldElim D1.
Apply refl_equal.

Exact Inc3H.

OldElim SC3.
OldElim (SUM5 D [d:D](ia Frame r3 (Tuple b d))
              (seq (seq (ia frame s5 (tuple b)) (Rn b)) y')).
OldElim SUM7.
ElimType ([d:D]Delta)=
        ([d:D]
      (comm
         (seq (ia Frame r3 (Tuple b d))
            (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
         (seq (ia Frame s3 lce) y))).
OldElim SUM1. 
Apply refl_equal.
Apply EXT. 
Intro.
OldElim A5.
OldElim CM7.
OldElim CF2'.
OldElim A7.
Apply refl_equal.
Apply eqF_intro'.
Apply eqF3.
OldElim (SUM5 D 
       [d:D] (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
       y').
OldElim (SC3 (seq (ia Frame s3 lce) y)
         (D
         +[d:D]
           (seq
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
              y'))).
OldElim (SUM7 D
        [d:D]
           (seq
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
              y')
          (seq (ia Frame s3 lce) y)).
ElimType ([d:D]Delta)=
    ([d:D](comm
           (seq
              (seq (ia Frame r3 (Tuple (toggle b) d))
                 (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
              y')
           (seq (ia Frame s3 lce) y))).
Unfold Delta.
OldElim SUM6.
OldElim CM2.
OldElim SUM1.
OldElim A7.
Apply refl_equal.
Apply EXT.
Intro.
OldElim A5.
OldElim CM7.
OldElim CF2'.
OldElim A7.
Apply refl_equal.
Apply eqF_intro'.
Apply eqF3.
Save.

Theorem Comms3Rn_b' : (x,y,y':proc)(b:bit)(d:D)
     
      (seq (ia Frame c3  (Tuple b d))
         (enc H (mer (mer (seq (ia frame s5 (tuple b))
                                (seq (Rn b) y')) y) x)))
     =
     (enc H
        (Lmer
           (comm
              (seq (ia Frame s3 (Tuple b d)) y)
              (seq (Rn b) y'))
           x)).
Goal.
Intros.
Pattern 2 (Rn b).
OldElim ProcRn.
OldElim (A4 (seq (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                   (D+[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b))))))
                  y').
OldElim (CM9 (seq (ia Frame s3 (Tuple b d)) y)
          (seq (seq
                     (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  y')
          (seq (D+[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b))))))
                   y')).
ElimType Delta=
       (comm (seq (ia Frame s3 (Tuple b d)) y)
               (seq
                  (D
                  +[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b))))))
                   y')).
OldElim (A6 (comm (seq (ia Frame s3 (Tuple b d)) y)
               (seq
                  (seq
                     (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  y'))).

OldElim (A5 (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                     (ia Frame r3 lce))
              (seq (ia frame s5 (tuple b)) (Rn b)) y').
OldElim (A4 (D+[d:D](ia Frame r3 (Tuple b d))) (ia Frame r3 lce)
       (seq (seq (ia frame s5 (tuple b)) (Rn b)) y')).
OldElim (CM9 (seq (ia Frame s3 (Tuple b d)) y)
      (seq (D+[d:D](ia Frame r3 (Tuple b d)))
                  (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
               (seq (ia Frame r3 lce)
                  (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))).
ElimType Delta=
          (comm (seq (ia Frame s3 (Tuple b d)) y)
               (seq (ia Frame r3 lce)
                  (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))).
OldElim (A6 (comm (seq (ia Frame s3 (Tuple b d)) y)
               (seq (D+[d:D](ia Frame r3 (Tuple b d)))
                  (seq (seq (ia frame s5 (tuple b)) (Rn b)) y')))).
OldElim (SUM5 D [d:D](ia Frame r3 (Tuple b d))
      (seq (seq (ia frame s5 (tuple b)) (Rn b)) y')).
OldElim (SC3 (seq (ia Frame s3 (Tuple b d)) y)
            (D+[d:D]
              (seq (ia Frame r3 (Tuple b d))
                 (seq (seq (ia frame s5 (tuple b)) (Rn b)) y')))).
OldElim (SUM7 D [d:D]
              (seq (ia Frame r3 (Tuple b d))
                 (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
           (seq (ia Frame s3 (Tuple b d)) y)).
ElimType ([d0:D]
        (cond
           (comm
              (seq (ia Frame r3 (Tuple b d))
                 (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
              (seq (ia Frame s3 (Tuple b d)) y))
           (eqD d0 d)
           Delta))=
         ([d0:D]
           (comm
              (seq (ia Frame r3 (Tuple b d0))
                 (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
              (seq (ia Frame s3 (Tuple b d)) y))).
OldElim (Sum_EliminationD [d:D](comm
                 (seq (ia Frame r3 (Tuple b d))
                    (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
                 (seq (ia Frame s3 (Tuple b d)) y)) d).
OldElim CM7.           
OldElim CF1.
OldElim CM3.
OldElim D5.
OldElim D1.
OldElim A5.
Apply refl_equal.
Exact Inc3H.
Apply EXT ; Intro.
Pattern 1 (comm
      (seq (ia Frame r3 (Tuple b d0))
         (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
      (seq (ia Frame s3 (Tuple b d)) y)).
OldElim (Bak4_2_1 (eqD d0 d)
        (comm
        (seq (ia Frame r3 (Tuple b d0))
           (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
        (seq (ia Frame s3 (Tuple b d)) y))).
OldElim (Def4_3_1_2
         (eqD d0 d)
              (comm
         (seq (ia Frame r3 (Tuple b d))
            (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
         (seq (ia Frame s3 (Tuple b d)) y))
                (comm
         (seq (ia Frame r3 (Tuple b d0))
            (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
         (seq (ia Frame s3 (Tuple b d)) y))
           (comm
         (seq (ia Frame r3 (Tuple b d0))
            (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
         (seq (ia Frame s3 (Tuple b d)) y))).
OldElim (Def4_3_1_2'
         (eqD d0 d)
         Delta
                (comm
         (seq (ia Frame r3 (Tuple b d0))
            (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
         (seq (ia Frame s3 (Tuple b d)) y))
           (comm
         (seq (ia Frame r3 (Tuple b d))
            (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
         (seq (ia Frame s3 (Tuple b d)) y))).
Apply refl_equal.
Intro.
OldElim CM7.
OldElim CF2'.
OldElim A7.
Apply refl_equal.
Red.
Intro.
Absurd true=false.
Red ; Intro.
Cut (P:bool->Prop)(P true)->(P false).
Intro L.
Apply (L ([b:bool](<Prop>Case b of True False end))).
Exact I.
Intros.
OldElim H1.
Assumption.
ElimType (eqD d0 d)=false.
ElimType  (eqF (Tuple b d0) (Tuple b d))=(eqD d0 d).
OldElim H0.
OldElim eqF4.
OldElim eqD7.
OldElim bit1.
OldElim andb1.
Apply refl_equal.
 
OldElim eqF4.
OldElim bit1.
OldElim andb1.
Apply refl_equal.
 
OldElim H.
Apply refl_equal.
Intro.
OldElim (eqD_intro d0 d).
Apply refl_equal.
Assumption.
OldElim CM7.
OldElim CF2'.
OldElim A7.
Apply refl_equal.
Apply eqF_intro'.
OldElim eqF3.
Apply refl_equal.
 
OldElim SC3.
OldElim (SUM5 D [d:D]
           (seq (ia Frame r3 (Tuple (toggle b) d))
              (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
        y').
OldElim SUM7.
ElimType ([d:D]Delta)=
     ([d0:D]
      (comm
         (seq
            (seq (ia Frame r3 (Tuple (toggle b) d0))
               (seq (ia D s4 d0) (ia frame s5 (tuple (toggle b)))))
            y')
         (seq (ia Frame s3 (Tuple b d)) y))).
OldElim SUM1.
Apply refl_equal.
Apply EXT.
Intro.
OldElim A5.
OldElim CM7.
OldElim CF2'.
OldElim A7.
Apply refl_equal.
Red ; Intro.
Absurd true=false.
Red.
Intro.
Cut (P:bool->Prop)(P true)->(P false).
Intro L.
Apply (L ([b:bool](<Prop>Case b of True False end))).
Exact I.
Intros.
OldElim H0.
Assumption.
ElimType (eqF (Tuple b d) (Tuple b d))=true.
Pattern 2 (Tuple b d).
OldElim H.
OldElim eqF4.
OldElim bit2.
OldElim andb2.
Apply refl_equal.
OldElim eqF4.
OldElim bit1.
OldElim andb1.
OldElim eqD7.
Apply refl_equal.
Save.


Theorem Comms3Rn_b  : (x,y,y':proc)(b:bit)(d:D)
     
(seq (ia Frame c3  (Tuple (toggle b) d))
       (enc H (mer y (mer
                        (seq (ia D s4 d)
                           (seq (ia frame s5 (tuple (toggle b)))
                                      y')) x))))
     =
     (enc H
        (Lmer
           (comm
              (seq (ia Frame s3 (Tuple (toggle b) d)) y)
              (seq (Rn b) y'))
           x)).
Goal.
Intros.
OldElim ProcRn.
OldElim (A4
(seq
                     (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                (D+[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b)))))) y').
OldElim (CM9
(seq (ia Frame s3 (Tuple (toggle b) d)) y)
(seq
                  (seq
                     (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  y')(seq
                  (D
                  +[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b))))))
                   y')).
ElimType Delta=
(comm (seq (ia Frame s3 (Tuple (toggle b) d)) y)
               (seq
                  (seq
                     (alt (D+[d:D](ia Frame r3 (Tuple b d)))
                        (ia Frame r3 lce))
                     (seq (ia frame s5 (tuple b)) (Rn b)))
                  y')).
OldElim (SUM5 D
[d:D]
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b)))))
y').
OldElim (SC3
(seq (ia Frame s3 (Tuple (toggle b) d)) y)
(D
               +[d:D]
                 (seq
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b)))))
                    y'))).
Cut (p:proc)(p=(alt Delta p)).
Intro H0.
OldElim (H0 
(comm
               (D
               +[d:D]
                 (seq
                    (seq (ia Frame r3 (Tuple (toggle b) d))
                       (seq (ia D s4 d)
                          (ia frame s5 (tuple (toggle b)))))
                    y'))
                (seq (ia Frame s3 (Tuple (toggle b) d)) y))).
OldElim (SUM7 D
[d:D]
              (seq
                 (seq (ia Frame r3 (Tuple (toggle b) d))
                    (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
                 y')
(seq (ia Frame s3 (Tuple (toggle b) d)) y)).
ElimType ([d1:D]
(cond 
           (comm
              (seq
                 (seq (ia Frame r3 (Tuple (toggle b) d))
                    (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
                 y')
              (seq (ia Frame s3 (Tuple (toggle b) d)) y))
(eqD d1 d)
           Delta))
=
([d0:D]
           (comm
              (seq
                 (seq (ia Frame r3 (Tuple (toggle b) d0))
                    (seq (ia D s4 d0) (ia frame s5 (tuple (toggle b)))))
                 y')
              (seq (ia Frame s3 (Tuple (toggle b) d)) y))).
OldElim (Sum_EliminationD
([d:D]
           (comm
              (seq
                 (seq (ia Frame r3 (Tuple (toggle b) d))
                    (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
                 y')
              (seq (ia Frame s3 (Tuple (toggle b) d)) y)))
d).
OldElim A5.
OldElim CM7.
OldElim CF1.
Unfold gamma.
OldElim CM3.
OldElim D5.
OldElim D1.
Try Unfold abbrev.
OldElim (SC6 y
(seq (seq (ia D s4 d) (ia frame s5 (tuple (toggle b))))
                  y')).
OldElim SC7.
OldElim A5;Trivial.
Exact Inc3H.
Apply EXT;Intros.
Cut ((true=(eqD d0 d))\/(false=(eqD d0 d))).
Cut (true=(eqD d0 d))->
(cond
      (comm
         (seq
            (seq (ia Frame r3 (Tuple (toggle b) d))
               (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
            y')
         (seq (ia Frame s3 (Tuple (toggle b) d)) y))
      (eqD d0 d) Delta)
  =(comm
      (seq
         (seq (ia Frame r3 (Tuple (toggle b) d0))
            (seq (ia D s4 d0) (ia frame s5 (tuple (toggle b)))))
         y')
      (seq (ia Frame s3 (Tuple (toggle b) d)) y)).
Cut (false=(eqD d0 d))->
 (cond
      (comm
         (seq
            (seq (ia Frame r3 (Tuple (toggle b) d))
               (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
            y')
         (seq (ia Frame s3 (Tuple (toggle b) d)) y))
      (eqD d0 d) Delta)
  =(comm
      (seq
         (seq (ia Frame r3 (Tuple (toggle b) d0))
            (seq (ia D s4 d0) (ia frame s5 (tuple (toggle b)))))
         y')
      (seq (ia Frame s3 (Tuple (toggle b) d)) y)).
Intros.
Exact (or_ind
(true=(eqD d0 d))
(false=(eqD d0 d))
((cond
      (comm
         (seq
            (seq (ia Frame r3 (Tuple (toggle b) d))
               (seq (ia D s4 d) (ia frame s5 (tuple (toggle b)))))
            y')
         (seq (ia Frame s3 (Tuple (toggle b) d)) y))
      (eqD d0 d) Delta)
  =(comm
      (seq
         (seq (ia Frame r3 (Tuple (toggle b) d0))
            (seq (ia D s4 d0) (ia frame s5 (tuple (toggle b)))))
         y')
      (seq (ia Frame s3 (Tuple (toggle b) d)) y)))
H1 H H2).
Intro.
OldElim H; OldElim COND2.
OldElim A5;OldElim CM7.
OldElim CF2'.
OldElim A7.
Trivial.
Apply eqF_intro'.
OldElim eqF4.
OldElim H.
OldElim bit1.
OldElim andb1.
Trivial.
Intro.
OldElim (eqD_intro d0 d H).
Trivial.
ElimType true=(eqD d0 d0).
OldElim COND1.
Trivial.
Apply eqD7.
OldElim (eqD d0 d).
Left.
Apply refl_equal.
Right.
Apply refl_equal.
Intro;OldElim A1;OldElim A6;Trivial.
OldElim (A5
(alt (D+[d:D](ia Frame r3 (Tuple b d))) (ia Frame r3 lce))
(seq (ia frame s5 (tuple b)) (Rn b))
y').
OldElim SC3.
OldElim (A4
(D+[d:D](ia Frame r3 (Tuple b d)))
(ia Frame r3 lce)
(seq (seq (ia frame s5 (tuple b)) (Rn b)) y')).
OldElim CM8.
OldElim CM7.
OldElim CF2'.
2:Apply eqF_intro'.
2:OldElim eqF2.
2:Trivial.
OldElim (SUM5 D
[d:D](ia Frame r3 (Tuple b d))
(seq (seq (ia frame s5 (tuple b)) (Rn b)) y')).
OldElim (SUM7 D
[d:D](seq (ia Frame r3 (Tuple b d))
              (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
(seq (ia Frame s3 (Tuple (toggle b) d)) y)).
ElimType ([d:D]Delta)=
([d0:D]
        (comm
           (seq (ia Frame r3 (Tuple b d0))
              (seq (seq (ia frame s5 (tuple b)) (Rn b)) y'))
           (seq (ia Frame s3 (Tuple (toggle b) d)) y))).
OldElim A7;OldElim SUM1;OldElim A6; Trivial.
Apply EXT;Intro;OldElim CM7;OldElim CF2'.
OldElim A7;Trivial.
Apply eqF_intro'.
OldElim eqF4.
OldElim bit2.
OldElim andb2;Trivial.
Save.

