(****************************************************************************)
(* This contribution was updated for Coq V5.10 by the COQ workgroup.        *)
(* January 1995                                                             *)
(****************************************************************************)
(*                                                                          *)
(*      Coq V5.8                                                            *)
(*                                                                          *)
(*                                                                          *)
(*      Alternating Bit Protocol                                            *)
(*                                                                          *)
(*      Jan Friso Groote                                                    *)
(*      Utrecht University                                                  *)
(*                                                                          *)
(*      November 1992                                                       *)
(*                                                                          *)
(* From bezem@phil.ruu.nl Fri Apr  2 13:14:31 1993                          *)
(*                                                                          *)
(****************************************************************************)
(*                                abp_lem2.v                                *)
(****************************************************************************)

Require abp_base.
Require abp_defs.
Require abp_lem1.

Theorem Lem1 : (sum D ([d:D] (seq (ia D r1 d) (X1 d))))=X.
Unfold 1 X.
OldElim ProcS ; OldElim ProcR.
OldElim EXPH4.
OldElim LmerSn.
OldElim LmerK.
OldElim LmerL.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommKL.
OldElim CommKRn.
OldElim CommSnK.
OldElim CommSnL.
OldElim CommSnRn.
Repeat OldElim A6.
OldElim (A6 (D+[d:D](seq (ia D r1 d)
           (enc H
              (mer (seq (Sn_d d e0) (seq (Sn e1) (S i)))
                 (mer (K i)
                    (mer (L i) (seq (Rn e1) (seq (Rn e0) (R i)))))))))).
Unfold X1.
Pattern 1 (R i).
OldElim ProcR.
Apply refl_equal.
Save.


Theorem Lem2 : (sum D ([d:D](seq (ia D r1 d) (Y1 d))))=Y.
Unfold Y.
OldElim ProcS .
OldElim EXPH4.
OldElim LmerSn.
OldElim LmerK.
OldElim LmerL.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommKL.
OldElim CommKRn.
OldElim CommSnK.
OldElim CommSnL.
OldElim CommSnRn.
Repeat OldElim A6.
OldElim (A6 (D
      +[d:D]
        (seq (ia D r1 d)
           (enc H
              (mer (seq (Sn_d d e1) (seq (Sn e0) (seq (Sn e1) (S i))))
                 (mer (K i) (mer (L i) (seq (Rn e0) (R i))))))))).

Unfold Y1.
Pattern 1 (S i).
OldElim ProcS.
Apply refl_equal.
Save.


Theorem Lem3 : (d:D)
    (seq (ia Frame c2 (Tuple e0 d))
      (enc H
         (mer (seq (Tn_d d e0) (seq (Sn e1) (S i)))
            (mer
               (seq
                  (alt (seq (ia one int i) (ia Frame s3 (Tuple e0 d)))
                     (seq (ia one int i) (ia Frame s3 lce)))
                  (K i))
               (mer (L i) (R i))))))=
     (X1 d).
Intro.
Unfold 1 X1.
OldElim EXPH4.
OldElim LmerSnd.
OldElim LmerK.
OldElim LmerL.
Pattern 2 3 5 8 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommKL.
OldElim CommKRn.
OldElim ProcSn_d.
OldElim A5.
OldElim Comms2K.
OldElim Comms2Rn.
OldElim Comms2L.
Repeat OldElim A6.
Repeat OldElim A6'.
OldElim SC7.
Apply refl_equal.
Save.

Theorem Lem4 : (d:D)
      (alt
         (seq
            (ia one int i)
            (enc H
               (mer (seq (ia Frame s3 (Tuple e0 d)) (K i))
                  (mer (seq (Tn_d d e0) (seq (Sn e1) (S i)))
                     (mer (L i) (R i))))))
         (seq 
            (ia one int i) 
            (enc H
               (mer (seq (ia Frame s3 lce) (K i))
                  (mer (seq (Tn_d d e0) (seq (Sn e1) (S i)))
                     (mer (L i) (R i)))))))
        =
      (enc H
         (mer (seq (Tn_d d e0) (seq (Sn e1) (S i)))
            (mer
               (seq
                  (alt (seq (ia one int i) (ia Frame s3 (Tuple e0 d)))
                     (seq (ia one int i) (ia Frame s3 lce)))
                  (K i))
               (mer (L i) (R i))))).
Intros. 
OldElim EXPH4.
OldElim LmerTnd.
OldElim LmerL.
OldElim A4.
OldElim A5.
OldElim A5.
OldElim Lmeri.
Pattern 5 6 8 11 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommiL.
OldElim CommiRn.
OldElim CommTn_dL.
OldElim CommTn_di.
OldElim CommTn_dRn.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.
Save.

Theorem Lem5 : (d:D)
       (seq (ia Frame c3 lce) 
         (enc H
            (mer (K i)
               (mer (seq (ia frame s5 (tuple e1)) (R i))
                  (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (L i))))))=
            (enc H
               (mer (seq (ia Frame s3 lce) (K i))
                  (mer (seq (Tn_d d e0) (seq (Sn e1) (S i)))
                     (mer (L i) (R i))))).
Intros.
OldElim EXPH4.
OldElim Lmers3.
OldElim LmerTnd.
OldElim LmerL.
Pattern 2 3 5 8 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommTn_dL.
OldElim CommTn_dRn.
OldElim Comms3Tn_d.
OldElim Comms3L.
OldElim Comms3Rn_lce.
Repeat OldElim A6'.
Repeat OldElim A6.
OldElim SC7.
Pattern 1 (R i).
OldElim ProcR.
OldElim A5.
Apply refl_equal.
Save.

Theorem Lem6 : (d:D)
(seq (ia Frame c3 (Tuple e0 d))
      (enc H
         (mer (K i)
            (mer
               (seq (ia D s4 d)
                  (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i))))
               (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (L i))))))
          =  (enc H
                (mer (seq (ia Frame s3 (Tuple e0 d)) (K i))
                   (mer (seq (Tn_d d e0) (seq (Sn e1) (S i)))
                      (mer (L i) (R i))))).
Intros.
OldElim EXPH4.
OldElim Lmers3.
OldElim LmerTnd.
OldElim LmerL.
Pattern 1 2 3 5 8 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommTn_dL.
OldElim CommTn_dRn.
OldElim Comms3Tn_d.
OldElim Comms3L.
Pattern 6 e0.
ElimType (toggle e1)=e0.
OldElim Comms3Rn_b.
Repeat OldElim A6'.
OldElim Toggle2.
Pattern 2 (R i).
OldElim ProcR.
Apply refl_equal.
OldElim Toggle2.
Apply refl_equal.
Save.

Theorem Lem7 : (d:D)
 (seq (ia D s4 d) (X2 d))
     =
      (enc H
         (mer (K i)
            (mer  
               (seq (ia D s4 d)
                  (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i))))
               (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (L i))))).

Intros.
OldElim EXPH4.
OldElim LmerK.
OldElim Lmers4.
OldElim LmerTnd.
OldElim LmerL.
OldElim CommTn_dL.
OldElim CommTn_ds4.
OldElim CommLs4.
OldElim CommKs4.
OldElim CommTn_dK.
OldElim CommKL.
Repeat OldElim A6.
Repeat OldElim A6'.
Unfold X2.
OldElim (SC6  (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i))) (L i)).
OldElim (SC6 (mer (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i)))
                  (L i)) (K i)).
OldElim (SC6 (mer (mer (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i)))
             (L i)) (K i))  (seq (Tn_d d e0) (seq (Sn e1) (S i)))).
OldElim SC7.
OldElim SC7.
OldElim (SC6 (mer (K i) (seq (Tn_d d e0) (seq (Sn e1) (S i)))) (L i)).
OldElim SC7.
Apply refl_equal.
Save.

Theorem Lem8 : (d:D)
     (seq (ia frame c5 (tuple e1)) 
        (enc H  (mer (R i)
           (mer
              (alt
                 (seq (ia one int i)
                    (seq (ia frame s6 (tuple e1)) (L i)))
                 (seq (ia one int i) (seq (ia frame s6 sce) (L i))))
              (mer (K i) (seq (Tn_d d e0) (seq (Sn e1) (S i))))))))
        =(enc H
            (mer (K i)
               (mer (seq (ia frame s5 (tuple e1)) (R i))
                  (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (L i))))).

Intros.
OldElim EXPH4.
OldElim LmerK.
OldElim LmerL.
OldElim Lmers5.
OldElim LmerTnd.
OldElim CommTn_dL.
OldElim CommTn_ds5.
OldElim CommLs5.
OldElim CommKs5.
OldElim CommKL.
OldElim CommTn_dK.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.
Save.

Theorem Lem9 : (d:D)
         (alt (seq (ia one int i) (enc H
            (mer (seq (ia frame s6 (tuple e1)) (L i))
               (mer (R i)
                  (mer (K i) (seq (Tn_d d e0) (seq (Sn e1) (S i))))))))
           (seq (ia one int i) (enc H
            (mer (seq (ia frame s6 sce) (L i))
               (mer (R i)
                  (mer (K i) (seq (Tn_d d e0) (seq (Sn e1) (S i)))))))))
    =
    (enc H  (mer (R i)
           (mer
              (alt
                 (seq (ia one int i)
                    (seq (ia frame s6 (tuple e1)) (L i)))
                 (seq (ia one int i) (seq (ia frame s6 sce) (L i))))
              (mer (K i) (seq (Tn_d d e0) (seq (Sn e1) (S i))))))).

Intros.
OldElim EXPH4.
OldElim Lmeri.
OldElim LmerK.
OldElim LmerTnd.
Pattern 3 9 10 11 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim (SC3 (seq (Rn e1) (seq (Rn e0) (R i))) 
              (seq (Tn_d d e0) (seq (Sn e1) (S i)))).
OldElim CommTn_dRn.
OldElim (SC3 (seq (Rn e1) (seq (Rn e0) (R i))) (K i)).
OldElim CommKRn.
OldElim (SC3 (seq (Rn e1) (seq (Rn e0) (R i)))
                           (alt
                              (seq (ia one int i)
                                 (seq (ia frame s6 (tuple e1)) (L i)))
                              (seq (ia one int i)
                                 (seq (ia frame s6 sce) (L i))))).

OldElim CommiRn.
OldElim (SC3 (alt (seq (ia one int i)
                              (seq (ia frame s6 (tuple e1)) (L i)))
                           (seq (ia one int i)
                              (seq (ia frame s6 sce) (L i))))
                        (seq (Tn_d d e0) (seq (Sn e1) (S i)))).

OldElim CommTn_di.
OldElim CommTn_dK.
OldElim CommiK.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.
Save.

