(****************************************************************************)
(* This contribution was updated for Coq V5.10 by the COQ workgroup.        *)
(* January 1995                                                             *)
(****************************************************************************)
(*                                                                          *)
(*      Coq V5.8                                                            *)
(*                                                                          *)
(*                                                                          *)
(*      Alternating Bit Protocol                                            *)
(*                                                                          *)
(*      Jan Friso Groote                                                    *)
(*      Utrecht University                                                  *)
(*                                                                          *)
(*      November 1992                                                       *)
(*                                                                          *)
(* From bezem@phil.ruu.nl Fri Apr  2 13:14:31 1993                          *)
(*                                                                          *)
(****************************************************************************)
(*                               abp_lem25.v                                *)
(****************************************************************************)

Require abp_base.
Require abp_defs.
Require abp_lem1.
Require abp_lem2.

Theorem Lem10 : (d:D)
      (seq (ia frame c6 (tuple e1)) (X1 d))=
         (enc H
            (mer (seq (ia frame s6 (tuple e1)) (L i))
               (mer (R i)
                  (mer (K i) (seq (Tn_d d e0) (seq (Sn e1) (S i))))))).
Goal.
Intros.
OldElim EXPH4.
OldElim Lmers6.
OldElim LmerK.
OldElim LmerTnd.
Pattern 1 3 4 5 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim CommTn_dK.
OldElim (SC3  (seq (Rn e1) (seq (Rn e0) (R i))) (K i)).
OldElim CommKRn.
OldElim (SC3 (seq (Rn e1) (seq (Rn e0) (R i)))
                     (seq (Tn_d d e0) (seq (Sn e1) (S i)))).
OldElim CommTn_dRn.
OldElim CommKs6.
OldElim CommRns6.
Pattern 1 2 e1.
ElimType (toggle e0)=e1.
OldElim CommTn_ds6_b.

Repeat OldElim A6.
Repeat OldElim A6'.
Unfold X1.
OldElim (SC6 (mer (seq (Sn_d d e0) (seq (Sn e1) (S i)))
               (mer (R i) (K i))) (L i)).
OldElim SC7.
OldElim SC7.
OldElim (SC6 (mer (K i) (L i)) (R i)).
OldElim SC7.
Apply refl_equal.
OldElim Toggle1.
Apply refl_equal.
Save.


Theorem Lem11 : (d:D)
       (seq (ia frame c6 sce) (X1 d))=
         (enc H
            (mer (seq (ia frame s6 sce) (L i))
               (mer (R i)
                  (mer (K i) (seq (Tn_d d e0) (seq (Sn e1) (S i))))))).
Goal.
Intros.
OldElim EXPH4.
OldElim Lmers6.
OldElim LmerK.
OldElim LmerTnd.
Pattern 1 3 4 5 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim CommTn_dK.
OldElim (SC3  (seq (Rn e1) (seq (Rn e0) (R i))) (K i)).
OldElim CommKRn.
OldElim (SC3 (seq (Rn e1) (seq (Rn e0) (R i)))
                     (seq (Tn_d d e0) (seq (Sn e1) (S i)))).
OldElim CommTn_dRn.
OldElim CommKs6.
OldElim CommRns6.
OldElim CommTn_ds6_sce.
Repeat OldElim A6.
Repeat OldElim A6'.
Unfold X1.
OldElim (SC6 (mer (seq (Sn_d d e0) (seq (Sn e1) (S i)))
               (mer (R i) (K i))) (L i)).
OldElim SC7.
OldElim SC7.
ElimType (mer (K i) (mer (L i) (R i)))=(mer (R i) (mer (K i) (L i))).
Apply refl_equal.
OldElim (SC6 (mer (K i) (L i)) (R i)).
OldElim SC7.
Apply refl_equal.
Save.

Theorem Lem12 : (d:D)
     (seq (ia Frame c2 (Tuple e0 d))
        (alt
           (seq (ia one int i) 
              (seq (ia Frame c3 (Tuple e0 d))
                  (seq (ia D s4 d) (X2 d))))
           (seq (ia one int i) 
              (seq (ia Frame c3 lce)
                 (seq (ia frame c5 (tuple e1)) 
                    (seq
                       (alt (seq (ia one int i) (ia frame c6 (tuple e1))) 
                            (seq (ia one int i) (ia frame c6 sce)))
                       (X1 d)))))))=(X1 d).
Goal.
Intros.
Pattern 2 (X1 d).
OldElim Lem3.
OldElim Lem4.
OldElim Lem5.
OldElim Lem6.
OldElim Lem7.
OldElim Lem8.
OldElim Lem9.
OldElim Lem10.
OldElim Lem11.
OldElim A4.
OldElim A5.
OldElim A5.
Apply refl_equal.
Save.


Theorem Lem13 : (d:D)
    (seq (ia Frame c2 (Tuple e1 d))
      (enc H
         (mer (seq (Tn_d d e1) (S i))
            (mer
               (seq
                  (alt (seq (ia one int i) (ia Frame s3 (Tuple e1 d)))
                     (seq (ia one int i) (ia Frame s3 lce)))
                  (K i))
               (mer (L i) (seq (Rn e0) (R i)))))))=
     (Y1 d).
Goal.
Intro.
Unfold 1 Y1.
OldElim EXPH4.
OldElim LmerSnd.
OldElim LmerK.
OldElim LmerL.
Pattern 2 3 5 8 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommKL.
OldElim CommKRn.
OldElim ProcSn_d.
OldElim A5.
OldElim Comms2K.
OldElim Comms2Rn.
OldElim Comms2L.
Repeat OldElim A6.
Repeat OldElim A6'.
OldElim SC7.
Apply refl_equal.
Save.


Theorem Lem14 : (d:D)
      (alt
      (seq (ia one int i)
         (enc H
            (mer (seq (ia Frame s3 (Tuple e1 d)) (K i))
               (mer (seq (Tn_d d e1) (S i))
                  (mer (L i) (seq (Rn e0) (R i)))))))
      (seq (ia one int i)
         (enc H
            (mer (seq (ia Frame s3 lce) (K i))
               (mer (seq (Tn_d d e1) (S i))
                  (mer (L i) (seq (Rn e0) (R i))))))))
        =
      (enc H
         (mer (seq (Tn_d d e1) (S i))
            (mer
               (seq
                  (alt (seq (ia one int i) (ia Frame s3 (Tuple e1 d)))
                     (seq (ia one int i) (ia Frame s3 lce)))
                  (K i))
               (mer (L i) (seq (Rn e0) (R i)))))).
Goal.
Intros.
OldElim EXPH4.
OldElim LmerTnd.
OldElim LmerL.
OldElim A4.
OldElim A5.
OldElim A5.
OldElim Lmeri.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommiL.
OldElim CommiRn.
OldElim CommTn_dL.
OldElim CommTn_di.
OldElim CommTn_dRn.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.
Save.



Theorem Lem15 : (d:D)
   (seq (ia Frame c3 lce)
      (enc H
         (mer (K i)
            (mer (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i)))
               (mer (seq (Tn_d d e1) (S i)) (L i))))))
              =
            (enc H
            (mer (seq (ia Frame s3 lce) (K i))
               (mer (seq (Tn_d d e1) (S i)) 
                  (mer (L i) (seq (Rn e0) (R i)))))).
Goal.
Intros.
OldElim EXPH4.
OldElim Lmers3.
OldElim LmerTnd.
OldElim LmerL.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommTn_dL.
OldElim CommTn_dRn.
OldElim Comms3Tn_d.
OldElim Comms3L.
OldElim Comms3Rn_lce.
Repeat OldElim A6'.
Repeat OldElim A6.
OldElim SC7.
OldElim A5.
Apply refl_equal.
Save.


Theorem Lem16 : (d:D)
   (seq (ia Frame c3 (Tuple e1 d))
      (enc H
         (mer (K i)
            (mer (seq (ia D s4 d) (seq (ia frame s5 (tuple e1)) (R i)))
               (mer (seq (Tn_d d e1) (S i)) (L i))))))
       = (enc H
            (mer (seq (ia Frame s3 (Tuple e1 d)) (K i))
               (mer (seq (Tn_d d e1) (S i))
                  (mer (L i) (seq (Rn e0) (R i)))))).
 
Goal.
Intros.
OldElim EXPH4.
OldElim Lmers3.
OldElim LmerTnd.
OldElim LmerL.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommTn_dL.
OldElim CommTn_dRn.
OldElim Comms3Tn_d.
OldElim Comms3L.
Pattern 4 e1.
ElimType (toggle e0)=e1.
OldElim Comms3Rn_b.
Repeat OldElim A6'.
OldElim Toggle1.
Apply refl_equal.
OldElim Toggle1.
Apply refl_equal.
Save.


Theorem Lem17 : (d:D)
 (seq (ia D s4 d) (Y2 d))
     =
      (enc H
         (mer (K i)
            (mer (seq (ia D s4 d) (seq (ia frame s5 (tuple e1)) (R i)))
               (mer (seq (Tn_d d e1) (S i)) (L i))))).
Goal.
Intros.
OldElim EXPH4.
OldElim LmerK.
OldElim Lmers4.
OldElim LmerTnd.
OldElim LmerL.
OldElim CommTn_dL.
OldElim CommTn_ds4.
OldElim CommLs4.
OldElim CommKs4.
OldElim (SC3 (seq (Tn_d d e1) (S i)) (K i)).
OldElim CommTn_dK.
OldElim CommKL.
Repeat OldElim A6.
Repeat OldElim A6'.
Unfold Y2.
OldElim (SC6  (seq (ia frame s5 (tuple e1)) (R i)) (L i)).
OldElim (SC6 (mer (seq (ia frame s5 (tuple e1)) (R i)) (L i)) (K i)).
OldElim (SC6 (mer (mer (seq (ia frame s5 (tuple e1)) (R i))
             (L i)) (K i))  (seq (Tn_d d e1) (S i))).
OldElim SC7.
OldElim SC7.
OldElim (SC6 (mer (K i) (seq (Tn_d d e1) (S i))) (L i)).
OldElim SC7.
Apply refl_equal.
Save.

Theorem Lem18 : (d:D)
   (seq (ia frame c5 (tuple e0))
      (enc H
         (mer (seq (Rn e0) (R i))
            (mer
               (alt
                  (seq (ia one int i)
                     (seq (ia frame s6 (tuple e0)) (L i)))
                  (seq (ia one int i) (seq (ia frame s6 sce) (L i))))
               (mer (K i) (seq (Tn_d d e1) (S i)))))))
        =(enc H
         (mer (K i)
            (mer (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i)))
               (mer (seq (Tn_d d e1) (S i)) (L i))))).
Goal.
Intros.
OldElim EXPH4.
OldElim LmerK.
OldElim LmerL.
OldElim Lmers5.
OldElim LmerTnd.
OldElim CommTn_dL.
OldElim CommTn_ds5.
OldElim CommLs5.
OldElim CommKs5.
OldElim CommKL.
OldElim CommTn_dK.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.
Save.

Theorem Lem19 : (d:D)
 (alt
      (seq (ia one int i)
         (enc H
            (mer (seq (ia frame s6 (tuple e0)) (L i))
               (mer (seq (Rn e0) (R i))
                  (mer (K i) (seq (Tn_d d e1) (S i)))))))
      (seq (ia one int i)
         (enc H
            (mer (seq (ia frame s6 sce) (L i))
               (mer (seq (Rn e0) (R i))
                  (mer (K i) (seq (Tn_d d e1) (S i))))))))
    =
      (enc H
         (mer (seq (Rn e0) (R i))
            (mer
               (alt
                  (seq (ia one int i)
                     (seq (ia frame s6 (tuple e0)) (L i)))
                  (seq (ia one int i) (seq (ia frame s6 sce) (L i))))
               (mer (K i) (seq (Tn_d d e1) (S i)))))).
Goal.
Intros.
OldElim EXPH4.
OldElim Lmeri.
OldElim LmerK.
OldElim LmerTnd.
OldElim LmerRn.
OldElim (SC3 (seq (Rn e0) (R i))
              (seq (Tn_d d e1) (S i))).
OldElim CommTn_dRn.
OldElim (SC3 (seq (Rn e0) (R i)) (K i)).
OldElim CommKRn.
OldElim (SC3 (seq (Rn e0) (R i))
            (alt (seq (ia one int i)
                    (seq (ia frame s6 (tuple e0)) (L i)))
                 (seq (ia one int i)
                    (seq (ia frame s6 sce) (L i))))).
 
OldElim CommiRn.
OldElim (SC3 (alt (seq (ia one int i)
                              (seq (ia frame s6 (tuple e0)) (L i)))
                           (seq (ia one int i)
                              (seq (ia frame s6 sce) (L i))))
                        (seq (Tn_d d e1) (S i))).
 
OldElim CommTn_di.
OldElim CommTn_dK.
OldElim CommiK.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.
Save.

