(****************************************************************************)
(* This contribution was updated for Coq V5.10 by the COQ workgroup.        *)
(* January 1995                                                             *)
(****************************************************************************)
(*                                                                          *)
(*      Coq V5.8                                                            *)
(*                                                                          *)
(*                                                                          *)
(*      Alternating Bit Protocol                                            *)
(*                                                                          *)
(*      Jan Friso Groote                                                    *)
(*      Utrecht University                                                  *)
(*                                                                          *)
(*      November 1992                                                       *)
(*                                                                          *)
(* From bezem@phil.ruu.nl Fri Apr  2 13:14:31 1993                          *)
(*                                                                          *)
(****************************************************************************)
(*                                abp_lem3.v                                *)
(****************************************************************************)

Require abp_base.
Require abp_defs.
Require abp_lem1.
Require abp_lem2.
Require abp_lem25.

Theorem Lem20 : (d:D)<proc>
      (seq (ia frame c6 (tuple e0)) (Y1 d))=
         (enc H
            (mer (seq (ia frame s6 (tuple e0)) (L i))
               (mer (seq (Rn e0) (R i))
                  (mer (K i) (seq (Tn_d d e1) (S i)))))).
Goal.
Intros.
OldElim EXPH4.
OldElim Lmers6.
OldElim LmerK.
OldElim LmerTnd.
OldElim LmerRn.
OldElim CommTn_dK.
OldElim (SC3  (seq (Rn e0) (R i)) (K i)).
OldElim CommKRn.
OldElim (SC3 (seq (Rn e0) (R i))
                     (seq (Tn_d d e1) (S i))).
OldElim CommTn_dRn.
OldElim CommKs6.
OldElim CommRns6.
Pattern 1 2 e0.
ElimType (toggle e1)=e0.
OldElim CommTn_ds6_b.
 
Repeat OldElim A6.
Repeat OldElim A6'.
OldElim Toggle2.
Unfold Y1.
OldElim (SC6 (mer (seq (Sn_d d e1) (S i))
               (mer (seq (Rn e0) (R i)) (K i))) (L i)).
OldElim SC7.
OldElim SC7.
OldElim (SC6 (mer (K i) (L i)) (seq (Rn e0) (R i))).
OldElim SC7.
Apply refl_equal.
OldElim Toggle2.
Apply refl_equal.
Save.



Theorem Lem21 : (d:D)
       (seq (ia frame c6 sce) (Y1 d))=
         (enc H
            (mer (seq (ia frame s6 sce) (L i))
               (mer (seq (Rn e0) (R i))
                  (mer (K i) (seq (Tn_d d e1) (S i)))))).
Goal.
Intros.
OldElim EXPH4.
OldElim Lmers6.
OldElim LmerK.
OldElim LmerTnd.
OldElim LmerRn.
OldElim CommTn_dK.
OldElim (SC3  (seq (Rn e0) (R i)) (K i)).
OldElim CommKRn.
OldElim (SC3 (seq (Rn e0) (R i))
                     (seq (Tn_d d e1) (S i))).
OldElim CommTn_dRn.
OldElim CommKs6.
OldElim CommRns6.
OldElim CommTn_ds6_sce.
Repeat OldElim A6.
Repeat OldElim A6'.
Unfold Y1.
OldElim (SC6 (mer (seq (Sn_d d e1) (S i))
               (mer (seq (Rn e0) (R i)) (K i))) (L i)).
OldElim SC7.
OldElim SC7.
ElimType (mer (K i) (mer (L i) (seq (Rn e0) (R i))))=
            (mer (seq (Rn e0) (R i)) (mer (K i) (L i))).
Apply refl_equal.
OldElim (SC6 (mer (K i) (L i)) (seq (Rn e0) (R i))).
OldElim SC7.
Apply refl_equal.
Save.


Goal (d:D)
     (seq (ia Frame c2 (Tuple e1 d))
        (alt
           (seq (ia one int i)
              (seq (ia Frame c3 (Tuple e1 d))
                  (seq (ia D s4 d) (Y2 d))))
           (seq (ia one int i)
              (seq (ia Frame c3 lce)
                 (seq (ia frame c5 (tuple e0))
                    (seq
                       (alt (seq (ia one int i) (ia frame c6 (tuple e0)))
                            (seq (ia one int i) (ia frame c6 sce)))
                       (Y1 d)))))))=(Y1 d).
Intros.
Pattern 2 (Y1 d).
OldElim Lem13.
OldElim Lem14.
OldElim Lem15.
OldElim Lem16.
OldElim Lem17.
OldElim Lem18.
OldElim Lem19.
OldElim Lem20.
OldElim Lem21.
OldElim A4.
OldElim A5.
OldElim A5.
Apply refl_equal.
 
Save Lem22.

Goal (d:D)
   (seq (ia frame c5 (tuple e0)) 
      (enc H
         (mer (seq (Rn e0) (R i))
            (mer
               (alt
                  (seq (ia one int i)
                     (seq (ia frame s6 (tuple e0)) (L i)))
                  (seq (ia one int i) (seq (ia frame s6 sce) (L i))))
               (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (K i))))))= (X2 d).

Intros.
Unfold X2.
OldElim EXPH4.
OldElim LmerTnd.
OldElim LmerK.
OldElim LmerL.
OldElim Lmers5.
OldElim (SC3 (L i) (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i)))).
OldElim CommLs5.
OldElim CommKL.
OldElim CommKs5.
OldElim (SC3 (seq (Tn_d d e0) (seq (Sn e1) (S i))) (K i)).
OldElim CommTn_dK.
OldElim CommTn_dL.
OldElim (SC3 (seq (Tn_d d e0) (seq (Sn e1) (S i)))
             (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i)))).
OldElim CommTn_ds5.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.

Save Lem23.

Goal (d:D)
     (alt (seq (ia one int i) (enc H
            (mer (seq (ia frame s6 (tuple e0)) (L i))
               (mer (seq (Rn e0) (R i))
                  (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (K i))))))
          (seq (ia one int i) (enc H
            (mer (seq (ia frame s6 sce) (L i))
               (mer (seq (Rn e0) (R i))
                  (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (K i)))))))
     =(enc H
         (mer (seq (Rn e0) (R i))
            (mer
               (alt
                  (seq (ia one int i)
                     (seq (ia frame s6 (tuple e0)) (L i)))
                  (seq (ia one int i) (seq (ia frame s6 sce) (L i))))
               (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (K i))))).
Intros.
OldElim EXPH4. 
OldElim LmerRn.
OldElim Lmeri.
OldElim LmerTnd.
OldElim LmerK.
OldElim (SC3 (seq (Tn_d d e0) (seq (Sn e1) (S i))) (K i)).
OldElim CommTn_dK.
OldElim (SC3 (seq (Rn e0) (R i))
                (alt
                   (seq (ia one int i)
                      (seq (ia frame s6 (tuple e0))
                         (L i)))
                   (seq (ia one int i)
                      (seq (ia frame s6 sce) (L i))))).
OldElim CommiRn.
OldElim (SC3 (seq (Rn e0) (R i)) (seq (Tn_d d e0) (seq (Sn e1) (S i)))).
OldElim CommTn_dRn.
OldElim (SC3 (seq (Rn e0) (R i)) (K i)).
OldElim CommKRn.
OldElim (SC3 (alt (seq (ia one int i) (seq (ia frame s6 (tuple e0)) (L i)))
                 (seq (ia one int i)
                                    (seq (ia frame s6 sce) (L i))))
                              (seq (Tn_d d e0) (seq (Sn e1) (S i)))).
OldElim CommTn_di.
OldElim CommiK. 
Repeat OldElim A6. 
Repeat OldElim A6'.
Apply refl_equal.
Save Lem24.

Goal (d:D)
       (seq (ia frame c6 (tuple e0)) Y)=
         (enc H
            (mer (seq (ia frame s6 (tuple e0)) (L i))
               (mer (seq (Rn e0) (R i))
                  (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (K i))))).
Intros.
OldElim EXPH4. 
OldElim LmerRn.
OldElim Lmers6.
OldElim LmerTnd.
OldElim LmerK.
OldElim (SC3 (seq (Tn_d d e0) (seq (Sn e1) (S i))) (K i)).
OldElim CommTn_dK.
OldElim (SC3 (seq (Rn e0) (R i)) (seq (Tn_d d e0) (seq (Sn e1) (S i)))).
OldElim CommTn_dRn.
OldElim CommRns6.
OldElim (SC3  (seq (Rn e0) (R i)) (K i)).
OldElim CommKRn.
OldElim CommKs6.
OldElim CommTn_ds6_b'.
Repeat OldElim A6.
Repeat OldElim A6'.
Unfold Y.
OldElim (SC6 (mer (seq (Sn e1) (S i)) (mer (seq (Rn e0) (R i)) (K i))) (L i)).
OldElim SC7.
OldElim SC7.
OldElim (SC6 (mer (K i) (L i)) (seq (Rn e0) (R i))).
OldElim SC7.
Apply refl_equal.
Save Lem25.

Goal (d:D)
      (seq (ia frame c6 sce) (enc H
         (mer (L i)
            (mer (seq (Sn_d d e0) (seq (Sn e1) (S i)))
               (mer (seq (Rn e0) (R i)) (K i))))))=
         (enc H
            (mer (seq (ia frame s6 sce) (L i))
               (mer (seq (Rn e0) (R i))
                  (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (K i))))).
     
Intros.
OldElim EXPH4.
OldElim LmerRn.
OldElim Lmers6.
OldElim LmerTnd.
OldElim LmerK.
OldElim (SC3 (seq (Tn_d d e0) (seq (Sn e1) (S i))) (K i)).
OldElim CommTn_dK.
OldElim (SC3 (seq (Rn e0) (R i)) (seq (Tn_d d e0) (seq (Sn e1) (S i)))).
OldElim CommTn_dRn.
OldElim CommRns6. 
OldElim (SC3  (seq (Rn e0) (R i)) (K i)).
OldElim CommKRn.  
OldElim CommKs6.
OldElim CommTn_ds6_sce.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.

Save Lem26.


Goal (d:D)
    (seq (ia Frame c2 (Tuple e0 d)) (enc H
         (mer (seq (Tn_d d e0) (seq (Sn e1) (S i)))
            (mer
               (alt
                  (seq (ia one int i)
                     (seq (ia Frame s3 (Tuple e0 d)) (K i)))
                  (seq (ia one int i) (seq (ia Frame s3 lce) (K i))))
               (mer (L i) (seq (Rn e0) (R i)))))))=
       (enc H
         (mer (L i)
            (mer (seq (Sn_d d e0) (seq (Sn e1) (S i)))
               (mer (seq (Rn e0) (R i)) (K i))))).
Intros.
OldElim EXPH4.
OldElim LmerL.
OldElim LmerSnd.
OldElim LmerRn.
OldElim LmerK.
OldElim CommLRn.
OldElim (SC3  (seq (Rn e0) (R i)) (K i)).
OldElim CommKRn.
OldElim CommSn_dK.
OldElim (SC3 (L i) (seq (Sn_d d e0) (seq (Sn e1) (S i)))).
OldElim CommSn_dL.
OldElim (SC3 (L i) (K i)).
OldElim CommKL.
OldElim CommSn_dRn.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.

Save Lem27.

Goal (d:D)
     (alt (seq (ia one int i) 
         (enc H
            (mer (seq (ia Frame s3 (Tuple e0 d)) (K i))
               (mer (seq (Tn_d d e0) (seq (Sn e1) (S i)))
                  (mer (L i) (seq (Rn e0) (R i)))))))
       (seq (ia one int i) (enc H
            (mer (seq (ia Frame s3 lce) (K i))
               (mer (seq (Tn_d d e0) (seq (Sn e1) (S i)))
                  (mer (L i) (seq (Rn e0) (R i))))))))=
      (enc H
         (mer (seq (Tn_d d e0) (seq (Sn e1) (S i)))
            (mer
               (alt
                  (seq (ia one int i)
                     (seq (ia Frame s3 (Tuple e0 d)) (K i)))
                  (seq (ia one int i) (seq (ia Frame s3 lce) (K i))))
               (mer (L i) (seq (Rn e0) (R i)))))).
Intros.
OldElim EXPH4.
OldElim LmerTnd.
OldElim Lmeri.
OldElim LmerL.
OldElim LmerRn.
OldElim CommTn_dRn.
OldElim CommTn_dL.
OldElim CommTn_di.
OldElim CommLRn.
OldElim CommiRn.
OldElim CommiL.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.
Save Lem28.

Goal (d:D)
   (seq (ia Frame c3 lce) (X2 d))=
         (enc H
            (mer (seq (ia Frame s3 lce) (K i))
               (mer (seq (Tn_d d e0) (seq (Sn e1) (S i)))
                  (mer (L i) (seq (Rn e0) (R i)))))).
Intros.   
OldElim EXPH4. 
OldElim Lmers3.
OldElim LmerTnd.
OldElim LmerL.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommTn_dL.
OldElim CommTn_dRn.
OldElim Comms3Tn_d.
OldElim Comms3L.
OldElim Comms3Rn_lce.
Repeat OldElim A6.
Repeat OldElim A6'.

Unfold X2.
OldElim (SC6 (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (L i))
            (mer (K i)
               (seq (seq (ia frame s5 (tuple e0)) (Rn e0)) (R i)))).
OldElim SC7.
OldElim (SC6 (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i))) (L i)).
OldElim (SC6 (mer (K i)
               (seq (seq (ia frame s5 (tuple e0)) (Rn e0)) (R i))) (L i)).
OldElim SC7.
OldElim A5.
Apply refl_equal.
Save Lem29.

Goal  (d:D)
   (seq (ia Frame c3 (Tuple e0 d)) (X2 d))=
         (enc H 
            (mer (seq (ia Frame s3 (Tuple e0 d)) (K i)) 
               (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) 
                  (mer (L i) (seq (Rn e0) (R i)))))). 
Intros.   
OldElim EXPH4.  
OldElim Lmers3. 
OldElim LmerTnd.
OldElim LmerL. 
OldElim LmerRn.
OldElim CommLRn. 
OldElim CommTn_dL.
OldElim CommTn_dRn.
OldElim Comms3Tn_d. 
OldElim Comms3L. 
OldElim Comms3Rn_b'.
Repeat OldElim A6. 
Repeat OldElim A6'. 
Unfold X2.
OldElim (SC6 (mer (seq (Tn_d d e0) (seq (Sn e1) (S i))) (L i))
    (mer (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i))) (K i))).

OldElim SC7.
OldElim (SC6 (mer (L i)
          (seq (ia frame s5 (tuple e0)) (seq (Rn e0) (R i)))) (K i)).
OldElim SC7.
Apply refl_equal.
Save Lem30.

Goal (d:D)
     (seq (ia frame c5 (tuple e0))
        (alt 
           (seq (ia one int i)
              (seq (ia frame c6 sce) 
                 (seq (ia Frame c2 (Tuple e0 d))
                    (seq
                       (alt (seq (ia one int i) (ia Frame c3 lce))
                            (seq (ia one int i) (ia Frame c3 (Tuple e0 d))))
                       (X2 d)))))
           (seq (ia one int i)
              (seq (ia frame c6 (tuple e0)) Y))))=(X2 d).
Intros.
Pattern 2 (X2 d).
OldElim Lem23.
OldElim Lem24.
OldElim Lem25.
OldElim Lem26.
OldElim Lem27.
OldElim Lem28.
OldElim Lem29.
OldElim Lem30.
OldElim (A1 (seq (ia one int i)
            (seq (ia frame c6 sce)
               (seq (ia Frame c2 (Tuple e0 d))
                  (alt
                     (seq (ia one int i)
                        (seq (ia Frame c3 (Tuple e0 d)) (X2 d)))
                     (seq (ia one int i)
                        (seq (ia Frame c3 lce) (X2 d)))))))
       (seq (ia one int i) (seq (ia frame c6 (tuple e0)) Y))).
OldElim A4.
OldElim (A1 
     (seq (ia one int i) (seq (ia Frame c3 lce) (X2 d)))
     (seq (ia one int i) (seq (ia Frame c3 (Tuple e0 d)) (X2 d)))).
OldElim A5.
OldElim A5.
Apply refl_equal.
Save Lem31.

Goal (d:D)
   (seq (ia frame c5 (tuple e1))
      (enc H
         (mer (R i)
            (mer
               (alt
                  (seq (ia one int i)
                     (seq (ia frame s6 (tuple e1)) (L i)))
                  (seq (ia one int i) (seq (ia frame s6 sce) (L i))))
               (mer (seq (Tn_d d e1) (S i)) (K i))))))=(Y2 d).

Intros.
Unfold Y2.
OldElim EXPH4.
OldElim LmerTnd.
OldElim LmerK.
OldElim LmerL.
OldElim Lmers5.
OldElim (SC3 (L i) (seq (ia frame s5 (tuple e1)) (R i))).
OldElim CommLs5.
OldElim CommKL.
OldElim CommKs5.
OldElim (SC3 (seq (Tn_d d e1) (S i)) (K i)).
OldElim CommTn_dK.
OldElim CommTn_dL.
OldElim (SC3 (seq (Tn_d d e1) (S i)) (seq (ia frame s5 (tuple e1)) (R i))).
OldElim CommTn_ds5.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.
Save Lem33.


Goal (d:D)
     (alt (seq (ia one int i) (enc H
            (mer (seq (ia frame s6 (tuple e1)) (L i))
               (mer (R i)
                  (mer (seq (Tn_d d e1) (S i)) (K i))))))
          (seq (ia one int i) (enc H
            (mer (seq (ia frame s6 sce) (L i))
               (mer (R i) (mer (seq (Tn_d d e1) (S i)) (K i)))))))
     =
      (enc H 
         (mer (R i)
            (mer  
               (alt 
                  (seq (ia one int i) 
                     (seq (ia frame s6 (tuple e1)) (L i))) 
                  (seq (ia one int i) (seq (ia frame s6 sce) (L i)))) 
               (mer (seq (Tn_d d e1) (S i)) (K i))))).
Intros.
OldElim EXPH4.
OldElim Lmeri.
OldElim LmerTnd.
OldElim LmerK.
Pattern 3 9 10 11 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim (SC3 (seq (Tn_d d e1) (S i)) (K i)).
OldElim CommTn_dK.
OldElim (SC3 (seq (Rn e1) (seq (Rn e0) (R i))) (K i)).
OldElim CommKRn.

OldElim (SC3 (seq (Rn e1) (seq (Rn e0) (R i)))
                (alt
                   (seq (ia one int i)
                      (seq (ia frame s6 (tuple e1))
                         (L i)))
                   (seq (ia one int i)
                      (seq (ia frame s6 sce) (L i))))).
OldElim CommiRn.
OldElim (SC3 (seq (Rn e1) (seq (Rn e0) (R i))) (seq (Tn_d d e1) (S i))).
OldElim CommTn_dRn.
OldElim (SC3 (alt (seq (ia one int i) (seq (ia frame s6 (tuple e1)) (L i)))
  (seq (ia one int i) (seq (ia frame s6 sce) (L i)))) (seq (Tn_d d e1) (S i))).

OldElim CommTn_di.
OldElim CommiK.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.
Save Lem34.

Goal (d:D)
       (seq (ia frame c6 (tuple e1)) X)=
         (enc H
            (mer (seq (ia frame s6 (tuple e1)) (L i))
               (mer (R i)
                  (mer (seq (Tn_d d e1) (S i)) (K i))))).

Intros.
OldElim EXPH4.
Pattern 2 6 7 8 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim Lmers6.
OldElim LmerTnd.
OldElim LmerK.
OldElim (SC3 (seq (Tn_d d e1) (S i)) (K i)).
OldElim CommTn_dK.
OldElim (SC3 (seq (Rn e1) (seq (Rn e0) (R i))) (seq (Tn_d d e1) (S i))).
OldElim CommTn_dRn.
OldElim CommRns6.
OldElim (SC3  (seq (Rn e1) (seq (Rn e0) (R i))) (K i)).
OldElim CommKRn.
OldElim CommKs6.
OldElim CommTn_ds6_b'.
Repeat OldElim A6.
Repeat OldElim A6'.
Unfold X.
OldElim (SC6 (mer (S i) (mer (R i) (K i))) (L i)).
OldElim SC7.
OldElim SC7.
OldElim (SC6 (mer (K i) (L i)) (R i)).
OldElim SC7.
Apply refl_equal.
Save Lem35.

Goal (d:D)
      (seq (ia frame c6 sce) (enc H
         (mer (L i)
            (mer (seq (Sn_d d e1) (S i))
               (mer (R i) (K i))))))=
         (enc H
            (mer (seq (ia frame s6 sce) (L i))
               (mer (R i) (mer (seq (Tn_d d e1) (S i)) (K i))))).

     
Intros.
OldElim EXPH4.
Pattern 3 7 8 9 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim Lmers6.
OldElim LmerTnd.
OldElim LmerK.
OldElim (SC3 (seq (Tn_d d e1) (S i)) (K i)).
OldElim CommTn_dK.
OldElim (SC3 (seq (Rn e1) (seq (Rn e0) (R i))) (seq (Tn_d d e1) (S i))).
OldElim CommTn_dRn.
OldElim CommRns6.
OldElim (SC3  (seq (Rn e1) (seq (Rn e0) (R i))) (K i)).
OldElim CommKRn.
OldElim CommKs6.
OldElim CommTn_ds6_sce.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.
Save Lem36.

Goal (d:D)
    (seq (ia Frame c2 (Tuple e1 d)) (enc H
         (mer (seq (Tn_d d e1) (S i))
            (mer
               (alt
                  (seq (ia one int i)
                     (seq (ia Frame s3 (Tuple e1 d)) (K i)))
                  (seq (ia one int i) (seq (ia Frame s3 lce) (K i))))
               (mer (L i) (R i))))))=
      (enc H
         (mer (L i)
            (mer (seq (Sn_d d e1) (S i))
               (mer (R i) (K i))))).
Intros.
OldElim EXPH4.
OldElim LmerL.
OldElim LmerSnd.
Pattern 2 4 5 8 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim LmerK.
OldElim CommLRn.
OldElim (SC3  (seq (Rn e1) (seq (Rn e0) (R i))) (K i)).
OldElim CommKRn.
OldElim CommSn_dK.
OldElim (SC3 (L i) (seq (Sn_d d e1) (S i))).
OldElim CommSn_dL.
OldElim (SC3 (L i) (K i)).
OldElim CommKL.
OldElim CommSn_dRn.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.
Save Lem37.

Goal (d:D)
     (alt (seq (ia one int i)
         (enc H
            (mer (seq (ia Frame s3 (Tuple e1 d)) (K i))
               (mer (seq (Tn_d d e1) (S i))
                  (mer (L i) (R i))))))
       (seq (ia one int i) (enc H
            (mer (seq (ia Frame s3 lce) (K i))
               (mer (seq (Tn_d d e1) (S i))
                  (mer (L i) (R i)))))))=
      (enc H
         (mer (seq (Tn_d d e1) (S i))
            (mer
               (alt
                  (seq (ia one int i)
                     (seq (ia Frame s3 (Tuple e1 d)) (K i)))
                  (seq (ia one int i) (seq (ia Frame s3 lce) (K i))))
               (mer (L i) (R i))))).
Intros.
OldElim EXPH4.
OldElim LmerTnd.
OldElim Lmeri.
OldElim LmerL.
Pattern 5 6 8 11 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim CommTn_dRn.
OldElim CommTn_dL.
OldElim CommTn_di.
OldElim CommLRn.
OldElim CommiRn.
OldElim CommiL.
Repeat OldElim A6.
Repeat OldElim A6'.
Apply refl_equal.

Save Lem38.



Goal (d:D)
   (seq (ia Frame c3 lce) (Y2 d))=
        (enc H
            (mer (seq (ia Frame s3 lce) (K i))
               (mer (seq (Tn_d d e1) (S i))
                  (mer (L i) (R i))))).
Intros.
OldElim EXPH4.
OldElim Lmers3.
OldElim LmerTnd.
OldElim LmerL.
Pattern 1 2 4 7 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommTn_dL.
OldElim CommTn_dRn.
OldElim Comms3Tn_d.
OldElim Comms3L.
OldElim Comms3Rn_lce.
Repeat OldElim A6.
Repeat OldElim A6'.
 
Unfold Y2.
OldElim (SC6 (mer (seq (Tn_d d e1) (S i)) (L i))
          (mer (K i)
               (seq (seq (ia frame s5 (tuple e1)) (Rn e1))
                  (seq (Rn e0) (R i))))).
OldElim SC7.
OldElim (SC6 (seq (ia frame s5 (tuple e1)) (R i)) (L i)).
OldElim (SC6 (mer (K i)
                  (seq (seq (ia frame s5 (tuple e1)) (Rn e1))
                     (seq (Rn e0) (R i)))) (L i)).
OldElim SC7.
OldElim A5.
Pattern 1 (R i).
OldElim ProcR.
Apply refl_equal.
Save Lem39.

Goal  (d:D)
   (seq (ia Frame c3 (Tuple e1 d)) (Y2 d))=
         (enc H
            (mer (seq (ia Frame s3 (Tuple e1 d)) (K i))
               (mer (seq (Tn_d d e1) (S i))
                  (mer (L i) (R i))))).
Intros.
OldElim EXPH4.
OldElim Lmers3.
OldElim LmerTnd.
OldElim LmerL.
Pattern 1 2 4 7 (R i).
OldElim ProcR.
OldElim LmerRn.
OldElim CommLRn.
OldElim CommTn_dL.
OldElim CommTn_dRn.
OldElim Comms3Tn_d.
OldElim Comms3L.
OldElim Comms3Rn_b'.
Repeat OldElim A6.
Repeat OldElim A6'.
Unfold Y2.
OldElim (SC6 (mer (seq (Tn_d d e1) (S i)) (L i))
    (mer (seq (ia frame s5 (tuple e1)) 
          (seq (Rn e1) (seq (Rn e0) (R i)))) (K i))).
 
OldElim SC7.
OldElim (SC6 (mer (L i)
          (seq (ia frame s5 (tuple e1)) (R i))) (K i)).
OldElim SC7.
Pattern 1 (R i).
OldElim ProcR.
Apply refl_equal.
Save Lem40.

Goal (d:D)
     (seq (ia frame c5 (tuple e1))
        (alt
           (seq (ia one int i)
              (seq (ia frame c6 sce)
                 (seq (ia Frame c2 (Tuple e1 d))
                    (seq
                       (alt (seq (ia one int i) (ia Frame c3 lce))
                            (seq (ia one int i) (ia Frame c3 (Tuple e1 d))))
                       (Y2 d)))))
           (seq (ia one int i)
              (seq (ia frame c6 (tuple e1)) X))))=(Y2 d).
Intros.
Pattern 2 (Y2 d).
OldElim Lem33.
OldElim Lem34.
OldElim Lem35.
OldElim Lem36.
OldElim Lem37.
OldElim Lem38.
OldElim Lem39.
OldElim Lem40.
OldElim (A1 (seq (ia one int i)
            (seq (ia frame c6 sce)
               (seq (ia Frame c2 (Tuple e1 d))
                  (alt
                     (seq (ia one int i)
                        (seq (ia Frame c3 (Tuple e1 d)) (Y2 d)))
                     (seq (ia one int i)
                        (seq (ia Frame c3 lce) (Y2 d)))))))
       (seq (ia one int i) (seq (ia frame c6 (tuple e1)) X))).
OldElim A4.
OldElim (A1
     (seq (ia one int i) (seq (ia Frame c3 lce) (Y2 d)))
     (seq (ia one int i) (seq (ia Frame c3 (Tuple e1 d)) (Y2 d)))).
OldElim A5.
OldElim A5.
Apply refl_equal.

Save Lem41.

