(****************************************************************************)
(* This contribution was updated for Coq V5.10 by the COQ workgroup.        *)
(* January 1995                                                             *)
(****************************************************************************)
(*                                                                          *)
(*      Coq V5.8                                                            *)
(*                                                                          *)
(*                                                                          *)
(*      Alternating Bit Protocol                                            *)
(*                                                                          *)
(*      Jan Friso Groote                                                    *)
(*      Utrecht University                                                  *)
(*                                                                          *)
(*      November 1992                                                       *)
(*                                                                          *)
(* From bezem@phil.ruu.nl Fri Apr  2 13:14:31 1993                          *)
(*                                                                          *)
(****************************************************************************)
(*                                abp_proc.v                                *)
(****************************************************************************)

Require abp_base.
Require abp_defs.
Require abp_lem1.
Require abp_lem2.
Require abp_lem25.
Require abp_lem3.

Require abp_lem1.

(* Now we define a number of simplified processes *)

Parameter X',Y':proc.
Parameter X1',X2',Y1',Y2':D->proc.


Axiom Lin2':
 (d:D)
        (alt
           (seq (ia one int i) (seq (ia D s4 d) (hide I' (X2 d))))
           (seq (ia one int i) (seq (ia one int i) (X1' d))))=(X1' d).


Axiom Lin3':
 (d:D)
        (alt
           (seq (ia one int i) (seq (ia one int i) (X2' d)))
           (seq (ia one int i) (hide I' Y)))=(X2' d).



Axiom Lin5':
(d:D)
        (alt
           (seq (ia one int i) (seq (ia D s4 d) (hide I' (Y2 d))))
           (seq (ia one int i) (seq (ia one int i) (Y1' d))))=(Y1' d).

Axiom Lin6':
 (d:D)
        (alt
           (seq (ia one int i) (seq (ia one int i)  (Y2' d)))
           (seq (ia one int i) (hide I' X)))=(Y2' d).


Goal (d:D)(seq (ia one tau i) (X1' d))=(hide I' (X1 d)).
Intros.
Apply (RSP 
         D 
         ([d:D](seq (ia one tau i)(X1' d)))
         ([d:D](hide I' (X1 d))) 
          ([X:D->proc][d:D](seq (ia one tau i)(alt
           (seq (ia one int i) (seq (ia D s4 d) (hide I' (X2 d))))
           (seq (ia one int i) (seq (ia one int i) (X d))))))).
Auto.
Intros.
Pattern 1 (X1' d0).
OldElim Lin2'.
OldElim T1'.
Apply refl_equal.

Intros.
Pattern 1 (X1 d0).
OldElim Lem12.
OldElim TI5.
OldElim TI4.
OldElim TI2.
OldElim TI5.
OldElim TI1.
OldElim TI5.
OldElim TI2.
OldElim TI5.
OldElim TI1.
OldElim TI5.
OldElim TI1.
OldElim TI5.
OldElim TI2.
OldElim TI5.
OldElim TI2.
OldElim TI5.
OldElim TI4.
OldElim TI5.
OldElim TI1.
OldElim TI2.
OldElim TI5.
OldElim TI1.
OldElim TI2.
OldElim A3.
Repeat OldElim T1'.
OldElim T1.
Apply refl_equal.
Exact Inc6I.
Exact InintI.
Exact Inc6I.
Exact InintI.
Exact Inc5I.
Exact Inc3I.
Exact InintI.
Exact Ins4I.
Exact Inc3I.
Exact InintI.
Exact Inc2I.

Save LemLin2.

Goal (d:D)(seq (ia one tau i) (X2' d))=(hide I' (X2 d)).
Intros.
Apply (RSP   
         D
         ([d:D](seq (ia one tau i)(X2' d)))
         ([d:D](hide I' (X2 d)))
         ([X:D->proc][d:D](seq (ia one tau i) 
          (alt
           (seq (ia one int i) (seq (ia one int i) (X d)))
           (seq (ia one int i) (hide I' Y)))))).
Auto.
Intro.
Pattern 1 (X2' d0).
OldElim Lin3'.
OldElim T1'.
Apply refl_equal.
Intro.
Pattern 1 (X2 d0).
OldElim Lem31.
OldElim TI5.
OldElim TI2.
OldElim TI4.
OldElim TI5.
OldElim TI1.
OldElim TI5.
OldElim TI2.

OldElim TI5.
OldElim TI2.
OldElim TI5.
OldElim TI4.
OldElim TI5.

OldElim TI1.
OldElim TI2.
OldElim TI5.
OldElim TI1.
OldElim TI2.
OldElim TI5.
OldElim TI1.
OldElim TI5.
OldElim TI2.
Repeat OldElim T1'.
Repeat OldElim T1.
OldElim A3.
Apply refl_equal.
Exact Inc6I.
Exact InintI.
Exact Inc3I.
Exact InintI.
Exact Inc3I.
Exact InintI.
Exact Inc2I.
Exact Inc6I.
Exact InintI.
Exact Inc5I.
Save LemLin3.

Goal (d:D)(seq (ia one tau i) (Y1' d))=(hide I' (Y1 d)).
Intros.
Apply (RSP 
         D 
         ([d:D](seq (ia one tau i)(Y1' d)))
         ([d:D](hide I' (Y1 d))) 
          ([Y:D->proc][d:D](seq (ia one tau i)(alt
           (seq (ia one int i) (seq (ia D s4 d) (hide I' (Y2 d))))
           (seq (ia one int i) (seq (ia one int i) (Y d))))))).
Auto.
Intros.
Pattern 1 (Y1' d0).
OldElim Lin5'.
OldElim T1'.
Apply refl_equal.
Intros.
Pattern 1 (Y1 d0).
OldElim Lem22.
OldElim TI5.
OldElim TI4.
OldElim TI2.
OldElim TI5.
OldElim TI1.
OldElim TI5.
OldElim TI2.
OldElim TI5.
OldElim TI1.
OldElim TI5.
OldElim TI1.
OldElim TI5.
OldElim TI2.
OldElim TI5.
OldElim TI2.
OldElim TI5.
OldElim TI4.
OldElim TI5.
OldElim TI1.
OldElim TI2.
OldElim TI5.
OldElim TI1.
OldElim TI2.
OldElim A3.
Repeat OldElim T1'.
OldElim T1.
Apply refl_equal.
Exact Inc6I.
Exact InintI.
Exact Inc6I.
Exact InintI.
Exact Inc5I.
Exact Inc3I.
Exact InintI.
Exact Ins4I.
Exact Inc3I.
Exact InintI.
Exact Inc2I.
Save LemLin5.

Goal (d:D)(seq (ia one tau i) (Y2' d))=(hide I' (Y2 d)).
Intros.
Apply (RSP   
         D
         ([d:D](seq (ia one tau i)(Y2' d)))
         ([d:D](hide I' (Y2 d)))
         ([Y:D->proc][d:D](seq (ia one tau i) 
          (alt
           (seq (ia one int i) (seq (ia one int i) (Y d)))
           (seq (ia one int i) (hide I' X)))))).
Auto.
Intro.
Pattern 1 (Y2' d0).
OldElim Lin6'.
OldElim T1'.
Apply refl_equal.
Intro.
Pattern 1 (Y2 d0).
OldElim Lem41.
OldElim TI5.
OldElim TI2.
OldElim TI4.
OldElim TI5.
OldElim TI1.
OldElim TI5.
OldElim TI2.

OldElim TI5.
OldElim TI2.
OldElim TI5.
OldElim TI4.
OldElim TI5.

OldElim TI1.
OldElim TI2.
OldElim TI5.
OldElim TI1.
OldElim TI2.
OldElim TI5.
OldElim TI1.
OldElim TI5.
OldElim TI2.
Repeat OldElim T1'.
Repeat OldElim T1.
OldElim A3.
Apply refl_equal.
Exact Inc6I.
Exact InintI.
Exact Inc3I.
Exact InintI.
Exact Inc3I.
Exact InintI.
Exact Inc2I.
Exact Inc6I.
Exact InintI.
Exact Inc5I.
Save LemLin6.


Goal (d:D)(seq (ia one tau i) (seq (ia D s4 d) 
          (hide I'' (hide I' (X2 d)))))=
              (seq (ia one tau i) (hide I'' (X1' d))).
Intro.
Apply sym_equal.
ElimType 
      (seq 
         (ia one tau i) 
         (hide I'' 
            (seq 
               (ia one int i) (seq (ia D s4 d) (hide I' (X2 d))))))=
       (seq 
          (ia one tau i) 
          (seq (ia D s4 d) (hide I'' (hide I' (X2 d))))).
Apply (KFAR2 one i int).
Exact InintI''.
Pattern  1 (X1' d).
OldElim Lin2'.
OldElim A1.
Apply refl_equal.
OldElim TI5.
OldElim TI2.
OldElim TI5.
OldElim TI1.
OldElim T1'.
Apply refl_equal.
Exact Ins4I''.
Exact InintI''.
Save KFlin2.

Goal (d:D)(seq (ia one tau i) (hide I'' (hide I' Y)))=
              (seq (ia one tau i) (hide I'' (X2' d))).
Intros.
Apply sym_equal.
ElimType 
       (seq (ia one tau i) (hide I'' (seq (ia one int i) (hide I' Y))))
          =(seq (ia one tau i) (hide I'' (hide I' Y))).
Apply (KFAR2 one i int).
Exact InintI''.
Pattern  1 (X2' d).
OldElim Lin3'.
Apply refl_equal.
OldElim TI5.
OldElim TI2.
OldElim T1'.
Apply refl_equal.
Exact InintI''.
Save KFlin3.

Goal (d:D)(seq (ia one tau i) (seq (ia D s4 d)
          (hide I'' (hide I' (Y2 d)))))=
              (seq (ia one tau i) (hide I'' (Y1' d))).
Intro.
Apply sym_equal.
ElimType 
      (seq
         (ia one tau i)
         (hide I''
            (seq
               (ia one int i) (seq (ia D s4 d) (hide I' (Y2 d))))))=
       (seq
          (ia one tau i)
          (seq (ia D s4 d) (hide I'' (hide I' (Y2 d))))).
Apply (KFAR2 one i int).
Exact InintI''.
Pattern  1 (Y1' d).
OldElim Lin5'.
OldElim A1.
Apply refl_equal.
OldElim TI5.
OldElim TI2.
OldElim TI5. 
OldElim TI1. 
OldElim T1'.
Apply refl_equal.
Exact Ins4I''. 
Exact InintI''. 
Save KFlin5. 

Goal (d:D)(seq (ia one tau i) (hide I'' (hide I' X)))=
              (seq (ia one tau i) (hide I'' (Y2' d))). 
Intros. 
Apply sym_equal. 
ElimType 
       (seq (ia one tau i) (hide I'' (seq (ia one int i) (hide I' X)))) 
          =(seq (ia one tau i) (hide I'' (hide I' X))). 
Apply (KFAR2 one i int). 
Exact InintI''. 
Pattern  1 (Y2' d). 
OldElim Lin6'.  

Apply refl_equal. 
OldElim TI5. 
OldElim TI2.
OldElim T1'. 
Apply refl_equal. 
Exact InintI''.
Save KFlin6.

Parameter B:proc.
Axiom Specificat:
 (sum D ([d:D](seq (ia D r1 d) (seq (ia D s4 d) B))))=B.

Goal B=(hide I'' (hide I' ABP)).

Apply (RSP one ([d:one]B) ([d:one](hide I'' (hide I' X)))
        ([Z:one->proc]([d':one]
             (sum D ([d:D](seq (ia D r1 d) (seq (ia D s4 d) 
               (sum D ([d:D](seq (ia D r1 d) (seq (ia D s4 d) (Z d')))))))))))).
Auto.
3:Exact i.
Intro.
Pattern 1 B.
OldElim Specificat.
Pattern 1 B.
OldElim Specificat.
Apply refl_equal.
Intro.
Pattern 1 X.
OldElim Lem1.
OldElim (SUM8 D [d:D](seq (ia D r1 d) (X1 d)) I').
OldElim (SUM8 D [d:D](hide I' (seq (ia D r1 d) (X1 d))) I'').
ElimType 
      ([d:D](seq (ia D r1 d)
         (seq (ia D s4 d)
            (D
            +[d0:D]
              (seq (ia D r1 d0)
                 (seq (ia D s4 d0) (hide I'' (hide I' X))))))))=
      ([d:D](hide I'' (hide I' (seq (ia D r1 d) (X1 d))))).
Apply refl_equal.
Apply EXT. Intro.
OldElim TI5.
OldElim TI1.
OldElim LemLin2.
OldElim T1'.
OldElim TI5.
OldElim TI1.
ElimType (seq (ia D r1 d0) (seq (ia one tau i) (hide I'' (X1' d0))))
               =(seq (ia D r1 d0) (hide I'' (X1' d0))).
2:Apply sym_equal.
2:Apply T1'.
OldElim KFlin2.
OldElim T1'.
OldElim LemLin3.

OldElim TI5.
OldElim TI1.
OldElim KFlin3.
OldElim T1'.
OldElim Lem2.
OldElim (SUM8 D [d:D](seq (ia D r1 d) (Y1 d)) I').
OldElim (SUM8 D [d:D](hide I' (seq (ia D r1 d) (Y1 d))) I'').

ElimType 
      ([d0:D](seq (ia D r1 d0) (seq (ia D s4 d0) (hide I'' (hide I' X)))))=
      ([d:D](hide I'' (hide I' (seq (ia D r1 d) (Y1 d))))).
Apply refl_equal.
Apply EXT. Intro.
OldElim TI5.
OldElim TI1.
OldElim LemLin5.
OldElim T1'. 
OldElim TI5.
OldElim TI1.
ElimType (seq (ia D r1 d1) (seq (ia one tau i) (hide I'' (Y1' d1))))
               =(seq (ia D r1 d1) (hide I'' (Y1' d1))).
2:Apply sym_equal.
2:Apply T1'.

OldElim KFlin5. 
OldElim T1'. 
OldElim LemLin6.
OldElim TI5.
OldElim TI1. 
OldElim KFlin6.
OldElim T1'.
Apply refl_equal.
Exact IntauI''.
Exact Inr1I''.
Exact Inr1I.
Exact IntauI''.
Exact Inr1I''.
Exact Inr1I.
 
Save Hurrah.

