(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                             constraintab.ml                              *)
(****************************************************************************)
#open "names";;
#open "impuniv";;

(* Universes *)
let UNIVERSES = ref initial_universes;;

let current_constraints () = !UNIVERSES;;
let empty_constraints = initial_universes;;

let push U =
    UNIVERSES := merge_universes (lib__make_path OBJ (id_of_string "uni")) !UNIVERSES U
;;

let init () = UNIVERSES := initial_universes;;

let freeze () = !UNIVERSES;;
let unfreeze fu = UNIVERSES := fu;;

library__declare_summary "constraints"
{summary__freeze_function = freeze;
 summary__unfreeze_function = unfreeze;
 summary__init_function = init;
 summary__sync_function = (fun () -> false)}
;;


let rollback f () =
    let fs = freeze()
    in try f ()
       with e -> (unfreeze fs; raise e)
;;

(* $Id: constraintab.ml,v 1.2 1996/02/12 15:37:27 cpaulin Exp $ *)
