(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               environ.mli                                *)
(****************************************************************************)

#open "names";;
#open "pp";;
#open "more_util";;
#open "term";;
#open "constrtypes";;
#open "libobject";;
#open "impuniv";;
#open "stdpp";;

(* Constants and Inductives *)

value const_of_path : section_path -> const_entry;;
value const_option_of_path : section_path -> const_entry option;;
value mind_of_path : section_path -> section_path * mutual_inductive_body;;
value mind_option_of_path : section_path -> (section_path * mutual_inductive_body) option;;

value search_synconst : path_kind -> identifier -> constr;;

type variable_object == identifier * 
                       (constr * constr option) * 
                       strength * bool * universes;;

type constant_object == constdecl_body * strength * universes;;
value print_constant_object : int -> constant_object -> std_ppcmds;;

type syntaxconstant_object == (path_kind,constr) listmap__t;;

type ppsyntax_object == syntax__syntax_entry;;

value inVariable : variable_object -> object;;
value outVariable : object -> variable_object;;

value inConstant : constant_object -> object;;
value outConstant : object -> constant_object;;

value inSyntaxConstant : syntaxconstant_object -> object;;
value outSyntaxConstant : object -> syntaxconstant_object;;

value inPPSyntax : ppsyntax_object -> object;;
value outPPSyntax : object -> ppsyntax_object;;

type mutual_inductive_object == mutual_inddecl_body * universes;;
value inMutualInductive : mutual_inductive_object -> object;;
value outMutualInductive : object -> mutual_inductive_object;;


(* $Id: environ.mli,v 1.5 1996/02/12 15:37:36 cpaulin Exp $ *)
