(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               impuniv.mli                                *)
(****************************************************************************)

#open "names";;
#open "pp";;
#open "stdpp";;

type universe = {u_sp : section_path ; u_num : int};;
type relation = 
   Greater of bool * universe * relation (* if bool then > else >= *)
 | Equiv of universe
 | Terminal;;

type arc = Arc of universe * relation | Undef
and universes == (universe,arc) fmavm__frozen_t;;

value Dummy_univ : universe;;
value New_univ : unit -> universe;;
value Super : universe -> universe;;
value sup : universe * universe -> universe;;
value initial_universes : universes;;

value enforcegt : universe -> universe -> unit;;
value enforcegeq : universe -> universe -> unit;;
value enforceq : universe -> universe -> unit;;
value enforce_relation : universe -> relation -> unit;;
value set_uniarc : universes -> unit;;
value get_uniarc : unit -> universes;;
value pr_uni : universe -> std_ppcmds;;
value pr_universes : universes -> std_ppcmds;;

value Dummy_univ : universe;;
value with_universes : ('a -> 'b) -> section_path * universes * 'a -> universes * 'b;;
value uni_ord : universe -> universe -> int;;
value uni_pred : ('a -> bool) -> 'a -> bool;;
value uni_or : (unit -> bool) -> (unit -> bool) -> bool;;
value merge_universes : section_path -> universes -> universes -> universes;;

value prop_univ : universe;;
value prop_univ_univ : universe;;
value prop_univ_univ_univ : universe;;

value num_universes : universes -> int;;
value num_edges : universes -> int;;

(* $Id: impuniv.mli,v 1.2 1996/02/12 15:37:41 cpaulin Exp $ *)
