(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                vartab.mli                                *)
(****************************************************************************)
#open "names";;
#open "more_util";;
#open "term";;

value initial_sign : unit -> constr signature;;
value initial_fsign : unit -> constr signature;;
value initial_assumptions : unit -> constr signature * constr signature;;

value auto_save_variables : unit -> identifier list;;

(* standard interface part for summaries *)
value push : identifier -> bool -> (constr * constr option) -> unit;;
value init : unit -> unit;;
type frozen_t;;
value freeze : unit -> frozen_t;;
value unfreeze : frozen_t -> unit;;
value rollback : (unit -> unit) -> unit -> unit;;

(* $Id: vartab.mli,v 1.2 1996/02/12 15:38:08 cpaulin Exp $ *)
