(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               command.mli                                *)
(****************************************************************************)
#open "names";;
#open "term";;
#open "proof";;
#open "libobject";;

value definition_body : identifier -> strength -> command -> unit;;
value syntax_definition : identifier -> command -> unit;;
value abstraction_definition : identifier -> int vect -> command -> unit;;
value hypothesis_def_var : string -> strength -> command -> unit;;
value parameter_def_var : string -> command -> unit;;

value build_mutual :  (identifier * command) list -> (bool * identifier * command * (identifier * command) list) list -> unit;;

value build_recursive :  (identifier * ((identifier * command) list) * command * command) list -> unit;;
value build_corecursive :  (identifier * command * command) list -> unit;;


value mkProdCit : (identifier * command) list -> command -> command ;;
value build_scheme : (identifier * bool * command * command) list -> unit;;

(* $Id: command.mli,v 1.3 1996/02/12 15:38:38 cpaulin Exp $ *)
