(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              constants.mli                               *)
(****************************************************************************)

#open "names";;
#open "more_util";;
#open "term";;
#open "constrtypes";;
#open "generic";;

value make_constant_body : path_kind -> bool -> constr signature * judgement -> constant_body;;
value make_constant : bool -> (constr signature * judgement) * (constr signature * information) -> (path_kind * constant_body) list;;
value infexecute_constant : (constr signature * constr signature) -> bool -> constr -> (path_kind,constant_body) listmap__t;;
value abstract_constant : identifier list -> constant_body -> constant_body * modification_action list;;
value expmod_constant : (sorts oper * sorts oper modification) list -> constant_body -> constant_body;;
value process_recipe_cmap : (section_path * section_path) -> (identifier list * (sorts oper * sorts oper modification) list) -> (path_kind * constant_body) list -> (sorts oper * sorts oper modification) list * (path_kind * constant_body) list;;

value infexecute_parameter : (constr signature * constr signature) -> constr -> (path_kind,constant_body) listmap__t;;

value cook_constant : section_path -> unit;;

(* debug *)



(* $Id: constants.mli,v 1.2 1996/02/12 15:38:42 cpaulin Exp $ *)
