(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               declare.mli                                *)
(****************************************************************************)

#open "names";;
#open "more_util";;
#open "term";;
#open "libobject";;
#open "summary";;

value is_global : identifier -> bool;;
value machine_variable : (constr signature * constr signature) -> (identifier * strength * bool * constr) -> unit;;

value machine_constant : (constr signature * constr signature) -> ((identifier * bool * strength) * constr) -> unit;;

value machine_constant_verbose : (constr signature * constr signature) -> ((identifier * bool * strength) * constr) -> unit;;

value machine_parameter : (constr signature * constr signature) -> (identifier * constr) -> unit;;

value machine_minductive : (constr signature * constr signature) -> int -> (identifier * name * constr * constr * identifier vect) vect -> bool vect -> unit;;

value machine_syntax_constant : identifier -> (path_kind,constr) listmap__t -> unit;;

value machine_abstraction : identifier -> int vect -> constr -> unit;;

value set_transparent : section_path -> unit;;
value set_opaque : section_path -> unit;;

(* $Id: declare.mli,v 1.3 1996/02/12 15:38:48 cpaulin Exp $ *)
