(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               parsing.mli                                *)
(****************************************************************************)
#infix "o";;
#open "std";;
#open "pp";;
#open "stdpp";;
#open "more_util";;
#open "names";;
#open "lexer";;
#open "termact";;
#open "ast";;
#open "vkey";;
#open "pureparse";;

type tokstream == vernac_keyword token stream;;
value ident_gram : tokstream -> frag;;
value number_gram : tokstream -> frag;;
value string_gram : tokstream -> frag;;
value unparsing_gram : tokstream -> frag;;
value grammar_parser : identifier -> vernac_keyword token stream -> (identifier * identifier) * (identifier list * (production_item list * action) list);;
value grammar_entry_gram : tokstream -> frag;;
value spat_gram : tokstream -> frag;;
value spat_parser : tokstream -> spat;;
value plist_trap_error : string -> ('a -> 'b) -> 'a -> 'b list;;
value interp_gram : string -> string -> tokstream -> frag;;
value annotation : tokstream -> ast;;
value annotation_gram : tokstream -> frag;;
value command : tokstream -> ast;;
value command_gram : tokstream -> frag;;
value lcommand : tokstream -> ast;;
value lcommand_gram : tokstream -> frag;;
value constructl : vernac_keyword token stream -> ast list;;
value tactic_com_list : tokstream -> ast;;
value tactic_com_list_gram : tokstream -> frag;;
value vernac : tokstream -> ast;;
value init_grammar : unit -> unit;;
value declare_prim_gram : (string * string) -> first_val list -> (vernac_keyword token stream -> frag) -> unit;;

(* $Id: parsing.mli,v 1.2 1996/02/12 15:38:56 cpaulin Exp $ *)
