(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                pretty.mli                                *)
(****************************************************************************)
#open "names";;
#open "std";;
#open "more_util";;
#open "term";;
#open "constrtypes";;
#open "pp";;
#open "stdpp";;

value print_closed_sections : bool ref;;

value print_context : bool -> lib__library_segment -> std_ppcmds;;
value print_library_entry : bool -> (section_path * lib__node) -> std_ppcmds;;
value print_full_context : unit -> std_ppcmds;;
value print_full_context_typ : unit -> std_ppcmds;;
value print_crible : identifier -> unit;;
value print_sec_context : string -> std_ppcmds;;
value print_sec_context_typ : string -> std_ppcmds;;
value print_val : judgement -> std_ppcmds;;
value print_mutual : path_kind -> mutual_inductive_body -> std_ppcmds;;
value print_name : identifier -> std_ppcmds;;
value print_opaque_name : identifier -> std_ppcmds;;
value print_type : judgement -> std_ppcmds;;
value print_evaluate : judgement -> std_ppcmds;;
value print_compute : judgement -> std_ppcmds;;
value print_simplify : judgement -> std_ppcmds;;
value print_local_context : unit -> std_ppcmds;;
value print_extracted_name : identifier -> std_ppcmds;;
value print_extraction : unit -> std_ppcmds;;
value print_extracted_vars : unit -> std_ppcmds;;
value crible : (string -> unit assumptions -> constr -> unit) -> identifier -> unit;;
value inspect : int -> std_ppcmds;;

(* $Id: pretty.mli,v 1.5 1996/02/12 15:39:04 cpaulin Exp $ *)
