(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              tacentries.mli                              *)
(****************************************************************************)

#open "std";;
#open "names";;
#open "tacmach";;
#open "ast";;
#open "lexer";;
#open "himsg";;
#open "more_util";;
#open "pp";;
#open "stdpp";;
#open "proof";;
#open "proof_trees";;
#open "tactics";;

value vernac_absurd : command -> tactic;;
value contradict : tactic;;
value vernac_idtac : tactic;;
value vernac_intro : tactic;;
value vernac_intros_with : identifier list -> tactic;;
value vernac_fix : identifier -> int -> tactic;;
value vernac_intros_until : identifier -> tactic;;
value vernac_intros : tactic;;
value intros_split_tac : (BindOcc * command) list -> tactic;;
value intros_right_tac : (BindOcc * command) list -> tactic;;
value intros_left_tac : (BindOcc * command) list -> tactic;;
value intros_exists_tac : (BindOcc * command) list -> tactic;;
value replace_tac_vernac : ast -> ast -> tactic;;
value rewrite_tac_LR : command -> tactic;;
value rewrite_tac_RL : command -> tactic;;
value reflexivity_tac : goal sigma -> goal list sigma * validation;;
value intros_reflexivity_tac : tactic;;
value symmetry_tac : goal sigma -> goal list sigma * validation;;
value intros_symmetry_tac : tactic;;
value transitivity_tac : command -> goal sigma -> goal list sigma * validation;;
value intros_transitivity_tac : command -> tactic;;

value vernac_assumption : tactic;;
value vernac_give_exact_com : command -> tactic;;
value vernac_red_hyp : identifier -> tactic;;
value vernac_red : tactic;;
value vernac_simpl_hyp : identifier -> tactic;;
value vernac_simpl_tac : tactic;;
value vernac_simpl_tac : tactic;;
value vernac_hnf_tac_hyp : identifier -> tactic;;
value vernac_hnf_tac : tactic;;
value vernac_change_hyp : ast -> identifier -> tactic;;
value vernac_change : command -> tactic;;
value pr_pattern : readable_constraints -> goal -> int list -> command -> (int * string) ppcmd_token stream;;
value vernac_pattern : (int list * ast) list -> tactic;;
value vernac_resolve_with_bindings : (ast * (BindOcc * ast) list) -> tactic;;
value vernac_constructor_with_bindings : int -> (BindOcc * ast) list -> tactic;;

value vernac_specialize_with_num : int -> ast -> (BindOcc * ast) list -> tactic;;
value vernac_specialize_with : ast -> (BindOcc * ast) list -> tactic;;
value vernac_specialize : command -> tactic;;
value vernac_generalize : ast list -> tactic;;

value vernac_elim_with_bindings : (ast * (BindOcc * ast) list) -> tactic;;
value vernac_elim_with_using : (ast * (BindOcc * ast) list) -> (ast * (BindOcc * ast) list) -> tactic;;
value vernac_elim : command -> tactic;;
value vernac_elim1 : command -> tactic;;
value vernac_elim_type : command -> tactic;;

value vernac_case_with_bindings : (ast * (BindOcc * ast) list) -> tactic;;
value vernac_induct_nodep : int -> tactic;;
value vernac_induct : identifier -> tactic;;
value vernac_destruct_nodep : int -> tactic;;
value vernac_destruct : identifier -> tactic;;
value vernac_cut : command -> tactic;;
value vernac_imp_elim : command -> tactic;;
value pr_unfold : int list -> identifier -> (int * string) ppcmd_token stream;;
value vernac_unfold_nth : (int list * identifier) list -> tactic;;
value vernac_unfold_nth_hyp : (int list * identifier) list -> identifier -> tactic;;
value vernac_clear_hyp : identifier list -> tactic;;
value vernac_interp : ast -> tactic;;

(* $Id: tacentries.mli,v 1.3 1996/02/12 15:39:09 cpaulin Exp $ *)
