(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              tacinterp.mli                               *)
(****************************************************************************)

#open "std";;
#open "names";;
#open "more_util";;
#open "proof";;
#open "proof_trees";;
#open "pp";;
#open "stdpp";;
#open "tacmach";;
#open "ast";;
#open "himsg";;

value cvt_arg : ast -> tactic_arg;;
value tactic_tab : (string, tactic_arg list -> tactic) mhm__t;;
value tacinterp_add : string * (tactic_arg list -> tactic) -> unit;;
value overwriting_tacinterp_add : string * (tactic_arg list -> tactic) -> unit;;
value tacinterp_map : string -> tactic_arg list -> tactic;;
value tacinterp_init : unit -> unit;;
value interp : ast -> tactic;;
value interp_semi_list : tactic -> ast list -> tactic;;
value interp : ast -> goal sigma -> goal list sigma * validation;;

(* $Id: tacinterp.mli,v 1.2 1996/02/12 15:39:13 cpaulin Exp $ *)
