(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 trad.mli                                 *)
(****************************************************************************)
#open "names";;
#open "term";;
#open "ast";;
#open "more_util";;
#open "proof";;
#open "pp";;
#open "stdpp";;

value constr_of_com : readable_constraints -> constr assumptions -> ast -> constr;;
value fconstr_of_com : readable_constraints -> constr assumptions -> ast -> constr;;
value constr_of_com_env : readable_constraints -> constr assumptions -> ast -> constr;;
value fconstr_of_com_env : readable_constraints -> constr assumptions -> ast -> constr;;
value constr_of_com_sign : readable_constraints -> constr signature -> ast -> constr;;
value fconstr_of_com_sign : readable_constraints -> constr signature -> ast -> constr;;
value raw_constr_of_com : readable_constraints -> constr assumptions -> ast -> constr;;
value raw_fconstr_of_com : readable_constraints -> constr assumptions -> ast -> constr;;
value raw_constr_of_compattern : readable_constraints -> constr assumptions -> ast -> constr;;
value fconstruct : readable_constraints -> constr signature -> ast -> judgement;;
value infconstruct : readable_constraints -> (constr signature * constr signature) -> ast -> judgement * information;;
value is_fmachine : bool -> constr assumptions -> constr -> constr;;
value attempt_ise_resolution : constr signature -> constr -> constr;;
value ise_resolve : readable_constraints -> constr assumptions -> constr -> constr;;

(* $Id: trad.mli,v 1.4 1996/02/12 15:39:25 cpaulin Exp $ *)
