(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                            vernacentries.mli                             *)
(****************************************************************************)

#open "std";;
#open "initial";;
#open "names";;
#open "system";;
#open "term";;
#open "mach";;
#open "discharge";;
#open "tacmach";;
#open "pfedit";;
#open "command";;
#open "pretty";;
#open "lexer";;
#open "vkey";;
#open "parsing";;
#open "himsg";;
#open "more_util";;
#open "pp";;
#open "stdpp";;
#open "proof";;
#open "proof_trees";;
#open "tactics";;
#open "library";;
#open "libobject";;
#open "environ";;
#open "termenv";;
#open "states";;
#open "trad";;
#open "ast";;
#open "vernacinterp";;
#open "declare";;

value join_binders : ('a list * 'b) list -> ('a * 'b) list;;
value add : string * (vernac_arg list -> unit -> unit) -> unit;;
value show_script : unit -> unit;;
value show_prooftree : unit -> unit;;
value show_open_subgoals : unit -> unit;;
value show_nth_open_subgoal : int -> unit;;
value show_open_subgoals_focused : unit -> unit;;
value show_node : unit -> unit;;
value print_loadpath : unit -> unit;;

(* $Id: vernacentries.mli,v 1.2 1996/02/12 15:39:37 cpaulin Exp $ *)
