(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                             vernacinterp.mli                             *)
(****************************************************************************)

#open "std";;
#open "names";;
#open "more_util";;
#open "pp";;
#open "stdpp";;
#open "himsg";;
#open "ast";;
#open "proof_trees";;
 
exception Drop;;

value drop : unit -> 'a;;

type vernac_arg = 
    VARG_VARGLIST of vernac_arg list
  | VCALL of string * vernac_arg list
  | VARG_COMMAND of ast
  | VARG_COMMANDLIST of ast list
  | VARG_STRING of string
  | VARG_NUMBER of int
  | VARG_IDENTIFIER of identifier
  | VARG_TACTIC of ast
  | VARG_BINDER of identifier list * ast
  | VARG_BINDERLIST of (identifier list * ast) list
  | VARG_NUMBERLIST of int list
  | VARG_SPAT of spat
  | VARG_SPAT_BINDER of identifier * spat
  | VARG_UNPARSING of unparsings__unparsing
  | VARG_GRAMMAR_ENTRY of pureparse__grammar_entry
  | VARG_TACTIC_ARG of tactic_arg
  | VARG_ANY of ast
  | VARG_NONE
;;

value vernac_tab : (string, vernac_arg list -> unit -> unit) mhm__t;;
value vinterp_add : string * (vernac_arg list -> unit -> unit) -> unit;;
value overwriting_vinterp_add : string * (vernac_arg list -> unit -> unit) -> unit;;
value vinterp_map : string -> vernac_arg list -> unit -> unit;;
value vinterp_init : unit -> unit;;
value cvt_varg : ast -> vernac_arg;;
value call : ast option -> string * vernac_arg list -> unit;;
value interprec : ast -> unit;;
value interp : ast -> unit;;

(* $Id: vernacinterp.mli,v 1.2 1996/02/12 15:39:41 cpaulin Exp $ *)
