#!/bin/sh -e

COQTOP=COQTOPDIRECTORY export COQTOP
CAMLLIB=CAMLLIBDIRECTORY export CAMLLIB
ARCH=ARCHVALUE export ARCH
COQTH=$COQTOP/theories export COQTH

if test ! \( -r $HOME/.coqrc -o -r $HOME/.coqrc.5.10 \) ; then
	echo "Humpf! I can't find a .coqrc in your home directory"
	sed -e "s|COQTOP|$COQTOP|" $COQTOP/coq.motd
fi

ROOT=$COQTOP/bin/$ARCH
IMAGE=$ROOT/coqtop.out
COQARGS=""
OTHER=""
COQSTATE="-inputstate tactics"
COQTACTICS="-I $COQTOP/tactics"
COQML=""
COQUSER=""
NOINITFILE=""
ISSPEC="NO"
TACTICS="TRUE"

while test "" != "$1"; do
    case $1 in
        -image) 
           IMAGE="$2"
           shift;;
        -is|-inputstate)
           COQSTATE="-inputstate $2"
           ISSPEC="YES"
           shift;;
	-nois) 
           COQSTATE=""
           ISSPEC="YES";;
        -user) 
           COQUSER="-user $2"
           shift;;
        -theories) 
           COQTH="$2"; export COQTH
           shift;;
	-tactics) 
           echo "Warning: -tactics is now obsolete";;
        -notactics) 
           COQML="-notactics"; COQTACTICS=""
           TACTICS="FALSE";;
        -q) 
           NOINITFILE="-q";;
	-I|-include)
           COQARGS="$COQARGS -I $2"
           OTHER="$OTHER -I $2"
           shift;; 
	-O|-open) 
           OTHER="$OTHER -O $2"
           shift;;
        *) COQARGS="$COQARGS $1";;
    esac;
    shift
done

if test "NO" = $ISSPEC
	then
	if test $TACTICS = "FALSE"
		then
		COQSTATE="-inputstate state"
		else
		COQSTATE="-inputstate tactics"
	fi
fi

INCLUDES="-I $COQTOP/bin/states \
          -I $COQTH/INIT \
          -I $COQTH/ARITH \
	  $COQTACTICS"

COQ_ARGUMENT="$INCLUDES $COQUSER $NOINITFILE $COQML $COQSTATE $COQARGS"
export COQ_ARGUMENT

PATH=CAMLBINDIRECTORY:$PATH
export PATH

COQ="$IMAGE -stdlib $CAMLLIB \
	  -I $COQTOP/src/lib/libc \
          -I $COQTOP/src/lib/stream-pp \
          -I $COQTOP/src/lib/util \
	  -I $COQTOP/src/meta \
	  -I $COQTOP/src/constr \
	  -I $COQTOP/src/proofs \
	  -I $COQTOP/src/env \
	  -I $COQTOP/src/tactics \
	  -I $COQTOP/src/link \
	  -I $COQTOP/tactics \
          $INCLUDES $OTHER"

exec $COQ

