(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              pp_control.ml                               *)
(****************************************************************************)

type pp_global_defaults =
    {mutable infinity : int;
     mutable line_length : int;
     mutable line_break : int;
     mutable margin : int;
     mutable min_space_left : int;
     mutable max_indent : int;
     mutable max_depth : int;
     mutable limit_depth : int;
     mutable ellipsis : string;
     mutable format_ellipsis : bool};;

type 'a pp_formatter_defaults =
    {mutable output : string -> int -> int -> unit ;
     mutable flush_out : unit -> unit;
     mutable print : 'a -> (int * string stream)};;

let (dflt_gp:pp_global_defaults) =
    {infinity =  9999;
     line_length = 78;
     line_break = 6;
     margin = 72;
     min_space_left = 10;
     max_indent = 62;
     max_depth = 35;
     limit_depth = 55;
     ellipsis = ".";
     format_ellipsis = true}
;;

let copy_gp ogp = 
    {infinity = ogp.infinity;
     line_length = ogp.line_length;
     line_break = ogp.line_break;
     margin = ogp.margin;
     min_space_left = ogp.min_space_left;
     max_indent = ogp.max_indent;
     max_depth = ogp.max_depth;
     limit_depth = ogp.limit_depth;
     ellipsis = ogp.ellipsis;
     format_ellipsis = ogp.format_ellipsis}
;;

let output_substring = output;;

let copy_fp ofp =
    {output = ofp.output;
     flush_out = ofp.flush_out;
     print = ofp.print}
;;

(* $Id: pp_control.ml,v 1.2 1996/02/12 15:40:16 cpaulin Exp $ *)
