(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 avm.mli                                  *)
(****************************************************************************)

type ('a,'b) t;;
type ('a,'b) frozen_t;;

value new : ('a -> 'a -> int) -> ('a,'b) t;;
value map : ('a,'b) t -> 'a -> 'b;;
value dom : ('a,'b) t -> 'a list;;
value rng : ('a,'b) t -> 'b list;;
value in_dom : ('a,'b) t -> 'a -> bool;;
value add : ('a,'b) t -> 'a * 'b -> ('a,'b) t;;
value rmv : ('a,'b) t -> 'a -> ('a,'b) t;;
value remap : ('a,'b) t -> 'a -> 'b -> ('a,'b) t;;
value app : (('a * 'c) -> 'b) -> ('a,'c) t -> unit;;
value toList : ('a,'b) t -> ('a * 'b) list;;
value ofList : ('a -> 'a -> int) -> ('a * 'b) list -> ('a,'b) t;;
value inv : ('a,'b) t -> 'b -> 'a list;;

value freeze : ('a,'b) t -> ('a,'b) frozen_t;;
value unfreeze : ('a,'b) frozen_t -> ('a,'b) t -> ('a,'b) t;;

value clone_empty : ('a,'b) t -> ('a,'b) t;;


(* $Id: avm.mli,v 1.2 1996/02/12 15:40:38 cpaulin Exp $ *)
