(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  avs.ml                                  *)
(****************************************************************************)

type 'a t == 'a set__t;;

let add s e = set__add e s;;
let rmv s e = set__remove e s;;
let memb s e = set__mem e s;;
let intersect = set__inter;;
let union = set__union;;
let diff = set__diff;;
let symdiff l1 l2 = diff(union l1 l2) (intersect l1 l2);;
let subset l1 l2 = for_all (memb l2) (set__elements l1);;
let equal = set__equal;;
let mt ord = set__empty ord;;

exception Caught;;
let exists P s =
    try (set__iter (fun e -> if P e then raise Caught else ()) s;
         false)
    with Caught -> true
;;

let toList = set__elements;;

let ofList ord l = it_list add (mt ord) l;;
let is_empty = set__is_empty;;
let app f s = set__iter f s;;

(* $Id: avs.ml,v 1.2 1996/02/12 15:40:41 cpaulin Exp $ *)
