(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 avs.mli                                  *)
(****************************************************************************)
#open "std";;

type 'a t;;

value add : 'a t -> 'a -> 'a t;;
value rmv : 'a t -> 'a -> 'a t;;
value memb : 'a t -> 'a -> bool;;
value intersect : 'a t -> 'a t -> 'a t;;
value union : 'a t -> 'a t -> 'a t;;
value diff : 'a t -> 'a t -> 'a t;;
value symdiff : 'a t -> 'a t -> 'a t;;
value subset : 'a t -> 'a t -> bool;;
value equal : 'a t -> 'a t -> bool;;
value mt : ('a -> 'a -> int) -> 'a t;;
value exists : ('a -> bool) -> 'a t -> bool;;
value toList : 'a t -> 'a list;;
value ofList : ('a -> 'a -> int) -> 'a list -> 'a t;;
value is_empty : 'a t -> bool;;
value app : ('a -> 'b) -> 'a t -> unit;;

(* $Id: avs.mli,v 1.2 1996/02/12 15:40:43 cpaulin Exp $ *)
