(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  bij.ml                                  *)
(****************************************************************************)

type ('a,'b) t == (('a,'b) listmap__t * ('b,'a) listmap__t);;

let new () = ([],[]);;
let map (lr,_) = listmap__map lr;;
let pam (_,rl) = listmap__map rl;;
let dom (lr,_) = listmap__dom lr;;
let rng (lr,_) = listmap__rng lr;;
let in_dom (lr,_) = listmap__in_dom lr;;
let in_rng (lr,_) = listmap__in_rng lr;;

let add ((lr,rl) as bij) (k,v) =
    if (not (in_dom bij k)) & (not (in_rng bij v)) then
        (listmap__add lr (k,v),
         listmap__add rl (v,k))
    else raise (Failure "bij__add")
;;

let rmv ((lr,rl) as bij) k =
    let v = map bij k
    in (listmap__rmv lr k,
        listmap__rmv rl v)
;;

let remap bij k v =
    add (rmv bij k) (k,v)
;;

let app f (lr,_) = listmap__app f lr
;;

let toList (lr,_) = listmap__toList lr;;

(* $Id: bij.ml,v 1.2 1996/02/12 15:40:50 cpaulin Exp $ *)
