(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                fmavmfs.ml                                *)
(****************************************************************************)

let new (ord,n) = fmavm__new(ord,n);;
let empty m = fmavm__empty m;;
let map m k = fmavm__map m k;;
let dom m = fmavm__dom m;;
let in_dom m k = fmavm__in_dom m k;;
let rng m = fmavm__rng m;;
let ind_dom m k = fmavm__in_dom m k;;
let add m (k,v) =
    try fmavm__remap m k (listset__add (fmavm__map m k) v)
    with Not_found -> fmavm__add m (k,[v])
;;

let rmv m (k,v) =
    fmavm__remap m k (listset__rmv (fmavm__map m k) v)
;;

let app f m = fmavm__app f m;;
let toList m = fmavm__toList m;;
let freeze m = fmavm__freeze m;;
let unfreeze fm m = fmavm__unfreeze fm m;;

(* $Id: fmavmfs.ml,v 1.2 1996/02/12 15:41:12 cpaulin Exp $ *)
