(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 fthm.mli                                 *)
(****************************************************************************)

type ('a,'b) t;;
type ('a,'b) frozen_t;;

value new : unit -> ('a,'b) t;;

(* Work on labels, not on paths *)

value map : ('a,'b) t -> 'a -> ('a,'b) t;;
value xtract : ('a,'b) t -> 'b listset__t;;
value dom : ('a,'b) t -> 'a list;;
value in_dom : ('a,'b) t -> 'a -> bool;;

(* Work on paths, not labels *)

value add : ('a,'b) t -> 'a list * 'b -> unit;;
value rmv : ('a,'b) t -> ('a list * 'b) -> unit;;

value empty : ('a,'b) t -> unit;;

value app : (('a list * 'c) -> 'b) -> ('a,'c) t -> unit;;
value toList : ('a,'b) t -> ('a list * 'b) list;;
(*value rng : ('a,'b) t -> 'b list;;*)
(*value in_rng : ('a,'b) t -> 'b -> bool;;*)

value freeze : ('a,'b) t -> ('a,'b) frozen_t;;
value unfreeze : ('a,'b) frozen_t -> ('a,'b) t -> unit;;

(* $Id: fthm.mli,v 1.2 1996/02/12 15:41:19 cpaulin Exp $ *)
