(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                intavm.mli                                *)
(****************************************************************************)

type 'b t;;

value new : unit -> 'b t;;
value map : 'b t -> int -> 'b;;
value dom : 'b t -> int list;;
value rng : 'b t -> 'b list;;
value in_dom : 'b t -> int -> bool;;
value add : 'b t -> int * 'b -> 'b t;;
value rmv : 'b t -> int -> 'b t;;
value remap : 'b t -> int -> 'b -> 'b t;;
value app : ((int * 'c) -> 'b) -> 'c t -> unit;;
value toList : 'b t -> (int * 'b) list;;
value ofList : (int * 'b) list -> 'b t;;
value inv : 'b t -> 'b -> int list;;

(* $Id: intavm.mli,v 1.2 1996/02/12 15:41:32 cpaulin Exp $ *)
