(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                intavs.ml                                 *)
(****************************************************************************)

type t == intset__t;;

let add s e = intset__add e s;;
let rmv s e = intset__remove e s;;
let memb s e = intset__mem e s;;
let intersect = intset__inter;;
let union = intset__union;;
let diff = intset__diff;;
let symdiff l1 l2 = diff(union l1 l2) (intersect l1 l2);;
let subset l1 l2 = for_all (memb l2) (intset__elements l1);;
let equal = intset__equal;;
let mt = intset__empty;;

exception Caught;;
let exists P s =
    try (intset__iter (fun e -> if P e then raise Caught else ()) s;
         false)
    with Caught -> true
;;

let toList = intset__elements;;

let ofList l = it_list add mt l;;
let is_empty = intset__is_empty;;

(* $Id: intavs.ml,v 1.2 1996/02/12 15:41:35 cpaulin Exp $ *)
