(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                intavs.mli                                *)
(****************************************************************************)
#open "std";;

type t;;

value add : t -> int -> t;;
value rmv : t -> int -> t;;
value memb : t -> int -> bool;;
value intersect : t -> t -> t;;
value union : t -> t -> t;;
value diff : t -> t -> t;;
value symdiff : t -> t -> t;;
value subset : t -> t -> bool;;
value equal : t -> t -> bool;;
value mt : t;;
value exists : (int -> bool) -> t -> bool;;
value toList : t -> int list;;
value ofList : int list -> t;;
value is_empty : t -> bool;;

(* $Id: intavs.mli,v 1.2 1996/02/12 15:41:37 cpaulin Exp $ *)
