(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               listmap.mli                                *)
(****************************************************************************)

type ('a,'b) t == ('a * 'b) list;;

value new : unit -> ('a,'b) t;;
value map : ('a,'b) t -> 'a -> 'b;;
value dom : ('a,'b) t -> 'a list;;
value rng : ('a,'b) t -> 'b list;;
value in_dom : ('a,'b) t -> 'a -> bool;;
value in_rng : ('a,'b) t -> 'b -> bool;;
value inv : ('a,'b) t -> 'b -> 'a list;;
value add : ('a,'b) t -> 'a * 'b -> ('a,'b) t;;
value rmv : ('a,'b) t -> 'a -> ('a,'b) t;;
value remap : ('a,'b) t -> 'a -> 'b -> ('a,'b) t;;
value app : (('a * 'c) -> 'b) -> ('a,'c) t -> unit;;
value toList : ('a,'b) t -> ('a * 'b) list;;

(* $Id: listmap.mli,v 1.2 1996/02/12 15:42:00 cpaulin Exp $ *)
