(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               listset.mli                                *)
(****************************************************************************)
#open "std";;

type 'a t == 'a list;;

value add : 'a t -> 'a -> 'a t;;
value rmv : 'a t -> 'a -> 'a t;;
value memb : 'a t -> 'a -> bool;;
value choose : ('a -> bool) -> 'a t -> 'a;;
value intersect : 'a t -> 'a t -> 'a t;;
value union : 'a t -> 'a t -> 'a t;;
value diff : 'a t -> 'a t -> 'a t;;
value symdiff : 'a t -> 'a t -> 'a t;;
value subset : 'a t -> 'a t -> bool;;
value equal : 'a t -> 'a t -> bool;;
value mt : 'a t;;
value ofList : 'a list -> 'a t;;
value toList : 'a t -> 'a list;;
value is_empty : 'a t -> bool;;
value app : ('a -> 'b) -> 'a t -> unit;;

(* $Id: listset.mli,v 1.2 1996/02/12 15:42:09 cpaulin Exp $ *)
