(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 mavm.ml                                  *)
(****************************************************************************)
#open "std";;

type ('a,'b) t = {mutable v : ('a,'b) avm__t;
                  ord : 'a -> 'a -> int};;

let new ord = {ord = ord ; v = (avm__new ord : ('a,'b) avm__t)};;
let empty mlm = mlm.v <- avm__new mlm.ord;;
let map mlm k = avm__map mlm.v k;;
let dom mlm = avm__dom mlm.v;;
let rng mlm = avm__rng mlm.v;;
let in_dom mlm = avm__in_dom mlm.v;;
let inv mlm = avm__inv mlm.v;;
let add mlm p = (mlm.v <- (avm__add mlm.v p));;
let rmv mlm k = (mlm.v <- (avm__rmv mlm.v k));;
let remap mlm k v = (mlm.v <- (avm__remap mlm.v k v));;
let app f mlm = avm__app f mlm.v;;
let toList mlm = avm__toList mlm.v;;

let freeze m = avm__freeze m.v;;
let unfreeze fm m = m.v <- avm__unfreeze fm m.v;;

(* $Id: mavm.ml,v 1.2 1996/02/12 15:42:25 cpaulin Exp $ *)
