(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  mhb.ml                                  *)
(****************************************************************************)
type ('a,'b) t = {f:('a,'b) mhm__t;
                   finv: ('b,'a) mhm__t};;
type ('a,'b) frozen_t == (('a,'b) mhm__frozen_t * ('b,'a) mhm__frozen_t);;

let new n = {f = mhm__new n;
             finv = mhm__new n};;

let map b k = mhm__map b.f k;;
let pam b k = mhm__map b.finv k;;
let dom b = mhm__dom b.f;;
let rng b = mhm__dom b.finv;;
let in_dom b k = mhm__in_dom b.f k;;
let in_rng b v = mhm__in_dom b.finv v;;

let add b (k,v) =
    if not(in_dom b k) & not(in_rng b v) then
        (mhm__add b.f (k,v);
         mhm__add b.finv (v,k))
    else failwith "mhb__add"
;;

let rmv b k =
let v = map b k
in (mhm__rmv b.f k;
    mhm__rmv b.finv v)
;;

let app F b = mhm__app F b.f;;

let toList b = mhm__toList b.f;;

let freeze b = (mhm__freeze b.f,mhm__freeze b.finv);;

let unfreeze (ff,ffinv) b =
    (mhm__unfreeze ff b.f;
     mhm__unfreeze ffinv b.finv)
;;

let set_maxlen b n =
    (mhm__set_maxlen b.f n;
     mhm__set_maxlen b.finv n)
;;

(* $Id: mhb.ml,v 1.2 1996/02/12 15:42:30 cpaulin Exp $ *)
