(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 mhb.mli                                  *)
(****************************************************************************)

type ('a,'b) t;;
type ('a,'b) frozen_t;;

value new : int -> ('a,'b) t;;
value map : ('a,'b) t -> 'a -> 'b;;
value pam : ('a,'b) t -> 'b -> 'a;;
value dom : ('a,'b) t -> 'a list;;
value rng : ('a,'b) t -> 'b list;;
value in_dom : ('a,'b) t -> 'a -> bool;;
value in_rng : ('a,'b) t -> 'b -> bool;;
value app : (('a * 'c) -> 'b) -> ('a,'c) t -> unit;;
value toList : ('a,'b) t -> ('a * 'b) list;;

value add : ('a,'b) t -> 'a * 'b -> unit;;
value rmv : ('a,'b) t -> 'a -> unit;;

(*value remap : ('a,'b) t -> 'a -> 'b -> ('a,'b) t;;*)

value freeze : ('a,'b) t -> ('a,'b) frozen_t;;
value unfreeze : ('a,'b) frozen_t -> ('a,'b) t -> unit;;
value set_maxlen : ('a,'b) t -> int -> unit;;

(* $Id: mhb.mli,v 1.2 1996/02/12 15:42:32 cpaulin Exp $ *)
