(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 mhm.mli                                  *)
(****************************************************************************)

type ('a,'b) t;;

value new : int -> ('a,'b) t;;
value empty : ('a,'b)t -> unit;;
value map : ('a,'b) t -> 'a -> 'b;;
value add : ('a,'b) t -> 'a * 'b -> unit;;
value rmv : ('a,'b) t -> 'a -> unit;;
value app : (('a * 'b) -> 'c) -> ('a,'b) t -> unit;;
value in_dom : ('a,'b) t -> 'a -> bool;;
value toList : ('a,'b) t -> ('a * 'b) list;;
value dom : ('a,'b) t -> 'a list;;
value remap : ('a,'b) t -> 'a -> 'b -> unit;;

(*value rng : ('a,'b) t -> 'b list;;
value inv : ('a,'b) t -> 'b -> 'a list;;
*)

type ('a,'b) frozen_t;;

value freeze : ('a,'b) t -> ('a,'b) frozen_t;;
value unfreeze : ('a,'b) frozen_t -> ('a,'b) t -> unit;;
value set_maxlen : ('a,'b) t -> int -> unit;;

(* $Id: mhm.mli,v 1.2 1996/02/12 15:42:37 cpaulin Exp $ *)
