(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 mhmfs.ml                                 *)
(****************************************************************************)

let new n = mhm__new n;;
let empty m = mhm__empty m;;
let map m k = mhm__map m k;;
let dom m = mhm__dom m;;
let in_dom m k = mhm__in_dom m k;;
(*let rng m = mhm__rng m;;*)
let ind_dom m k = mhm__in_dom m k;;
let add m (k,v) =
    try mhm__remap m k (listset__add (mhm__map m k) v)
    with Not_found -> mhm__add m (k,[v])
;;

let rmv m (k,v) =
    mhm__remap m k (listset__rmv (mhm__map m k) v)
;;

let app f m = mhm__app f m;;
let toList m = mhm__toList m;;
let freeze m = mhm__freeze m;;
let unfreeze fm m = mhm__unfreeze fm m;;

(* $Id: mhmfs.ml,v 1.2 1996/02/12 15:42:39 cpaulin Exp $ *)
