(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  mlm.ml                                  *)
(****************************************************************************)
#open "std";;

type ('a,'b) t == ('a * 'b) list nref;;

let new () = nref ([] : ('a * 'b) list);;
let empty mlm = mlm.v <- [];;
let map mlm k = listmap__map mlm.v k;;
let dom mlm = listmap__dom mlm.v;;
let rng mlm = listmap__rng mlm.v;;
let in_dom mlm = listmap__in_dom mlm.v;;
let in_rng mlm = listmap__in_rng mlm.v;;
let inv mlm = listmap__inv mlm.v;;
let add mlm p = (mlm.v <- (listmap__add mlm.v p));;
let rmv mlm k = (mlm.v <- (listmap__rmv mlm.v k));;
let remap mlm k v = (mlm.v <- (listmap__remap mlm.v k v));;
let app f mlm = listmap__app f mlm.v;;
let toList mlm = mlm.v;;

(* $Id: mlm.ml,v 1.2 1996/02/12 15:42:49 cpaulin Exp $ *)
