(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 mlm.mli                                  *)
(****************************************************************************)

type ('a,'b) t;;

value new : unit -> ('a,'b) t;;
value empty : ('a,'b)t -> unit;;
value map : ('a,'b) t -> 'a -> 'b;;
value dom : ('a,'b) t -> 'a list;;
value rng : ('a,'b) t -> 'b list;;
value in_dom : ('a,'b) t -> 'a -> bool;;
value in_rng : ('a,'b) t -> 'b -> bool;;
value inv : ('a,'b) t -> 'b -> 'a list;;
value add : ('a,'b) t -> 'a * 'b -> unit;;
value rmv : ('a,'b) t -> 'a -> unit;;
value remap : ('a,'b) t -> 'a -> 'b -> unit;;
value app : (('a * 'b) -> 'c) -> ('a,'b) t -> unit;;
value toList : ('a,'b) t -> ('a * 'b) list;;

(* $Id: mlm.mli,v 1.2 1996/02/12 15:42:51 cpaulin Exp $ *)
