(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 mls.mli                                  *)
(****************************************************************************)
#open "std";;

type 'a t == 'a list ref;;

value add : 'a t -> 'a -> unit;;
value rmv : 'a t -> 'a -> unit;;
value memb : 'a t -> 'a -> bool;;
value subset : 'a t -> 'a t -> bool;;
value equal : 'a t -> 'a t -> bool;;
value mt : unit -> 'a t;;
value ofList : 'a list -> 'a t;;
value toList : 'a t -> 'a list;;
value is_empty : 'a t -> bool;;
value empty : 'a t -> unit;;
value freeze : 'a t -> 'a list;;
value unfreeze : 'a list -> 'a t -> unit;;
value app : ('a -> 'b) -> 'a t -> unit;;

(* $Id: mls.mli,v 1.2 1996/02/12 15:42:55 cpaulin Exp $ *)
