(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              more_util.mli                               *)
(****************************************************************************)

#open "std";;
#open "pp";;
#open "stdpp";;
#open "sys";;

type 'a option = 
    NONE
  | SOME of 'a
;;
value option_app : ('a -> 'b) -> 'a option -> 'b option;;
value do_option : ('a -> unit) -> 'a option -> unit;;
value inSOME : 'a -> 'a option;;
value outSOME : 'a option -> 'a;;
value in_dom : 'a -> ('a * 'b) list -> bool;;
value nth_from_zero : int * 'a list -> 'a;;
value nth_from_one : int * 'a list -> 'a;;
value maxList : int list -> int;;
value maxNEList : int list -> int;;
value in_range : char * char -> char -> bool;;
value islower : char -> bool;;
value isupper : char -> bool;;
value isalpha : char -> bool;;
value isdigit : char -> bool;;
value isxdigit : char -> bool;;
value isalnum : char -> bool;;
value is_ident_start : char -> bool;;
value is_ident_rest : char -> bool;;
value app : ('a -> 'b) -> 'a list -> unit;;
value appLR : ('a -> 'b) -> 'a list -> unit;;
value implode_chars : char list -> string;;
value explode_chars : string -> char list;;
value plist : ('a stream -> 'b) -> 'a stream -> 'b list;;
value cons : 'a * 'a list -> 'a list;;
value maybe_empty_list_with_sep : 'a -> ('b * 'a -> 'a) -> ('c stream -> unit) -> ('c stream -> 'b) -> 'c stream -> 'a;;
value plist_with_sep : ('a stream -> unit) -> ('a stream -> 'b) -> 'a stream -> 'b list;;
value prlist : ('a -> 'b stream) -> 'a list -> 'b stream;;
value prvect : ('a -> 'b stream) -> 'a vect -> 'b stream;;
value prlist_with_sep : (unit -> 'a stream) -> ('b -> 'a stream) -> 'b list -> 'a stream;;
value prvect_with_sep : (unit -> 'a stream) -> ('b -> 'a stream) -> 'b vect -> 'a stream;;
value string_to_char_stream : string -> char stream;;
value ensure_eof : ('a stream -> 'b) -> 'a stream -> 'b;;
value char_to_string : char -> string;;
value stream_to_list : 'a stream -> 'a list;;
value stream_of_list : 'a list -> 'a stream;;
value string_stream_to_string : string stream -> string;;
value string_stream_to_char_stream : string stream -> char stream;;
value atoi_base : int -> string -> int;;
value load_string : 'a -> unit -> 'a stream;;
value output_string_stream : string stream -> unit;;
value revc : 'a list * 'a list -> 'a list;;
value pure_index : 'a * 'a list -> int;;
value first : int * 'a list -> 'a list;;
value distinct : 'a list -> bool;;
value uniquize : 'a list -> 'a list;;
value uniquize_join : 'a list list -> 'a list;;
value mem_eqfun : ('a -> 'b -> bool) -> 'a -> 'b list -> bool;;
value uniquize_eqfun : ('a -> 'a -> bool) -> 'a list -> 'a list;;
value combine_map : ('a -> 'b) -> 'a list -> ('b * 'a) list;;
value p_atom : char stream -> string;;
value number : char stream -> int;;
value string_for_read_octal : string -> string;;
value pair : 'a * 'b -> 'a * 'b;;
value upto : int -> int -> int list;;
value map_trapping_failure : ('a -> 'b) -> 'a list -> 'b list;;
value string_of_char : char -> string;;
value map_stream : ('a -> 'b stream) -> 'a stream -> 'b stream;;
value map_stream_tokens : ('a -> 'b) -> 'a stream -> 'b stream;;
value plist : ('a stream -> 'b) -> 'a stream -> 'b list;;
value ne_plist : ('a stream -> 'b) -> 'a stream -> 'b * 'b list;;
value ne_list_with_sep : ('a stream -> unit) -> ('a stream -> 'b) -> 'a stream -> 'b list;;
value list_with_sep : ('a stream -> unit) -> ('a stream -> 'b) -> 'a stream -> 'b list;;
value right_assoc : ('a stream -> 'b -> 'b -> 'b) -> ('a stream -> 'b) -> 'a stream -> 'b;;
value left_assoc : ('a stream -> 'b -> 'b -> 'b) -> ('a stream -> 'b) -> 'a stream -> 'b;;
value reduce_stream : ('a stream -> 'b) -> 'a stream -> 'b stream;;
value list_index_pred : ('a -> bool) -> 'a list -> int;;
value first_result_i : (int -> 'a -> 'b) -> int -> 'a list -> 'b option;;
value first_result : ('a -> 'b) -> 'a list -> 'b option;;

(* $Id: more_util.mli,v 1.3 1996/02/12 15:42:59 cpaulin Exp $ *)
