(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 stack.ml                                 *)
(****************************************************************************)
#open "list";;
#open "exc";;
#open "std";;
#open "more_util";;

type 'a t = { mutable c : 'a list };;

let new () = { c = [] };;

let push x s = s.c <- x :: s.c;;

let pop s =
  match s.c with
    hd::tl -> s.c <- tl; hd
  | []     -> raise Empty
;;

let clear s = s.c <- [];;

let length s = list_length s.c;;

let iter f s = do_list f s.c;;

let top s =
    match s.c with
    [] -> NONE
  | h::_ -> SOME h
;;

let truncate n s =
    if list_length s.c > n then
        s.c <- fst(chop_list n s.c)
    else ()
;;


(* $Id: stack.ml,v 1.2 1996/02/12 15:43:06 cpaulin Exp $ *)
