(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                system.mli                                *)
(****************************************************************************)
#open "pp";;
#open "stdpp";;
#open "unix";;

value add_path : string -> unit;;
value del_path : string -> unit;;
value search_paths : unit -> string list;;

value safe_getenv : string -> string;;
value safe_getlogin : unit -> string;;
value glob : string -> string;;

value open_trapping_failure : (string -> 'a) -> string -> string -> 'a;;
value open_with_suffix : (string -> 'a) -> string -> string -> 'a;;
value open_with_suffix_from_path : (string -> 'a) -> string list -> string -> string -> 'a;;
value open_in_maybe_compressed : string -> in_channel;;

value timestamp : unit -> int * process_times;;
value fmt_time_difference : int * process_times -> int * process_times -> (int * string) ppcmd_token stream;;

value mode_append : int;;
value l_xtnd : int;;
value comline : string -> unit;;
value extern_intern : int * string -> (string -> 'a -> unit) * (string -> 'a);;

value file_readable_p : string -> bool;;

(* $Id: system.mli,v 1.2 1996/02/12 15:43:19 cpaulin Exp $ *)
