(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              arg_parse.mli                               *)
(****************************************************************************)

type spec = 
    Unit of (unit -> unit)
  | String of (string -> unit)
  | Int of (int -> unit)
  | Float of (float -> unit)
;;

exception Bad of string
;;

value implode : char list -> string;;
value isolate_tokens : string -> string list;;
value parse : (string * spec) list -> (string -> 'a) -> string -> unit;;

(* $Id: arg_parse.mli,v 1.2 1996/02/12 15:44:11 cpaulin Exp $ *)
