(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 fvavs.ml                                 *)
(****************************************************************************)

type t == fvset__t;;

let add s e = fvset__add e s;;
let rmv s e = fvset__remove e s;;
let memb s e = fvset__mem e s;;
let intersect = fvset__inter;;
let union = fvset__union;;
let diff = fvset__diff;;
let symdiff l1 l2 = diff(union l1 l2) (intersect l1 l2);;
let subset l1 l2 = for_all (memb l2) (fvset__elements l1);;
let equal = fvset__equal;;
let mt = fvset__empty;;

exception Caught;;
let exists P s =
    try (fvset__iter (fun e -> if P e then raise Caught else ()) s;
         false)
    with Caught -> true
;;

let toList = fvset__elements;;

let ofList l = it_list add mt l;;
let is_empty = fvset__is_empty;;
let app f s = fvset__iter f s;;

(* $Id: fvavs.ml,v 1.2 1996/02/12 15:44:55 cpaulin Exp $ *)
