(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                fvavs.mli                                 *)
(****************************************************************************)
#open "std";;

type t;;

value add : t -> ast__first_val -> t;;
value rmv : t -> ast__first_val -> t;;
value memb : t -> ast__first_val -> bool;;
value intersect : t -> t -> t;;
value union : t -> t -> t;;
value diff : t -> t -> t;;
value symdiff : t -> t -> t;;
value subset : t -> t -> bool;;
value equal : t -> t -> bool;;
value mt : t;;
value exists : (ast__first_val -> bool) -> t -> bool;;
value toList : t -> ast__first_val list;;
value ofList : ast__first_val list -> t;;
value is_empty : t -> bool;;
value app : (ast__first_val -> 'b) -> t -> unit;;

(* $Id: fvavs.mli,v 1.2 1996/02/12 15:44:57 cpaulin Exp $ *)
