(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 gkavs.ml                                 *)
(****************************************************************************)

type t == gkset__t;;

let add s e = gkset__add e s;;
let rmv s e = gkset__remove e s;;
let memb s e = gkset__mem e s;;
let intersect = gkset__inter;;
let union = gkset__union;;
let diff = gkset__diff;;
let symdiff l1 l2 = diff(union l1 l2) (intersect l1 l2);;
let subset l1 l2 = for_all (memb l2) (gkset__elements l1);;
let equal = gkset__equal;;
let mt = gkset__empty;;

exception Caught;;
let exists P s =
    try (gkset__iter (fun e -> if P e then raise Caught else ()) s;
         false)
    with Caught -> true
;;

let toList = gkset__elements;;

let ofList l = it_list add mt l;;
let is_empty = gkset__is_empty;;
let app f s = gkset__iter f s;;

(* $Id: gkavs.ml,v 1.2 1996/02/12 15:45:08 cpaulin Exp $ *)
