(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                gkavs.mli                                 *)
(****************************************************************************)
#open "std";;

type t;;

value add : t -> ast__gram_key -> t;;
value rmv : t -> ast__gram_key -> t;;
value memb : t -> ast__gram_key -> bool;;
value intersect : t -> t -> t;;
value union : t -> t -> t;;
value diff : t -> t -> t;;
value symdiff : t -> t -> t;;
value subset : t -> t -> bool;;
value equal : t -> t -> bool;;
value mt : t;;
value exists : (ast__gram_key -> bool) -> t -> bool;;
value toList : t -> ast__gram_key list;;
value ofList : ast__gram_key list -> t;;
value is_empty : t -> bool;;
value app : (ast__gram_key -> 'b) -> t -> unit;;

(* $Id: gkavs.mli,v 1.2 1996/02/12 15:45:10 cpaulin Exp $ *)
