(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               initial.mli                                *)
(****************************************************************************)

#open "more_util";;

value make_silent : bool -> unit;;
value is_silent : unit -> bool;;
value silently : ('a -> 'b) -> 'a -> 'b;;

value add_unsafe : string -> unit;;
value is_unsafe : string -> bool;;

value setMETA : int -> unit;;
value newMETA : unit -> int;;


type 'a timestamped;;
(* ts_mod gives a 'b timestamped with a new stamp *)
value ts_mod : ('a -> 'b) -> 'a timestamped -> 'b timestamped;;
value ts_it : 'a timestamped -> 'a;;
value ts_mk : 'a -> 'a timestamped;;
value ts_eq : 'a timestamped -> 'a timestamped -> bool;;
value ts_stamp : 'a timestamped -> int;;

type 'a idstamped;;
(* ids_mod gives a 'b stamped with the same stamp *)
value ids_mod : ('a -> 'b) -> 'a idstamped -> 'b idstamped;;
value ids_it : 'a idstamped -> 'a;;
value ids_mk : 'a -> 'a idstamped;;
value ids_eq : 'a idstamped -> 'a idstamped -> bool;;

value make_focus : int -> unit;;
value focus : unit -> int;;
value set_print_hyps_limit : int -> unit;;
value unset_print_hyps_limit : unit -> unit;;
value print_hyps_limit : unit -> int option;;

(* $Id: initial.mli,v 1.3 1996/02/12 15:45:18 cpaulin Exp $ *)
