(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                pridyn.ml                                 *)
(****************************************************************************)

#open "stdpp";;

type t == dyn__t;;

let ridyntab =
 (mlm__new() : (string,(dyn__t -> dyn__t) * (dyn__t -> std_ppcmds)) mlm__t)
;;

let new (s,rifun,prfun) =
    let (infun,outfun) = dyn__new s in
    let dyn_rifun dob = infun(rifun(outfun dob)) in
    let dyn_prfun dob = prfun(outfun dob)
    in mlm__add ridyntab (s,(dyn_rifun,dyn_prfun));
       (infun,outfun)
;;

let tag dob = dyn__tag dob;;

let ri_dyn dob =
    let s = tag dob in
    fst (mlm__map ridyntab s) dob
;;

let pr_dyn dob =
    let s = tag dob in
    snd (mlm__map ridyntab s) dob
;;

(* $Id: pridyn.ml,v 1.3 1996/02/12 15:45:43 cpaulin Exp $ *)
