(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              reintern0.mli                               *)
(****************************************************************************)

#open "std";;
#open "names";;
#open "libobject";;

value sa_fmavm : (SA__t, string) fmavm__t;;
value pa_fmavm : (PA__t, string list) fmavm__t;;
value use_hash_cons : bool ref;;
value install_saved_tables : ('a * 'b * (SA__t, string) fmavm__frozen_t) * ('c * 'd * (PA__t, string list) fmavm__frozen_t) -> unit;;
value erase_tables : unit -> unit;;
value do_reintern : ('a -> 'b) -> bool -> (('c * 'd * (SA__t, string) fmavm__frozen_t) * ('e * 'f * (PA__t, string list) fmavm__frozen_t)) * 'a -> 'b;;
value prepare_extern : 'a -> (SA__frozen_t * PA__frozen_t) * 'a;;
value ri_nref : ('a -> 'b) -> 'a nref -> 'b nref;;
value ri_sa : SA__t -> SA__t;;
value ri_pa : PA__t -> PA__t;;
value ri_id : identifier -> identifier;;
value ri_sp : section_path -> section_path;;
value ri_name : name -> name;;
value ri_sign : ('a -> 'b) -> identifier list * 'a list -> identifier list * 'b list;;
value ri_dbsign : ('a -> 'b) -> (name * 'a) list -> (name * 'b) list;;
value ri_env : ('a -> 'b) -> ('c -> 'd) -> ('a, 'c) env -> ('b, 'd) env;;
value ri_spavs : spavs__t -> spavs__t;;
value ri_avm : ('a -> 'a -> int) -> ('b -> 'a) -> ('c -> 'd) -> ('b, 'c) avm__t -> ('a, 'd) avm__t;;
value ri_intavm : ('a -> 'b) -> 'a intavm__t -> 'b intavm__t;;
value ri_avm_frozen_t : ('a -> 'a -> int) -> ('a -> 'a) -> ('b -> 'c) -> ('a, 'b) avm__frozen_t -> ('a, 'c) avm__frozen_t;;
value ri_object : object -> object;;
value ri_node : lib__node -> lib__node;;
value ri_ctxt : (section_path * lib__node) list -> (section_path * lib__node) list;;
value ri_cdc : lib__closed_dir_contents -> lib__closed_dir_contents;;
value ri_odc : lib__open_dir_contents -> lib__open_dir_contents;;

(* $Id: reintern0.mli,v 1.3 1996/02/12 15:45:54 cpaulin Exp $ *)
