(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 spavs.ml                                 *)
(****************************************************************************)

type t == spset__t;;

let add s e = spset__add e s;;
let rmv s e = spset__remove e s;;
let memb s e = spset__mem e s;;
let intersect = spset__inter;;
let union = spset__union;;
let diff = spset__diff;;
let symdiff l1 l2 = diff(union l1 l2) (intersect l1 l2);;
let subset l1 l2 = for_all (memb l2) (spset__elements l1);;
let equal = spset__equal;;
let mt = spset__empty;;

exception Caught;;
let exists P s =
    try (spset__iter (fun e -> if P e then raise Caught else ()) s;
         false)
    with Caught -> true
;;

let toList = spset__elements;;

let ofList l = it_list add mt l;;
let is_empty = spset__is_empty;;

(* $Id: spavs.ml,v 1.2 1996/02/12 15:45:57 cpaulin Exp $ *)
