(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                spavs.mli                                 *)
(****************************************************************************)

(* This module deals with section_path sets *)
#open "std";;
#open "names";;

type t;;

value add : t -> section_path -> t;;
value rmv : t -> section_path -> t;;
value memb : t -> section_path -> bool;;
value intersect : t -> t -> t;;
value union : t -> t -> t;;
value diff : t -> t -> t;;
value symdiff : t -> t -> t;;
value subset : t -> t -> bool;;
value equal : t -> t -> bool;;
value mt : t;;
value exists : (section_path -> bool) -> t -> bool;;
value toList : t -> section_path list;;
value ofList : section_path list -> t;;
value is_empty : t -> bool;;

(* $Id: spavs.mli,v 1.2 1996/02/12 15:46:00 cpaulin Exp $ *)
