(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                states.mli                                *)
(****************************************************************************)

#open "names";;
#open "more_util";;
#open "lib";;
#open "summary";;

type state == lib__frozen_t * summary__frozen_t;;

value raw_save_state : string -> string -> unit;;
value raw_restore_state : string -> unit;;
value raw_restore_last_saved_state : unit -> unit;;
value forget_state : bool -> string -> unit;;
value list_saved_states : unit -> (string * string) list;;

value extern_state : string -> unit;;
value intern_state : string -> unit;;

(* $Id: states.mli,v 1.3 1996/02/12 15:46:12 cpaulin Exp $ *)
