(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               summary.mli                                *)
(****************************************************************************)
#open "pp";;
#open "stdpp";;
#open "names";;
#open "more_util";;

value IMPORTED : section_path list ref;;
value search_imports : unit -> section_path list;;

type 'a summary_declaration =
    {freeze_function : unit -> 'a;
     unfreeze_function : 'a -> unit;
     init_function : unit -> unit;
     sync_function : unit -> bool}
;;

value declare_summary : string -> 'a summary_declaration -> unit;;

type summary_vector;;

value freeze_summary : unit -> summary_vector;;
value unfreeze_summary : summary_vector -> unit;;

value freeze_to_key : section_path -> unit;;
value unfreeze_from_key : section_path -> unit;;
value find_latest : unit -> section_path;;
value unfreeze_latest : section_path -> unit;;

type frozen_t;;
value get_frozen_summaries : unit -> frozen_t;;
value set_frozen_summaries : frozen_t -> unit;;

value init_caches : unit -> unit;;
value resync_caches : unit -> bool;;

value list_frozen_summaries : unit -> section_path list;;

(* $Id: summary.mli,v 1.2 1996/02/12 15:46:22 cpaulin Exp $ *)
