(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                syntax.mli                                *)
(****************************************************************************)
#open "names";;
#open "std";;
#open "ast";;
#open "unparsings";;

type frozen_t;;

type syntax_entry =
    {syn_universe : identifier;
     syn_id : string;
     syn_astpat : spat;
     syn_recbindings : (identifier * spat) list;
     syn_unparsing : unparsing}
;;

value add : section_path * syntax_entry -> unit;;
value map : identifier -> ast -> syntax_entry list;;
value init : unit -> unit;;
value freeze : unit -> frozen_t;;
value unfreeze : frozen_t -> unit;;

value ri_syntax_entry : syntax_entry -> syntax_entry;;

(* $Id: syntax.mli,v 1.2 1996/02/12 15:46:26 cpaulin Exp $ *)
