(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               termact.mli                                *)
(****************************************************************************)
#open "std";;
#open "names";;
#open "pp";;
#open "stdpp";;
#open "ast";;
#open "vkey";;
#open "lexer";;

type nonterm_map == (identifier,frag) listmap__t;;

type binding == identifier * spat;;

type pattern == spat;;

type action =
    ACTL of binding list
  | CASE of identifier * (spat * action) list
;;

type tokstream == vernac_keyword token stream;;

value mt : nonterm_map;;

value strip_to_value :  nonterm_map -> frag;;

value interp_act : action -> nonterm_map -> frag;;

value parse_act : (tokstream -> spat) -> vernac_keyword lexer__token stream -> action;;

value fmt_act : action -> std_ppcmds;;

value push : identifier -> frag -> nonterm_map -> nonterm_map;;

value ri_action : action -> action;;

(* $Id: termact.mli,v 1.2 1996/02/12 15:46:31 cpaulin Exp $ *)
