(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 vkey.ml                                  *)
(****************************************************************************)
#open "std";;

let (vernac_keywords,rev_vernac_keywords) =
  let t = make_vect 307 [] in
  let rev_t = make_vect 307 [] in
  do_list (fun (s,tok) -> hash_add_assoc (s,tok) t;
                          hash_add_assoc (tok,s) rev_t)
  [
    "AddPath",Kaddpath;
    "Definition",Kdefinition;
    "DelPath",Kdelpath;
    "Dependent",Kdependent;
    "end", Kend;
    "Grammar", Kgrammar;
    "Inductive", Kinductive;
    "CoInductive", Kcoinductive;
    "in", Kin; 
    "Load", Kload;
    "LoadPath",Kloadpath;
    "NewSyntax",Ksyntax;
    "Non",Knon; 
    "Orelse",Korelse;
    "Proof",Kproof;
    "Qed",Kqed;
    "Quit", Kquit;
    "Remove",Kremove;
    "Reset", Kreset;
    "Restore",Krestore;
    "State",Kstate;
    "Syntax", Ksyntax;
    "with", Kwith;
    "using", Kuse
  ]; (t,rev_t)
;;

(* $Id: vkey.ml,v 1.5 1996/02/12 15:46:37 cpaulin Exp $ *)
