(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                             evar_refiner.mli                             *)
(****************************************************************************)

#open "initial";;
#open "names";;
#open "more_util";;
#open "term";;
#open "mach";;
#open "pp";;
#open "stdpp";;
#open "proof";;
#open "proof_trees";;
#open "proof_constraints";;
#open "refiner";;

value rc_of_pfsigma : proof sigma -> readable_constraints;;
value rc_of_glsigma : goal sigma -> readable_constraints;;

type walking_constraints;;
type 'a result_w_tactic == walking_constraints -> walking_constraints * 'a;;
type w_tactic == walking_constraints -> walking_constraints;;

value Local_Constraints : local_constraints -> goal sigma -> goal list sigma * validation;;

value StartWalk : goal sigma -> walking_constraints * (walking_constraints -> tactic);;
value Walking_THEN : 'a result_w_tactic -> ('a -> tactic) -> tactic;;
value Walking : w_tactic -> tactic;;
value w_Focusing_THEN : section_path -> 'a result_w_tactic -> ('a -> w_tactic) -> w_tactic;;
value w_Declare : section_path -> constr -> w_tactic;;
value w_Declare_At : section_path -> section_path -> constr -> w_tactic;;
value w_Define : section_path -> constr -> w_tactic;;

value w_Underlying : walking_constraints -> readable_constraints;;
value w_hyps : walking_constraints -> constr signature;;
value w_type_of : walking_constraints -> constr -> constr;;
value w_add_sign : (identifier * constr) -> walking_constraints -> walking_constraints;;

value w_IDTAC : w_tactic;;
value w_ORELSE : w_tactic -> w_tactic -> w_tactic;;
value ctxt_type_of : readable_constraints -> constr -> constr;;

value evars_of : readable_constraints -> constr -> spavs__t;;

(* $Id: evar_refiner.mli,v 1.2 1996/02/12 15:47:22 cpaulin Exp $ *)
