(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 evc.mli                                  *)
(****************************************************************************)
#open "names";;
#open "more_util";;
#open "term";;
#open "constrtypes";;
#open "proof";;
#open "proof_constraints";;

value lc_toList : local_constraints -> section_path listset__t;;
value lc_ofList : section_path listset__t -> local_constraints;;
value lc_equal : local_constraints -> local_constraints -> bool;;

value toList : readable_constraints -> (section_path * evar_declaration) list;;
value dom : readable_constraints -> section_path list;;
value map : readable_constraints -> section_path -> evar_declaration;;
value in_dom : readable_constraints -> section_path -> bool;;
value add : readable_constraints -> section_path * evar_declaration -> readable_constraints;;
value log_add : readable_constraints -> section_path * evar_declaration -> readable_constraints;;
value remap : readable_constraints -> section_path -> evar_declaration -> readable_constraints;;
value app : (section_path * evar_declaration -> 'a) -> readable_constraints -> unit;;
value equal : readable_constraints -> readable_constraints -> bool;;

value set_focus : readable_constraints -> local_constraints -> readable_constraints;;
value get_focus : readable_constraints -> local_constraints;;
value saving_focus : (readable_constraints -> readable_constraints) -> readable_constraints -> readable_constraints;;
value mentions : readable_constraints -> section_path -> section_path -> bool;;
value accessible : readable_constraints -> section_path -> section_path -> bool;;
value ctxt_access : readable_constraints -> section_path -> bool;;
value is_evar : readable_constraints -> section_path -> bool;;
value get_hyps : readable_constraints -> constr signature;;
value get_gc : readable_constraints -> global_constraints;;

(* $Id: evc.mli,v 1.2 1996/02/12 15:47:26 cpaulin Exp $ *)
