(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              extraction.mli                              *)
(****************************************************************************)

#open "names";;
#open "generic";;
#open "term";;
#open "proof";;

value inf_app : (judgement -> judgement) -> information -> information;;
value inf_var : constr assumptions -> contents -> identifier -> information;;
value inf_sort : sorts -> information;;
value inf_apply : information -> information -> information;;

value inf_gen_rel : name -> information -> information -> information;;
value inf_abs_var : identifier -> constr -> information -> information * modification_action;;
value inf_abs_rel : name -> information -> information -> information;;
value inf_abs_rel_count : name -> information -> information -> information*modification_action;;
value inf_rel : constr assumptions -> contents -> int -> information;;
value extract : information -> judgement;;
value inf_mutcase : 'a assumptions -> readable_constraints -> constr -> judgement -> information -> information vect -> information;;
value inf_fix : readable_constraints -> int -> constr -> name list -> information vect -> (information * int) vect -> information;;
value inf_cofix : readable_constraints -> int -> constr -> name list -> information vect -> information vect -> information;;

(* $Id: extraction.mli,v 1.4 1996/02/12 15:47:30 cpaulin Exp $ *)
