(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 himsg.ml                                 *)
(****************************************************************************)
#open "pp";;
#open "stdpp";;
#open "names";;

let MSG = lomsg__MSG;;
let MSGNL = lomsg__MSGNL;;
let MSGERR = lomsg__MSGERR;;
let MSGERRNL = lomsg__MSGERRNL;;

let WARN pps = PPNL [< 'S"Warning: " ; pps >];;

let message = lomsg__message;;
let warning = lomsg__warning;;

let pFTERM = printer__fprterm;;
let pTERM = printer__prterm;;
let pENV = printer__pr_term_env;;
let pTERMINENV (env,t) = printer__term0 env t;;
let pFTERMINENV (env,t) = printer__fterm0 env t;;

let pTACTIC = printer__gentacpr;;
let pCMD(pk,com) = printer__gencompr pk com;;
let pVERNAC = printer__genvernacpr;;

let pDECLS = printer__pr_decls;;
let pSEQ = printer__pr_seq;;

let pCTXT = printer__pr_ctxt;;
let pID id = [< 'S(string_of_id id) >];;

(* $Id: himsg.ml,v 1.2 1996/02/12 15:47:33 cpaulin Exp $ *)
