(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               indtypes.mli                               *)
(****************************************************************************)
#open "names";;
#open "term";;
#open "constrtypes";;
#open "generic";;
#open "more_util";;
#open "proof";;
#open "pp";;
#open "stdpp";;
#open "termenv";;

value inf_minductive : constr assumptions -> constr assumptions -> int -> constr -> constr -> bool -> (int * constr option * modification_action list * constr option);;

value infexecute_minductive : constr signature * constr signature -> int -> (name * identifier * identifier vect) vect ->bool vect-> (constr * constr) vect -> (path_kind,mutual_inductive_body) listmap__t;;

value execute_minductive : constr signature -> int -> (name * identifier * identifier vect) vect -> bool vect -> (constr * constr) vect -> (path_kind,mutual_inductive_body) listmap__t;;
 
value abstract_mimap : section_path * section_path -> identifier list -> (path_kind * mutual_inductive_body) list -> ('a oper * 'b oper modification) list * (path_kind * mutual_inductive_body) list;;

value expmod_mimap : (sorts oper * sorts oper modification) list -> ('a * mutual_inductive_body) list -> ('a * mutual_inductive_body) list;;

value process_mimap : (section_path * section_path) -> (identifier list * (sorts oper * sorts oper modification) list) -> (path_kind * mutual_inductive_body) list -> ((sorts oper * sorts oper modification) list) * (path_kind * mutual_inductive_body) list;;


(** DEBUG **)
value is_logic_casted_type : constr -> bool;;

(* $Id: indtypes.mli,v 1.5 1996/02/12 15:47:43 cpaulin Exp $ *)
