(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                logic.mli                                 *)
(****************************************************************************)
#open "std";;
#open "initial";;
#open "names";;
#open "term";;
#open "reduction";;
#open "termenv";;
#open "mach";;
#open "more_util";;
#open "proof";;
#open "proof_trees";;
#open "pp";;
#open "stdpp";;

value pr_prim_rule : prim_rule -> std_ppcmds;;
value prim_refiner : prim_rule -> readable_constraints -> goal -> goal list;;
value prim_extractor : ((constr, constr) env -> proof -> constr) -> (constr, constr) env -> proof -> constr;;
value extract_constr : constr assumptions -> constr -> constr;;

(* $Id: logic.mli,v 1.2 1996/02/12 15:47:47 cpaulin Exp $ *)
