(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 mach.mli                                 *)
(****************************************************************************)
#open "names";;
#open "generic";;
#open "term";;
#open "more_util";;
#open "impuniv";;
#open "proof";;
#open "pp";;
#open "stdpp";;

value instantiate_universes : constr -> constr;;

(* MACHINE WITH INFORMATION *)
value infmachine : bool -> (readable_constraints * (int * (constr * information)) list) -> constr assumptions -> constr assumptions -> constr -> (judgement * information);;

value infexecute_rec : readable_constraints -> (constr assumptions * constr assumptions) -> constr -> (judgement * information);;
value infexecute : readable_constraints -> (constr signature * constr signature) -> constr -> (judgement * information);;
value infexemeta : readable_constraints -> (int * (constr * information)) list -> (constr assumptions * constr assumptions) -> constr -> (judgement * information);;
value fsign_of_sign : readable_constraints -> constr signature -> fterm signature;;

(* MACHINE WITHOUT INFORMATION *)
value fmachine : bool -> (readable_constraints * (int * constr) list) -> constr assumptions -> constr -> judgement;;

value fexecute : readable_constraints -> constr signature -> constr -> judgement;;
value execute_rec : readable_constraints -> constr assumptions -> constr -> judgement;;
value type_of : readable_constraints -> constr signature -> constr -> constr;;
value type_of_rel : readable_constraints -> constr assumptions -> constr -> constr;;
value unsafe_type_of : readable_constraints -> constr assumptions -> constr -> constr;;
value castify_sign : readable_constraints -> constr signature -> constr signature;;
value castify_env : readable_constraints -> constr assumptions -> constr assumptions;;
value fexemeta : readable_constraints -> (int * constr) list -> constr assumptions -> constr -> judgement;;


value assumption_of_judgement : readable_constraints -> judgement -> sorts oper term;;
value j_val : judgement -> constr;;
value FSIGN : readable_constraints -> constr signature -> (constr signature * constr signature);;
value FENV  : readable_constraints -> constr assumptions -> (constr assumptions * constr assumptions);;
value FGLOB : (constr signature * constr signature) -> (constr assumptions * constr assumptions);;
value fvar_type : readable_constraints -> (constr signature * constr signature) -> fterm -> fterm;;

value core_fmachine : bool -> readable_constraints * (int * constr) list -> (constr, constr) env -> constr -> judgement;;
value core_infmachine : readable_constraints * ((int * constr) list * (int * information) list) -> (constr, constr) env -> constr assumptions -> constr -> information;;
value add_inf_rel : name * information -> constr assumptions -> constr assumptions;;

(* debug *)

(* $Id: mach.mli,v 1.3 1996/02/12 15:47:51 cpaulin Exp $ *)
