(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               machops.mli                                *)
(****************************************************************************)
#open "std";;
#open "names";;
#open "vectops";;
#open "impuniv";;
#open "extraction";;
#open "generic";;
#open "term";;
#open "reduction";;
#open "typing";;
#open "pp";;
#open "stdpp";;
#open "more_util";;
#open "proof";;

value cast_fully : bool ref;;
value j_val : judgement -> constr;;

value id_from_name : name -> identifier;;
value assumption_of_judgement : readable_constraints -> judgement -> constr;;
value fcn_proposition : contents -> judgement;;
value fcn_type_with_universe : contents * universe -> judgement;;
value gen_rel : readable_constraints -> constr assumptions -> name -> constr -> judgement -> judgement;;
value abs_rel : readable_constraints -> name -> constr -> judgement -> judgement;;
value abs_var : readable_constraints -> identifier -> constr -> judgement -> judgement * modification_action;;
value relative : readable_constraints -> int -> ('a, constr) env -> judgement;;
value apply_error : constr assumptions -> constr * constr -> (constr * constr) list -> (int * string) ppcmd_token stream;;
value apply_rel_list : readable_constraints -> constr assumptions -> bool -> judgement list -> judgement -> judgement;;
value cast_rel : readable_constraints -> constr assumptions -> judgement -> judgement -> judgement;;
value type_of_constant : readable_constraints -> 'a assumptions -> constr -> constr;;
value type_of_const : readable_constraints -> 'a assumptions -> constr -> constr;;
value inf_of_const : readable_constraints -> 'a * 'b assumptions -> constr -> information;;
value type_of_mind : readable_constraints -> 'a assumptions -> constr -> constr;;
value type_of_mconstr : readable_constraints -> 'a assumptions -> constr -> constr;;
value verify_wf_env : (constr, constr) env -> unit;;
value cast_of_judgement : judgement -> constr;;


value hyp_seq_ordered_inclusion : constr signature -> constr signature -> bool;;
value lookup_exist : readable_constraints -> 'a assumptions -> section_path -> constr;;
value global_reference : 'a assumptions -> section_path -> identifier -> constr;;
value search_reference : 'a assumptions -> identifier -> constr;;
value search_freference : 'a assumptions -> identifier -> constr;;
value search : 'a assumptions -> identifier -> constr;;
value global : 'a assumptions -> identifier -> constr;;
value type_of_existential : readable_constraints -> (constr, 'a) env -> constr -> constr;;

(* $Id: machops.mli,v 1.4 1996/02/12 15:47:55 cpaulin Exp $ *)
