(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               printer.mli                                *)
(****************************************************************************)
#open "more_util";;
#open "pp";;
#open "stdpp";;
#open "names";;
#open "term";;
#open "constrtypes";;
#open "proof";;
#open "proof_constraints";;

value prterm : constr -> std_ppcmds;;
value fprterm : fterm -> std_ppcmds;;
value pr_subgoals : goal list -> std_ppcmds;;
value pr_subgoal : int -> goal list -> std_ppcmds;;

value fterm0 : 'a assumptions -> fterm -> std_ppcmds;;
value term0 : 'a assumptions -> constr -> std_ppcmds;;
value pr_term_env : constr assumptions -> std_ppcmds;;
value print_arguments : bool ref;;
value print_casts : bool ref;;

value pr_evd : evar_declaration -> std_ppcmds;;
value pr_evc : readable_constraints -> std_ppcmds;;
value pr_decls : global_constraints -> std_ppcmds;;
value prgl : goal -> std_ppcmds;;
value pr_seq : goal -> std_ppcmds;;
value pr_focus : local_constraints -> std_ppcmds;;
value pr_ctxt : ctxt -> std_ppcmds;;

value gencompr : path_kind -> command -> std_ppcmds;;
value gentacpr : command -> std_ppcmds;;
value genvernacpr : command -> std_ppcmds;;



(* $Id: printer.mli,v 1.2 1996/02/12 15:48:00 cpaulin Exp $ *)
