(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 proof.ml                                 *)
(****************************************************************************)


#open "initial";;
#open "names";;
#open "more_util";;
#open "proof_trees";;
#open "proof_constraints";;

(* Constraints for existential variables *)

type local_constraints == spavs__t;;
type global_constraints == spavs__t evar_declsty timestamped;;
type readable_constraints == spavs__t evar_contextty;;

let repr_lc x = x;;
let repr_gc x = x;;
let repr_rc x = x;;

let abs_lc x = x;;
let abs_gc x = x;;
let abs_rc x = x;;

let rc_of_gc (gc:global_constraints) (gl:local_constraints goalty) =
    ((evc_of_evds (ts_it gc) gl) : readable_constraints);;


let mt_evc = mt_evcty spavs__mt (lavm__new sp_ord);;
let mt_lc = spavs__mt;;
let mt_ctxt = mt_ctxtty;;

let mkGOAL = proof_trees__mkGOAL;;

(* $Id: proof.ml,v 1.2 1996/02/12 15:48:03 cpaulin Exp $ *)
