(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                proof.mli                                 *)
(****************************************************************************)

#open "initial";;
#open "names";;
#open "term";;
#open "proof_trees";;
#open "ast";;
#open "proof_constraints";;

(* TODO: remove command *)
type command == ast;;


type local_constraints;;
type global_constraints;;
type readable_constraints;;
type evar_declaration == local_constraints evar_declarationty;;

value repr_lc : local_constraints -> spavs__t;;
value abs_lc : spavs__t -> local_constraints;;

value repr_gc : global_constraints -> local_constraints evar_declsty timestamped;;
value abs_gc : local_constraints evar_declsty timestamped -> global_constraints;;

value repr_rc : readable_constraints -> local_constraints evar_contextty;;
value abs_rc : local_constraints evar_contextty -> readable_constraints;;

type proof == local_constraints proofty;;
type goal == local_constraints goalty;;
type rule == local_constraints rulety;;
type ctxt == local_constraints ctxtty;;

value mt_ctxt : ctxt;;
value mt_evc : readable_constraints;;
value mt_lc : local_constraints;;

value mkGOAL : local_constraints -> ctxt -> constr signature -> constr -> goal;;
value rc_of_gc : global_constraints -> goal -> readable_constraints;;

(* $Id: proof.mli,v 1.2 1996/02/12 15:48:05 cpaulin Exp $ *)
