(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                          proof_constraints.mli                           *)
(****************************************************************************)


(* The module proof declares the structure of proof trees and a few
   utilities on them *)


#open "initial";;
#open "names";;
#open "more_util";;
#open "term";;
#open "constrtypes";;
#open "pp";;
#open "stdpp";;
#open "ast";;
#open "proof_trees";;

type evar_body =
    EVAR_EMPTY | EVAR_DEFINED of constr

and 'a evar_declarationty =
    {evgoal : 'a goalty;
     body : evar_body}

and 'a evar_declsty == (section_path, 'a evar_declarationty) lavm__t

and 'a evar_recordty = {focus : 'a;
                        sign : constr signature;
                        decls : 'a evar_declsty}

and 'a evar_contextty == 'a evar_recordty timestamped
;;

value mt_evcty : 'a -> 'a evar_declsty -> 'a evar_contextty;;


type evar_decls == spavs__t evar_declsty;;
type evar_record == spavs__t evar_recordty;;
type evar_context == spavs__t evar_contextty;;

value evc_of_evds : 'a evar_declsty -> 'a goalty -> 'a
evar_contextty;; (* evc_of_evds takes an evar_declsty decl and a
goalty g, and makes an evar_contextty, where focus = local constraints
of g, sign = signature of g, decls = decl*)

(* $Id: proof_constraints.mli,v 1.2 1996/02/12 15:48:09 cpaulin Exp $ *)
