(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                typing.mli                                *)
(****************************************************************************)

#open "std";;
#open "names";;
#open "pp";;
#open "stdpp";;
#open "term";;
#open "proof";;
#open "constrtypes";;
#open "termenv";;

exception Singleton;;

value type_mconstruct : readable_constraints -> int -> constr -> constr;;
value type_mconstructs : readable_constraints -> constr -> constr vect * constr vect;;
value mis_type_mconstructs : mind_specif -> constr vect * constr vect;;
value type_case_elim :  'a assumptions -> readable_constraints -> constr -> constr -> constr vect -> constr -> constr -> constr;;
value type_case_branches : 'a assumptions -> readable_constraints -> constr -> constr -> constr -> constr -> constr vect * constr;;
value type_case : 'a assumptions -> readable_constraints -> constr -> constr -> constr -> constr -> constr;;
value type_one_branch_dep : (readable_constraints * int * constr list * constr) -> constr -> constr -> constr;;
value type_one_branch_nodep : (readable_constraints * int * constr list * constr) -> constr -> constr;;
value check_fix : readable_constraints -> constr  -> unit;;
value type_fix : readable_constraints -> constr -> constr vect -> constr;;

value check_cofix : readable_constraints -> constr  -> unit;;
value type_cofix  : readable_constraints -> constr -> constr vect -> constr;;

value find_case_dep_mis :  'a assumptions -> readable_constraints -> mind_specif -> constr * constr -> constr * constr list -> constr -> bool;;

value type_of_product : readable_constraints -> constr -> constr -> constr;;
value sort_of_arity : readable_constraints -> constr -> constr;;
value type_of_type : constr -> constr;;
value check_branches_message :   'a assumptions -> readable_constraints -> (constr * constr) -> (constr vect * constr vect) -> unit ;;
value control_only_guard :  readable_constraints -> constr ->unit;;
value make_arity_nodep : constr -> constr -> constr;;
value make_arity_dep : constr -> constr -> constr -> constr;;
(* debug *)

(* $Id: typing.mli,v 1.5 1996/02/12 15:48:38 cpaulin Exp $ *)
