(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 auto.mli                                 *)
(****************************************************************************)
#open "more_util";;
#open "names";;
#open "term";;
#open "proof";;
#open "tacmach";;
#open "clenv";;
#open "pp";;
#open "stdpp";;
#open "termenv";;
#open "vernacinterp";;



type auto_tactic = 
    Res_pf of constr * unit clausenv
  | Give_exact of constr
  | Res_pf_THEN_trivial_fail of constr * unit clausenv
  | Unfold_nth of section_path
;;
type pri_auto_tactic = 
  { pri : int
  ; pat : constr option
  ; code : auto_tactic
  }
;;
value automatic : int -> tactic;;
value SEARCH_DEPTH : int ref;;
value auto : int option -> tactic;;
value real_failing_trivial_tactic : goal sigma -> goal list sigma * validation;;
value failing_trivial_tactic : tactic;;
value trivial : goal sigma -> goal list sigma * validation;;

(* $Id: auto.mli,v 1.2 1996/02/12 15:06:49 cpaulin Exp $ *)
