(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                btermdn.ml                                *)
(****************************************************************************)
#open "more_util";;
#open "term";;
#open "termdn";;

let dnet_depth = ref 8;;

let bounded_constr_pat_discr (t,depth) =
    if depth = 0 then NONE else
    match constr_pat_discr t with
    NONE -> NONE
  | SOME (c,l) -> SOME(c,map (fun c -> (c,depth-1)) l)
;;
let bounded_constr_val_discr (t,depth) =
    if depth = 0 then NONE else
    match constr_val_discr t with
    NONE -> NONE
  | SOME (c,l) -> SOME(c,map (fun c -> (c,depth-1)) l)
;;

type 'a t == (lbl,constr * int,'a) dn__under_t;;

let newdn () = dn__new bounded_constr_pat_discr;;

let ex_termdn = newdn();;

let inDN tdn = {dn__args = ex_termdn.dn__args;
                dn__tm = tdn};;
let outDN dn = dn.dn__tm;;

let new () = outDN (newdn());;
let add dn (c,v) = outDN (dn__add (inDN dn) ((c,!dnet_depth),v));;
let rmv dn (c,v) = outDN (dn__rmv (inDN dn) ((c,!dnet_depth),v));;

let lookup dn t = map (fun ((c,_),v) -> (c,v)) (dn__lookup (inDN dn) bounded_constr_val_discr (t,!dnet_depth));;

let app f dn = dn__app (fun ((c,_),v) -> f(c,v)) (inDN dn);;

(* $Id: btermdn.ml,v 1.2 1996/02/12 15:49:03 cpaulin Exp $ *)
