(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                discr.mli                                 *)
(****************************************************************************)

#open "std";;
#open "names";;
#open "vectops";;
#open "generic";;
#open "ast";;
#open "term";;
#open "reduction";;
#open "typing";;
#open "termenv";;
#open "mach";;
#open "more_util";;
#open "pp";;
#open "stdpp";;
#open "tacmach";;
#open "proof";;
#open "proof_trees";;
 
value pf_get_new_ids : identifier list -> goal sigma -> identifier list;;
exception constructor_not_found
;;
value find_constructor : readable_constraints -> constr -> sorts oper term * constr list;;
value lambda_from_prod_end : sorts oper term -> sorts oper term -> sorts oper term;;
value lambda_ize : int -> constr -> constr -> constr;;
value make_case : 'a oper term -> 'a oper term -> 'a oper term list -> 'a oper term;;
value make_discriminator : constr -> constr -> constr -> goal sigma -> goal list sigma * validation;;
value discr_error_msg : string;;
value are_discriminable : readable_constraints -> constr -> constr -> bool;;
value real_discriminate_tac : goal sigma -> goal list sigma * validation;;
value whd_cast : 'a oper term -> 'a oper term;;
value range_of_prod : 'a oper term -> 'a oper term;;
value discriminate_tac : tactic;;
value iterate_succeed : ('a -> 'a) -> 'a -> 'a;;
exception incorrect_path
;;
value proj_function : goal sigma -> constr -> int -> sorts oper term * constr;;
value injection_step : int -> constr -> goal sigma -> constr;;
value injection : int list -> constr -> goal sigma -> constr;;
value real_injection_tac : int list -> command -> goal sigma -> goal list sigma * validation;;
value vernac_injection_tac : int list -> identifier -> tactic;;

(* $Id: discr.mli,v 1.4 1996/02/12 15:06:53 cpaulin Exp $ *)
