(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  dn.mli                                  *)
(****************************************************************************)
#open "std";;
#open "more_util";;

type ('lbl,'pat) dn_args == 'pat -> ('lbl * 'pat list) option;;

type ('lbl,'pat,'inf) t =
    {tm : (('lbl * int) option,'pat * 'inf) tlm__t;
     args : ('lbl,'pat) dn_args}
;;

type ('lbl,'pat,'inf) under_t == (('lbl * int) option,'pat * 'inf) tlm__t;;

value new : ('lbl,'pat) dn_args -> ('lbl,'pat,'inf) t;;

value add : ('lbl,'pat,'inf) t -> 'pat * 'inf -> ('lbl,'pat,'inf) t;;
value rmv : ('lbl,'pat,'inf) t -> 'pat * 'inf -> ('lbl,'pat,'inf) t;;
value path_of : ('lbl,'pat) dn_args -> 'pat -> ('lbl * int) option list;;

value lookup : ('lbl,'pat,'inf) t -> ('lbl,'term) dn_args -> 'term -> ('pat * 'inf) list;;
value app : (('pat * 'inf) -> 'c) -> ('lbl,'pat,'inf) t -> unit;;

(* $Id: dn.mli,v 1.2 1996/02/12 15:06:54 cpaulin Exp $ *)
