(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 fhdn.mli                                 *)
(****************************************************************************)
#open "std";;
#open "more_util";;

type ('lbl,'pat) dn_args == 'pat -> ('lbl * 'pat list) option;;

type ('lbl,'pat,'inf) t =
    {tm : (('lbl * int) option,'pat * 'inf) fthm__t;
     args : ('lbl,'pat) dn_args}
;;

value new : ('lbl,'pat) dn_args -> ('lbl,'pat,'inf) t;;

value add : ('lbl,'pat,'inf) t -> 'pat * 'inf -> unit;;
value rmv : ('lbl,'pat,'inf) t -> 'pat * 'inf -> unit;;
value path_of : ('lbl,'pat) dn_args -> 'pat -> ('lbl * int) option list;;

value lookup : ('lbl,'pat,'inf) t -> ('lbl,'term) dn_args -> 'term -> ('pat * 'inf) list;;

value empty : ('lbl,'pat,'inf) t -> unit;;

type ('lbl,'pat,'inf) frozen_t == (('lbl * int) option,'pat * 'inf) fthm__frozen_t;;
value freeze : ('lbl,'pat,'inf) t -> ('lbl,'pat,'inf) frozen_t;;
value unfreeze : ('lbl,'pat,'inf) frozen_t -> ('lbl,'pat,'inf) t -> unit;;

value app : (('pat * 'inf) -> 'c) -> ('lbl,'pat,'inf) t -> unit;;

(* $Id: fhdn.mli,v 1.2 1996/02/12 15:06:56 cpaulin Exp $ *)
