(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               nbtermdn.mli                               *)
(****************************************************************************)
#open "generic";;
#open "term";;
#open "more_util";;

type 'na args =
    {name_ord : 'na -> 'na -> int};;

type ('na,'a) t;;
type ('na,'a) frozen_t;;

value new : 'na args -> ('na,'a) t;;

value add : ('na,'a) t -> ('na * (constr * 'a)) -> unit;;
value rmv : ('na,'a) t -> 'na -> unit;;
value in_dn : ('na,'a) t -> 'na -> bool;;
value remap : ('na,'a) t -> 'na -> (constr * 'a) -> unit;;

value lookup : ('na,'a) t -> constr -> (constr * 'a) list;;
value app : (('na * (constr * 'a)) -> 'c) -> ('na,'a) t -> unit;;

value dnet_depth : int ref;;

value freeze : ('na,'a) t -> ('na,'a) frozen_t;;
value unfreeze : ('na,'a) frozen_t -> ('na,'a) t -> unit;;
value empty : ('na,'a) t -> unit;;


(* $Id: nbtermdn.mli,v 1.2 1996/02/12 15:06:59 cpaulin Exp $ *)
