(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               sopattern.ml                               *)
(****************************************************************************)
#open "std";;
#open "more_util";;
#open "pp";;
#open "stdpp";;
#open "initial";;
#open "names";;
#open "generic";;
#open "term";;
#open "reduction";;
#open "lexer";;
#open "vkey";;
#open "parsing";;
#open "termenv";;
#open "proof";;
#open "trad";;
#open "stock";;

type marked_term == constr stock__stocked;;

let rec whd_replmeta = function
    DOP0(XTRA("ISEVAR",[])) -> DOP0(Meta (newMETA()))
  | DOP2(Cast,c,_) -> whd_replmeta c
  | c -> c
;;

let raw_sopattern_of_compattern sign com =
let c = raw_constr_of_compattern mt_evc (GLOB sign) com in
    strong whd_replmeta c
;;

let parse_pattern s =
  let parser = function [< command r; end_of_stream _ >] -> r in
  let com = try with_tokens vernac_keywords parser s
            with Parse_failure -> error "Malformed pattern" in
  let c = raw_sopattern_of_compattern (initial_sign()) com
  in c
;;

let (pattern_stock : constr stock__stock) =
    stock__make_stock {name="PATTERN";proc=parse_pattern};;

let make_module_marker = stock__make_module_marker pattern_stock;;
let put_pat = stock__stock pattern_stock;;
let get_pat = stock__retrieve pattern_stock;;

(* $Id: sopattern.ml,v 1.2 1996/02/12 15:49:20 cpaulin Exp $ *)
