(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               tactics1.mli                               *)
(****************************************************************************)
#open "std";;
#open "more_util";;
#open "term";;
#open "tacmach";;
#open "names";;
#open "proof";;
#open "pattern";;

value error_first_n : int -> 'a list -> 'a list;;
value error_lookup_sign : identifier -> 'a signature -> identifier * 'a;;

type clause == identifier option;;

value THEN_i1 : tactic -> (int -> tactic) -> tactic;;
value nth_clause : int -> goal sigma -> clause;;
value clause_type : clause -> goal sigma -> constr;;
value h : clause -> goal sigma -> constr;;

value matches : goal sigma -> constr -> marked_term -> bool;;
value dest_match : goal sigma -> constr -> marked_term -> constr list;;

value somatches : constr -> sopattern__marked_term -> bool;;
value dest_somatch : constr -> sopattern__marked_term -> constr list;;
value soinstance : sopattern__marked_term -> constr list -> constr;;

value OnCL : (goal sigma -> clause list) -> (clause list -> tactic) -> tactic;;
value TryClauses : (clause -> tactic) -> clause list -> tactic;;
value OnClauses : (clause -> tactic) -> clause list -> tactic;;

value AllHyps : goal sigma -> clause list;;
value LastHyp : goal sigma -> clause  list;;
value NLastHyps : int -> goal sigma -> clause list;;
value AllClauses : goal sigma -> clause list;;

value ApplyToAHyp : (clause -> tactic) -> tactic;;
value TryAllClauses : (clause -> tactic) -> tactic;;
value OnAllClauses : (clause -> tactic) -> tactic;;
value OnClause : (clause -> tactic) -> clause -> tactic;;
value OnAllClausesLR : (clause -> tactic) -> tactic;;
value OnLastHyp : (clause -> tactic) -> tactic;;
value OnNthLastHyp : int -> (clause -> tactic) -> tactic;;
value OnNLastHyps : int -> (clause -> tactic) -> tactic;;
value ClauseTacThen : (clause -> tactic) -> tactic -> clause -> tactic;;
value If : (goal sigma -> bool) -> tactic -> (tactic) -> tactic;;
value IfOnClause : (clause * constr -> bool) -> (clause -> tactic) -> (clause -> tactic) -> clause -> tactic;;

value RepeatFor : int -> tactic -> tactic;;

value OnL : ('a -> tactic) -> 'a list -> tactic;;
value TryL : ('a -> tactic) -> 'a list -> tactic;;

(* $Id: tactics1.mli,v 1.2 1996/02/12 15:07:09 cpaulin Exp $ *)
