(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               tactics2.mli                               *)
(****************************************************************************)
#open "std";;
#open "more_util";;
#open "term";;
#open "tacmach";;
#open "names";;
#open "proof";;
#open "pattern";;
#open "tactics1";;
#open "clenv";;

value Unfolds : identifier list -> clause -> tactic;;
value mmk : module_mark;;
value Intro : tactic;;
value IntroUsing : identifier -> tactic;;
value IntroReplacing : identifier -> tactic;;
value IntroErasing : identifier -> tactic;;
value ImpIntro : tactic;;
value Exact : constr -> tactic;;
value ExactClause : clause -> tactic;;
value False_term : marked_term;;
value Absurdity : identifier -> tactic;;
value and_pattern : marked_term;;
value prod_pattern : marked_term;;
value AndIntro : tactic;;
value sumbool_pattern : marked_term;;
value sumor_pattern : marked_term;;
value or_pattern : marked_term;;
value sum_pattern : marked_term;;
value IRight : tactic;;
value ILeft : tactic;;
value Cut : constr -> tactic;;
value CutReplacing : identifier -> constr -> tactic;;
value ParallelCut : constr list -> tactic;;
value is_and_term : goal sigma -> constr -> bool;;
value is_or_term : goal sigma -> constr -> bool;;
value is_imp_term : constr -> bool;;
value AndE : identifier -> tactic;;
value DAnd : clause -> tactic;;
value OrE : identifier -> tactic;;
value DOr : int -> clause -> tactic;;
value ImpE : identifier -> tactic;;
value DImp : clause -> tactic;;
value BringHyps : clause list -> tactic;;
value ThinClauses : clause list -> tactic;;
value ThinClause : clause -> tactic;;
value IntrosThinning : bool list -> tactic;;
value ChangeClause : constr -> clause -> tactic;;

value res_pf_THEN : (walking_constraints -> tactic) -> walking_constraints clausenv -> (walking_constraints clausenv -> tactic) -> tactic;;
value res_pf_THEN_i : (walking_constraints -> tactic) -> walking_constraints clausenv -> (walking_constraints clausenv -> int -> tactic) -> int -> tactic;;
value elim_res_pf_THEN_i : (walking_constraints -> tactic) -> walking_constraints clausenv -> (walking_constraints clausenv -> int -> tactic) -> int -> tactic;;
value HnfClause : clause -> tactic;;
value mk_clenv_using : walking_constraints -> constr -> walking_constraints clausenv;;
value ApplyUsing : constr -> goal sigma -> goal list sigma * (proof list -> proof);;
value clenv_apply_n_times : int -> walking_constraints clausenv -> walking_constraints clausenv;;

(* $Id: tactics2.mli,v 1.2 1996/02/12 15:07:11 cpaulin Exp $ *)
