(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                termdn.mli                                *)
(****************************************************************************)
#open "generic";;
#open "term";;
#open "more_util";;

type lbl =
    TERM of constr
  | DOPER of sorts oper
  | DLAMBDA
;;

type 'a t == (lbl,constr,'a) dn__t;;

value new : unit -> 'a t;;

value add : 'a t -> (constr * 'a) -> 'a t;;
value rmv : 'a t -> (constr * 'a) -> 'a t;;

value lookup : 'a t -> constr -> (constr * 'a) list;;
value app : ((constr * 'a) -> 'c) -> 'a t -> unit;;

value constr_pat_discr : constr -> (lbl * constr list) option;;
value constr_val_discr : constr -> (lbl * constr list) option;;

(* $Id: termdn.mli,v 1.2 1996/02/12 15:07:15 cpaulin Exp $ *)
