(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 Cofix.v                                  *)
(****************************************************************************)

Declare ML Module "cofix".

(* Introduce a Cofixpoint giving a name for it *)

Grammar tactic simple_tactic := 
   [ "Cofix" identarg($id) ] ->  [$0 = (Cofix $id)].

Syntax tactic pp_cofix_tactic
   (Cofix $id) 0 "Cofix " <$id:"idboundbycofix":*>.


Grammar tactic cofixdecl := 
   [  identarg($id) ":" comarg($c) cofixdecl($fd) ] 
     -> [$0 = ($CONS (COFIXEXP $id $c) $fd)]
| [] -> [$0 = ($LIST)].

Grammar tactic ne_cofixdecl := 
   [  identarg($id)  ":" comarg($c) cofixdecl($fd) ] 
     -> [$0 = ($CONS (COFIXEXP $id $c) $fd)].


Grammar tactic simple_tactic := 
   [ "Cofix" identarg($id) "with" ne_cofixdecl($fd)] ->   
                  [$0 = ($OPER{MutualCofix} ($CONS $id $fd))].

Syntax tactic mutualcofixtactic ($OPER{MutualCofix} ($CONS $id $fd)) 0 
    "Cofix "  <$id:"idboundbycofix":*>  [1 0] 
    "with" [1 0] <$FD:"mutuals":*>
    with $FD:= ($OPER{COFIXLIST} $fd) .

Syntax tactic ne_cofixdecllist ($OPER{COFIXLIST} ($CONS (COFIXEXP $id $c) $fd)) 0
    <$id:"idboundbycofix":*>  ":" <$c:"arity":*> 
    <$FD:"mutuals":*> with $FD:= ($OPER{COFIXLIST} $fd).

Syntax tactic cofixdeclnil ($OPER{COFIXLIST} ($LIST)) 0.


(* The name of the CoFixpoint is the name of the theorem by default *)

Grammar tactic simple_tactic := 
   [ "Cofix" ] ->  [$0 = (SimpleCofix)].

Syntax tactic pp_simple_cofix_tactic (SimpleCofix) 0 "Cofix".

(* $Id: Cofix.v,v 1.4 1996/02/12 15:55:18 cpaulin Exp $ *)
