(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  Elim.v                                  *)
(****************************************************************************)

Declare ML Module "elim".

Grammar tactic simple_tactic :=
  [ "RepeatAndE" identarg($id) ] -> [$0 = (RepeatAndE $id)]
| [ "RepeatE" "[" ne_identarg_list($l) "]" identarg($id) ]
  -> [$0 = ($OPER{RepeatE} ($CONS $id $l))]
.


Syntax tactic repeat_and_e  (RepeatAndE $id) 0
        "RepeatAndE " <$id:"ident":*>.
Syntax tactic repeat_e ($OPER{RepeatE} ($CONS $id $l)) 0
        "RepeatE " "[" <$L:"IdentList":*> "]" <$id:"ident":*>
        with $L:=($OPER{NEIDENTARGLIST} $l).

(* $Id: Elim.v,v 1.2 1996/02/12 15:55:28 cpaulin Exp $ *)
