(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  Fix.v                                   *)
(****************************************************************************)

Declare ML Module "fix".


(* Introduce a Fixpoint giving a name for it *)

Grammar tactic simple_tactic := 
   [ "Fix" identarg($id) "/" numarg($n)] ->   [$0 = (Fix $id $n)].

Syntax tactic fixtactic (Fix $id ($PRIM $n)) 0 
    "Fix "  <$id:"idboundbyfix":*> "/" <$n:"whicharg":*>.

Grammar tactic fixdecl := 
   [  identarg($id) "/" numarg($n) ":" comarg($c) fixdecl($fd) ] 
     -> [$0 = ($CONS (FIXEXP $id $n $c) $fd)]
| [] -> [$0 = ($LIST)].

Grammar tactic ne_fixdecl := 
   [  identarg($id) "/" numarg($n) ":" comarg($c) fixdecl($fd) ] 
     -> [$0 = ($CONS (FIXEXP $id $n $c) $fd)].


Grammar tactic simple_tactic := 
   [ "Fix" identarg($id) "/" numarg($n) "with" ne_fixdecl($fd)] ->   
                  [$0 = ($OPER{MutualFix} ($CONS $id ($CONS $n $fd)))].

Syntax tactic mutualfixtactic ($OPER{MutualFix} ($CONS $id ($CONS ($PRIM $n) $fd))) 0 
    "Fix "  <$id:"idboundbyfix":*> "/" <$n:"whicharg":*> [1 0] 
    "with" [1 0] <$FD:"mutuals":*>
    with $FD:= ($OPER{FIXLIST} $fd) .

Syntax tactic ne_fixdecllist ($OPER{FIXLIST} ($CONS (FIXEXP $id ($PRIM $n) $c) $fd)) 0
    <$id:"idboundbyfix":*> "/" <$n:"whicharg":*> ":" <$c:"arity":*> 
    <$FD:"mutuals":*> with $FD:= ($OPER{FIXLIST} $fd) .

Syntax tactic fixdeclnil ($OPER{FIXLIST} ($LIST)) 0.


(* The name of the Fixpoint is the name of the theorem by default *)


Grammar tactic simple_tactic := 
   [ "Fix"  numarg($n)] ->   [$0 = (SimpleFix  $n)].

Syntax tactic simplefixtactic (SimpleFix ($PRIM $n)) 0   "Fix "  <$n:"whicharg":*>.

(* $Id: Fix.v,v 1.7 1996/02/12 15:55:31 cpaulin Exp $ *)
