(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 GElim.v                                  *)
(****************************************************************************)

Require Export Equality.

Declare ML Module "gelim".

Grammar tactic simple_tactic :=
  [ "CompGElim" identarg($id) ] -> [$0 = (GElim $id)]

| [ "CompGElim" identarg($id) "in" ne_identarg_list($l) ]
  -> [$0 = ($OPER{GElimIn} ($CONS $id $l))]

| [ "HalfGElim" identarg($id) ] -> [$0 = (HalfGElim $id)]
.




Syntax tactic  GElim (GElim $id)  0
        "CompGElim" [1 0]  <$id:"ident":*>.

Syntax tactic GElimin ($OPER{GElimIn} ($CONS $id $l)) 0
   "CompGElim" [1 0] <$id:"ident":*> [1 0] "in" [1 0] <$L:"idlist":*>
     with $L:=($OPER{NEIDENTARGLIST} $l).

Syntax tactic halfGElim (HalfGElim $id)   0
   "HalfGElim" [1 0] <$id:"ident":*>.

Syntax tactic useGElimlema (UseGElimersionLemma $id $c) 0
    "GElim" [1 0] <$id:"ident":*> [1 0] <$c:"comarg":*>.

Syntax tactic useGElimlemain ($OPER{UseGElimersionLemmaIn} ($CONS $id ($CONS $c $l)))   0
     "GElim" [1 0] <$id:"ident":*> [1 0] <$c:"comarg":*> [1 0] "in" [1 0] <$L:"idlist":*>
     with $L:=($OPER{NEIDENTARGLIST} $l).  


Syntax vernac makeGElimlemmafromhyp_n (MakeGElimersionLemmaFromHyp ($PRIM $n) $na $id)   0
        "MakeGElim " <$n:"numarg":*> [1 0] <$na:"ident":*> [1 0]  <$id:"ident":*>.
Syntax vernac makeGElimlemmafromhyp_1 (MakeGElimersionLemmaFromHyp {1} $na $id)   0
        "MakeGElim " <$na:"ident":*> [1 0]  <$id:"ident":*>.

Syntax vernac makeGElimlemma (MakeGElimersionLemma $na $com)   0
        "MakeGElim " <$na:"ident":*> [1 0] "with" [1 0] <$com:"comarg":*>.







(* $Id: GElim.v,v 1.2 1996/02/12 15:55:34 cpaulin Exp $ *)
