(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 Macros.v                                 *)
(****************************************************************************)

Declare ML Module "macros".

Grammar tactic simple_tactic :=
  [ "Call" identarg($na) "[" comarg_list($l) "]" ] ->
	[$0 = ($OPER{CallMacro} ($CONS $na $l))]
| [ "Call" identarg($na) ] ->
	[$0 = (CallMacro $na)]
.

Grammar vernac vernac :=
  [ "Tactic" "Definition" identarg($id) "[" ne_identarg_list($ids) "]"
    ":=" spatarg($tac) "." ]
  -> [$0 = ($OPER{TacticDefinition} ($CONS $id ($CONS $tac $ids)))]
| [ "Tactic" "Definition" identarg($id)
    ":=" spatarg($tac) "." ]
  -> [$0 = (TacticDefinition $id $tac)]
.


Syntax tactic callmacro_list ($OPER{CallMacro} ($CONS $na $l)) 0
        "Call " <$na:"ident":*> "[" <$L:"comarglist":*> "]"
        with $L:= ($OPER{COMARGLIST} $l).

Syntax tactic callmacro_list (CallMacro $na) 0
         "Call " <$na:"ident":*>.


Syntax vernac tacdef_list ($OPER{TacticDefinition} ($CONS $id ($CONS $tac $ids))) 0
  "Tactic Definition " <$id:"ident":*> "[" <$IDS:"identlist":*> "]"
    ":=" <$tac:"spatarg":*>
   with $IDS:=($OPER{NEIDENTARGLIST} $ids).

Syntax vernac tacdef (TacticDefinition $id $tac) 0
   "Tactic Definition " <$id:"ident":*> [1 0] ":=" [1 0] <$tac:"spatarg":*>  .

(* $Id: Macros.v,v 1.2 1996/02/12 15:55:37 cpaulin Exp $ *)
