(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 Mimick.v                                 *)
(****************************************************************************)

Declare ML Module "mimick".

Grammar vernac vernac :=
  [ "Write" "Mimick" prim:string($s) "." ]
  -> [$0 = (WriteMimick ($PRIM $s))]
| [ "Show" "Mimick" "." ]
  -> [$0 = (ShowMimick)]
.

Grammar tactic simple_tactic :=
  [ "Mimick" prim:string($s) ] -> [$0 = (Mimick ($PRIM $s))]

| [ "Tactic" "Mimick" prim:string($s) ] -> [$0 = (TacticMimick ($PRIM $s))]

| [ "Mimick" ] -> [$0 = (DumpMimick)]

| [ "Tactic" "Mimick" ] -> [$0 = (DumpTacticMimick)]

| [ "Mimick" identarg($id) ] -> [$0 = (DumpMimickWith $id)]

| [ "Tactic" "Mimick" identarg($id) ] -> [$0 = (DumpTacticMimickWith $id)]
.


Syntax vernac writemimick (WriteMimick ($PRIM $s)) 0
        "Write Mimick " <$s:"string":*>.

Syntax vernac showmimick (ShowMimick) 0
        "Show Mimick".

Syntax tactic mimick (Mimick ($PRIM $s)) 0
        "Mimick " <$s:"string":*>.


(* $Id: Mimick.v,v 1.2 1996/02/12 15:55:39 cpaulin Exp $ *)
