(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 ProPre.v                                 *)
(****************************************************************************)

(* Grammaire de ProPre : "Recursive Definition" *)

Declare ML Module "propre".


Token "=>".
Grammar vernac eqs_def1 :=
  [ ] -> [$0 = ($LIST)]
| [ "|" command:ne_command_list($ts) "=>" command:command($u) eqs_def1($es) ]
  -> [$0 = ($CONS ($OPER{COMMANDLIST} ($CONS $u $ts)) $es)]
.

Grammar vernac eqs_def :=
 [command:ne_command_list($ts) "=>" command:command($u) eqs_def1($es)]
 -> [$0 = ($CONS ($OPER{COMMANDLIST} ($CONS $u $ts)) $es)]
.

Grammar vernac vernac :=
 [ "Recursive"  "Definition" 
   identarg($id_f) indpar($prms_f) ":" comarg($type_f) " := "
   eqs_def($eqs_f) "." ]
 -> [$0 = ($OPER{RecursiveDefinition} ($CONS $id_f ($CONS $prms_f ($CONS $type_f $eqs_f))))]
.

Syntax vernac ch_uni_necommnadlist_nil ($OPER{CH_UNI_NECOMMANDLIST} ($LIST)) 0.
Syntax vernac ch_uni_necommnadlist_cons 
   ($OPER{CH_UNI_NECOMMANDLIST} ($CONS $c $l))  0
     <$C:"Command":*> [1 0] <$L:"Necommandlist":*> 
      with $C:=(COMMAND $c)
           $L:=($OPER{CH_UNI_NECOMMANDLIST} $l).
        

Syntax vernac eqdef1_nil ($OPER{EQDEF1}  ($LIST)) 0.
Syntax vernac eqdef1_cons 
  ($OPER{EQDEF1} ($CONS ($OPER{COMMANDLIST} ($CONS $u $ts)) $es)) 0
   [<v 0> [<hov 0> "| " <$TS:"Neommandlist":*> [1 0] 
                        "=>"[1 0] <$U:"Command":*>] FNL <$ES:"Eqsdef1":*> ]
   with $TS:=($OPER{CH_UNI_NECOMMANDLIST} $ts)
        $ES:=($OPER{EQDEF1} $es)
        $U:=(COMMAND $u).

Syntax vernac eqs_def 
 ($OPER{EQSDEF} ($CONS ($OPER{COMMANDLIST} ($CONS $u $ts)) $es)) 0
    [<v 0>  [<hov 0> [2 0] <$TS:"Neommandlist":*> [1 0] "=>" [1 0] <$U:"Command":*>] FNL
             <$ES:"Eqsdef1":*> ]
    with $TS:=($OPER{CH_UNI_NECOMMANDLIST} $ts)
         $ES:=($OPER{EQDEF1} $es)
         $U:=(COMMAND $u).


Syntax vernac recursivedef 
 ($OPER{RecursiveDefinition} ($CONS $id_f ($CONS $prms_f ($CONS $type_f $eqs_f)))) 0
   [<v 0> [<hov 0> "Recursive Definition " <$id_f:"ident":*> [1 0] 
              <$INDP:"indpar":*> " : " <$type_f:"comarg":*> ] " := "FNL
                    <$EQSF:"eqs_f":*> "."]
    with $EQSF:=($OPER{EQSDEF} $eqs_f)
         $INDP := (INDPAR $prms_f).
    





(* $Id: ProPre.v,v 1.3 1996/02/12 15:55:43 cpaulin Exp $ *)
