(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 Prolog.v                                 *)
(****************************************************************************)

Declare ML Module "prolog".

Grammar tactic simple_tactic :=
  [ "EApply" comarg_binding_list($cl) ] 
                          -> [$0 = ($OPER{EApplyWithBindings} $cl)]

| [ "EExact" comarg($c) ] -> [$0 = (EExact $c)]

(*
| [ "EApply" comarg($c) "with" comarg($c1) ":=" comarg($c2) binding_list($bl) ] ->
	case $c1 of
	(COMMAND ($VAR $id)) ->
[$0 = ($OPER{EApplyWithName} ($CONS $c ($CONS (BINDING ($VAR $id) $c2) $bl)))]
	esac

| [ "EApply" comarg($c) "with" comarg($c1) comarg_list($cl) ] ->
	[$0 = ($OPER{EApplyWith} ($CONS $c ($CONS $c1 $cl)))]

| [ "EApply" comarg($c) "with" numarg($n) ":=" comarg($c2) binding_list($bl) ] ->
	[$0 = ($OPER{EApplyWithName} ($CONS $c ($CONS (BINDING $n $c2) $bl)))]
*)

| [ "Prolog" "[" comarg_list($l) "]" numarg($n) ] ->
	[$0 = ($OPER{Prolog} ($CONS $n $l))]

| [ "Instantiate" numarg($n) comarg($c) ] ->
	[$0 = (Instantiate $n $c)]

| [ "NormEvars" ] -> [$0 = (NormEvars)]
.



Syntax tactic eapply (EApply $c) 0
        "EApply " <$c:"comarg":*>.

Syntax tactic eexact (EExact $c) 0
        "EExact " <$c:"comarg":*>.

Syntax tactic applywithname
   ($OPER{EApplyWithName} ($CONS $c ($CONS (BINDING $id $c2) $bl)))  0
      [<hov 0>  "EApply " <$c:"Comarg":*>  [1 0] "with" [1 0] 
         <$id:"Comarg":*> [1 0]  ":=" [1 0] <$c2:"comarg":*> [1 0]
         <$BL:"binding_list":*>]
      with $BL:=($OPER{BINDINGLIST} $bl).


Syntax tactic eapplywith ($OPER{EApplyWith} ($CONS $c ($CONS $c1 $cl)))  0
       [<hov 0> "EApply " <$c:"Comarg":*> [1 0] "with" [1 0] <$c1:"Comarg":*>
                 [1 0] <$CL:"ComargList":*>]
        with $CL:=($OPER{COMARGLIST} $cl).

Syntax tactic  applywithnamelist
  ($OPER{EApplyWithName} ($CONS $c ($CONS (BINDING ($PRIM $n (SOME{INT})) $c2) $bl))) 0
    [<hov 0> "EApply " <$c:"Comarg":*> [1 0] "with" [1 0] 
       <$n:"Numarg":*> ":="  <$c2:"Comarg":*> [1 0] <$BL:"binding_list":*>]
    with $BL:=($OPER{BINDINGLIST} $bl).  
        
Syntax tactic prolog ($OPER{Prolog} ($CONS ($PRIM $n) $l))  0
       [<hov 0> "Prolog" [1 0] "[" [1 0]  <$L:"ComargList":*> "]" [1 0] <$n:"numarg":*>]
        with $L:=($OPER{COMARGLIST} $l).

Syntax tactic instantiate (Instantiate ($PRIM $n) $c)  0
        "Instantiate " <$n:"numarg":*> [1 0] <$c:"Comarg":*>.

Syntax tactic normevars (NormEvars)  0
        "NormEvars".










(* $Id: Prolog.v,v 1.3 1996/02/12 15:55:46 cpaulin Exp $ *)
