(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 Record.v                                 *)
(****************************************************************************)

Declare ML Module "record".

Grammar vernac ne_fields :=
  [ idcom($idc) ";" ne_fields($fs) ] -> [ $0 = ($CONS $idc $fs) ]
|                   [ idcom($idc) ] -> [ $0 = ($LIST $idc) ].

Grammar vernac fields := 
  [ ne_fields($fs) ] -> [ $0 = ($OPER{BINDERLIST}$fs) ]
|                 [] -> [ $0 = (BINDERLIST)].

Grammar command S := [ "Prop" ] -> [$0 = (PROP {Null})]
                   | [ "Set" ] -> [$0 = (PROP {Pos})]
                   | [ "Data" ]  -> [$0 = (PROP {Pos})]
                   | [ "Type" ] -> [$0 = (TYPE {Null})]
                   | [ "Typeset" ] -> [$0 = (TYPE {Pos})].

Grammar vernac vernac := [ "Record" identarg($name) indpar($ps) ":" 
                           command:S($s) ":=" "{" fields($fs) "}" "." ] ->
                         [ $0 = (RECORD $name $ps (COMMAND $s) $fs)].

Grammar vernac vernac := [ "Record" identarg($name) indpar($ps) ":" 
                           command:S($s) ":=" identarg($c) "{" fields($fs) "}" "." ] ->
                         [ $0 = (RECORD1 $name $ps (COMMAND $s) $c $fs)].

Syntax vernac fields_cons 
        ($OPER{Fields} ($CONS $bind $lb)) 0
        <$bind:"Binder":*> ";" FNL <$TAIL:"ListBind":*>
        with $TAIL := ($OPER{Fields} $lb).

Syntax vernac ne_fields_one ($OPER{Fields} ($LIST $bind)) 0
        <$bind:"Binder":*>.

Syntax vernac ne_fields_zero ($OPER{Fields} ($LIST)) 0.

Syntax vernac record (RECORD $id $ps (COMMAND $s) ($OPER {BINDERLIST} $fields)) 0
   FNL "Record "  <$id:"Name":*> " " <$IP:"IndParam":*>
    " : " <$s:"Command":*>  " := " "{" FNL  <$FIELDS:"Command":*> " }" "." FNL
    with  $IP:=(INDPAR $ps)
          $FIELDS:=($OPER{Fields} $fields).

Syntax vernac record1 (RECORD1 $id $ps (COMMAND $s) $c ($OPER {BINDERLIST} $fields)) 0
   FNL "Record "  <$id:"Name":*> " " <$IP:"IndParam":*>
    " : " <$s:"Command":*>  " := " <$c:"Command":*> " {" FNL
<$FIELDS:"Command":*> " }" "." FNL
    with  $IP:=(INDPAR $ps)
          $FIELDS:=($OPER{Fields} $fields).


(* $Id: Record.v,v 1.3 1996/02/12 15:55:48 cpaulin Exp $ *)
