(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 unif.mli                                 *)
(****************************************************************************)

#open "general";;
#open "dpctypes";;

exception Not_unifiable;;

value unif_atoms : atom_id * term list -> atom_id * term list 
                   -> (term * term) list;;
value unif_terms : term -> term -> (term * term) list;;

value assoc_unif : 'a -> ('a * 'a) list -> 'a;;
value apply_unif : (term * term) list -> term -> term;;
value appear_var_term : term -> term -> bool;;

exception Up_error;;

value up : (term * term) list -> (term * term) list -> (term * term) list;;


(* $Id: unif.mli,v 1.2 1996/02/12 17:37:39 cpaulin Exp $ *)
