(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 dind.ml                                  *)
(****************************************************************************)
#infix "o";;
#open "std";;
#open "more_util";;
#open "initial";;
#open "names";;
#open "vectops";;
#open "generic";;
#open "term";;
#open "reduction";;
#open "himsg";;
#open "mach";;
#open "proof";;
#open "proof_trees";;
#open "trad";;
#open "tacmach";;
#open "tactics";;
#open "pp";;
#open "stdpp";;
#open "clenv";;
#open "termenv";;
#open "tactics";;
#open "vernacinterp";;
#open "sopattern";;
#open "tactics1";;
#open "termast";;
#open "ast";;
#open "tactics0";;
#open "tactics1";;
#open "tactics2";;
#open "tactics3";;
#open "equality";;

#open "tactics0";;
#open "tactics1";;
#open "tactics2";;
#open "tactics3";;
#open "equality";;
#open "inv";;

#infix "ORELSE";;
#infix "NEXT";;
#infix "THEN";;
#infix "THENF";;
#infix "THENL";;
#infix "THENS";;

#infix "THEN_i1";;

let rec number_of_nodep_references i cl =
  match whd_castapp cl with
    DOP2(Prod,_,DLAM(_,B)) ->
      match (i=1,dependent (Rel 1) B) with
      (true,false) -> 1
    | (true,true) ->  1 + (number_of_nodep_references 1 B)
    | (false,false) -> 1 + (number_of_nodep_references (i-1) B)
    | (false,true) ->  1 + (number_of_nodep_references i B)
;;

let mmk = make_module_marker [];;
let Prop_term = put_pat mmk "Prop";;

let induction_trailer abs_i abs_j bargs =
  (RepeatFor (abs_j - abs_i) Intro) THEN
  (OnLastHyp
  (fun (SOME id) gls ->
   let idty = pf_type_of gls (VAR id) in
   let fvty = global_vars idty in
   let sign_ids = ids_of_sign(pf_hyps gls) in

   let ids =
   it_list
   (fun oids cid ->
    let cidty = (pf_type_of gls (VAR cid)) in
    if eq_constr (get_pat Prop_term,pf_type_of gls cidty)
         & []<>listset__intersect (global_vars cidty) fvty then
     cid::oids
        else oids)
   [] sign_ids in

   InvIn id ids gls))
;;


let DInd i j gls =
let cl = pf_concl gls in
let abs_i = number_of_nodep_references i cl and
    abs_j = number_of_nodep_references j cl in

    ((RepeatFor abs_i Intro) THEN
    (OnLastHyp
    (fun (SOME id) ->
         elimination_then
         (IntroElimAssumsThen (induction_trailer abs_i abs_j))
         ([],[]) (VAR id)))) gls
;;

let DInd_tac =
let gentac = register_tactic "DInd"
    (fun [INTEGER i; INTEGER j] -> DInd i j)
    (fun sigma goal (_,[INTEGER i; INTEGER j]) ->
         [< 'S"DInd " ; 'INT i ; 'SPC ; 'INT j >])
in fun i j -> gentac [INTEGER i;INTEGER j]
;;

(* $Id: dind.ml,v 1.2 1996/02/12 15:56:02 cpaulin Exp $ *)
