(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                double.ml                                 *)
(****************************************************************************)
#infix "o";;
#open "std";;
#open "more_util";;
#open "initial";;
#open "names";;
#open "vectops";;
#open "generic";;
#open "term";;
#open "reduction";;
#open "himsg";;
#open "mach";;
#open "proof";;
#open "proof_trees";;
#open "trad";;
#open "tacmach";;
#open "tactics";;
#open "pp";;
#open "stdpp";;
#open "clenv";;
#open "termenv";;
#open "tactics";;
#open "vernacinterp";;
#open "sopattern";;
#open "tactics1";;
#open "termast";;
#open "ast";;
#open "tactics0";;
#open "tactics1";;
#open "tactics2";;
#open "tactics3";;
#open "equality";;

#open "tactics0";;
#open "tactics1";;
#open "tactics2";;
#open "tactics3";;
#open "equality";;
#open "inv";;

#infix "ORELSE";;
#infix "NEXT";;
#infix "THEN";;
#infix "THENF";;
#infix "THENL";;
#infix "THENS";;

#infix "THEN_i1";;

(* Double induction tactic *)


let rec number_of_nodep_references i cl =
  match whd_castapp cl with
    DOP2(Prod,_,DLAM(_,B)) ->
      match (i=1,dependent (Rel 1) B) with
      (true,false) -> 1
    | (true,true) ->  1 + (number_of_nodep_references 1 B)
    | (false,false) -> 1 + (number_of_nodep_references (i-1) B)
    | (false,true) ->  1 + (number_of_nodep_references i B)
;;

let mmk = make_module_marker [];;
let Prop_term = put_pat mmk "Prop";;

let simple_elimination c gls =
    simple_elimination_then (fun _ -> IDTAC) c gls;;

let induction_trailer abs_i abs_j bargs =
  (RepeatFor (abs_j - abs_i) Intro) THEN
  (OnLastHyp
  (fun (SOME id) gls ->
   let idty = pf_type_of gls (VAR id) in
   let fvty = global_vars idty in
   let possible_bring_ids =
	(cdr (map outSOME (NLastHyps (abs_j - abs_i) gls)))
	@bargs.assums in

   let (ids,_) =
   it_list
   (fun (bring_ids,leave_ids) cid ->
    let cidty = pf_type_of gls (VAR cid) in
    if not (listset__memb leave_ids cid) then
      (cid::bring_ids,leave_ids)
    else (bring_ids,cid::leave_ids))
    ([],fvty) possible_bring_ids in

    (BringHyps (map inSOME ids) THEN
     ThinClauses (rev (map inSOME ids)) THEN
     simple_elimination (VAR id)) gls))
;;


let Double abs_i abs_j gls =
let cl = pf_concl gls in

    ((RepeatFor abs_i Intro) THEN
    (OnLastHyp
    (fun (SOME id) ->
         elimination_then
         (IntroElimAssumsThen (induction_trailer abs_i abs_j))
         ([],[]) (VAR id)))) gls
;;

let Double_tac =
let gentac = register_tactic "Double"
    (fun [INTEGER i; INTEGER j] -> Double i j)
    (fun sigma goal (_,[INTEGER i; INTEGER j]) ->
         [< 'S"Double " ; 'INT i ; 'SPC ; 'INT j >])
in fun i j -> gentac [INTEGER i;INTEGER j]
;;

(* $Id: double.ml,v 1.2 1996/02/12 15:56:04 cpaulin Exp $ *)
