(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               equality.mli                               *)
(****************************************************************************)
#open "std";;
#open "more_util";;
#open "term";;
#open "tacmach";;
#open "names";;
#open "proof";;
#open "tactics1";;
#open "sopattern";;


value Discr : identifier -> tactic;;
value DiscrClause : clause -> tactic;;
value DiscrConcl : tactic;;
value DiscrHyp : identifier -> tactic;;
value DiscrConcl_tac : tactic;;
value DiscrHyp_tac : identifier -> tactic;;
value Inj : identifier -> tactic;;

value DEq : clause -> tactic;;
value DEqThen : (int -> tactic) -> clause -> tactic;;

value make_iterated_tuple : readable_constraints -> constr assumptions -> (constr * constr) -> (constr * constr) -> (constr * constr * constr);;


value Subst : constr -> clause -> tactic;;
value HypSubst : identifier -> clause -> tactic;;
value RevSubst : constr -> clause -> tactic;;
value RevHypSubst : identifier -> clause -> tactic;;

value discriminable : readable_constraints -> constr signature -> 
  constr -> constr -> bool;;

(* $Id: equality.mli,v 1.6 1996/02/12 15:56:10 cpaulin Exp $ *)
