#open "std";;
#open "pp";;
#open "stdpp";;
#open "names";;
#open "refiner";;
#open "tacmach";;
#open "proof_trees";;
#open "tactics";;
#infix "THEN";;
#infix "THENS";;
#open "pfedit";;
#open "names";;
#open "more_util";;


let fix f n  =  ((refiner (PRIM{name="FIX";newids=[f];
                                hypspecs=[];terms=[];params=[ast__TOKnum n]}))
                 THEN
                 (DO n intro))
                ;;

let mutual_fix_intros lf ln lcom gl =  
   let trad = pf_constr_of_com gl in 
   let lar = map trad lcom 
   and lna = map (fun n -> ast__TOKnum n) ln in
   ((refiner (PRIM{name="FIX";newids=lf;
                                hypspecs=[];terms=lar;params=lna}))
                 THENS
                 (map (fun n->(DO n intro)) ln)) gl
                ;;


let fix_tac = 
    register_tactic "Fix" 
    (fun [IDENTIFIER id;INTEGER n] -> fix id n)
    (fun _ _ (_,[IDENTIFIER id; INTEGER n]) ->
	  [< 'S"Fix" ; 'SPC ; print_id id; 'S"/"; 'INT n >])
;;


let mutual_fix_tac = 
    register_tactic "MutualFix" 
    (fun ((IDENTIFIER id)::(INTEGER n)::lfix) -> 
    let rec decomp lid ln lar = 
   function (FIXEXP (id,n,ar)::rest) 
        -> decomp (id::lid) (n::ln) (ar::lar) rest
          | [] -> (rev lid,rev ln,rev lar) 
   in let (lid,ln,lar) = decomp [] [] [] lfix
   in mutual_fix_intros (id::lid) (n::ln) lar)
    (fun sigma goal (_,(IDENTIFIER id):: (INTEGER n)::lfd) ->
	  [< 'S"Fix" ; 'SPC ; print_id id; 'S"/"; 'INT n ; 'FNL;
          'S"with"; 'SPC ; 
     prlist_with_sep (fun () -> [<'SPC>])
      (function FIXEXP(f,n,c) -> 
      (HOV 0 [< print_id f; 'S"/"; 'INT n ;'S":"; pr_com sigma goal c >]))
       lfd >])
;;

   
let simple_fix_tac = 
    register_tactic "SimpleFix" 
    (fun [INTEGER n] -> 
                       let l = pfedit__list_proofs() in
                       let id = id_of_string (hd l) 
                       in fix id n)
    (fun _ _ (_,[INTEGER n]) ->
	  [< 'S"Fix" ; 'SPC ; 'INT n >])
;;


(* $Id: fix.ml,v 1.3 1996/02/12 15:56:12 cpaulin Exp $ *)
