(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                mimick.mli                                *)
(****************************************************************************)
#infix "o";;
#open "std";;
#open "more_util";;
#open "reintern0";;
#open "reintern1";;
#open "names";;
#open "generic";;
#open "generic";;
#open "term";;
#open "proof_constraints";;
#open "proof_trees";;
#open "proof";;
#open "tacmach";;
#open "pfedit";;

value ri_proof : local_constraints proofty -> local_constraints proofty;;
value inProof : string -> proof;;
value outProof : string -> proof -> unit;;

value SaveProof : string -> unit;;
value ReadProof : string -> proof;;
value AssociateProof : proof -> tactic;;
value EraseProof : tactic;;
value eq_goal : goal -> goal -> bool;;
value Mimick : proof -> tactic;;

type ttactic == proof -> proof list * (proof list -> proof);;

value ElideTactics : string list -> ttactic;;

value show_mimick_script : unit -> unit;;

(* $Id: mimick.mli,v 1.2 1996/02/12 15:56:48 cpaulin Exp $ *)
