(*****************************************************************************)
(*          Projet Formel - Calculus of Inductive Constructions V5.10        *)
(*****************************************************************************)
(*									     *)
(*                   Two Left Adjoints of a Functor are Iso                  *)
(*									     *)
(*****************************************************************************)
(*									     *)
(*                     A. SAIBI	  May 95                  		     *)
(*									     *)
(*****************************************************************************)

Require Export Adjunction1.

Section ladj_iso_def.

Variable C, D      : Category.
Variable G         : (Functor C D).
Variable la, la'   : (LeftAdj G).

Local F := (Adjoint la).

Local ad := (Adj_l la).

Local F' := (Adjoint la').

Local ad' := (Adj_l la').

Local LAdj_unit := [a:(Ob D)](Unit ? ? ? ? ad a). 

Local LAdj_unit' := [a:(Ob D)](Unit ? ? ? ? ad' a). 

Definition LAdj_tau_iso := [a:(Ob D)](UA_iso ? ? a G (LAdj_unit a)
                                             (LAdj_unit' a)).

Definition LAdj_tau := [a:(Ob D)](Iso_mor ? ? ? (LAdj_tau_iso a)).

Lemma LAdj_nt_law : (NT_law F F' LAdj_tau).
Proof.
Unfold nt_law; Intros a b f.
Apply (Prf_trans (Hom (FOb F a) (FOb F' b))) with
  y:=(UA_diese (LAdj_unit a) ? (f o (UA_mor (LAdj_unit' b)))).
Apply (Prf_UA_law2 ? ? ? ? (LAdj_unit a) ? (f o (UA_mor (LAdj_unit' b)))
                   ((FMor F f) o (LAdj_tau b))).
Unfold ua_eq.
Apply (Prf_trans (Hom a (FOb G (FOb F' b)))) with
  y:=((UA_mor (LAdj_unit a)) o (FMor G (FMor F f))) o 
              (FMor G (LAdj_tau b)).
Apply (Prf_trans (Hom a (FOb G (FOb F' b)))) with
  y:=(UA_mor (LAdj_unit a)) o ((FMor G (FMor F f)) o 
              (FMor G (LAdj_tau b))).
Apply (Prf_congl D).
Unfold fMor; Apply (Prf_Fcomp_law ? ? G).
Unfold Comp; Apply (Prf_ass D).
Apply (Prf_trans (Hom a (FOb G (FOb F' b)))) with
  y:=(f o (UA_mor (LAdj_unit b))) o (FMor G (LAdj_tau b)).
Apply (Prf_congr D).
Apply (Prf_sym (Hom a (FOb G (UA_ob (LAdj_unit b))))).
Apply (Prf_NT_law ? ? ? ? (Unit_NT ? ? ? ? ad) a b f).
Apply (Prf_trans (Hom a (FOb G (FOb F' b)))) with
  y:=f o ((UA_mor (LAdj_unit b)) o (FMor G (LAdj_tau b))).
Apply (Prf_sym (Hom a (FOb G (FOb F' b)))).
Unfold Comp; Apply (Prf_ass D).
Apply (Prf_congl D).
Apply (Prf_UA_law1 ? ? ? ? (LAdj_unit b) ? (UA_mor (LAdj_unit' b))).
Apply (Prf_sym (Hom (FOb F a) (FOb F' b))).
Apply (Prf_UA_law2 ? ? ? ? (LAdj_unit a) ? (f o (UA_mor (LAdj_unit' b)))
                   ((LAdj_tau a) o (FMor F' f))).
Unfold ua_eq.
Apply (Prf_trans (Hom a (FOb G (FOb F' b)))) with
  y:=(UA_mor (LAdj_unit a)) o ((FMor G (LAdj_tau a)) o 
     (FMor G (FMor F' f))).
Apply (Prf_congl D).
Unfold fMor; Apply (Prf_Fcomp_law ? ? G).
Apply (Prf_trans (Hom a (FOb G (FOb F' b)))) with
  y:=((UA_mor (LAdj_unit a)) o (FMor G (LAdj_tau a))) o 
     (FMor G (FMor F' f)).
Unfold Comp; Apply (Prf_ass D).
Apply (Prf_trans (Hom a (FOb G (FOb F' b)))) with
  y:=(UA_mor (LAdj_unit' a)) o (FMor G (FMor F' f)).
Apply (Prf_congr D).
Apply (Prf_UA_law1 ? ? ? ? (LAdj_unit a) ? (UA_mor (LAdj_unit' a))).
Apply (Prf_sym (Hom a (FOb G (FOb F' b)))).
Apply (Prf_NT_law ? ? ? ? (Unit_NT ? ? ? ? ad') a b f).
Qed.

Definition LAdj_nt := (Build_NT F F' LAdj_tau LAdj_nt_law).

Lemma LAdj_isIso : (IsNatIso LAdj_nt).
Proof.
Apply (NT_isIso ? ? F F' LAdj_nt).
Intro a; Exact (UA_isIso ? ? a G (LAdj_unit a) (LAdj_unit' a)).
Defined.

Definition LAdj_iso := (Build_iso (CatFunct D C) F F' LAdj_nt LAdj_isIso).
 
End ladj_iso_def.

(* $Id: LeftAdj_Iso.v,v 1.2 1996/02/12 15:22:53 cpaulin Exp $ *)
