(*****************************************************************************)
(*          Projet Formel - Calculus of Inductive Constructions V5.10        *)
(*****************************************************************************)
(*									     *)
(*	                   Full SubCategory                   		     *)
(*									     *)
(*****************************************************************************)
(*									     *)
(*                     A. SAIBI	  May 95                  		     *)
(*									     *)
(*****************************************************************************)

Require Export Category.

Section fscat.

Variable C : Category.
Variable I : Type.
Variable a : I -> (Ob C).

Definition FSC_mor_setoid := [i,j:I](Hom (a i) (a j)).

(* composition *)

Definition Comp_FSC := [i,j,l:I](Op_comp C (a i) (a j) (a l)).

Lemma Assoc_FSC : (assoc_law I FSC_mor_setoid Comp_FSC).
Proof.
Unfold assoc_law; Intros i1 i2 i3 i4 f g h.
Unfold Cat_comp FSC_mor_setoid Comp_FSC.
Exact (Prf_ass C ? ? ? ? f g h).
Qed.

(* Id *)

Definition Id_FSC := [i:I](Id (a i)).

Lemma Idl_FSC : (idl_law I FSC_mor_setoid Comp_FSC Id_FSC).
Proof.
Unfold idl_law; Intros i j f; Simpl.
Exact (Prf_idl C ? ? f).
Qed.

Lemma Idr_FSC : (idr_law I FSC_mor_setoid Comp_FSC Id_FSC).
Proof.
Unfold idr_law; Intros i j f; Simpl.
Exact (Prf_idr C ? ? f).
Qed.

Definition fullSubCat := (Build_Category I FSC_mor_setoid Comp_FSC
                                Id_FSC Assoc_FSC Idl_FSC Idr_FSC).

End fscat.

Syntactic Definition FullSubCat := fullSubCat | 2.
Syntax constr fullSubCat <<(fullSubCat $1 $2 $a)>> 10
	     [<hov 0> "FullSubCat " <$a:"term":L>].


(* $Id: FullSubCat.v,v 1.2 1996/02/12 15:23:48 cpaulin Exp $ *)
