(*****************************************************************************)
(*          Projet Formel - Calculus of Inductive Constructions V5.10        *)
(*****************************************************************************)
(*									     *)
(*	                    Category ONE                  		     *)
(*									     *)
(*****************************************************************************)
(*									     *)
(*                     A. SAIBI	  May 95                  		     *)
(*									     *)
(*****************************************************************************)


Require Export Category.

(* The category One *)

Inductive One_ob : Type := Obone : One_ob.

Inductive One_mor : One_ob -> One_ob -> Type := 
   Id_Obone : (One_mor Obone Obone).

 Section equal_one_mor.

 Variable a, b : One_ob.

 Definition Equal_One_mor := [f,g:(One_mor a b)]True.

 Lemma Equal_One_mor_equiv : (Equivalence Equal_One_mor).
 Proof.
 Unfold Equal_One_mor; Apply Build_equivalence; Red; Trivial.
 Qed.

 Definition One_mor_setoid := (Build_Setoid (One_mor a b) Equal_One_mor Equal_One_mor_equiv).
 
 End equal_one_mor.

Definition Comp_One_mor := [a:One_ob]
  <[x:One_ob](b,c:One_ob)(One_mor x b)->(One_mor b c)->(One_mor x c)>
  Case a of [b,c:?]
    <[x:One_ob](One_mor Obone b)->(One_mor b x)->(One_mor Obone x)>
    Case c of [_:?][_:?]Id_Obone end
  end.

Lemma Comp_One_mor_congl : (Congl_law One_ob One_mor_setoid Comp_One_mor).
Proof.
Unfold Congl_law Comp_One_mor; Simpl; Unfold Equal_One_mor; Trivial.
Qed.

Lemma Comp_One_mor_congr : (Congr_law One_ob One_mor_setoid Comp_One_mor).
Proof.
Unfold Congr_law Comp_One_mor; Simpl; Unfold Equal_One_mor; Trivial.
Qed.

Definition Comp_One := (Build_Comp One_ob One_mor_setoid Comp_One_mor 
                                      Comp_One_mor_congl Comp_One_mor_congr).

Lemma Assoc_One : (assoc_law One_ob One_mor_setoid Comp_One).
Proof.
Unfold assoc_law; Simpl.
Unfold Comp_One Equal_One_mor; Trivial.
Qed.

Definition Id_One := [a:One_ob]<[x:One_ob](One_mor x x)>
                                Case a of Id_Obone end.

Lemma Idl_One : (idl_law One_ob One_mor_setoid Comp_One Id_One).
Proof.
Unfold idl_law; Simpl.
Unfold Comp_One Id_One Equal_One_mor; Trivial.
Qed.

Lemma Idr_One : (idr_law One_ob One_mor_setoid Comp_One Id_One).
Proof.
Unfold idr_law; Simpl.
Unfold Comp_One Id_One Equal_One_mor; Trivial.
Qed.

Definition One := (Build_Category One_ob One_mor_setoid Comp_One Id_One 
                                  Assoc_One Idl_One Idr_One).






(* $Id: ONE.v,v 1.2 1996/02/12 15:24:01 cpaulin Exp $ *)
