(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              PermCat.v                                   *)
(****************************************************************************)

Require Export Inverses_Group.
Require Export Category.
 
(* The Group of permutations on an object of a Category C *)

(* The Monoid of Endomorphisms on an object of a Category C *)

Section endo_mon.

Variable C : Category.
Variable a : (Ob C).

Definition Endo_Monoid := (Build_Monoid (Hom a a) (Op_comp C a a a) (Id a) 
                            (Prf_ass C a a a a) (Prf_idl C a a) (Prf_idr C a a)).

Definition Perm_Group := (Inverses_group Endo_Monoid).

End endo_mon.



(* $Id: PermCat.v,v 1.2 1996/02/12 15:24:10 cpaulin Exp $ *)
