(*****************************************************************************)
(*          Projet Formel - Calculus of Inductive Constructions V5.10        *)
(*****************************************************************************)
(*									     *)
(*	                      Comma Category (x|G) : Projection		     *)
(*									     *)
(*****************************************************************************)
(*									     *)
(*                     A. SAIBI	  May 95                  		     *)
(*									     *)
(*****************************************************************************)

Require Export Comma.

(* Functor Projection *)

Section comma_proj_def.

Variable A,X : Category.
Variable G   : (Functor A X).
Variable x   : (Ob X).

Definition Comma_proj_ob := [a:(Com_ob G x)](Ob_com_ob a).

 Section comma_proj_map_def.

 Variable a, b : (Com_ob G x).

 Definition Comma_proj_mor := [f:(Com_arrow a b)](Mor_com_arrow f).

 Lemma Comma_proj_map_law : (map_law (hom (Comma G x) a b) ? Comma_proj_mor).
 Proof.
 Unfold map_law Comma_proj_mor; Simpl.
 Intros f g; Unfold Equal_com_arrow; Auto.
 Qed.

 Definition Comma_proj_map := (build_Map (hom (Comma G x) a b) ? Comma_proj_mor Comma_proj_map_law).

 End comma_proj_map_def.

Lemma Comma_proj_comp_law : (fcomp_law (Comma G x) A Comma_proj_ob Comma_proj_map).
Proof.
Unfold fcomp_law; Simpl.
Intros a b c f g; Unfold Comp_com_arrow Comma_proj_mor.
Apply (Prf_refl (Hom (Comma_proj_ob a) (Comma_proj_ob c))).
Qed.

Lemma Comma_proj_id_law : (fid_law (Comma G x) A Comma_proj_ob Comma_proj_map).
Proof.
Unfold fid_law; Simpl.
Intro a; Apply (Prf_refl (Hom (Comma_proj_ob a) (Comma_proj_ob a))).
Qed.

Definition comma_proj := (Build_Functor (Comma G x) A Comma_proj_ob Comma_proj_map
                                        Comma_proj_comp_law Comma_proj_id_law).

End comma_proj_def.

Syntactic Definition Comma_proj := comma_proj | 2.
Syntax constr comma_proj <<(comma_proj $1 $2 $G $x)>> 10
	     [<hov 0> "Comma_proj " <$G:"term":L> " " <$x:"term":L>].

(* $Id: Comma_proj.v,v 1.2 1996/02/12 15:24:56 cpaulin Exp $ *)
