(*****************************************************************************)
(*          Projet Formel - Calculus of Inductive Constructions V5.10        *)
(*****************************************************************************)
(*									     *)
(*	               Forgetful Functor : MON -> SET                        *)
(*									     *)
(*****************************************************************************)
(*									     *)
(*                     A. SAIBI	  May 95                  		     *)
(*									     *)
(*****************************************************************************)

Require Export MON.
Require Export Functor.

(* Foncteur d'oubli *)

Definition FunForget_ob := [m:Monoid](Mcarrier m).

Section forget_map_def.

Variable m1, m2 : Monoid.

Definition FunForget_mor := [f:(MonMor m1 m2)](MonMap f).

Lemma FunForget_map_law : (map_law (MonMor_setoid m1 m2)
                                ((FunForget_ob m1)=>(FunForget_ob m2)) FunForget_mor).
Proof.
Unfold map_law; Simpl.
Unfold Equal_MonMor FunForget_mor; Trivial.
Qed.

Definition FunForget_map := (build_Map (MonMor_setoid m1 m2)
                                    ((FunForget_ob m1)=>(FunForget_ob m2))
                                    FunForget_mor FunForget_map_law).

End forget_map_def.

Lemma FunForget_fcomp_law : (fcomp_law MON SET FunForget_ob FunForget_map).
Proof.
Unfold fcomp_law; Simpl.
Unfold Comp_MonMor_map FunForget_mor Ext.
Intros m1 m2 m3 f g x; Apply (Prf_refl (Mcarrier m3)).
Qed.

Lemma FunForget_fid_law : (fid_law MON SET FunForget_ob FunForget_map).
Proof.
Unfold fid_law; Simpl.
Unfold Id_MON_map Ext.
Intros m x; Apply (Prf_refl (Mcarrier m)).
Qed.

Definition FunForget := (Build_Functor MON SET FunForget_ob FunForget_map 
                            FunForget_fcomp_law FunForget_fid_law).

(* $Id: FunForget.v,v 1.2 1996/02/12 15:25:02 cpaulin Exp $ *)
