(*****************************************************************************)
(*          Projet Formel - Calculus of Inductive Constructions V5.10        *)
(*****************************************************************************)
(*									     *)
(*	                     Identity Functor             		     *)
(*									     *)
(*****************************************************************************)
(*									     *)
(*                     A. SAIBI	  May 95                  		     *)
(*									     *)
(*****************************************************************************)


Require Export Functor.

(* Id(C) : C -> C *)

Section idCat.

Variable C : Category.

Definition Id_CAT_ob := [a:(Ob C)]a.
                      
Definition Id_CAT_map := [a,b:(Ob C)](Id_map (Hom a b)).
                   
Lemma Id_CAT_comp_law : (Fcomp_law Id_CAT_ob Id_CAT_map).
Proof.
Unfold fcomp_law; Intros; Apply (Prf_refl (Hom a c)).
Qed.

Lemma Id_CAT_id_law : (Fid_law Id_CAT_ob Id_CAT_map).
Proof.
Unfold fid_law Id_CAT_ob; Intros a; Apply (Prf_refl (Hom a a)).
Qed.

Definition Id_CAT := (Build_Functor C C Id_CAT_ob Id_CAT_map
                                    Id_CAT_comp_law Id_CAT_id_law).

End idCat.





(* $Id: IdCAT.v,v 1.2 1996/02/12 15:25:13 cpaulin Exp $ *)
