(*****************************************************************************)
(*          Projet Formel - Calculus of Inductive Constructions V5.10        *)
(*****************************************************************************)
(*									     *)
(*	   Limits  cones(c,F) iso C(c,limF)                		     *)
(*									     *)
(*****************************************************************************)
(*									     *)
(*                     A. SAIBI	  May 95                  		     *)
(*									     *)
(*****************************************************************************)

Require Export SET.
Require Export Limit.


(* cones(c,F) iso C(c,limF) *)

Section iso_cone.

Variable J, C : Category.
Variable F    : (Functor J C).
Variable l    : (Limit F).
Variable c    : (Ob C).

(* Map cones(c,F) vers C(c,limF) *)

Definition PhiCone_fun := [tau:(Cone c F)](CoUA_diese l ? tau).

Lemma PhiCone_map_law : (map_law (Cones c F) ? PhiCone_fun).
Proof.
Unfold map_law PhiCone_fun; Simpl.
Intros T1 T2 H.
Apply (Codiese_map ? ? ? ? l ? T1 T2); Trivial.
Qed.

Definition PhiCone_map := (build_Map (Cones c F) ? PhiCone_fun PhiCone_map_law).

(* Map C(c,limF) vers cones(c,F) *)

 Section phicone_1_fun_def.

 Variable f : |(Hom c (Lim l))|.

 Definition PhiCone_1_fun_tau := [i:(Ob J)]f o (ApNT (Limiting_cone l) i).

 Lemma PhiCone_1_fun_cone_law : (Cone_law c F PhiCone_1_fun_tau).
 Proof.
 Unfold cone_law PhiCone_1_fun_tau; Simpl.
 Intros i j g.
 (* *) Apply (Prf_trans (Hom c (FOb F j))) with
   y:=f o ((ApNT (Limiting_cone l) i) o (FMor F g)).
 Apply (Prf_congl C).
 Apply (Eq_cone ? ? ? ? (Limiting_cone l) i j g).
 Unfold Comp; Apply (Prf_ass C).
 Qed.

 Definition PhiCone_1_fun := (Build_Cone c F PhiCone_1_fun_tau PhiCone_1_fun_cone_law).

 End phicone_1_fun_def. 

Lemma PhiCone_1_map_law : (map_law ? (Cones c F) PhiCone_1_fun).
Proof.
Unfold map_law PhiCone_1_fun. 
Intros f g H; Simpl.
Unfold Equal_NT; Simpl.
Unfold PhiCone_1_fun_tau; Intro i.
Apply (Prf_congr C); Trivial.
Qed.

Definition PhiCone_1_map := (build_Map ? (Cones c F) PhiCone_1_fun PhiCone_1_map_law).

(* phi et PhiCone_1 sont iso *)

Lemma Check_iso_l : (Iso_law SET ? ? PhiCone_map PhiCone_1_map).
Proof.
Unfold Iso_law; Simpl; Unfold Ext; Simpl.
Intro f; Unfold PhiCone_fun.
Unfold Id_fun.
Apply (Prf_sym (Hom c (Lim l))).
Apply (Prf_CoUA_law2 ? ? ? ? l).
Unfold coUA_eq PhiCone_1_fun; Simpl.
Unfold Equal_NT; Simpl.
Unfold Comp_tau PhiCone_1_fun_tau; Simpl.
Unfold Delta_mor_tau; Intro i.
Apply (Prf_refl (Hom c (FOb F i))).
Qed.

Lemma Check_iso_r : (Iso_law SET ? ? PhiCone_1_map PhiCone_map).
Proof.
Unfold Iso_law; Simpl; Unfold Ext; Simpl.
Intro f; Unfold Equal_NT.
Unfold PhiCone_1_fun PhiCone_fun; Simpl.
Intro i; Unfold PhiCone_1_fun_tau Id_fun.
Apply (Prf_sym (Hom c (FOb F i))).
Apply (Eq_limit ? ? ? l c f i).
Qed.

Lemma Lim_iso : (iso SET (Cones c F) (Hom c (Lim l))).
Proof.
Apply Build_iso with PhiCone_map.
Apply Build_isIso with PhiCone_1_map.
Exact Check_iso_l.
Exact Check_iso_r.
Defined.

End iso_cone.



(* $Id: Iso_Limit.v,v 1.2 1996/02/12 15:25:36 cpaulin Exp $ *)
