(*****************************************************************************)
(*          Projet Formel - Calculus of Inductive Constructions V5.10        *)
(*****************************************************************************)
(*									     *)
(*	         Category .->.<-. (used for Pullbacks)     		     *)
(*									     *)
(*****************************************************************************)
(*									     *)
(*                     A. SAIBI	  May 95                  		     *)
(*									     *)
(*****************************************************************************)


Require Export Category.
Require Export BasicTypes.


Inductive PULB_ob : Type := 
   P1 : PULB_ob
 | P2 : PULB_ob
 | P3 : PULB_ob.

Inductive PULB_mor : PULB_ob -> PULB_ob -> Type :=
   IP1 : (PULB_mor P1 P1)
 | IP2 : (PULB_mor P2 P2)
 | IP3 : (PULB_mor P3 P3)
 | F12 : (PULB_mor P1 P2)
 | F32 : (PULB_mor P3 P2).

(* *)

Lemma PULB_11_P : ((PULB_mor P1 P1)->Prop) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Prop.
Proof.
Intros P a b; Elim a; Elim b.
Exact P.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Defined.

Lemma PULB_11_ind : (P:(PULB_mor P1 P1)->Prop)(P IP1) ->
                    (x:(PULB_mor P1 P1))(P x).
Proof.
Intros P Pi1 x.
Change (PULB_11_P P P1 P1 x).
Apply (PULB_mor_ind ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_11_P P a b f))); Simpl.
Exact Pi1.
Trivial.
Trivial.
Trivial.
Trivial.
Qed.


Lemma PULB_22_P : ((PULB_mor P2 P2)->Prop) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Prop.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Exact P.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Defined.

Lemma PULB_22_ind : (P:(PULB_mor P2 P2)->Prop)(P IP2) ->
                         (x:(PULB_mor P2 P2))(P x).
Proof.
Intros P Pi1 x.
Change (PULB_22_P P P2 P2 x).
Apply (PULB_mor_ind ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_22_P P a b f))); Simpl.
Trivial.
Exact Pi1.
Trivial.
Trivial.
Trivial.
Qed.

Lemma PULB_33_P : ((PULB_mor P3 P3)->Prop) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Prop.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Exact P.
Defined.

Lemma PULB_33_ind : (P:(PULB_mor P3 P3)->Prop)(P IP3) ->
                    (x:(PULB_mor P3 P3))(P x).
Proof.
Intros P Pi1 x.
Change (PULB_33_P P P3 P3 x).
Apply (PULB_mor_ind ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_33_P P a b f))); Simpl.
Trivial.
Trivial.
Exact Pi1.
Trivial.
Trivial.
Qed.

Lemma PULB_12_P : ((PULB_mor P1 P2)->Prop) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Prop.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact True.
Exact P.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Defined.

Lemma PULB_12_ind : (P:(PULB_mor P1 P2)->Prop)(P F12) ->
                    (x:(PULB_mor P1 P2))(P x).
Proof.
Intros P Pi1 x.
Change (PULB_12_P P P1 P2 x).
Apply (PULB_mor_ind ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_12_P P a b f))); Simpl.
Trivial.
Trivial.
Trivial.
Exact Pi1.
Trivial.
Qed.

Lemma PULB_32_P : ((PULB_mor P3 P2)->Prop) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Prop.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Exact P.
Intro x; Exact True.
Defined.

Lemma PULB_32_ind : (P:(PULB_mor P3 P2)->Prop)(P F32) ->
                    (x:(PULB_mor P3 P2))(P x).
Proof.
Intros P Pi1 x.
Change (PULB_32_P P P3 P2 x).
Apply (PULB_mor_ind ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_32_P P a b f))); Simpl.
Trivial.
Trivial.
Trivial.
Trivial.
Exact Pi1.
Qed.

Lemma PULB_21_P : ((PULB_mor P2 P1)->Prop) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Prop.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Exact P.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Defined.

Lemma PULB_21_ind : (P:(PULB_mor P2 P1)->Prop)
                    (x:(PULB_mor P2 P1))(P x).
Proof.
Intros P x.
Change (PULB_21_P P P2 P1 x).
Apply (PULB_mor_ind ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_21_P P a b f))); Simpl; Auto.
Qed.

Lemma PULB_21_T : ((PULB_mor P2 P1)->Type) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Type.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Exact P.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Defined.

Lemma PULB_21_rect : (P:(PULB_mor P2 P1)->Type)
                     (x:(PULB_mor P2 P1))(P x).
Proof.
Intros P x.
Change (PULB_21_T P P2 P1 x).
Apply (PULB_mor_rect ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_21_T P a b f))); Simpl; Auto.
Qed.

Lemma PULB_31_P : ((PULB_mor P3 P1)->Prop) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Prop.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Exact P.
Intro x; Exact True.
Intro x; Exact True.
Defined.

Lemma PULB_31_ind : (P:(PULB_mor P3 P1)->Prop)
                    (x:(PULB_mor P3 P1))(P x).
Proof.
Intros P x.
Change (PULB_31_P P P3 P1 x).
Apply (PULB_mor_ind ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_31_P P a b f))); Simpl; Auto.
Qed.

Lemma PULB_31_T : ((PULB_mor P3 P1)->Type) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Type.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Exact P.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Defined.

Lemma PULB_31_rect : (P:(PULB_mor P3 P1)->Type)
                     (x:(PULB_mor P3 P1))(P x).
Proof.
Intros P x.
Change (PULB_31_T P P3 P1 x).
Apply (PULB_mor_rect ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_31_T P a b f))); Simpl; Auto.
Qed.

Lemma PULB_13_P : ((PULB_mor P1 P3)->Prop) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Prop.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact True.
Intro x; Exact True.
Exact P.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Defined.

Lemma PULB_13_ind : (P:(PULB_mor P1 P3)->Prop)
                    (x:(PULB_mor P1 P3))(P x).
Proof.
Intros P x.
Change (PULB_13_P P P1 P3 x).
Apply (PULB_mor_ind ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_13_P P a b f))); Simpl; Auto.
Qed.

Lemma PULB_13_T : ((PULB_mor P1 P3)->Type) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Type.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Exact P.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Defined.

Lemma PULB_13_rect : (P:(PULB_mor P1 P3)->Type)
                     (x:(PULB_mor P1 P3))(P x).
Proof.
Intros P x.
Change (PULB_13_T P P1 P3 x).
Apply (PULB_mor_rect ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_13_T P a b f))); Simpl; Auto.
Qed.

Lemma PULB_23_P : ((PULB_mor P2 P3)->Prop) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Prop.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Exact P.
Intro x; Exact True.
Intro x; Exact True.
Intro x; Exact True.
Defined.

Lemma PULB_23_ind : (P:(PULB_mor P2 P3)->Prop)
                    (x:(PULB_mor P2 P3))(P x).
Proof.
Intros P x.
Change (PULB_23_P P P2 P3 x).
Apply (PULB_mor_ind ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_23_P P a b f))); Simpl; Auto.
Qed.

Lemma PULB_23_T : ((PULB_mor P2 P3)->Type) ->
                       (a,b:PULB_ob)(PULB_mor a b) -> Type.
Proof.
Intros P a b; Elim a; Elim b.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Exact P.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Intro x; Exact UnitType.
Defined.

Lemma PULB_23_rect : (P:(PULB_mor P2 P3)->Type)
                     (x:(PULB_mor P2 P3))(P x).
Proof.
Intros P x.
Change (PULB_23_T P P2 P3 x).
Apply (PULB_mor_rect ([a,b:PULB_ob][f:(PULB_mor a b)](PULB_23_T P a b f))); Simpl; Auto.
Qed.

(* equlaity *)

 Section pulb_setoid_def.

 Variable a, b : PULB_ob.

 Definition Equal_PULB_mor := [f,g:(PULB_mor a b)]True.
 
 Lemma Equal_PULB_mor_equiv : (Equivalence Equal_PULB_mor).
 Proof.
 Apply Build_equivalence; Red; Unfold Equal_PULB_mor; Simpl; Auto.
 Qed.
 
 Definition PULB_mor_setoid := (Build_Setoid (PULB_mor a b) Equal_PULB_mor Equal_PULB_mor_equiv).

 End pulb_setoid_def.

(* composition *)

Definition Comp_PULB_mor := [a,b,c:PULB_ob][f:(PULB_mor a b)]
 <[p,p0:PULB_ob][_:(PULB_mor p p0)](PULB_mor p0 c)->(PULB_mor p c)>Case f of 
 (* IP1 *) <[p:PULB_ob](PULB_mor P1 p)->(PULB_mor P1 p)>Case c of
           (* P1 *) [_:?]IP1 
           (* P2 *) [_:?]F12
           (* P3 *) [g:?](PULB_13_rect ([_:(PULB_mor P1 P3)](PULB_mor P1 P3)) g)
           end
 (* IP1 *) <[p:PULB_ob](PULB_mor P2 p)->(PULB_mor P2 p)> Case c of             
           (* P1 *) [g:?](PULB_21_rect ([_:(PULB_mor P2 P1)](PULB_mor P2 P1)) g)
           (* P2 *) [_:?]IP2
           (* P3 *) [g:?](PULB_23_rect ([_:(PULB_mor P2 P3)](PULB_mor P2 P3)) g)
           end
 (* IP3 *) <[p:PULB_ob](PULB_mor P3 p)->(PULB_mor P3 p)>Case c of
           (* P1 *) [g:?](PULB_31_rect ([_:(PULB_mor P3 P1)](PULB_mor P3 P1)) g)  
           (* P2 *) [_:?]F32
           (* P3 *) [_:?]IP3 
           end
 (* F12  *) <[p:PULB_ob](PULB_mor P2 p)->(PULB_mor P1 p)>Case c of
            (* P1 *) [g:?](PULB_21_rect ([_:(PULB_mor P2 P1)](PULB_mor P1 P1)) g)
            (* P2 *) [_:?]F12
            (* P3 *) [g:?](PULB_23_rect ([_:(PULB_mor P2 P3)](PULB_mor P1 P3)) g)
            end
 (* F32  *) <[p:PULB_ob](PULB_mor P2 p)->(PULB_mor P3 p)>Case c of
            (* P1 *) [g:?](PULB_21_rect ([_:(PULB_mor P2 P1)](PULB_mor P3 P1)) g)
            (* P2 *) [_:?]F32
            (* P3 *) [g:?](PULB_23_rect ([_:(PULB_mor P2 P3)](PULB_mor P3 P3)) g)
            end end.

Lemma Comp_PULB_congl : (Congl_law PULB_ob PULB_mor_setoid Comp_PULB_mor).
Proof.
Unfold Congl_law Equal_PULB_mor; Simpl; Auto.
Qed.

Lemma Comp_PULB_congr : (Congr_law PULB_ob PULB_mor_setoid Comp_PULB_mor).
Proof.
Unfold Congr_law Equal_PULB_mor; Simpl; Auto.
Qed.
 
Definition Comp_PULB := (Build_Comp PULB_ob PULB_mor_setoid Comp_PULB_mor 
                                       Comp_PULB_congl Comp_PULB_congr).

Lemma Assoc_PULB : (assoc_law PULB_ob PULB_mor_setoid Comp_PULB).
Proof.
Unfold assoc_law; Simpl; Unfold Equal_PULB_mor; Simpl; Auto.
Qed.

(* Id *)

Definition Id_PULB := [a:PULB_ob]<[a':PULB_ob](PULB_mor a' a')>
                                 Case a of (* P1 *) IP1 
                                           (* P2 *) IP2 
                                           (* P3 *) IP3 end.

Lemma Idl_PULB : (idl_law PULB_ob PULB_mor_setoid Comp_PULB Id_PULB).
Proof.
Unfold idl_law; Simpl; Unfold Equal_PULB_mor; Simpl; Auto.
Qed.

Lemma Idr_PULB : (idr_law PULB_ob PULB_mor_setoid Comp_PULB Id_PULB).
Proof.
Unfold idr_law; Simpl; Unfold Equal_PULB_mor; Simpl; Auto.
Qed.
 
Definition PULB := (Build_Category PULB_ob PULB_mor_setoid Comp_PULB Id_PULB
                                   Assoc_PULB Idl_PULB Idr_PULB).


(* $Id: PULB.v,v 1.2 1996/02/12 15:25:44 cpaulin Exp $ *)
