(*****************************************************************************)
(*          Projet Formel - Calculus of Inductive Constructions V5.10        *)
(*****************************************************************************)
(*									     *)
(*	    Limits by Producys and equalizers              		     *)
(*									     *)
(*****************************************************************************)
(*									     *)
(*                        A.SAIBI         May 95			     *)
(*									     *)
(*****************************************************************************)

Require Export Equalizers1.
Require Export Products1.

Section thl.

Variable C, J      : Category.
Variable Limit_ob  : (k:(Ob J)->(Ob C))(Product1 k).
Variable Limit_arr : (k:(Arrs J)->(Ob C))(Product1 k).
Variable Limit_fg  : (a,b:(Ob C))(f,g:|(Hom a b)|)(Equalizer1_fg f g).
Variable F         : (Functor J C).

(* IIi Fi *)

Definition Thl_k_Fi := [i:(Ob J)](FOb F i).

Definition Thl_l_Fi := (Limit_ob Thl_k_Fi).

Definition Thl_PI_Fi := (pi1 ? (Ob J) Thl_k_Fi Thl_l_Fi).

(* ||u F(codomu) *)

Definition Thl_k_Fu := [u:(Arrs J)](FOb F (Codom u)).

Definition Thl_l_Fu := (Limit_arr Thl_k_Fu).

Definition Thl_PI_Fu := (pi1 ? (Arrs J) Thl_k_Fu Thl_l_Fu).

(* qq u. fu : IIi Fi -> ku (= F(codomu)) *)

Definition Thl_fu := [u:(Arrs J)](proj1 ? ? Thl_k_Fi Thl_l_Fi (Codom u)).

(* donc E! f : IIi Fi -> ||u F(codomu) tq ... *)

Definition Thl_f := (pd1_diese ? ? Thl_k_Fu Thl_l_Fu Thl_PI_Fi Thl_fu).

Lemma Thl_diag1 : (u:(Arrs J))(Thl_fu u) =%S (Thl_f o (proj1 ? ? Thl_k_Fu Thl_l_Fu u)).
Proof.
Exact (Prf_pd1_law1 C (Arrs J) Thl_k_Fu Thl_l_Fu Thl_PI_Fi Thl_fu).
Qed.

(* qq u. gu : IIi Fi --p(domu)--> F(domu) --Fu--> ku (= F(codomu)) *)

Definition Thl_gu := [u:(Arrs J)](proj1 ? ? Thl_k_Fi Thl_l_Fi (Dom u)) o 
                        (FMor F (Arrow u)).

(* donc E! g : IIi Fi -> ||u F(codomu) tq ... *)

Definition Thl_g := (pd1_diese ? ? Thl_k_Fu Thl_l_Fu Thl_PI_Fi Thl_gu).

Lemma Thl_diag2 : (u:(Arrs J))(Thl_gu u) =%S (Thl_g o (proj1 ? ? Thl_k_Fu Thl_l_Fu u)).
Proof.
Exact (Prf_pd1_law1 C (Arrs J) Thl_k_Fu Thl_l_Fu Thl_PI_Fi Thl_gu).
Qed.

(* equalizer de f et g *)

Definition Thl_l_fg := (Limit_fg ? ? Thl_f Thl_g).

Definition Thl_d := (e1_ob ? ? ? TwoElts (K_fg Thl_f Thl_g) Thl_l_fg).
  
Definition Thl_e := (e1_mor ? ? ? TwoElts (K_fg Thl_f Thl_g) Thl_l_fg).
 
(* construction du limiting cone *)

Definition Thl_mu_tau := [j:(Ob J)] (Thl_e o (proj1 ? ? Thl_k_Fi Thl_l_Fi j)).

Lemma Thl_mu_cone_law : (Cone_law Thl_d F Thl_mu_tau).
Proof.
Unfold cone_law; Intros j k u; Unfold Thl_mu_tau.
(* *) Apply (Prf_trans (Hom Thl_d (FOb F k))) with 
  y:=Thl_e o (Thl_f o (proj1 C (Arrs J) Thl_k_Fu Thl_l_Fu (Build_Arrs ? ? ? u))).
Apply (Prf_congl C).
Apply (Thl_diag1 (Build_Arrs ? ? ? u)).
(* *) Apply (Prf_trans (Hom Thl_d (FOb F k))) with 
  y:=Thl_e o ((proj1 C (Ob J) Thl_k_Fi Thl_l_Fi j) o (FMor F u)).
(* *) Apply (Prf_trans (Hom Thl_d (FOb F k))) with 
  y:=Thl_e o (Thl_g o (proj1 C (Arrs J) Thl_k_Fu Thl_l_Fu (Build_Arrs ? ? ? u))).
(* *) Apply (Prf_trans (Hom Thl_d (FOb F k))) with 
  y:=(Thl_e o Thl_f) o (proj1 C (Arrs J) Thl_k_Fu Thl_l_Fu (Build_Arrs ? ? ? u)).
Unfold Comp; Apply (Prf_ass C).
(* *) Apply (Prf_trans (Hom Thl_d (FOb F k))) with 
  y:=(Thl_e o Thl_g) o (proj1 C (Arrs J) Thl_k_Fu Thl_l_Fu (Build_Arrs ? ? ? u)).
Apply (Prf_congr C).
Apply (Prf_E1_law1 ? ? ? TwoElts (K_fg Thl_f Thl_g) Thl_l_fg Elt1 Elt2).
Apply (Prf_sym (Hom Thl_d (FOb F k))).
Unfold Comp; Apply (Prf_ass C).
Apply (Prf_congl C).
Apply (Prf_sym (Hom Thl_PI_Fi (FOb F k))).
Exact (Thl_diag2 (Build_Arrs ? ? ? u)).
Unfold Comp; Apply (Prf_ass C).
Qed.
 
Definition Thl_mu := (Build_Cone Thl_d F Thl_mu_tau Thl_mu_cone_law).

 Section taudiese.

 (* construction de l'ope'ration # *)

 Variable c : (Ob C).
 Variable tau : (Cone c F).

 Definition Thl_h := (pd1_diese C (Ob J) Thl_k_Fi Thl_l_Fi c ([i:(Ob J)](ApNT tau i))).

 Lemma Thl_diag3 : (i:(Ob J))(ApNT tau i) =%S (Thl_h o (proj1 ? ? Thl_k_Fi Thl_l_Fi i)).
 Proof.
 Intro i; Apply (Prf_pd1_law1 C ? Thl_k_Fi Thl_l_Fi c ([i:(Ob J)](ApNT tau i)) i).
 Qed.

 (* hof = hog *)
 (* hof = (IIFcodu)# (+) *)
 (* tau(codu) = h o p(codu)   Thl_diag3 *)
 (*           = h o f o p(u)  Thl_diag1 *)
 (* on a (+) par unicite' de IIFcodu *)

 (* hog = (IIFcodu)# (**) *)
 (* p(domu) o Fu = g o p(u) Thl_diag2 *)
 (* h o p(domu) o Fu = h o g o p(u) *)
 (* tau(domu)   o Fu = h o g o p(u) Thl_diag3 *)
 (* tau(codomu)      = h o f o p(u) tau est un cone *)
	
 Lemma Thl_diag4 : (Thl_h o Thl_f) =%S (Thl_h o Thl_g).
 Proof.
 (* *) Apply (Prf_trans (Hom c Thl_PI_Fu)) with 
   y:=(pd1_diese C ? Thl_k_Fu Thl_l_Fu c ([u:(Arrs J)](ApNT tau (Codom u)))).
 Apply (Prf_pd1_law2 C ? Thl_k_Fu Thl_l_Fu c ([u:(Arrs J)](ApNT tau (Codom u)))).
 Unfold product_eq; Intro u.
 (* *) Apply (Prf_trans (Hom c (FOb F (codom J u)))) with
   y:=Thl_h o (proj1 ? ? Thl_k_Fi Thl_l_Fi (Codom u)).
 Apply (Thl_diag3 (Codom u)).
 (* *) Apply (Prf_trans (Hom c (FOb F (codom J u)))) with
   y:=Thl_h o (Thl_f o (proj1 C (Arrs J) Thl_k_Fu Thl_l_Fu u)).
 Apply (Prf_congl C).
 Apply (Thl_diag1 u).
 Unfold Comp; Apply (Prf_ass C).
 Apply (Prf_sym (Hom c Thl_PI_Fu)).
 Apply (Prf_pd1_law2 C ? Thl_k_Fu Thl_l_Fu c ([u:(Arrs J)](ApNT tau (Codom u)))).
 Unfold product_eq; Intro u.
 (* *) Apply (Prf_trans (Hom c (FOb F (codom J u)))) with
   y:=(ApNT tau (Dom u)) o (FMor F (Arrow u)).
 Apply (Eq_cone ? ? c F tau ? ? (Arrow u)).
 (* *) Apply (Prf_trans (Hom c (FOb F (codom J u)))) with
   y:=(Thl_h o (proj1 ? ? Thl_k_Fi Thl_l_Fi (Dom u))) o (FMor F (Arrow u)).
 Apply (Prf_congr C).
 Apply (Thl_diag3 (Dom u)).
 (* *) Apply (Prf_trans (Hom c (FOb F (codom J u)))) with
   y:=Thl_h o ((proj1 ? ? Thl_k_Fi Thl_l_Fi (Dom u)) o (FMor F (Arrow u))).
 Apply (Prf_sym (Hom c (FOb F (codom J u)))).
 Unfold Comp; Apply (Prf_ass C).
 (* *) Apply (Prf_trans (Hom c (FOb F (codom J u)))) with
   y:=Thl_h o (Thl_g o (proj1 C (Arrs J) Thl_k_Fu Thl_l_Fu u)).
 Apply (Prf_congl C).
 Apply (Thl_diag2 u).
 Unfold Comp; Apply (Prf_ass C).
 Qed.

 (* posons tau# = h# *)

 Definition Thl_diese := (E1_diese (K_fg Thl_f Thl_g) Thl_l_fg Elt1 ? Thl_h 
                                   (Prf_law1_fg Thl_diag4)).

 End taudiese.

(* universalite' *)

Lemma Thl_coUA_law1 : (Limit_law1 F Thl_d Thl_mu Thl_diese).
Proof.
Unfold limit_law1 coUA_law1 coUA_eq; Intros c tau; Simpl.
Unfold Equal_NT; Intro i.
Simpl; Unfold Comp_tau fMor; Simpl.
Unfold Delta_mor_tau.
(* *) Apply (Prf_trans (Hom c (FOb F i))) with
  y:= ((Thl_diese c tau) o Thl_e) o (proj1 ? ? Thl_k_Fi Thl_l_Fi i).
(* *) Apply (Prf_trans (Hom c (FOb F i))) with
  y:= (Thl_diese c tau) o (Thl_e o (proj1 ? ? Thl_k_Fi Thl_l_Fi i)).
Apply (Prf_refl (Hom c (FOb F i))).
Unfold Comp; Apply (Prf_ass C).
(* *) Apply (Prf_trans (Hom c (FOb F i))) with
  y:= (pd1_diese C ? Thl_k_Fi Thl_l_Fi c ([i:(Ob J)](ApNT tau i))) o
      (proj1 ? ? Thl_k_Fi Thl_l_Fi i).
Apply (Prf_congr C).
Apply (Prf_sym (Hom c (CoUA_ob Thl_l_Fi))).
Apply (Prf_E1_law2 ? ? ? TwoElts (k_fg ? ? ? Thl_f Thl_g) Thl_l_fg Elt1 ? ?
                  (Prf_law1_fg (Thl_diag4 c tau))).
Apply (Prf_sym (Hom c (FOb F i))).
Apply (Thl_diag3 c tau i).
Qed.

(* hyp: t o mu(i) = tau(i) *)
(* s` prouver: t = tau# (=h#) *)
(* par universalite' de e, revient a` prouver:
   h = t o e 
   or, (rappel) h =def (i|->tau(i))# pour ||Fi
   donc par universalite' de IIFi, revient a` prouver:
   qq i:Ob(J). tau(i) = t o e o p(i) 
   vrai par hyp car mu(i) =def e o p(i) *)

Lemma Thl_coUA_law2 : (Limit_law2 F Thl_d Thl_mu Thl_diese).
Proof.
Unfold limit_law2 coUA_law2 coUA_eq; Intros c tau t H.
Unfold Thl_diese; Apply (Prf_E1_law3 ? ? ? TwoElts (k_fg ? ? ? Thl_f Thl_g) Thl_l_fg Elt1).
Apply (Prf_sym (Hom c Thl_PI_Fi)).
Unfold Thl_h.
Apply (Prf_pd1_law2 C (Ob J) Thl_k_Fi Thl_l_Fi); Unfold product_eq; Intro i.
Apply (Prf_trans (Hom c (Thl_k_Fi i))) with
  y:=t o (Thl_e o (proj1 C (Ob J) Thl_k_Fi Thl_l_Fi i)).
Apply (Prf_sym (Hom c (Thl_k_Fi i))).
Exact (H i).
Unfold Comp; Apply (Prf_ass C).
Qed.

Lemma Thl_islimit : (IsLimit F Thl_d Thl_mu).
Proof.
Exact (Build_IsLimit F Thl_d Thl_mu Thl_diese Thl_coUA_law1 Thl_coUA_law2).
Defined.

Definition Thl_limit := (Build_Limit F Thl_d Thl_mu Thl_islimit).

End thl.









(* $Id: Th_Limits.v,v 1.2 1996/02/12 15:26:09 cpaulin Exp $ *)
