(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               Noetherian.v                               *)
(****************************************************************************)

Require Relations.

Section Noether.
   Variable U: Type.
   Variable R: (Relation U).
   
   Inductive noetherian : U -> Prop :=
         Build_noetherian:
           (x: U) ((y: U) (R x y) -> (noetherian y)) -> (noetherian x).
   
   Definition Noetherian : Prop :=  (x: U) (noetherian x).
   
End Noether.

Hint Build_noetherian.

Theorem Noetherian_contains_Noetherian :
  (U: Type)(R,R': (Relation U)) (Noetherian U R) -> (Contains U R R') ->
            (Noetherian U R').
Goal.
Unfold 2 Noetherian.
Intros U R R' H' H'0 x.
Elim H' with x; Auto.
Save.




(* $Id: Noetherian.v,v 1.2 1996/02/12 15:26:39 cpaulin Exp $ *)
