(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 Group.v                                  *)
(****************************************************************************)

Require Export Monoid.

(* The Type of Groups *)

Section group_laws.

Variable A : Monoid.

Local A_ := (Mcarrier A).

Definition Inverses_rel := [x,y:|A_|] (x +%M y) =%S (Munit A).

Variable inv : (Map A_ A_).

Definition Group_invl := (x:|A_|)(Inverses_rel (Ap inv x) x).

Definition Group_invr := (x:|A_|)(Inverses_rel x (Ap inv x)).

End group_laws.

Structure Group : Type := 
 {Gmon       : Monoid;
  Ginv       : (Map (Mcarrier Gmon) (Mcarrier Gmon));
  Prf_ginv_l : (Group_invl ? Ginv);
  Prf_ginv_r : (Group_invr ? Ginv)}.

(* $Id: Group.v,v 1.2 1996/02/12 15:27:18 cpaulin Exp $ *)
