(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  Div.v                                   *)
(****************************************************************************)

Require Le.
Require Compare_dec.
Require Mult.
Require Plus.

Fixpoint inf_dec [n:nat] : nat->bool :=
      [m:nat]<bool>Case n of
                true
                [n':nat]<bool>Case m of
                                false 
                                [m':nat](inf_dec n' m')
			end
		end.

Inductive diveucl [a,b:nat] : Set 
  := divex : (q,r:nat)(gt b r)->(a=(plus (mult q b) r))->(diveucl a b).

Theorem div1 : (b:nat)(gt b O)->(a:nat)(diveucl a b).
Realizer [b,a:nat]<nat*nat>Match a with
   (* O *) (O,O)
   (* S *) [n,h]<nat*nat>let (q,r) = h in 
              		<nat*nat>if (le_gt_dec b (S r)) then
				      ((S q),O)
				 else (q,(S r))
          end.
Program_all.
Rewrite e.
Replace b with (S r).
Simpl.
Elim plus_n_O; Auto.
Apply le_antisym; Auto.
Elim plus_n_Sm; Auto.
Save.

Theorem div2 : (b:nat)(gt b O)->(a:nat)(diveucl a b).
Realizer [b,a:nat]<nat*nat>Match a with
   (* O *) (O,O)
   (* S *) [n,h]<nat*nat>let (q,r) = h in 
              		<nat*nat>if (inf_dec b (S r)) 
				:: :: { {(le b (S r))}+{(gt b (S r))} } 
				 then ((S q),O)
				 else (q,(S r))
          end.
Program_all.
Rewrite e.
Replace b with (S r).
Simpl.
Elim plus_n_O; Auto.
Apply le_antisym; Auto.
Elim plus_n_Sm; Auto.
Save.


(* $Id: Div.v,v 1.4 1996/02/12 15:27:38 cpaulin Exp $ *)
