(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 EqNat.v                                  *)
(****************************************************************************)

(***********************************)
(* Equality on natural numbers     *)
(***********************************)

Definition eq_nat : nat -> nat -> Prop :=
  [n,m:nat]<Prop>Case n of <Prop>Case m of True [m1:nat]False end
                           [n1:nat]<Prop>Case m of False 
                                                    [m1:nat](n1=m1)
                                         end
                 end.

Theorem eq_nat_refl : (n:nat)(eq_nat n n).
Induction n; Simpl; Auto.
Qed.
Hint eq_nat_refl.

Theorem eq_eq_nat : (n,m:nat)(n=m)->(eq_nat n m).
Induction 1; Trivial.
Qed.
Immediate eq_eq_nat.

Theorem eq_nat_eq : (n,m:nat)(eq_nat n m)->(n=m).
Induction n; Induction m; Simpl; (Contradiction Orelse Auto).
Qed.
Immediate eq_nat_eq.

Theorem eq_nat_elim : (n:nat)(P:nat->Prop)(P n)->(m:nat)(eq_nat n m)->(P m).
Intros; Replace m with n; Auto.
Qed.


(* $Id: EqNat.v,v 1.3 1996/02/12 15:27:40 cpaulin Exp $ *)
