(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  Min.v                                   *)
(****************************************************************************)
Require Arith.

(* minimum of two natural numbers *)

Fixpoint min [n:nat] : nat -> nat := 
[m:nat](<nat>Case n of
      (* O *) O
   (* S n' *) [n':nat]
              (<nat>Case m of 
              (* O *) O 
           (* S m' *) [m':nat](S (min n' m')) end) end).

Lemma min_SS : (n,m:nat)((S (min n m))=(min (S n) (S m))).
Proof.
Auto.
Qed.

Lemma le_min_l : (n,m:nat)(le (min n m) n).
Proof.
Induction n; Intros; Simpl; Auto.
Elim m; Intros; Simpl; Auto.
Qed.
Hint le_min_l.

Lemma le_min_r : (n,m:nat)(le (min n m) m).
Proof.
Induction n; Simpl; Auto.
Induction m; Simpl; Auto.
Qed.
Hint le_min_r.

(* min n m is equal to n or m *)

Lemma min_case : (n,m:nat)(P:nat->Set)(P n)->(P m)->(P (min n m)).
Proof.
Induction n; Simpl; Auto.
Induction m; Intros; Simpl; Auto.
Pattern (min n0 n1); Apply H ; Auto.
Qed.


(* $Id: Min.v,v 1.2 1996/02/12 15:27:48 cpaulin Exp $ *)
