(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              July 1st 1995                               *)
(*                                                                          *)
(****************************************************************************)
(*                                  Orb.v                                   *)
(****************************************************************************)

Require Bool.

Lemma orb_true_intro 
    : (b1,b2:bool)(b1=true)\/(b2=true)->(orb b1 b2)=true.
Destruct b1; Auto.
Destruct 1; Intros.
Elim diff_true_false; Auto.
Rewrite H0; Trivial.
Save.
Hint orb_true_intro.

Lemma orb_b_true : (b:bool)(orb b true)=true.
Auto.
Save.
Hint orb_b_true.

Lemma orb_true_b : (b:bool)(orb true b)=true.
Trivial.
Save.

Lemma orb_true_elim : (b1,b2:bool)(orb b1 b2)=true -> {b1=true}+{b2=true}.
Destruct b1; [Auto | Destruct b2; Auto].
Save.

Lemma orb_false_intro 
    : (b1,b2:bool)(b1=false)->(b2=false)->(orb b1 b2)=false.
Intros b1 b2 H1 H2; Rewrite H1; Rewrite H2; Trivial.
Save.
Hint orb_false_intro.

Lemma orb_b_false : (b:bool)(orb b false)=b.
Destruct b; Trivial.
Save.
Hint orb_b_false.


Lemma orb_false_elim : 
    (b1,b2:bool)(orb b1 b2)=false -> (b1=false)/\(b2=false).
Destruct b1.
Intros; Elim diff_true_false; Auto.
Destruct b2.
Intros; Elim diff_true_false; Auto.
Auto.
Save.

(* $Id: Orb.v,v 1.2 1996/02/12 15:28:09 cpaulin Exp $ *)
