(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                            Logic_TypeSyntax.v                            *)
(****************************************************************************)

Token "==".

Grammar command command1 :=
  [ "<" lcommand($l1) ">" command0($c1) "==" command0($c2)]
  -> [$0 = <<(eqT $l1 $c1 $c2)>>]
.

Grammar command command1 :=
  [ command0($c) "==" command0($c2) ] -> [$0 = <<(eqT ? $c $c2)>>]
.

Grammar command command1 :=
  [ "<" lcommand($l1) ">" "AllT" "(" command($l2) ")" ]
  -> [$0 = <<(allT $l1 $l2)>>]
.

Grammar command command1 :=
  [ "<" lcommand($l1) ">" "ExT" "(" command($l2) ")" ]
  -> [$0 = <<(exT $l1 $l2)>>]
.

Grammar command command1 :=
  [ "<" lcommand($l1) ">" "ExT2" "(" command($c1) "," command($c2) ")" ]
  -> [$0 = <<(exT2 $l1 $c1 $c2)>>]
.

(* $Id: Logic_TypeSyntax.v,v 1.3 1996/02/12 15:28:35 cpaulin Exp $ *)
