(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              Compare_prog.v                              *)
(****************************************************************************)

Require Program.
Require Le.
Require Lt.

Theorem lt_eq_lt_dec : (n,m:nat){(lt n m)}+{<nat>n=m}+{(lt m n)}.
Realizer [n:nat]<nat->(sumor bool)>Match n with 
          (* O *) [m]<(sumor bool)>Case m of
                          (* O *) (inleft ? false)
                        (* S p *) [_](inleft ? true) 
			 end
        (* S p *) [p,H,m]<(sumor bool)>Case m of
                           (* O *) (inright ?)
                         (* S q *) [q](H q)
			end
	end.
Program_all.
Save.

Lemma gt_eq_gt_dec : (n,m:nat)({(gt m n)}+{<nat>n=m})+{(gt n m)}.
Proof lt_eq_lt_dec.

Fixpoint le_lt_dec_pg [n:nat] : nat -> bool :=
[m:nat]<bool>Case n of
     (* O *) true
   (* S m *) [p:nat]<bool>Case m of
                   (* O *) false
                 (* S q *) [q:nat](le_lt_dec_pg p q)
		    end
	end.

Lemma le_lt_dec : (n,m:nat) {le n m} + {lt m n}.
Realizer le_lt_dec_pg.
Program_all.
(*Elim l; Auto.*)
Save.

Lemma le_le_S_dec : (n,m:nat) {le n m} + {le (S m) n}.
Proof le_lt_dec.

Lemma le_ge_dec : (n,m:nat) {le n m} + {ge n m}.
Realizer [n,m:nat](le_lt_dec n m).
Program_all.
Save.

Theorem le_gt_dec : (n,m:nat){(le n m)}+{(gt n m)}.
Proof le_lt_dec.

Theorem le_lt_eq_dec : (n,m:nat)(le n m)->({(lt n m)}+{<nat>n=m}).
Realizer [n,m:nat]<bool>Case (lt_eq_lt_dec n m) of
                       (* inleft b *) [b]b
                        (* inright *) (except ?)
		  end.
Program_all.
Absurd (lt m n); Auto.
Save.


(* $Id: Compare_prog.v,v 1.4 1996/02/12 15:29:31 cpaulin Exp $ *)
