(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              Euclid_prog.v                               *)
(****************************************************************************)

Require Program.
Require Euclid_def.
Require Compare_dec.
Require Minus.
Require Wf_nat.
Require Plus.

Theorem eucl_dev : (b:nat)(gt b O)->(a:nat)(diveucl a b).
Realizer [b:nat]
          (<nat*nat>rec div :: :: { lt }
              [a:nat]<nat*nat>if (le_gt_dec b a) then
			<nat*nat>let (q,r) = (div (minus a b)) in
				((S q),r)
			 else (O,a)).
Program_all.
Exact lt_wf.
Simpl.
Rewrite plus_assoc_r.
Elim e; Auto.
Save.

Lemma quotient : (b:nat)(gt b O)->
     (a:nat){q:nat|(Ex ([r:nat]((a=(plus (mult q b) r)))/\(gt b r)))}.
Realizer [b:nat]
	  (<nat>rec div :: :: { lt }
              [a:nat]<nat>if (le_gt_dec b a) then
                        (S (div (minus a b)))
                        else O).
Program_all.
Exact lt_wf.
Elim y.
Intros.
Exists x0; Simpl; Elim H0; Intros.
Elim plus_assoc_l.
Elim H1; Auto.
Exists a0; Simpl; Auto.
Save.

Lemma modulo : (b:nat)(gt b O)->
     (a:nat){r:nat|(Ex([q:nat]((a=(plus (mult q b) r)))/\(gt b r)))}.
Realizer [b:nat]
           (<nat>rec div :: :: { lt }
              [a:nat]<nat>if (le_gt_dec b a) then
			    (div (minus a b))
			  else a).
Program_all.
Exact lt_wf.
Elim e; Intros q Hq.
Elim Hq; Intros; Exists (S q); Simpl.
Elim plus_assoc_l.
Elim H0; Auto.
Exists O; Simpl; Auto.
Save.


(* $Id: Euclid_prog.v,v 1.3 1996/02/12 15:29:41 cpaulin Exp $ *)
