(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              Euclid_proof.v                              *)
(****************************************************************************)

Require Arith.
Require Compare_dec.
Require Wf_nat.
Require Euclid_def.

Lemma eucl_dev : (b:nat)(gt b O)->(a:nat)(diveucl a b).
Intros b H a; Pattern a; Apply gt_wf_rec; Intros n H0.
Elim (le_gt_dec b n).
Intro lebn.
Elim (H0 (minus n b)); Auto.
Intros q r e g.
Apply divex with (S q) r; Simpl; Auto.
Elim plus_assoc_l.
Elim e; Auto.
Intros gtbn.
Apply divex with O n; Simpl; Auto.
Save.

Lemma quotient : (b:nat)(gt b O)->
     (a:nat){q:nat|(Ex [r:nat](a=(plus (mult q b) r))/\(gt b r))}.
Intros b H a; Pattern a; Apply gt_wf_rec; Intros n H0.
Elim (le_gt_dec b n).
Intro lebn.
Elim (H0 (minus n b)); Auto.
Intros q Hq; Exists (S q).
Elim Hq; Intros r Hr.
Exists r; Simpl; Elim Hr; Intros.
Elim plus_assoc_l.
Elim H1; Auto.
Intros gtbn.
Exists O; Exists n; Simpl; Auto.
Save.

Lemma modulo : (b:nat)(gt b O)->
     (a:nat){r:nat|(Ex [q:nat](a=(plus (mult q b) r))/\(gt b r))}.
Intros b H a; Pattern a; Apply gt_wf_rec; Intros n H0.
Elim (le_gt_dec b n).
Intro lebn.
Elim (H0 (minus n b)); Auto.
Intros r Hr; Exists r.
Elim Hr; Intros q Hq.
Elim Hq; Intros; Exists (S q); Simpl.
Elim plus_assoc_l.
Elim H1; Auto.
Intros gtbn.
Exists n; Exists O; Simpl; Auto.
Save.


(* $Id: Euclid_proof.v,v 1.3 1996/02/12 15:29:44 cpaulin Exp $ *)
