(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              Floyd_proof.v                               *)
(****************************************************************************)

Require SetTheory.
Require Floyd_def.

Theorem build_floyd_matrix : (Q:set)((x,y:V)(In F x)->(In F y)->(floyd Q x y))->(floyd_matrix Q).
Unfold floyd_matrix; Auto.
Save.
Hint build_floyd_matrix.

Theorem acces_floyd_matrix : (Q:set)(floyd_matrix Q)->((x,y:V)(In F x)->(In F y)->(floyd Q x y)).
Unfold floyd_matrix.
Intros Q H x y Fx Fy.
Apply (acces (floyd Q x) F); Auto.
Apply (acces [x:V](array (floyd Q x) F) F); Auto.
Save.
Hint acces_floyd_matrix.

Theorem Floyd_2 : (floyd_matrix F).
Apply F_induction; Auto.
Save.


(* $Id: Floyd_proof.v,v 1.2 1996/02/12 15:29:52 cpaulin Exp $ *)
