(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               Heap_proof.v                               *)
(****************************************************************************)

Require List.
Require Heap_def.

(*****************)
(* specification *)
(*****************)

Theorem heapsort : (l:list){m:list|(sort m)&(eq_fun (list_content l) (list_content m))}.
Goal.
Intros.
Elim (list_to_heap l).
Intros.
Elim (heap_to_list T); Trivial.
Intros.
Exists l0;Auto.
Unfold eq_fun;Intro.
Apply trans_equal with (content T a).
Exact (e a).
Exact (e0 a).
Save.


(* $Id: Heap_proof.v,v 1.2 1996/02/12 15:29:58 cpaulin Exp $ *)
