(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                               Peano_prog.v                               *)
(****************************************************************************)

Require Program.

Theorem O_or_S : (n:nat)({m:nat|(S m)=n})+{O=n}.
Realizer [n:nat]<(sumor nat)>Case n of
                  (* O *) (inright ?)
                (* S p *) [p](inleft ? p) 
		   end.
Program_all.
Save.

Theorem eq_nat_dec : (n,m:nat){n=m}+{~n=m}.
Realizer [n:nat]<nat->bool>Match n with 
                  (* O *) [m]<bool>Case m of
                                (* O *) true
                              (* S p *) [_]false
				 end
                (* S p *) [p,H,m]<bool>Case m of
                                (* O *) false
                              (* S q *) [q:nat](H q)
				end
		end.
Program_all.
Save.


(* $Id: Peano_prog.v,v 1.4 1996/02/12 15:30:10 cpaulin Exp $ *)
