(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                              Tauto_proof.v                               *)
(****************************************************************************)

Require Bool.
Require Tauto_def.

Theorem Norm_prog : (F:IFExpr){G:IFExpr | (Normal G) & (Equiv F G)}.
Intro; Pattern F; Apply IFExpr_norm_rec.
Exists Tr; Auto.
Exists Fa; Auto.
Intro; Exists (Var n); Auto.
Induction 1; Intros nY NormY EquivY.
Exists nY; Auto.
Induction 1; Intros nZ NormZ EquivZ.
Exists nZ; Auto.
Induction 1; Intros nY NormY EquivY.
Induction 1; Intros nZ NormZ EquivZ.
Exists (IfE (Var n) nY nZ); Auto.
Induction 1; Intros nF NormF EquivF.
Exists nF; Trivial.
Apply Equiv_trans with (IfE X (IfE T Y Z) (IfE U Y Z)); Auto.
Save.




(* $Id: Tauto_proof.v,v 1.2 1996/02/12 15:30:37 cpaulin Exp $ *)
