(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                             Warshall_proof.v                             *)
(****************************************************************************)

Require SetTheory.
Require Warshall_def.

Lemma build_matrix : (P:V->V->Prop)((x,y:V){(P x y)}+{~(P x y)})->(repr_matrix P).
Red ; Auto.
Save.
Hint build_matrix.

Lemma acces_matrix : (P:V->V->Prop)(repr_matrix P)->(x,y:V){(P x y)}+{~(P x y)}.
Unfold repr_matrix ; Intros P H x y.
Apply (acces [v:V]({(P x v)}+{~(P x v)}) allV) ; Auto.
Apply (acces [v:V](array [v0:V]({(P v v0)}+{~(P v v0)}) allV) allV) ;
   Auto.
Save.
Hint acces_matrix.

(************************************)
(*      New specification           *)
(************************************)

Lemma warshall_rep : (repr_matrix (connected allV)).
Elim finit_V ; Auto.
Save.
Hint warshall_rep.

Theorem warshall2 : (x,y:V){(connected allV x y)}+{~(connected allV x y)}.
Auto.
Save.


(* $Id: Warshall_proof.v,v 1.2 1996/02/12 15:30:45 cpaulin Exp $ *)
