(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.11                                 *)
(*                               Feb 2nd 1996                               *)
(*                                                                          *)
(****************************************************************************)
(*                             Equipollence.v                               *)
(****************************************************************************)

Require Ensembles.    (* Ensemble, In, Included, Setminus *)
Require Relations_1.  (* Relation *)
Require Functions.

(************************************************************************)
(*         Equipollence and relation "is of cardinal less than"         *)

Section Equipollence.

Variable U:Type.
Variables A,B:(Ensemble U).
Local Rela := (Relation U).

Inductive equipollence : Prop :=
    equipollence_intro :  (f:Rela)(bijection U A B f)->equipollence.

Inductive inf_card : Prop :=
    inf_card_intro : (f:Rela)(injection U A B f)->inf_card.

End Equipollence.

(* $Id: Equipollence.v,v 1.2 1996/02/12 15:32:42 cpaulin Exp $ *)
