(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.11                                 *)
(*                              Feb 2nd 1996                                *)
(*                                                                          *)
(****************************************************************************)
(*                            Setminus_fact.v                               *)
(****************************************************************************)

Require Ensembles.    (* Ensemble, In, Included, Setminus *)

Section Contravariance_of_Setminus.

Variable U:Type.

Lemma Setminus_contravariant :
  (A,B,B':(Ensemble U))
  (Included U B' B)->(Included U (Setminus U A B) (Setminus U A B')).
Intros A B B' B'_Included_B; Unfold Setminus.
Red; Intros x x_in_B.
Elim x_in_B; Intros x_in_A x_in_nonB.
Split.
  Assumption.
Red; Intro x_in_B'.
Apply x_in_nonB.
Apply B'_Included_B.
Assumption.
Qed.

End Contravariance_of_Setminus.


(* $Id: Setminus_fact.v,v 1.2 1996/02/12 15:32:49 cpaulin Exp $ *)
