(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.11                                 *)
(*                              Feb 2nd 1996                                *)
(*                                                                          *)
(****************************************************************************)
(*                                  Sums.v                                  *)
(****************************************************************************)

Require Ensembles.    (* Ensemble, In, Included, Setminus *)

Section Sums.

Variable U:Type.

Inductive Sum [D:(Ensemble (Ensemble U))] : U -> Prop :=
 Sum_intro : (B:(Ensemble U))(In (Ensemble U) D B)->(x:U)(In U B x)->(Sum D x).

Lemma Sum_is_majoring :
  (D:(Ensemble (Ensemble U)))(A:(Ensemble U))
     ((C:(Ensemble U))(D C)->(Included U C A))
     ->(Included U (Sum D) A).
Intros.
Red; Intros x x_in_Sum_D.
Red in x_in_Sum_D.
Elim x_in_Sum_D.
Assumption.
Qed.

Lemma Sum_is_minoring :
  (D:(Ensemble (Ensemble U)))(A:(Ensemble U))
   (In (Ensemble U) D A)->(Included U A (Sum D)).
Do 2 Intro; Red; Intros A_in_D x x_in_A.
Red; Apply Sum_intro with A; Assumption.
Qed.

End Sums.



(* $Id: Sums.v,v 1.2 1996/02/12 15:32:51 cpaulin Exp $ *)
