(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Sept 1st 1995                               *)
(*                                                                          *)
(****************************************************************************)
(*                         A_decidable_ordering.v                           *)
(****************************************************************************)

(* G. Huet 1-9-95 *)

(* This is needed in order to have parametric lists and multisets share
   the same abstract type A, in the absence of parametric modules *)
Require Generic.

(**********************************************)
(* We postulate a decidable equality equ on A *)
(**********************************************)

Parameter   equ : A -> A -> Prop.
Axiom equ_decide : (x,y:A){(equ x y)}+{~(equ x y)}.


(* $Id: A_decidable.v,v 1.2 1996/02/12 15:32:55 cpaulin Exp $ *)
