(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Sept 1st 1995                               *)
(*                                                                          *)
(****************************************************************************)
(*                           A_total_ordering.v                             *)
(****************************************************************************)

(* G. Huet 1-9-95 *)

Require Generic.

(******************************************)
(* We postulate a total ordering inf on A *)
(******************************************)

Parameter   inf : A -> A -> Prop.

Axiom inf_total : (x,y:A){(inf x y)}+{(inf y x)}.
Axiom inf_tran : (x,y,z:A)(inf x y)->(inf y z)->(inf x z).
Axiom inf_refl : (x:A)(inf x x).

Hint inf_refl inf_total.



(* $Id: A_total_ordering.v,v 1.2 1996/02/12 15:33:00 cpaulin Exp $ *)
