(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                 init.ml                                  *)
(****************************************************************************)

(*							*)
(*	init.ml		(JCF 4/5/94)			*)
(*							*)

type 'a option = NONE | SOME of 'a 
;;

type ML_token = Use_module of string
;;

type Coq_token = Require of string
               | RequireString of string
               | Declare of string list
;;

let mlAccu  = ref ([] : (string * string option) list) and 
    mliAccu = ref ([] : (string * string option) list) and
    vAccu   = ref ([] : (string * string option) list)
;;

let mlKnown  = ref ([] : (string * string option) list) and 
    mliKnown = ref ([] : (string * string option) list) and
    vKnown   = ref ([] : (string * string option) list)
;;

let (dep_tab : (string,string list) hashtbl__t) = hashtbl__new 151
;;

let addQueue q v = q := v :: !q
;;

let file_name = 
  fun (s,NONE)     -> s 
    | (s,SOME ".") -> s
    | (s,SOME d)   -> filename__concat d s
;;
