(*							*)
(*	lex_cld.mll	(JCF  4/5/94)			*)
(*							*)
{
 #open "init";;
 
 let comment_depth = ref 0;;
 
 exception fin_fichier;;

}
rule action = parse
    "#" [` ` `\t` `\n`]* "open" [` ` `\t` `\n`]* `"`
      { opened_file lexbuf }
  | [`a`-`z` `_` `0`-`9` `A`-`Z`]+"__"  
      { let lex = (get_lexeme lexbuf) in
        let str =(sub_string lex 0 (string_length lex - 2)) in 
        (Use_module str) }
  | "`" { Char lexbuf; action lexbuf }
  | "\""
      { chaine lexbuf; action lexbuf }
  | "(*"
      { comment_depth := 1; Comment lexbuf; action lexbuf }  
  | eof    { raise fin_fichier} 
  | _      { action lexbuf }
and Comment = parse
    "(*"
      { comment_depth := succ !comment_depth; Comment lexbuf }
  | "*)"
      { comment_depth := pred !comment_depth;
        if !comment_depth > 0 then Comment lexbuf }
  | "`" [^ `\\` `\``] "`"
      { Comment lexbuf }
  | "`" `\\` [`\\` `\`` `n` `t` `b` `r`] "`"
      { Comment lexbuf }
  | "`" `\\` [`0`-`9`] [`0`-`9`] [`0`-`9`] "`"
      { Comment lexbuf }
  | eof
      { raise fin_fichier} 
  | _ {Comment lexbuf}
and chaine = parse
    `"`             { () }
  | `\\` [`"` `\\`] { chaine lexbuf }
  | _               { chaine lexbuf }
and Char = parse
    [^ `\\` `\``] "`"
      { () }
  | `\\` [`\\` `\`` `n` `t` `b` `r`] "`"
      { () }
  | `\\` [`0`-`9`] [`0`-`9`] [`0`-`9`] "`"
      { () }
  | _ { () }
and opened_file = parse
   [^`"`]* `"`
      { let lex = (get_lexeme lexbuf) in 
      	let str = sub_string lex 0 (string_length lex - 1) in
      	(Use_module str) }
;;
