(*							*)
(*	lex_coq.mll	(JCF  4/5/94)			*)
(*							*)
{
 #open "init";;
 
 let comment_depth = ref 0;;
 
 exception fin_fichier;;

 let module_name = ref "";;

 let mllist = ref ([] : string list);;
}
rule action = parse
    "Require"[` ` `\t` `\n`]+
      { opened_file lexbuf }
  | "Require"[` ` `\t` `\n`]+"Export"[` ` `\t` `\n`]+
      { opened_file lexbuf}
  | "Require"[` ` `\t` `\n`]+"Syntax"[` ` `\t` `\n`]+
      { opened_file lexbuf}
  | "Require"[` ` `\t` `\n`]+"Import"[` ` `\t` `\n`]+
      { opened_file lexbuf}
  | "Require"[` ` `\t` `\n`]+"Implementation"[` ` `\t` `\n`]+
      { opened_file lexbuf}
  | "Declare"[` ` `\t` `\n`]+"ML"[` ` `\t` `\n`]+"Module"[` ` `\t` `\n`]+
      { mllist := []; modules lexbuf}
  | "\""
      { chaine lexbuf; action lexbuf}
  | "(*"
      { comment_depth := 1; Comment lexbuf; action lexbuf }  
  | eof { raise fin_fichier} 
  | _   { action lexbuf }
and Comment = parse
    "(*"
      { comment_depth := succ !comment_depth; Comment lexbuf }
  | "*)"
      { comment_depth := pred !comment_depth;
        if !comment_depth > 0 then Comment lexbuf }
  | "`" [^ `\\` `\``] "`"
      { Comment lexbuf }
  | "`" `\\` [`\\` `\`` `n` `t` `b` `r`] "`"
      { Comment lexbuf }
  | "`" `\\` [`0`-`9`] [`0`-`9`] [`0`-`9`] "`"
      { Comment lexbuf }
  | eof
      { raise fin_fichier } 
  | _ { Comment lexbuf }
and chaine = parse
    `"`                { () }
  | `\\` [`"` `\\`]    { chaine lexbuf }
  | _		       { chaine lexbuf }
and opened_file = parse
    "(*"  	{ comment_depth := 1; Comment lexbuf; opened_file lexbuf }
  | [` ` `\t` `\n`]*
      	       	{ opened_file lexbuf }
  | [`a`-`z` `_` `0`-`9` `A`-`Z`]+
       	       	{ module_name := (get_lexeme lexbuf);
                  opened_file_end lexbuf }
and opened_file_end = parse
    `.`               { Require (!module_name) }
  | [` ` `\t` `\n`]*  { opened_file_end lexbuf }
  | "(*"              { comment_depth := 1; Comment lexbuf;
      	       	       	opened_file_end lexbuf }
  | `"` [^`"`]* `"`   { let lex = get_lexeme lexbuf in
      	       	       	let str = sub_string lex 1 (string_length lex - 2) in
			(RequireString str) }
  | eof		      { raise fin_fichier }
  | _		      { opened_file_end lexbuf }
and modules = parse
    [` ` `\t` `\n`]     { modules lexbuf }
  | "(*"		{ comment_depth := 1; Comment lexbuf;
      	       	       	  modules lexbuf }
  | `"` [^`"`]* `"`
        { let lex = (get_lexeme lexbuf) in 
	  let str = sub_string lex 1 (string_length lex - 2) in
	  mllist := str :: (!mllist); modules lexbuf }
  | _   { (Declare (rev (!mllist))) }   
;;
