(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                Coq V5.10                                 *)
(*                              Nov 25th 1994                               *)
(*                                                                          *)
(****************************************************************************)
(*                                gallina.ml                                *)
(****************************************************************************)
(*							*)
(*	coqdep.ml     	(JCF 4/5/94)			*)
(*							*)

#open "init";;

let vfiles = ref ([] : string list)
;;

let option_moins = ref false
;;

let option_stdout = ref false
;;

let traite_fichier f = 
  try 
    let chan_in = open_in (f^".v") in 
    let buf = lexing__create_lexer_channel chan_in in
    (
    if not (!option_stdout) then 
      chan_out := open_out (f ^ ".g");
    try while true do
         lex_coq__action buf
        done
    with lex_coq__fin_fichier -> (flush (!chan_out);
      	       	       	       	  close_in chan_in;
				  if not (!option_stdout) then
      	       	       	       	    close_out (!chan_out))
    )
  with sys__Sys_error _ -> () 
;;

let traite_stdin () =
  try
    let buf = lexing__create_lexer_channel std_in in
    try while true do
      	  lex_coq__action buf
	done
    with lex_coq__fin_fichier -> flush (!chan_out)
  with sys__Sys_error _ -> ()
;;

let gallina () =
  let lg_command = vect_length sys__command_line in
  if lg_command < 2 then (
    output_string std_err "Usage: gallina [-] [-stdout] file1 file2 ...\n";
    flush std_err)
  else 
    let treat = function
       "-" -> option_moins := true
     | "-stdout" -> option_stdout := true
     | f   -> if filename__check_suffix f ".v" then
       	       	 vfiles := (filename__chop_suffix f ".v") :: (!vfiles)
    in (
    do_vect treat sys__command_line;
    if (!option_moins) then
      traite_stdin ()
     else
      do_list traite_fichier (!vfiles)
    )
;;

printexc__f gallina ();;

